/*
   +----------------------------------------------------------------------+
   | HipHop for PHP                                                       |
   +----------------------------------------------------------------------+
   | Copyright (c) 2010-2013 Facebook, Inc. (http://www.facebook.com)     |
   +----------------------------------------------------------------------+
   | This source file is subject to version 3.01 of the PHP license,      |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.php.net/license/3_01.txt                                  |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
*/
#line 2 "lex.yy.cpp"

#line 4 "lex.yy.cpp"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 35
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* An opaque pointer. */
#ifndef YY_TYPEDEF_YY_SCANNER_T
#define YY_TYPEDEF_YY_SCANNER_T
typedef void* yyscan_t;
#endif

/* For convenience, these vars (plus the bison vars far below)
   are macros in the reentrant scanner. */
#define yyin yyg->yyin_r
#define yyout yyg->yyout_r
#define yyextra yyg->yyextra_r
#define yyleng yyg->yyleng_r
#define yytext yyg->yytext_r
#define yylineno (YY_CURRENT_BUFFER_LVALUE->yy_bs_lineno)
#define yycolumn (YY_CURRENT_BUFFER_LVALUE->yy_bs_column)
#define yy_flex_debug yyg->yy_flex_debug_r

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN yyg->yy_start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START ((yyg->yy_start - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE hphprestart(yyin ,yyscanner )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    #define YY_LESS_LINENO(n)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = yyg->yy_hold_char; \
		YY_RESTORE_YY_MORE_OFFSET \
		yyg->yy_c_buf_p = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, yyg->yytext_ptr , yyscanner )

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via hphprestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( yyg->yy_buffer_stack \
                          ? yyg->yy_buffer_stack[yyg->yy_buffer_stack_top] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE yyg->yy_buffer_stack[yyg->yy_buffer_stack_top]

void hphprestart (FILE *input_file ,yyscan_t yyscanner );
void hphp_switch_to_buffer (YY_BUFFER_STATE new_buffer ,yyscan_t yyscanner );
YY_BUFFER_STATE hphp_create_buffer (FILE *file,int size ,yyscan_t yyscanner );
void hphp_delete_buffer (YY_BUFFER_STATE b ,yyscan_t yyscanner );
void hphp_flush_buffer (YY_BUFFER_STATE b ,yyscan_t yyscanner );
void hphppush_buffer_state (YY_BUFFER_STATE new_buffer ,yyscan_t yyscanner );
void hphppop_buffer_state (yyscan_t yyscanner );

static void hphpensure_buffer_stack (yyscan_t yyscanner );
static void hphp_load_buffer_state (yyscan_t yyscanner );
static void hphp_init_buffer (YY_BUFFER_STATE b,FILE *file ,yyscan_t yyscanner );

#define YY_FLUSH_BUFFER hphp_flush_buffer(YY_CURRENT_BUFFER ,yyscanner)

YY_BUFFER_STATE hphp_scan_buffer (char *base,yy_size_t size ,yyscan_t yyscanner );
YY_BUFFER_STATE hphp_scan_string (yyconst char *yy_str ,yyscan_t yyscanner );
YY_BUFFER_STATE hphp_scan_bytes (yyconst char *bytes,int len ,yyscan_t yyscanner );

void *hphpalloc (yy_size_t ,yyscan_t yyscanner );
void *hphprealloc (void *,yy_size_t ,yyscan_t yyscanner );
void hphpfree (void * ,yyscan_t yyscanner );

#define yy_new_buffer hphp_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        hphpensure_buffer_stack (yyscanner); \
		YY_CURRENT_BUFFER_LVALUE =    \
            hphp_create_buffer(yyin,YY_BUF_SIZE ,yyscanner); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        hphpensure_buffer_stack (yyscanner); \
		YY_CURRENT_BUFFER_LVALUE =    \
            hphp_create_buffer(yyin,YY_BUF_SIZE ,yyscanner); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

typedef unsigned char YY_CHAR;

typedef int yy_state_type;

#define yytext_ptr yytext_r
static yyconst flex_int16_t yy_nxt[][256] =
    {
    {
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0
    },

    {
       45,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   47,   46,   46,   46,   46,

       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       48,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,

       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,

       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46
    },

    {
       45,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   47,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       48,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,

       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,

       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
       46,   46,   46,   46,   46,   46
    },

    {
       45,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,

       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       50,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,

       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,

       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49
    },

    {
       45,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,

       50,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,

       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49

    },

    {
       45,   51,   51,   51,   51,   51,   51,   51,   51,   52,
       52,   51,   51,   52,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   52,   53,   54,   55,   56,   57,   58,   59,
       60,   61,   62,   63,   61,   64,   65,   66,   67,   68,
       68,   68,   68,   68,   68,   68,   68,   68,   69,   61,
       70,   71,   72,   73,   61,   74,   75,   76,   77,   78,
       79,   80,   81,   82,   81,   81,   83,   81,   84,   85,
       86,   81,   87,   88,   89,   90,   91,   92,   93,   94,
       81,   61,   95,   61,   96,   97,   98,   74,   75,   76,

       77,   78,   79,   80,   81,   82,   81,   81,   83,   81,
       84,   85,   86,   81,   87,   88,   89,   90,   91,   92,
       93,   94,   81,   99,  100,  101,   61,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,

       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81
    },

    {
       45,   51,   51,   51,   51,   51,   51,   51,   51,   52,
       52,   51,   51,   52,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   52,   53,   54,   55,   56,   57,   58,   59,

       60,   61,   62,   63,   61,   64,   65,   66,   67,   68,
       68,   68,   68,   68,   68,   68,   68,   68,   69,   61,
       70,   71,   72,   73,   61,   74,   75,   76,   77,   78,
       79,   80,   81,   82,   81,   81,   83,   81,   84,   85,
       86,   81,   87,   88,   89,   90,   91,   92,   93,   94,
       81,   61,   95,   61,   96,   97,   98,   74,   75,   76,
       77,   78,   79,   80,   81,   82,   81,   81,   83,   81,
       84,   85,   86,   81,   87,   88,   89,   90,   91,   92,
       93,   94,   81,   99,  100,  101,   61,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,

       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,

       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81
    },

    {
       45,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       50,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,

       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,

       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49
    },

    {
       45,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,

       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       50,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,

       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,

       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49
    },

    {
       45,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  103,  102,  104,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,

      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  105,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  106,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,

      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102

    },

    {
       45,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  103,  102,  104,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  105,  102,  102,  102,  102,  102,  102,  102,

      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  106,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,

      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102
    },

    {
       45,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  108,  107,  107,  107,

      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  109,  107,  107,  107,  110,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  111,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,

      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,

      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107
    },

    {
       45,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  108,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,

      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  109,  107,  107,  107,  110,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  111,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,

      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107
    },

    {
       45,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,

      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  113,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,

      112,  112,  112,  114,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,

      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112
    },

    {
       45,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  113,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,

      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  114,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,

      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112

    },

    {
       45,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,

      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,

      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112
    },

    {
       45,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,

      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,

      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,

      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112
    },

    {
       45,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,

      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,   51,   51,   51,   51,  115,   51,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,   51,   51,   51,   51,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,

      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115
    },

    {
       45,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,

       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,   51,   51,   51,   51,  115,   51,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,

      115,  115,  115,   51,   51,   51,   51,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,

      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115
    },

    {
       45,  116,  116,  116,  116,  116,  116,  116,  116,  117,
      117,  116,  116,  117,  116,  116,  116,  116,  116,  116,
      116,  116,  116,  116,  116,  116,  116,  116,  116,  116,
      116,  116,  117,  116,  116,  116,  116,  116,  116,  116,
      116,  116,  116,  116,  116,  118,  116,  116,  116,  116,
      116,  116,  116,  116,  116,  116,  116,  116,  116,  116,

      116,  116,  116,  116,  116,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  116,  116,  116,  116,  119,  116,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  116,  116,  116,  116,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,

      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119

    },

    {
       45,  116,  116,  116,  116,  116,  116,  116,  116,  117,
      117,  116,  116,  117,  116,  116,  116,  116,  116,  116,
      116,  116,  116,  116,  116,  116,  116,  116,  116,  116,
      116,  116,  117,  116,  116,  116,  116,  116,  116,  116,
      116,  116,  116,  116,  116,  118,  116,  116,  116,  116,
      116,  116,  116,  116,  116,  116,  116,  116,  116,  116,
      116,  116,  116,  116,  116,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  116,  116,  116,  116,  119,  116,  119,  119,  119,

      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  116,  116,  116,  116,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,

      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119
    },

    {
       45,  120,  120,  120,  120,  120,  120,  120,  120,  120,
      120,  120,  120,  120,  120,  120,  120,  120,  120,  120,
      120,  120,  120,  120,  120,  120,  120,  120,  120,  120,
      120,  120,  120,  120,  120,  120,  120,  120,  120,  120,

      120,  120,  120,  120,  120,  120,  120,  120,  120,  120,
      120,  120,  120,  120,  120,  120,  120,  120,  120,  120,
      120,  120,  120,  120,  120,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  120,  120,  120,  120,  121,  120,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  120,  120,  120,  120,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,

      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,

      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121
    },

    {
       45,  120,  120,  120,  120,  120,  120,  120,  120,  120,
      120,  120,  120,  120,  120,  120,  120,  120,  120,  120,
      120,  120,  120,  120,  120,  120,  120,  120,  120,  120,
      120,  120,  120,  120,  120,  120,  120,  120,  120,  120,
      120,  120,  120,  120,  120,  120,  120,  120,  120,  120,
      120,  120,  120,  120,  120,  120,  120,  120,  120,  120,
      120,  120,  120,  120,  120,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,

      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  120,  120,  120,  120,  121,  120,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  120,  120,  120,  120,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,

      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121
    },

    {
       45,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,

       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,  122,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,

       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,

       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51
    },

    {
       45,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,  122,   51,

       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,

       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51

    },

    {
       45,   51,   51,   51,   51,   51,   51,   51,   51,  123,
      123,   51,   51,  123,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,  123,  124,  124,  123,  125,  124,  124,  123,
      124,  124,  124,  124,  124,  124,  124,  124,  126,  127,
      127,  127,  127,  127,  127,  127,  127,  127,  124,  124,
      124,  124,  124,  124,  124,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,  124,  123,  128,  124,   81,  124,   81,   81,   81,

       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,  124,  124,  124,  124,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,

       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81
    },

    {
       45,   51,   51,   51,   51,   51,   51,   51,   51,  123,
      123,   51,   51,  123,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,  123,  124,  124,  123,  125,  124,  124,  123,

      124,  124,  124,  124,  124,  124,  124,  124,  126,  127,
      127,  127,  127,  127,  127,  127,  127,  127,  124,  124,
      124,  124,  124,  124,  124,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,  124,  123,  128,  124,   81,  124,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,  124,  124,  124,  124,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,

       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,

       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81
    },

    {
       45,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
      129,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,

       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,

       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51
    },

    {
       45,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,

       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
      129,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,

       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,

       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51
    },

    {
       45,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  131,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,

      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,

      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130

    },

    {
       45,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  131,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,

      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,

      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130
    },

    {
       45,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,

      130,  130,  132,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,

      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,

      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130
    },

    {
       45,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  132,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,

      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,

      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130
    },

    {
       45,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      134,  133,  133,  135,  133,  133,  133,  133,  133,  133,

      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  136,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  137,  138,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,

      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,

      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133
    },

    {
       45,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      134,  133,  133,  135,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  136,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,

      133,  133,  137,  138,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,

      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
      133,  133,  133,  133,  133,  133

    },

    {
       45,  139,  139,  139,  139,  139,  139,  139,  139,  140,
      140,  139,  139,  140,  139,  139,  139,  139,  139,  139,
      139,  139,  139,  139,  139,  139,  139,  139,  139,  139,
      139,  139,  140,  139,  141,  142,  139,  139,  139,  139,
      139,  139,  139,  139,  139,  139,  143,  144,  145,  146,
      146,  146,  146,  146,  146,  146,  146,  146,  139,  139,
      139,  147,  148,  139,  139,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  139,  139,  139,  139,  149,  139,  149,  149,  149,

      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  150,  139,  139,  139,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,

      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149
    },

    {
       45,  139,  139,  139,  139,  139,  139,  139,  139,  140,
      140,  139,  139,  140,  139,  139,  139,  139,  139,  139,
      139,  139,  139,  139,  139,  139,  139,  139,  139,  139,
      139,  139,  140,  139,  141,  142,  139,  139,  139,  139,

      139,  139,  139,  139,  139,  139,  143,  144,  145,  146,
      146,  146,  146,  146,  146,  146,  146,  146,  139,  139,
      139,  147,  148,  139,  139,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  139,  139,  139,  139,  149,  139,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  150,  139,  139,  139,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,

      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,

      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149
    },

    {
       45,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,  151,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,

       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,

       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51
    },

    {
       45,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,

       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,  151,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,

       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,

       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51
    },

    {
       45,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,  152,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,

       51,   51,  153,   51,   51,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,   51,   51,   51,   51,  154,   51,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,   51,   51,   51,   51,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,

      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154

    },

    {
       45,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,  152,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,  153,   51,   51,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,   51,   51,   51,   51,  154,   51,  154,  154,  154,

      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,   51,   51,   51,   51,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,

      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154
    },

    {
       45,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,

      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      156,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  157,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,

      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,

      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155
    },

    {
       45,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      156,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,

      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  157,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,

      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  155
    },

    {
       45,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,

      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  159,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,

      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,

      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158
    },

    {
       45,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  159,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,

      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,

      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158

    },

    {
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,

      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,

      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,  -45,
      -45,  -45,  -45,  -45,  -45,  -45
    },

    {
       45,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  -46,  160,  160,  160,  160,

      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      161,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,

      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,

      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160
    },

    {
       45,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      163,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,

      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,

      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162
    },

    {
       45,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,

      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  165,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      -48,  164,  164,  166,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  167,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  167,  164,  164,  164,  164,

      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,

      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164
    },

    {
       45,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,

      169,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,

      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168

    },

    {
       45,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  165,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      -50,  170,  170,  166,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  171,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,

      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  171,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,

      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170
    },

    {
       45,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,

      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,

      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,

      -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,  -51,
      -51,  -51,  -51,  -51,  -51,  -51
    },

    {
       45,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  172,
      172,  -52,  -52,  172,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  172,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,

      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,

      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,  -52,
      -52,  -52,  -52,  -52,  -52,  -52
    },

    {
       45,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,

      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  173,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,

      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,

      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,  -53,
      -53,  -53,  -53,  -53,  -53,  -53
    },

    {
       45,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  175,  174,  176,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,

      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  177,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  178,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,

      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174

    },

    {
       45,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,

      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,

      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,  -55,
      -55,  -55,  -55,  -55,  -55,  -55
    },

    {
       45,  -56,  -56,  -56,  -56,  -56,  -56,  -56,  -56,  -56,
      -56,  -56,  -56,  -56,  -56,  -56,  -56,  -56,  -56,  -56,
      -56,  -56,  -56,  -56,  -56,  -56,  -56,  -56,  -56,  -56,
      -56,  -56,  -56,  -56,  -56,  -56,  -56,  -56,  -56,  -56,

      -56,  -56,  -56,  -56,  -56,  -56,  -56,  -56,  -56,  -56,
      -56,  -56,  -56,  -56,  -56,  -56,  -56,  -56,  -56,  -56,
      -56,  -56,  -56,  -56,  -56,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  -56,  -56,  -56,  -56,  179,  -56,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  -56,  -56,  -56,  -56,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,

      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,

      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179
    },

    {
       45,  -57,  -57,  -57,  -57,  -57,  -57,  -57,  -57,  -57,
      -57,  -57,  -57,  -57,  -57,  -57,  -57,  -57,  -57,  -57,
      -57,  -57,  -57,  -57,  -57,  -57,  -57,  -57,  -57,  -57,
      -57,  -57,  -57,  -57,  -57,  -57,  -57,  -57,  -57,  -57,
      -57,  -57,  -57,  -57,  -57,  -57,  -57,  -57,  -57,  -57,
      -57,  -57,  -57,  -57,  -57,  -57,  -57,  -57,  -57,  -57,
      -57,  180,  181,  -57,  -57,  182,  182,  182,  182,  182,
      182,  182,  182,  182,  182,  182,  182,  182,  182,  182,

      182,  182,  182,  182,  182,  182,  182,  182,  182,  182,
      182,  -57,  -57,  -57,  -57,  182,  -57,  182,  182,  182,
      182,  182,  182,  182,  182,  182,  182,  182,  182,  182,
      182,  182,  182,  182,  182,  182,  182,  182,  182,  182,
      182,  182,  182,  -57,  -57,  -57,  -57,  182,  182,  182,
      182,  182,  182,  182,  182,  182,  182,  182,  182,  182,
      182,  182,  182,  182,  182,  182,  182,  182,  182,  182,
      182,  182,  182,  182,  182,  182,  182,  182,  182,  182,
      182,  182,  182,  182,  182,  182,  182,  182,  182,  182,
      182,  182,  182,  182,  182,  182,  182,  182,  182,  182,

      182,  182,  182,  182,  182,  182,  182,  182,  182,  182,
      182,  182,  182,  182,  182,  182,  182,  182,  182,  182,
      182,  182,  182,  182,  182,  182,  182,  182,  182,  182,
      182,  182,  182,  182,  182,  182,  182,  182,  182,  182,
      182,  182,  182,  182,  182,  182,  182,  182,  182,  182,
      182,  182,  182,  182,  182,  182,  182,  182,  182,  182,
      182,  182,  182,  182,  182,  182,  182,  182,  182,  182,
      182,  182,  182,  182,  182,  182
    },

    {
       45,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,

      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  183,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  184,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,

      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,

      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,  -58,
      -58,  -58,  -58,  -58,  -58,  -58
    },

    {
       45,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  186,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,

      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  187,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,

      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185

    },

    {
       45,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  188,
      -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,
      -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,
      -60,  -60,  188,  -60,  -60,  -60,  -60,  -60,  -60,  -60,
      -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,
      -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,
      -60,  -60,  -60,  -60,  -60,  189,  190,  -60,  191,  -60,
      192,  -60,  -60,  193,  -60,  -60,  -60,  -60,  -60,  194,
      -60,  -60,  195,  196,  -60,  197,  -60,  -60,  -60,  -60,
      -60,  -60,  -60,  -60,  -60,  -60,  -60,  189,  190,  -60,

      191,  -60,  192,  -60,  -60,  193,  -60,  -60,  -60,  -60,
      -60,  194,  -60,  -60,  195,  196,  -60,  197,  -60,  -60,
      -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,
      -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,
      -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,
      -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,
      -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,
      -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,
      -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,
      -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,

      -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,
      -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,
      -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,
      -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,
      -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,  -60,
      -60,  -60,  -60,  -60,  -60,  -60
    },

    {
       45,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,

      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,

      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,

      -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,  -61,
      -61,  -61,  -61,  -61,  -61,  -61
    },

    {
       45,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  198,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,

      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,

      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,  -62,
      -62,  -62,  -62,  -62,  -62,  -62
    },

    {
       45,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,

      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  199,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  200,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,

      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,

      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,  -63,
      -63,  -63,  -63,  -63,  -63,  -63
    },

    {
       45,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  201,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,

      -64,  202,  203,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,

      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,  -64,
      -64,  -64,  -64,  -64,  -64,  -64

    },

    {
       45,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  204,  -65,  205,  205,
      205,  205,  205,  205,  205,  205,  205,  205,  -65,  -65,
      -65,  206,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,

      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,

      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,  -65,
      -65,  -65,  -65,  -65,  -65,  -65
    },

    {
       45,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,

      -66,  -66,  207,  -66,  -66,  -66,  -66,  208,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  209,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,

      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,

      -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
      -66,  -66,  -66,  -66,  -66,  -66
    },

    {
       45,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,
      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,
      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,
      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,
      -67,  -67,  -67,  -67,  -67,  -67,  210,  -67,  211,  211,
      211,  211,  211,  211,  211,  211,  211,  211,  -67,  -67,
      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  212,
      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,

      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  213,  -67,
      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,
      -67,  212,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,
      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,
      213,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,
      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,
      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,
      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,
      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,
      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,

      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,
      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,
      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,
      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,
      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,
      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,
      -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,  -67,
      -67,  -67,  -67,  -67,  -67,  -67
    },

    {
       45,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,
      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,

      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,
      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,
      -68,  -68,  -68,  -68,  -68,  -68,  210,  -68,  211,  211,
      211,  211,  211,  211,  211,  211,  211,  211,  -68,  -68,
      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  212,
      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,
      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,
      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,
      -68,  212,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,
      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,

      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,
      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,
      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,
      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,
      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,
      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,
      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,
      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,
      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,
      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,

      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,
      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,
      -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,  -68,
      -68,  -68,  -68,  -68,  -68,  -68
    },

    {
       45,  -69,  -69,  -69,  -69,  -69,  -69,  -69,  -69,  -69,
      -69,  -69,  -69,  -69,  -69,  -69,  -69,  -69,  -69,  -69,
      -69,  -69,  -69,  -69,  -69,  -69,  -69,  -69,  -69,  -69,
      -69,  -69,  -69,  -69,  -69,  -69,  -69,  -69,  -69,  -69,
      -69,  -69,  -69,  -69,  -69,  -69,  -69,  -69,  -69,  -69,
      -69,  -69,  -69,  -69,  -69,  -69,  -69,  -69,  214,  -69,

      -69,  -69,  -69,  -69,  -69,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  -69,  -69,  -69,  -69,  215,  -69,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  -69,  -69,  -69,  -69,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,

      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215

    },

    {
       45,  -70,  -70,  -70,  -70,  -70,  -70,  -70,  -70,  -70,
      -70,  -70,  -70,  -70,  -70,  -70,  -70,  -70,  -70,  -70,
      -70,  -70,  -70,  -70,  -70,  -70,  -70,  -70,  -70,  -70,
      -70,  -70,  -70,  -70,  -70,  -70,  -70,  -70,  -70,  -70,
      -70,  -70,  -70,  -70,  -70,  -70,  -70,  216,  -70,  -70,
      -70,  -70,  -70,  -70,  -70,  -70,  -70,  -70,  -70,  -70,
      217,  218,  219,  -70,  -70,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  -70,  -70,  -70,  -70,  220,  -70,  220,  220,  220,

      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  -70,  -70,  -70,  -70,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,

      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220
    },

    {
       45,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,

      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  221,  222,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,

      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,

      -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,  -71,
      -71,  -71,  -71,  -71,  -71,  -71
    },

    {
       45,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  223,  224,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,

      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,

      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,  -72,
      -72,  -72,  -72,  -72,  -72,  -72
    },

    {
       45,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,

      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  225,  -73,
      -73,  -73,  226,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,

      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,

      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,  -73,
      -73,  -73,  -73,  -73,  -73,  -73
    },

    {
       45,  -74,  -74,  -74,  -74,  -74,  -74,  -74,  -74,  -74,
      -74,  -74,  -74,  -74,  -74,  -74,  -74,  -74,  -74,  -74,
      -74,  -74,  -74,  -74,  -74,  -74,  -74,  -74,  -74,  -74,
      -74,  -74,  -74,  -74,  -74,  -74,  -74,  -74,  -74,  -74,
      -74,  -74,  -74,  -74,  -74,  -74,  -74,  -74,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -74,  -74,

      -74,  -74,  -74,  -74,  -74,  227,  228,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  229,  227,
      227,  227,  230,  231,  232,  227,  227,  233,  227,  227,
      227,  -74,  -74,  -74,  -74,  227,  -74,  227,  228,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      229,  227,  227,  227,  230,  231,  232,  227,  227,  233,
      227,  227,  227,  -74,  -74,  -74,  -74,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45,  -75,  -75,  -75,  -75,  -75,  -75,  -75,  -75,  -75,
      -75,  -75,  -75,  -75,  -75,  -75,  -75,  -75,  -75,  -75,
      -75,  -75,  -75,  -75,  -75,  -75,  -75,  -75,  -75,  -75,
      -75,  -75,  -75,  -75,  234,  -75,  -75,  -75,  -75,  235,
      -75,  -75,  -75,  -75,  -75,  -75,  -75,  -75,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -75,  -75,
      236,  -75,  -75,  -75,  -75,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  237,  227,  227,  227,  227,  227,  227,  227,
      227,  -75,  -75,  -75,  -75,  227,  -75,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  237,  227,  227,  227,  227,  227,
      227,  227,  227,  -75,  -75,  -75,  -75,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  -76,  -76,  -76,  -76,  -76,  -76,  -76,  -76,  -76,
      -76,  -76,  -76,  -76,  -76,  -76,  -76,  -76,  -76,  -76,
      -76,  -76,  -76,  -76,  -76,  -76,  -76,  -76,  -76,  -76,
      -76,  -76,  -76,  -76,  -76,  -76,  -76,  -76,  -76,  -76,

      -76,  -76,  -76,  -76,  -76,  -76,  -76,  -76,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -76,  -76,
      -76,  -76,  -76,  -76,  -76,  238,  227,  227,  227,  227,
      227,  227,  239,  227,  227,  227,  240,  227,  227,  241,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  -76,  -76,  -76,  -76,  227,  -76,  238,  227,  227,
      227,  227,  227,  227,  239,  227,  227,  227,  240,  227,
      227,  241,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  -76,  -76,  -76,  -76,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  -77,  -77,  -77,  -77,  -77,  -77,  -77,  -77,  -77,
      -77,  -77,  -77,  -77,  -77,  -77,  -77,  -77,  -77,  -77,
      -77,  -77,  -77,  -77,  -77,  -77,  -77,  -77,  -77,  -77,
      -77,  -77,  -77,  -77,  -77,  -77,  -77,  -77,  -77,  -77,
      -77,  -77,  -77,  -77,  -77,  -77,  -77,  -77,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -77,  -77,
      -77,  -77,  -77,  -77,  -77,  227,  227,  227,  227,  242,
      227,  227,  227,  243,  227,  227,  227,  227,  227,  244,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  -77,  -77,  -77,  -77,  227,  -77,  227,  227,  227,
      227,  242,  227,  227,  227,  243,  227,  227,  227,  227,
      227,  244,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  -77,  -77,  -77,  -77,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  -78,  -78,  -78,  -78,  -78,  -78,  -78,  -78,  -78,
      -78,  -78,  -78,  -78,  -78,  -78,  -78,  -78,  -78,  -78,

      -78,  -78,  -78,  -78,  -78,  -78,  -78,  -78,  -78,  -78,
      -78,  -78,  -78,  -78,  -78,  -78,  -78,  -78,  -78,  -78,
      -78,  -78,  -78,  -78,  -78,  -78,  -78,  -78,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -78,  -78,
      -78,  -78,  -78,  -78,  -78,  227,  227,  245,  227,  227,
      227,  227,  227,  227,  227,  227,  246,  247,  248,  227,
      227,  227,  227,  227,  227,  227,  249,  227,  250,  227,
      227,  -78,  -78,  -78,  -78,  227,  -78,  227,  227,  245,
      227,  227,  227,  227,  227,  227,  227,  227,  246,  247,
      248,  227,  227,  227,  227,  227,  227,  227,  249,  227,

      250,  227,  227,  -78,  -78,  -78,  -78,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  -79,  -79,  -79,  -79,  -79,  -79,  -79,  -79,  -79,
      -79,  -79,  -79,  -79,  -79,  -79,  -79,  -79,  -79,  -79,
      -79,  -79,  -79,  -79,  -79,  -79,  -79,  -79,  -79,  -79,
      -79,  -79,  -79,  -79,  -79,  -79,  -79,  -79,  -79,  -79,
      -79,  -79,  -79,  -79,  -79,  -79,  -79,  -79,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -79,  -79,

      -79,  -79,  -79,  -79,  -79,  227,  227,  227,  227,  227,
      227,  227,  227,  251,  227,  227,  227,  227,  227,  252,
      227,  227,  227,  227,  227,  253,  227,  227,  227,  227,
      227,  -79,  -79,  -79,  -79,  227,  -79,  227,  227,  227,
      227,  227,  227,  227,  227,  251,  227,  227,  227,  227,
      227,  252,  227,  227,  227,  227,  227,  253,  227,  227,
      227,  227,  227,  -79,  -79,  -79,  -79,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45,  -80,  -80,  -80,  -80,  -80,  -80,  -80,  -80,  -80,
      -80,  -80,  -80,  -80,  -80,  -80,  -80,  -80,  -80,  -80,
      -80,  -80,  -80,  -80,  -80,  -80,  -80,  -80,  -80,  -80,
      -80,  -80,  -80,  -80,  -80,  -80,  -80,  -80,  -80,  -80,
      -80,  -80,  -80,  -80,  -80,  -80,  -80,  -80,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -80,  -80,
      -80,  -80,  -80,  -80,  -80,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  254,  227,  227,  255,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  -80,  -80,  -80,  -80,  227,  -80,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  254,  227,
      227,  255,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  -80,  -80,  -80,  -80,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  -81,  -81,  -81,  -81,  -81,  -81,  -81,  -81,  -81,
      -81,  -81,  -81,  -81,  -81,  -81,  -81,  -81,  -81,  -81,
      -81,  -81,  -81,  -81,  -81,  -81,  -81,  -81,  -81,  -81,
      -81,  -81,  -81,  -81,  -81,  -81,  -81,  -81,  -81,  -81,

      -81,  -81,  -81,  -81,  -81,  -81,  -81,  -81,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -81,  -81,
      -81,  -81,  -81,  -81,  -81,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  -81,  -81,  -81,  -81,  227,  -81,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  -81,  -81,  -81,  -81,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  -82,  -82,  -82,  -82,  -82,  -82,  -82,  -82,  -82,
      -82,  -82,  -82,  -82,  -82,  -82,  -82,  -82,  -82,  -82,
      -82,  -82,  -82,  -82,  -82,  -82,  -82,  -82,  -82,  -82,
      -82,  -82,  -82,  -82,  -82,  -82,  -82,  -82,  -82,  -82,
      -82,  -82,  -82,  -82,  -82,  -82,  -82,  -82,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -82,  -82,
      -82,  -82,  -82,  -82,  -82,  227,  227,  227,  227,  227,
      256,  227,  227,  227,  227,  227,  227,  257,  258,  227,

      227,  227,  227,  259,  227,  227,  227,  227,  227,  227,
      227,  -82,  -82,  -82,  -82,  227,  -82,  227,  227,  227,
      227,  227,  256,  227,  227,  227,  227,  227,  227,  257,
      258,  227,  227,  227,  227,  259,  227,  227,  227,  227,
      227,  227,  227,  -82,  -82,  -82,  -82,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  -83,  -83,  -83,  -83,  -83,  -83,  -83,  -83,  -83,
      -83,  -83,  -83,  -83,  -83,  -83,  -83,  -83,  -83,  -83,

      -83,  -83,  -83,  -83,  -83,  -83,  -83,  -83,  -83,  -83,
      -83,  -83,  -83,  -83,  -83,  -83,  -83,  -83,  -83,  -83,
      -83,  -83,  -83,  -83,  -83,  -83,  -83,  -83,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -83,  -83,
      -83,  -83,  -83,  -83,  -83,  227,  227,  227,  227,  227,
      227,  227,  227,  260,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  -83,  -83,  -83,  -83,  227,  -83,  227,  227,  227,
      227,  227,  227,  227,  227,  260,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  -83,  -83,  -83,  -83,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  -84,  -84,  -84,  -84,  -84,  -84,  -84,  -84,  -84,
      -84,  -84,  -84,  -84,  -84,  -84,  -84,  -84,  -84,  -84,
      -84,  -84,  -84,  -84,  -84,  -84,  -84,  -84,  -84,  -84,
      -84,  -84,  -84,  -84,  -84,  -84,  -84,  -84,  -84,  -84,
      -84,  -84,  -84,  -84,  -84,  -84,  -84,  -84,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -84,  -84,

      -84,  -84,  -84,  -84,  -84,  261,  227,  227,  227,  262,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  -84,  -84,  -84,  -84,  227,  -84,  261,  227,  227,
      227,  262,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  -84,  -84,  -84,  -84,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45,  -85,  -85,  -85,  -85,  -85,  -85,  -85,  -85,  -85,
      -85,  -85,  -85,  -85,  -85,  -85,  -85,  -85,  -85,  -85,
      -85,  -85,  -85,  -85,  -85,  -85,  -85,  -85,  -85,  -85,
      -85,  -85,  -85,  -85,  -85,  -85,  -85,  -85,  -85,  -85,
      -85,  -85,  -85,  -85,  -85,  -85,  -85,  -85,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -85,  -85,
      -85,  -85,  -85,  -85,  -85,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  263,  227,  227,  227,  227,  227,  227,  227,
      227,  -85,  -85,  -85,  -85,  227,  -85,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  263,  227,  227,  227,  227,  227,
      227,  227,  227,  -85,  -85,  -85,  -85,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  -86,  -86,  -86,  -86,  -86,  -86,  -86,  -86,  -86,
      -86,  -86,  -86,  -86,  -86,  -86,  -86,  -86,  -86,  -86,
      -86,  -86,  -86,  -86,  -86,  -86,  -86,  -86,  -86,  -86,
      -86,  -86,  -86,  -86,  -86,  -86,  -86,  -86,  -86,  -86,

      -86,  -86,  -86,  -86,  -86,  -86,  -86,  -86,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -86,  -86,
      -86,  -86,  -86,  -86,  -86,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  264,  227,  227,  265,  227,  227,  227,  227,
      227,  -86,  -86,  -86,  -86,  227,  -86,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  264,  227,  227,  265,  227,  227,
      227,  227,  227,  -86,  -86,  -86,  -86,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  -87,  -87,  -87,  -87,  -87,  -87,  -87,  -87,  -87,
      -87,  -87,  -87,  -87,  -87,  -87,  -87,  -87,  -87,  -87,
      -87,  -87,  -87,  -87,  -87,  -87,  -87,  -87,  -87,  -87,
      -87,  -87,  -87,  -87,  -87,  -87,  -87,  -87,  -87,  -87,
      -87,  -87,  -87,  -87,  -87,  -87,  -87,  -87,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -87,  -87,
      -87,  -87,  -87,  -87,  -87,  227,  227,  227,  227,  266,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  -87,  -87,  -87,  -87,  227,  -87,  227,  227,  227,
      227,  266,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  -87,  -87,  -87,  -87,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  -88,  -88,  -88,  -88,  -88,  -88,  -88,  -88,  -88,
      -88,  -88,  -88,  -88,  -88,  -88,  -88,  -88,  -88,  -88,

      -88,  -88,  -88,  -88,  -88,  -88,  -88,  -88,  -88,  -88,
      -88,  -88,  -88,  -88,  -88,  -88,  -88,  -88,  -88,  -88,
      -88,  -88,  -88,  -88,  -88,  -88,  -88,  -88,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -88,  -88,
      -88,  -88,  -88,  -88,  -88,  227,  227,  227,  227,  227,
      227,  227,  267,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  268,  227,  227,  269,  227,  227,
      227,  -88,  -88,  -88,  -88,  227,  -88,  227,  227,  227,
      227,  227,  227,  227,  267,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  268,  227,  227,  269,

      227,  227,  227,  -88,  -88,  -88,  -88,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  -89,  -89,  -89,  -89,  -89,  -89,  -89,  -89,  -89,
      -89,  -89,  -89,  -89,  -89,  -89,  -89,  -89,  -89,  -89,
      -89,  -89,  -89,  -89,  -89,  -89,  -89,  -89,  -89,  -89,
      -89,  -89,  -89,  -89,  -89,  -89,  -89,  -89,  -89,  -89,
      -89,  -89,  -89,  -89,  -89,  -89,  -89,  -89,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -89,  -89,

      -89,  -89,  -89,  -89,  -89,  227,  227,  227,  227,  227,
      227,  227,  270,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  271,  227,  227,  272,  227,  227,  227,  273,
      227,  -89,  -89,  -89,  -89,  227,  -89,  227,  227,  227,
      227,  227,  227,  227,  270,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  271,  227,  227,  272,  227,  227,
      227,  273,  227,  -89,  -89,  -89,  -89,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45,  -90,  -90,  -90,  -90,  -90,  -90,  -90,  -90,  -90,
      -90,  -90,  -90,  -90,  -90,  -90,  -90,  -90,  -90,  -90,
      -90,  -90,  -90,  -90,  -90,  -90,  -90,  -90,  -90,  -90,
      -90,  -90,  -90,  -90,  -90,  -90,  -90,  -90,  -90,  -90,
      -90,  -90,  -90,  -90,  -90,  -90,  -90,  -90,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -90,  -90,
      -90,  -90,  -90,  -90,  -90,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  274,  227,
      227,  227,  227,  275,  227,  227,  227,  227,  227,  227,
      227,  -90,  -90,  -90,  -90,  227,  -90,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      274,  227,  227,  227,  227,  275,  227,  227,  227,  227,
      227,  227,  227,  -90,  -90,  -90,  -90,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  -91,  -91,  -91,  -91,  -91,  -91,  -91,  -91,  -91,
      -91,  -91,  -91,  -91,  -91,  -91,  -91,  -91,  -91,  -91,
      -91,  -91,  -91,  -91,  -91,  -91,  -91,  -91,  -91,  -91,
      -91,  -91,  -91,  -91,  -91,  -91,  -91,  -91,  -91,  -91,

      -91,  -91,  -91,  -91,  -91,  -91,  -91,  -91,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -91,  -91,
      -91,  -91,  -91,  -91,  -91,  276,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  -91,  -91,  -91,  -91,  227,  -91,  276,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  -91,  -91,  -91,  -91,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  -92,  -92,  -92,  -92,  -92,  -92,  -92,  -92,  -92,
      -92,  -92,  -92,  -92,  -92,  -92,  -92,  -92,  -92,  -92,
      -92,  -92,  -92,  -92,  -92,  -92,  -92,  -92,  -92,  -92,
      -92,  -92,  -92,  -92,  -92,  -92,  -92,  -92,  -92,  -92,
      -92,  -92,  -92,  -92,  -92,  -92,  -92,  -92,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -92,  -92,
      -92,  -92,  -92,  -92,  -92,  227,  227,  227,  227,  227,
      227,  227,  277,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  -92,  -92,  -92,  -92,  227,  -92,  227,  227,  227,
      227,  227,  227,  227,  277,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  -92,  -92,  -92,  -92,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  -93,  -93,  -93,  -93,  -93,  -93,  -93,  -93,  -93,
      -93,  -93,  -93,  -93,  -93,  -93,  -93,  -93,  -93,  -93,

      -93,  -93,  -93,  -93,  -93,  -93,  -93,  -93,  -93,  -93,
      -93,  -93,  -93,  -93,  -93,  -93,  -93,  -93,  -93,  -93,
      -93,  -93,  -93,  -93,  -93,  -93,  -93,  -93,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -93,  -93,
      -93,  -93,  -93,  -93,  -93,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  278,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  -93,  -93,  -93,  -93,  227,  -93,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  278,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  -93,  -93,  -93,  -93,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  -94,  -94,  -94,  -94,  -94,  -94,  -94,  -94,  -94,
      -94,  -94,  -94,  -94,  -94,  -94,  -94,  -94,  -94,  -94,
      -94,  -94,  -94,  -94,  -94,  -94,  -94,  -94,  -94,  -94,
      -94,  -94,  -94,  -94,  -94,  -94,  -94,  -94,  -94,  -94,
      -94,  -94,  -94,  -94,  -94,  -94,  -94,  -94,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -94,  -94,

      -94,  -94,  -94,  -94,  -94,  227,  227,  227,  227,  227,
      227,  227,  227,  279,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  -94,  -94,  -94,  -94,  227,  -94,  227,  227,  227,
      227,  227,  227,  227,  227,  279,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  -94,  -94,  -94,  -94,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,

      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,

      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,  -95,
      -95,  -95,  -95,  -95,  -95,  -95
    },

    {
       45,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,

      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  280,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,

      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,

      -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,  -96,
      -96,  -96,  -96,  -96,  -96,  -96
    },

    {
       45,  -97,  -97,  -97,  -97,  -97,  -97,  -97,  -97,  -97,
      -97,  -97,  -97,  -97,  -97,  -97,  -97,  -97,  -97,  -97,
      -97,  -97,  -97,  -97,  -97,  -97,  -97,  -97,  -97,  -97,
      -97,  -97,  -97,  -97,  -97,  -97,  -97,  -97,  -97,  -97,
      -97,  -97,  -97,  -97,  -97,  -97,  -97,  -97,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  -97,  -97,
      -97,  -97,  -97,  -97,  -97,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  -97,  -97,  -97,  -97,  281,  -97,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  -97,  -97,  -97,  -97,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,

      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,

      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,

      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,  -98,
      -98,  -98,  -98,  -98,  -98,  -98
    },

    {
       45,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,

      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,

      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,  -99,
      -99,  -99,  -99,  -99,  -99,  -99

    },

    {
       45, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100,  282, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,

     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100,  283, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,

     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
     -100, -100, -100, -100, -100, -100
    },

    {
       45, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,

     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101,  284, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,

     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,

     -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
     -101, -101, -101, -101, -101, -101
    },

    {
       45,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285, -102,  285,  286,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  287,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  288,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285
    },

    {
       45, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,

     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,

     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,

     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
     -103, -103, -103, -103, -103, -103
    },

    {
       45,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  290,  289,  291,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,

      289,  289,  289,  289,  289,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  289,  293,  289,  289,  292,  289,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  294,  289,  289,  289,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,

      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292

    },

    {
       45,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285
    },

    {
       45,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  290,  285,  295,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  287,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  296,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285
    },

    {
       45,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  298,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  299,  297,  297,  297, -107,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  300,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297
    },

    {
       45,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,

      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  302,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  301,  303,  301,  301,  292,  304,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,

      292,  292,  292,  294,  301,  301,  301,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,

      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292
    },

    {
       45,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297

    },

    {
       45, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,

     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,

     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110, -110, -110, -110, -110,
     -110, -110, -110, -110, -110, -110
    },

    {
       45,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  295,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  299,  297,  297,  297,  304,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  305,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297
    },

    {
       45, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,

     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,

     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112, -112, -112, -112, -112,
     -112, -112, -112, -112, -112, -112
    },

    {
       45, -113, -113, -113, -113, -113, -113, -113, -113, -113,
     -113, -113, -113, -113, -113, -113, -113, -113, -113, -113,

     -113, -113, -113, -113, -113, -113, -113, -113, -113, -113,
     -113, -113, -113, -113, -113, -113, -113, -113, -113, -113,
     -113, -113, -113, -113, -113, -113, -113, -113, -113, -113,
     -113, -113, -113, -113, -113, -113, -113, -113, -113, -113,
     -113, -113, -113, -113, -113,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292, -113, -113, -113, -113,  292, -113,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,

      292,  292,  292,  294, -113, -113, -113,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,

      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292
    },

    {
       45, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114,  295, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,

     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,

     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114, -114, -114, -114, -114,
     -114, -114, -114, -114, -114, -114

    },

    {
       45, -115, -115, -115, -115, -115, -115, -115, -115, -115,
     -115, -115, -115, -115, -115, -115, -115, -115, -115, -115,
     -115, -115, -115, -115, -115, -115, -115, -115, -115, -115,
     -115, -115, -115, -115, -115, -115, -115, -115, -115, -115,
     -115, -115, -115, -115, -115, -115, -115, -115,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306, -115, -115,
     -115, -115, -115, -115, -115,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306, -115, -115, -115, -115,  306, -115,  306,  306,  306,

      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306, -115, -115, -115, -115,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,

      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306
    },

    {
       45, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,

     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,

     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,

     -116, -116, -116, -116, -116, -116, -116, -116, -116, -116,
     -116, -116, -116, -116, -116, -116
    },

    {
       45, -117, -117, -117, -117, -117, -117, -117, -117,  307,
      307, -117, -117,  307, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117,  307, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,

     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,

     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
     -117, -117, -117, -117, -117, -117
    },

    {
       45, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,

     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118,  308, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,

     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,

     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
     -118, -118, -118, -118, -118, -118
    },

    {
       45, -119, -119, -119, -119, -119, -119, -119, -119, -119,
     -119, -119, -119, -119, -119, -119, -119, -119, -119, -119,
     -119, -119, -119, -119, -119, -119, -119, -119, -119, -119,
     -119, -119, -119, -119, -119, -119, -119, -119, -119, -119,
     -119, -119, -119, -119, -119, -119, -119, -119,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309, -119, -119,

     -119, -119, -119, -119, -119,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309, -119, -119, -119, -119,  309, -119,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309, -119, -119, -119, -119,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,

      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309

    },

    {
       45, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,

     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,

     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
     -120, -120, -120, -120, -120, -120
    },

    {
       45, -121, -121, -121, -121, -121, -121, -121, -121, -121,
     -121, -121, -121, -121, -121, -121, -121, -121, -121, -121,
     -121, -121, -121, -121, -121, -121, -121, -121, -121, -121,
     -121, -121, -121, -121, -121, -121, -121, -121, -121, -121,

     -121, -121, -121, -121, -121, -121, -121, -121,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310, -121, -121,
     -121, -121, -121, -121, -121,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310, -121, -121, -121, -121,  310, -121,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310, -121, -121, -121, -121,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,

      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,

      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310
    },

    {
       45, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,

     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,

     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
     -122, -122, -122, -122, -122, -122
    },

    {
       45, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,

     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,

     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,

     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
     -123, -123, -123, -123, -123, -123
    },

    {
       45, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,

     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,

     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124, -124, -124, -124, -124,
     -124, -124, -124, -124, -124, -124

    },

    {
       45, -125, -125, -125, -125, -125, -125, -125, -125, -125,
     -125, -125, -125, -125, -125, -125, -125, -125, -125, -125,
     -125, -125, -125, -125, -125, -125, -125, -125, -125, -125,
     -125, -125, -125, -125, -125, -125, -125, -125, -125, -125,
     -125, -125, -125, -125, -125, -125, -125, -125, -125, -125,
     -125, -125, -125, -125, -125, -125, -125, -125, -125, -125,
     -125, -125, -125, -125, -125,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179, -125, -125, -125, -125,  179, -125,  179,  179,  179,

      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179, -125, -125, -125, -125,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,

      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179
    },

    {
       45, -126, -126, -126, -126, -126, -126, -126, -126, -126,
     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,
     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,
     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,

     -126, -126, -126, -126, -126, -126, -126, -126,  311,  311,
      311,  311,  311,  311,  311,  311,  311,  311, -126, -126,
     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,
     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,
     -126, -126, -126, -126, -126, -126, -126, -126,  312, -126,
     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,
     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,
     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,
      312, -126, -126, -126, -126, -126, -126, -126, -126, -126,
     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,

     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,
     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,
     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,
     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,
     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,
     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,
     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,
     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,
     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,
     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,

     -126, -126, -126, -126, -126, -126, -126, -126, -126, -126,
     -126, -126, -126, -126, -126, -126
    },

    {
       45, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127,  313,  313,
      313,  313,  313,  313,  313,  313,  313,  313, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,

     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,

     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127, -127, -127, -127, -127,
     -127, -127, -127, -127, -127, -127
    },

    {
       45, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,

     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,

     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,

     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
     -128, -128, -128, -128, -128, -128
    },

    {
       45, -129, -129, -129, -129, -129, -129, -129, -129, -129,
     -129, -129, -129, -129, -129, -129, -129, -129, -129, -129,
     -129, -129, -129, -129, -129, -129, -129, -129, -129, -129,
     -129, -129, -129, -129, -129, -129, -129, -129, -129, -129,
     -129, -129, -129, -129, -129, -129, -129, -129, -129, -129,
     -129, -129, -129, -129, -129, -129, -129, -129, -129, -129,

     -129, -129, -129, -129, -129,  314,  314,  314,  314,  314,
      314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
      314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
      314, -129, -129, -129, -129,  314, -129,  314,  314,  314,
      314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
      314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
      314,  314,  314, -129, -129, -129, -129,  314,  314,  314,
      314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
      314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
      314,  314,  314,  314,  314,  314,  314,  314,  314,  314,

      314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
      314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
      314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
      314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
      314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
      314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
      314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
      314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
      314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
      314,  314,  314,  314,  314,  314

    },

    {
       45,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315, -130,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,

      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,

      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315
    },

    {
       45, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,

     -131, -131, -131, -131, -131, -131, -131,  316, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,

     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,

     -131, -131, -131, -131, -131, -131, -131, -131, -131, -131,
     -131, -131, -131, -131, -131, -131
    },

    {
       45, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132,  317, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,

     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,

     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132, -132, -132, -132, -132,
     -132, -132, -132, -132, -132, -132
    },

    {
       45,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      319,  318,  318,  319,  318,  318,  318,  318,  318,  318,

      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  319,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  319,  319,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,

      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,

      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318
    },

    {
       45, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,

     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,

     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134, -134, -134, -134, -134,
     -134, -134, -134, -134, -134, -134

    },

    {
       45, -135, -135, -135, -135, -135, -135, -135, -135, -135,
      320, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,

     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,

     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
     -135, -135, -135, -135, -135, -135
    },

    {
       45, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,

     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136,  321, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,

     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,

     -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
     -136, -136, -136, -136, -136, -136
    },

    {
       45, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,

     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,

     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137, -137, -137, -137, -137,
     -137, -137, -137, -137, -137, -137
    },

    {
       45, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,

     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138,  321, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,

     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,

     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138, -138, -138, -138, -138,
     -138, -138, -138, -138, -138, -138
    },

    {
       45, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,

     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,

     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139, -139, -139, -139, -139,
     -139, -139, -139, -139, -139, -139

    },

    {
       45, -140, -140, -140, -140, -140, -140, -140, -140,  172,
      172, -140, -140,  172, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140,  172, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,

     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,

     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140, -140, -140, -140, -140,
     -140, -140, -140, -140, -140, -140
    },

    {
       45,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  323,  322,  322,  322,  322,  322,

      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,

      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,

      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322
    },

    {
       45, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,

     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,

     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
     -142, -142, -142, -142, -142, -142
    },

    {
       45, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,

     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143,  205,  205,
      205,  205,  205,  205,  205,  205,  205,  205, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,

     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,

     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
     -143, -143, -143, -143, -143, -143
    },

    {
       45, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144,  207, -144, -144, -144, -144,  208, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,

     -144, -144,  324, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,

     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144, -144, -144, -144, -144,
     -144, -144, -144, -144, -144, -144

    },

    {
       45, -145, -145, -145, -145, -145, -145, -145, -145, -145,
     -145, -145, -145, -145, -145, -145, -145, -145, -145, -145,
     -145, -145, -145, -145, -145, -145, -145, -145, -145, -145,
     -145, -145, -145, -145, -145, -145, -145, -145, -145, -145,
     -145, -145, -145, -145, -145, -145,  210, -145,  211,  211,
      211,  211,  211,  211,  211,  211,  211,  211, -145, -145,
     -145, -145, -145, -145, -145, -145, -145, -145, -145,  212,
     -145, -145, -145, -145, -145, -145, -145, -145, -145, -145,
     -145, -145, -145, -145, -145, -145, -145, -145,  213, -145,
     -145, -145, -145, -145, -145, -145, -145, -145, -145, -145,

     -145,  212, -145, -145, -145, -145, -145, -145, -145, -145,
     -145, -145, -145, -145, -145, -145, -145, -145, -145, -145,
      213, -145, -145, -145, -145, -145, -145, -145, -145, -145,
     -145, -145, -145, -145, -145, -145, -145, -145, -145, -145,
     -145, -145, -145, -145, -145, -145, -145, -145, -145, -145,
     -145, -145, -145, -145, -145, -145, -145, -145, -145, -145,
     -145, -145, -145, -145, -145, -145, -145, -145, -145, -145,
     -145, -145, -145, -145, -145, -145, -145, -145, -145, -145,
     -145, -145, -145, -145, -145, -145, -145, -145, -145, -145,
     -145, -145, -145, -145, -145, -145, -145, -145, -145, -145,

     -145, -145, -145, -145, -145, -145, -145, -145, -145, -145,
     -145, -145, -145, -145, -145, -145, -145, -145, -145, -145,
     -145, -145, -145, -145, -145, -145, -145, -145, -145, -145,
     -145, -145, -145, -145, -145, -145, -145, -145, -145, -145,
     -145, -145, -145, -145, -145, -145, -145, -145, -145, -145,
     -145, -145, -145, -145, -145, -145
    },

    {
       45, -146, -146, -146, -146, -146, -146, -146, -146, -146,
     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,
     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,
     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,

     -146, -146, -146, -146, -146, -146,  210, -146,  211,  211,
      211,  211,  211,  211,  211,  211,  211,  211, -146, -146,
     -146, -146, -146, -146, -146, -146, -146, -146, -146,  212,
     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,
     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,
     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,
     -146,  212, -146, -146, -146, -146, -146, -146, -146, -146,
     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,
     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,
     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,

     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,
     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,
     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,
     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,
     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,
     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,
     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,
     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,
     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,
     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,

     -146, -146, -146, -146, -146, -146, -146, -146, -146, -146,
     -146, -146, -146, -146, -146, -146
    },

    {
       45, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,

     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,

     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147, -147, -147, -147, -147,
     -147, -147, -147, -147, -147, -147
    },

    {
       45, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,

     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,

     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,

     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
     -148, -148, -148, -148, -148, -148
    },

    {
       45, -149, -149, -149, -149, -149, -149, -149, -149, -149,
     -149, -149, -149, -149, -149, -149, -149, -149, -149, -149,
     -149, -149, -149, -149, -149, -149, -149, -149, -149, -149,
     -149, -149, -149, -149, -149, -149, -149, -149, -149, -149,
     -149, -149, -149, -149, -149,  325, -149, -149,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  325, -149,

     -149, -149, -149, -149, -149,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326, -149, -149, -149, -149,  326, -149,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326, -149, -149, -149, -149,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,

      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326

    },

    {
       45, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,

     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,

     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150, -150, -150, -150, -150,
     -150, -150, -150, -150, -150, -150
    },

    {
       45, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,

     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,

     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,

     -151, -151, -151, -151, -151, -151, -151, -151, -151, -151,
     -151, -151, -151, -151, -151, -151
    },

    {
       45, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,

     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,

     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152, -152, -152, -152, -152,
     -152, -152, -152, -152, -152, -152
    },

    {
       45, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,

     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,

     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,

     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153, -153, -153, -153, -153,
     -153, -153, -153, -153, -153, -153
    },

    {
       45, -154, -154, -154, -154, -154, -154, -154, -154, -154,
     -154, -154, -154, -154, -154, -154, -154, -154, -154, -154,
     -154, -154, -154, -154, -154, -154, -154, -154, -154, -154,
     -154, -154, -154, -154, -154, -154, -154, -154, -154, -154,
     -154, -154, -154, -154, -154,  327, -154, -154,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  327, -154,

     -154, -154, -154, -154, -154,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328, -154, -154, -154, -154,  328, -154,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328, -154, -154, -154, -154,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,

      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328

    },

    {
       45,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
     -155,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,

      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329, -155,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,

      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329
    },

    {
       45, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156,  330, -156, -156, -156, -156, -156, -156,

     -156, -156, -156, -156, -156, -156, -156,  331, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,

     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,

     -156, -156, -156, -156, -156, -156, -156, -156, -156, -156,
     -156, -156, -156, -156, -156, -156
    },

    {
       45, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,

     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,

     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157, -157, -157, -157, -157,
     -157, -157, -157, -157, -157, -157
    },

    {
       45,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,

      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332, -158,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,

      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,

      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332
    },

    {
       45, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159,  333, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,

     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,

     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159, -159, -159, -159, -159,
     -159, -159, -159, -159, -159, -159

    },

    {
       45,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334, -160,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      335,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,

      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,

      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334
    },

    {
       45,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160, -161,  160,  160,

      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
     -161,  160,  160, -161,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160, -161,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160, -161,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,

      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,

      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160
    },

    {
       45,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      163,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,

      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,

      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162
    },

    {
       45, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,

     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,

     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,

     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163, -163, -163, -163, -163,
     -163, -163, -163, -163, -163, -163
    },

    {
       45,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160, -164,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,

      161,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,

      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160

    },

    {
       45, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165,  336, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,

     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,

     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165, -165, -165, -165, -165,
     -165, -165, -165, -165, -165, -165
    },

    {
       45, -166, -166, -166, -166, -166, -166, -166, -166, -166,
     -166, -166, -166, -166, -166, -166, -166, -166, -166, -166,
     -166, -166, -166, -166, -166, -166, -166, -166, -166, -166,
     -166, -166, -166, -166, -166, -166, -166, -166, -166, -166,

     -166, -166, -166, -166, -166, -166, -166, -166, -166, -166,
     -166, -166, -166, -166, -166, -166, -166, -166, -166, -166,
     -166,  336, -166, -166, -166, -166, -166, -166, -166, -166,
     -166, -166,  337, -166, -166, -166, -166, -166, -166, -166,
      338, -166, -166, -166, -166, -166, -166, -166, -166, -166,
     -166, -166, -166, -166, -166, -166, -166, -166, -166, -166,
     -166, -166, -166, -166,  337, -166, -166, -166, -166, -166,
     -166, -166,  338, -166, -166, -166, -166, -166, -166, -166,
     -166, -166, -166, -166, -166, -166, -166, -166, -166, -166,
     -166, -166, -166, -166, -166, -166, -166, -166, -166, -166,

     -166, -166, -166, -166, -166, -166, -166, -166, -166, -166,
     -166, -166, -166, -166, -166, -166, -166, -166, -166, -166,
     -166, -166, -166, -166, -166, -166, -166, -166, -166, -166,
     -166, -166, -166, -166, -166, -166, -166, -166, -166, -166,
     -166, -166, -166, -166, -166, -166, -166, -166, -166, -166,
     -166, -166, -166, -166, -166, -166, -166, -166, -166, -166,
     -166, -166, -166, -166, -166, -166, -166, -166, -166, -166,
     -166, -166, -166, -166, -166, -166, -166, -166, -166, -166,
     -166, -166, -166, -166, -166, -166, -166, -166, -166, -166,
     -166, -166, -166, -166, -166, -166, -166, -166, -166, -166,

     -166, -166, -166, -166, -166, -166, -166, -166, -166, -166,
     -166, -166, -166, -166, -166, -166
    },

    {
       45, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167,  339, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,

     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167,  339,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,

     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167, -167, -167, -167, -167,
     -167, -167, -167, -167, -167, -167
    },

    {
       45,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,

      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      341,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,

      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,

      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340
    },

    {
       45,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168, -169,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,

     -169,  168,  168, -169,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168, -169,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168, -169,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,

      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168

    },

    {
       45,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      169,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,

      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,

      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168,  168,  168,  168,  168,
      168,  168,  168,  168,  168,  168
    },

    {
       45, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,

     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171, -171,  339, -171, -171,
     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171, -171, -171, -171,  339,
     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,

     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,

     -171, -171, -171, -171, -171, -171, -171, -171, -171, -171,
     -171, -171, -171, -171, -171, -171
    },

    {
       45, -172, -172, -172, -172, -172, -172, -172, -172,  172,
      172, -172, -172,  172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172,  172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,

     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,

     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172, -172, -172, -172, -172,
     -172, -172, -172, -172, -172, -172
    },

    {
       45, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,

     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173,  342, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,

     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,

     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173, -173, -173, -173, -173,
     -173, -173, -173, -173, -173, -173
    },

    {
       45,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  175,  174,  176,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,

      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  177,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  178,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,

      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174

    },

    {
       45, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,

     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,

     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175, -175, -175, -175, -175,
     -175, -175, -175, -175, -175, -175
    },

    {
       45,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  175,  343,  176,  343,  343,  343,

      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343, -176, -176, -176, -176, -176,
     -176, -176, -176, -176, -176, -176, -176, -176, -176, -176,
     -176, -176, -176, -176, -176, -176, -176, -176, -176, -176,
     -176,  343,  344,  343,  343, -176,  343, -176, -176, -176,
     -176, -176, -176, -176, -176, -176, -176, -176, -176, -176,
     -176, -176, -176, -176, -176, -176, -176, -176, -176, -176,
     -176, -176, -176, -176,  343,  343,  343, -176, -176, -176,
     -176, -176, -176, -176, -176, -176, -176, -176, -176, -176,

     -176, -176, -176, -176, -176, -176, -176, -176, -176, -176,
     -176, -176, -176, -176, -176, -176, -176, -176, -176, -176,
     -176, -176, -176, -176, -176, -176, -176, -176, -176, -176,
     -176, -176, -176, -176, -176, -176, -176, -176, -176, -176,
     -176, -176, -176, -176, -176, -176, -176, -176, -176, -176,
     -176, -176, -176, -176, -176, -176, -176, -176, -176, -176,
     -176, -176, -176, -176, -176, -176, -176, -176, -176, -176,
     -176, -176, -176, -176, -176, -176, -176, -176, -176, -176,
     -176, -176, -176, -176, -176, -176, -176, -176, -176, -176,
     -176, -176, -176, -176, -176, -176, -176, -176, -176, -176,

     -176, -176, -176, -176, -176, -176, -176, -176, -176, -176,
     -176, -176, -176, -176, -176, -176
    },

    {
       45,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,

      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,

      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174
    },

    {
       45,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,

      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  175,  174, -178,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  177,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,

      174,  174,  174,  178,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,

      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174
    },

    {
       45, -179, -179, -179, -179, -179, -179, -179, -179, -179,
     -179, -179, -179, -179, -179, -179, -179, -179, -179, -179,
     -179, -179, -179, -179, -179, -179, -179, -179, -179, -179,
     -179, -179, -179, -179, -179, -179, -179, -179, -179, -179,
     -179, -179, -179, -179, -179, -179, -179, -179,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345, -179, -179,

     -179, -179, -179, -179, -179,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345, -179, -179, -179, -179,  345, -179,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345, -179, -179, -179, -179,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,

      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345

    },

    {
       45, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,

     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,

     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180, -180, -180, -180, -180,
     -180, -180, -180, -180, -180, -180
    },

    {
       45, -181, -181, -181, -181, -181, -181, -181, -181, -181,
      346, -181, -181,  347, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,

     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,

     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,

     -181, -181, -181, -181, -181, -181, -181, -181, -181, -181,
     -181, -181, -181, -181, -181, -181
    },

    {
       45, -182, -182, -182, -182, -182, -182, -182, -182, -182,
     -182, -182, -182, -182, -182, -182, -182, -182, -182, -182,
     -182, -182, -182, -182, -182, -182, -182, -182, -182, -182,
     -182, -182, -182, -182, -182, -182, -182, -182, -182, -182,
     -182, -182, -182, -182, -182,  348, -182, -182,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  348, -182,
     -182, -182, -182, -182, -182,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,

      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349, -182, -182, -182, -182,  349, -182,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349, -182, -182, -182, -182,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,

      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349
    },

    {
       45, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,

     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,

     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,

     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183, -183, -183, -183, -183,
     -183, -183, -183, -183, -183, -183
    },

    {
       45, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,

     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,

     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
     -184, -184, -184, -184, -184, -184

    },

    {
       45,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  186,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  187,  185,  185,  185,  185,  185,  185,  185,

      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,

      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185
    },

    {
       45, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,

     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,

     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,

     -186, -186, -186, -186, -186, -186, -186, -186, -186, -186,
     -186, -186, -186, -186, -186, -186
    },

    {
       45,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,

      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,

      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185
    },

    {
       45, -188, -188, -188, -188, -188, -188, -188, -188,  188,
     -188, -188, -188, -188, -188, -188, -188, -188, -188, -188,

     -188, -188, -188, -188, -188, -188, -188, -188, -188, -188,
     -188, -188,  188, -188, -188, -188, -188, -188, -188, -188,
     -188, -188, -188, -188, -188, -188, -188, -188, -188, -188,
     -188, -188, -188, -188, -188, -188, -188, -188, -188, -188,
     -188, -188, -188, -188, -188,  189,  190, -188,  191, -188,
      192, -188, -188,  193, -188, -188, -188, -188, -188,  194,
     -188, -188,  195,  196, -188,  197, -188, -188, -188, -188,
     -188, -188, -188, -188, -188, -188, -188,  189,  190, -188,
      191, -188,  192, -188, -188,  193, -188, -188, -188, -188,
     -188,  194, -188, -188,  195,  196, -188,  197, -188, -188,

     -188, -188, -188, -188, -188, -188, -188, -188, -188, -188,
     -188, -188, -188, -188, -188, -188, -188, -188, -188, -188,
     -188, -188, -188, -188, -188, -188, -188, -188, -188, -188,
     -188, -188, -188, -188, -188, -188, -188, -188, -188, -188,
     -188, -188, -188, -188, -188, -188, -188, -188, -188, -188,
     -188, -188, -188, -188, -188, -188, -188, -188, -188, -188,
     -188, -188, -188, -188, -188, -188, -188, -188, -188, -188,
     -188, -188, -188, -188, -188, -188, -188, -188, -188, -188,
     -188, -188, -188, -188, -188, -188, -188, -188, -188, -188,
     -188, -188, -188, -188, -188, -188, -188, -188, -188, -188,

     -188, -188, -188, -188, -188, -188, -188, -188, -188, -188,
     -188, -188, -188, -188, -188, -188, -188, -188, -188, -188,
     -188, -188, -188, -188, -188, -188, -188, -188, -188, -188,
     -188, -188, -188, -188, -188, -188
    },

    {
       45, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,

     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189,  350, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189,  350, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,

     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189, -189, -189, -189, -189,
     -189, -189, -189, -189, -189, -189

    },

    {
       45, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190,  351, -190, -190, -190, -190, -190,  352,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,

     -190, -190, -190, -190, -190,  351, -190, -190, -190, -190,
     -190,  352, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,

     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190, -190, -190, -190, -190,
     -190, -190, -190, -190, -190, -190
    },

    {
       45, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,

     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191, -191, -191, -191,  353,
     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191,  353, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,

     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,

     -191, -191, -191, -191, -191, -191, -191, -191, -191, -191,
     -191, -191, -191, -191, -191, -191
    },

    {
       45, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192,  354, -192, -192, -192,

     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192,  354, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,

     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192, -192, -192, -192, -192,
     -192, -192, -192, -192, -192, -192
    },

    {
       45, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,

     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193, -193, -193,  355, -193,
     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
      355, -193, -193, -193, -193, -193, -193, -193, -193, -193,

     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,

     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193, -193, -193, -193, -193,
     -193, -193, -193, -193, -193, -193
    },

    {
       45, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,

     -194, -194, -194, -194, -194, -194,  356, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194,  356, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,

     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194, -194, -194, -194, -194,
     -194, -194, -194, -194, -194, -194

    },

    {
       45, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195,  357,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,

     -195,  357, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,

     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195, -195, -195, -195, -195,
     -195, -195, -195, -195, -195, -195
    },

    {
       45, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,

     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196,  358, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196,  358, -196, -196, -196,
     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,

     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,

     -196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
     -196, -196, -196, -196, -196, -196
    },

    {
       45, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197,  359, -197,

     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
      359, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,

     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197, -197, -197, -197, -197,
     -197, -197, -197, -197, -197, -197
    },

    {
       45, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,

     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,

     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,

     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198, -198, -198, -198, -198,
     -198, -198, -198, -198, -198, -198
    },

    {
       45, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,

     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,

     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199, -199, -199, -199, -199,
     -199, -199, -199, -199, -199, -199

    },

    {
       45, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,

     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,

     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200, -200, -200, -200, -200,
     -200, -200, -200, -200, -200, -200
    },

    {
       45, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,

     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,

     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,

     -201, -201, -201, -201, -201, -201, -201, -201, -201, -201,
     -201, -201, -201, -201, -201, -201
    },

    {
       45, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,

     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,

     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202, -202, -202, -202, -202,
     -202, -202, -202, -202, -202, -202
    },

    {
       45, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,

     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,

     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,

     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203, -203, -203, -203, -203,
     -203, -203, -203, -203, -203, -203
    },

    {
       45, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204,  360, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,

     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,

     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204, -204, -204, -204, -204,
     -204, -204, -204, -204, -204, -204

    },

    {
       45, -205, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205,  205,  205,
      205,  205,  205,  205,  205,  205,  205,  205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205, -205,  212,
     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,

     -205,  212, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,

     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205, -205, -205, -205, -205,
     -205, -205, -205, -205, -205, -205
    },

    {
       45, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,

     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,

     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,

     -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
     -206, -206, -206, -206, -206, -206
    },

    {
       45, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207,  361, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,

     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,

     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207, -207, -207, -207, -207,
     -207, -207, -207, -207, -207, -207
    },

    {
       45, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,

     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,

     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,

     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208, -208, -208, -208, -208,
     -208, -208, -208, -208, -208, -208
    },

    {
       45, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,

     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,

     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209, -209, -209, -209, -209,
     -209, -209, -209, -209, -209, -209

    },

    {
       45, -210, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210,  362,  362,
      362,  362,  362,  362,  362,  362,  362,  362, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210, -210,  212,
     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,

     -210,  212, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,

     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210, -210, -210, -210, -210,
     -210, -210, -210, -210, -210, -210
    },

    {
       45, -211, -211, -211, -211, -211, -211, -211, -211, -211,
     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,
     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,
     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,

     -211, -211, -211, -211, -211, -211,  210, -211,  211,  211,
      211,  211,  211,  211,  211,  211,  211,  211, -211, -211,
     -211, -211, -211, -211, -211, -211, -211, -211, -211,  212,
     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,
     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,
     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,
     -211,  212, -211, -211, -211, -211, -211, -211, -211, -211,
     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,
     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,
     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,

     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,
     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,
     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,
     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,
     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,
     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,
     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,
     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,
     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,
     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,

     -211, -211, -211, -211, -211, -211, -211, -211, -211, -211,
     -211, -211, -211, -211, -211, -211
    },

    {
       45, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212,  363, -212,  363, -212, -212,  364,  364,
      364,  364,  364,  364,  364,  364,  364,  364, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,

     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,

     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212, -212, -212, -212, -212,
     -212, -212, -212, -212, -212, -212
    },

    {
       45, -213, -213, -213, -213, -213, -213, -213, -213, -213,
     -213, -213, -213, -213, -213, -213, -213, -213, -213, -213,

     -213, -213, -213, -213, -213, -213, -213, -213, -213, -213,
     -213, -213, -213, -213, -213, -213, -213, -213, -213, -213,
     -213, -213, -213, -213, -213, -213, -213, -213,  365,  365,
      365,  365,  365,  365,  365,  365,  365,  365, -213, -213,
     -213, -213, -213, -213, -213,  365,  365,  365,  365,  365,
      365, -213, -213, -213, -213, -213, -213, -213, -213, -213,
     -213, -213, -213, -213, -213, -213, -213, -213, -213, -213,
     -213, -213, -213, -213, -213, -213, -213,  365,  365,  365,
      365,  365,  365, -213, -213, -213, -213, -213, -213, -213,
     -213, -213, -213, -213, -213, -213, -213, -213, -213, -213,

     -213, -213, -213, -213, -213, -213, -213, -213, -213, -213,
     -213, -213, -213, -213, -213, -213, -213, -213, -213, -213,
     -213, -213, -213, -213, -213, -213, -213, -213, -213, -213,
     -213, -213, -213, -213, -213, -213, -213, -213, -213, -213,
     -213, -213, -213, -213, -213, -213, -213, -213, -213, -213,
     -213, -213, -213, -213, -213, -213, -213, -213, -213, -213,
     -213, -213, -213, -213, -213, -213, -213, -213, -213, -213,
     -213, -213, -213, -213, -213, -213, -213, -213, -213, -213,
     -213, -213, -213, -213, -213, -213, -213, -213, -213, -213,
     -213, -213, -213, -213, -213, -213, -213, -213, -213, -213,

     -213, -213, -213, -213, -213, -213, -213, -213, -213, -213,
     -213, -213, -213, -213, -213, -213, -213, -213, -213, -213,
     -213, -213, -213, -213, -213, -213, -213, -213, -213, -213,
     -213, -213, -213, -213, -213, -213
    },

    {
       45, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,

     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,

     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214, -214, -214, -214, -214,
     -214, -214, -214, -214, -214, -214

    },

    {
       45, -215, -215, -215, -215, -215, -215, -215, -215, -215,
     -215, -215, -215, -215, -215, -215, -215, -215, -215, -215,
     -215, -215, -215, -215, -215, -215, -215, -215, -215, -215,
     -215, -215, -215, -215, -215, -215, -215, -215, -215, -215,
     -215, -215, -215, -215, -215,  366, -215, -215,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  366, -215,
     -215, -215, -215, -215, -215,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367, -215, -215, -215, -215,  367, -215,  367,  367,  367,

      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367, -215, -215, -215, -215,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,

      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367
    },

    {
       45, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,

     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216,  368, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216,  368, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,

     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,

     -216, -216, -216, -216, -216, -216, -216, -216, -216, -216,
     -216, -216, -216, -216, -216, -216
    },

    {
       45, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
      369,  370, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,

     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,

     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217, -217, -217, -217, -217,
     -217, -217, -217, -217, -217, -217
    },

    {
       45, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,

     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,

     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,

     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218, -218, -218, -218, -218,
     -218, -218, -218, -218, -218, -218
    },

    {
       45, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,

     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,

     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219, -219, -219, -219, -219,
     -219, -219, -219, -219, -219, -219

    },

    {
       45, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,

     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,

     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220, -220, -220, -220, -220,
     -220, -220, -220, -220, -220, -220
    },

    {
       45, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,

     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221,  371, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,

     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,

     -221, -221, -221, -221, -221, -221, -221, -221, -221, -221,
     -221, -221, -221, -221, -221, -221
    },

    {
       45, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,

     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,

     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222, -222, -222, -222, -222,
     -222, -222, -222, -222, -222, -222
    },

    {
       45, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,

     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,

     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,

     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223, -223, -223, -223, -223,
     -223, -223, -223, -223, -223, -223
    },

    {
       45, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,

     -224,  372, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,

     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224, -224, -224, -224, -224,
     -224, -224, -224, -224, -224, -224

    },

    {
       45, -225, -225, -225, -225, -225, -225, -225, -225, -225,
     -225, -225, -225, -225, -225, -225, -225, -225, -225, -225,
     -225, -225, -225, -225, -225, -225, -225, -225, -225, -225,
     -225, -225, -225, -225, -225, -225, -225, -225, -225, -225,
     -225, -225, -225, -225, -225, -225, -225, -225, -225, -225,
     -225, -225, -225, -225, -225, -225, -225, -225, -225, -225,
     -225, -225, -225, -225, -225,  373,  373,  373,  373,  373,
      373,  373,  373,  373,  373,  373,  373,  373,  373,  373,
      373,  373,  373,  373,  373,  373,  373,  373,  373,  373,
      373, -225, -225, -225, -225,  373, -225,  373,  373,  373,

      373,  373,  373,  373,  373,  373,  373,  373,  373,  373,
      373,  373,  373,  373,  373,  373,  373,  373,  373,  373,
      373,  373,  373, -225, -225, -225, -225,  373,  373,  373,
      373,  373,  373,  373,  373,  373,  373,  373,  373,  373,
      373,  373,  373,  373,  373,  373,  373,  373,  373,  373,
      373,  373,  373,  373,  373,  373,  373,  373,  373,  373,
      373,  373,  373,  373,  373,  373,  373,  373,  373,  373,
      373,  373,  373,  373,  373,  373,  373,  373,  373,  373,
      373,  373,  373,  373,  373,  373,  373,  373,  373,  373,
      373,  373,  373,  373,  373,  373,  373,  373,  373,  373,

      373,  373,  373,  373,  373,  373,  373,  373,  373,  373,
      373,  373,  373,  373,  373,  373,  373,  373,  373,  373,
      373,  373,  373,  373,  373,  373,  373,  373,  373,  373,
      373,  373,  373,  373,  373,  373,  373,  373,  373,  373,
      373,  373,  373,  373,  373,  373,  373,  373,  373,  373,
      373,  373,  373,  373,  373,  373
    },

    {
       45, -226, -226, -226, -226, -226, -226, -226, -226, -226,
      374, -226, -226,  375, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,

     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,

     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,

     -226, -226, -226, -226, -226, -226, -226, -226, -226, -226,
     -226, -226, -226, -226, -226, -226
    },

    {
       45, -227, -227, -227, -227, -227, -227, -227, -227, -227,
     -227, -227, -227, -227, -227, -227, -227, -227, -227, -227,
     -227, -227, -227, -227, -227, -227, -227, -227, -227, -227,
     -227, -227, -227, -227, -227, -227, -227, -227, -227, -227,
     -227, -227, -227, -227, -227, -227, -227, -227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -227, -227,
     -227, -227, -227, -227, -227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -227, -227, -227, -227,  227, -227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -227, -227, -227, -227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -228, -228, -228, -228, -228, -228, -228, -228, -228,
     -228, -228, -228, -228, -228, -228, -228, -228, -228, -228,

     -228, -228, -228, -228, -228, -228, -228, -228, -228, -228,
     -228, -228, -228, -228, -228, -228, -228, -228, -228, -228,
     -228, -228, -228, -228, -228, -228, -228, -228,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -228, -228,
     -228, -228, -228, -228, -228,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  376,  227,  227,  227,  227,  227,  227,
      227, -228, -228, -228, -228,  227, -228,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  376,  227,  227,  227,  227,

      227,  227,  227, -228, -228, -228, -228,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -229, -229, -229, -229, -229, -229, -229, -229, -229,
     -229, -229, -229, -229, -229, -229, -229, -229, -229, -229,
     -229, -229, -229, -229, -229, -229, -229, -229, -229, -229,
     -229, -229, -229, -229, -229, -229, -229, -229, -229, -229,
     -229, -229, -229, -229, -229, -229, -229, -229,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -229, -229,

     -229, -229, -229, -229, -229,  227,  227,  227,  377,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -229, -229, -229, -229,  227, -229,  227,  227,  227,
      377,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -229, -229, -229, -229,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -230, -230, -230, -230, -230, -230, -230, -230, -230,
     -230, -230, -230, -230, -230, -230, -230, -230, -230, -230,
     -230, -230, -230, -230, -230, -230, -230, -230, -230, -230,
     -230, -230, -230, -230, -230, -230, -230, -230, -230, -230,
     -230, -230, -230, -230, -230, -230, -230, -230,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -230, -230,
     -230, -230, -230, -230, -230,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  378,  227,  227,  227,  227,  227,  227,  227,
      227, -230, -230, -230, -230,  227, -230,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  378,  227,  227,  227,  227,  227,
      227,  227,  227, -230, -230, -230, -230,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -231, -231, -231, -231, -231, -231, -231, -231, -231,
     -231, -231, -231, -231, -231, -231, -231, -231, -231, -231,
     -231, -231, -231, -231, -231, -231, -231, -231, -231, -231,
     -231, -231, -231, -231, -231, -231, -231, -231, -231, -231,

     -231, -231, -231, -231, -231, -231, -231, -231,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -231, -231,
     -231, -231, -231, -231, -231,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  379,
      227, -231, -231, -231, -231,  227, -231,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  379,  227, -231, -231, -231, -231,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -232, -232, -232, -232, -232, -232, -232, -232, -232,
     -232, -232, -232, -232, -232, -232, -232, -232, -232, -232,
     -232, -232, -232, -232, -232, -232, -232, -232, -232, -232,
     -232, -232, -232, -232, -232, -232, -232, -232, -232, -232,
     -232, -232, -232, -232, -232, -232, -232, -232,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -232, -232,
     -232, -232, -232, -232, -232,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  380,  227,  227,  227,  227,  227,
      227, -232, -232, -232, -232,  227, -232,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  380,  227,  227,  227,
      227,  227,  227, -232, -232, -232, -232,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -233, -233, -233, -233, -233, -233, -233, -233, -233,
     -233, -233, -233, -233, -233, -233, -233, -233, -233, -233,

     -233, -233, -233, -233, -233, -233, -233, -233, -233, -233,
     -233, -233, -233, -233, -233, -233, -233, -233, -233, -233,
     -233, -233, -233, -233, -233, -233, -233, -233,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -233, -233,
     -233, -233, -233, -233, -233,  381,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -233, -233, -233, -233,  227, -233,  381,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -233, -233, -233, -233,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  175,  174,  176,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,

      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  177,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  178,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,

      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174

    },

    {
       45,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  186,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  187,  185,  185,  185,  185,  185,  185,  185,

      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,

      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185
    },

    {
       45, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,

     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
      382, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,

     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,

     -236, -236, -236, -236, -236, -236, -236, -236, -236, -236,
     -236, -236, -236, -236, -236, -236
    },

    {
       45, -237, -237, -237, -237, -237, -237, -237, -237, -237,
     -237, -237, -237, -237, -237, -237, -237, -237, -237, -237,
     -237, -237, -237, -237, -237, -237, -237, -237, -237, -237,
     -237, -237, -237, -237, -237, -237, -237, -237, -237, -237,
     -237, -237, -237, -237, -237, -237, -237, -237,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -237, -237,
     -237, -237, -237, -237, -237,  227,  227,  227,  227,  383,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -237, -237, -237, -237,  227, -237,  227,  227,  227,
      227,  383,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -237, -237, -237, -237,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -238, -238, -238, -238, -238, -238, -238, -238, -238,
     -238, -238, -238, -238, -238, -238, -238, -238, -238, -238,

     -238, -238, -238, -238, -238, -238, -238, -238, -238, -238,
     -238, -238, -238, -238, -238, -238, -238, -238, -238, -238,
     -238, -238, -238, -238, -238, -238, -238, -238,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -238, -238,
     -238, -238, -238, -238, -238,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  384,  385,  227,  227,  227,  227,  227,
      227, -238, -238, -238, -238,  227, -238,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  384,  385,  227,  227,  227,

      227,  227,  227, -238, -238, -238, -238,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -239, -239, -239, -239, -239, -239, -239, -239, -239,
     -239, -239, -239, -239, -239, -239, -239, -239, -239, -239,
     -239, -239, -239, -239, -239, -239, -239, -239, -239, -239,
     -239, -239, -239, -239, -239, -239, -239, -239, -239, -239,
     -239, -239, -239, -239, -239, -239, -239, -239,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -239, -239,

     -239, -239, -239, -239, -239,  227,  227,  227,  227,  227,
      227,  227,  227,  386,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -239, -239, -239, -239,  227, -239,  227,  227,  227,
      227,  227,  227,  227,  227,  386,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -239, -239, -239, -239,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -240, -240, -240, -240, -240, -240, -240, -240, -240,
     -240, -240, -240, -240, -240, -240, -240, -240, -240, -240,
     -240, -240, -240, -240, -240, -240, -240, -240, -240, -240,
     -240, -240, -240, -240, -240, -240, -240, -240, -240, -240,
     -240, -240, -240, -240, -240, -240, -240, -240,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -240, -240,
     -240, -240, -240, -240, -240,  387,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  388,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -240, -240, -240, -240,  227, -240,  387,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  388,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -240, -240, -240, -240,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -241, -241, -241, -241, -241, -241, -241, -241, -241,
     -241, -241, -241, -241, -241, -241, -241, -241, -241, -241,
     -241, -241, -241, -241, -241, -241, -241, -241, -241, -241,
     -241, -241, -241, -241, -241, -241, -241, -241, -241, -241,

     -241, -241, -241, -241, -241, -241, -241, -241,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -241, -241,
     -241, -241, -241, -241, -241,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  389,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -241, -241, -241, -241,  227, -241,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      389,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -241, -241, -241, -241,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -242, -242, -242, -242, -242, -242, -242, -242, -242,
     -242, -242, -242, -242, -242, -242, -242, -242, -242, -242,
     -242, -242, -242, -242, -242, -242, -242, -242, -242, -242,
     -242, -242, -242, -242, -242, -242, -242, -242, -242, -242,
     -242, -242, -242, -242, -242, -242, -242, -242,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -242, -242,
     -242, -242, -242, -242, -242,  227,  227,  390,  227,  227,
      391,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -242, -242, -242, -242,  227, -242,  227,  227,  390,
      227,  227,  391,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -242, -242, -242, -242,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -243, -243, -243, -243, -243, -243, -243, -243, -243,
     -243, -243, -243, -243, -243, -243, -243, -243, -243, -243,

     -243, -243, -243, -243, -243, -243, -243, -243, -243, -243,
     -243, -243, -243, -243, -243, -243, -243, -243, -243, -243,
     -243, -243, -243, -243, -243, -243, -243, -243,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -243, -243,
     -243, -243, -243, -243, -243,  227,  227,  227,  227,  392,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -243, -243, -243, -243,  227, -243,  227,  227,  227,
      227,  392,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -243, -243, -243, -243,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -244, -244, -244, -244, -244, -244, -244, -244, -244,
     -244, -244, -244, -244, -244, -244, -244, -244, -244, -244,
     -244, -244, -244, -244, -244, -244, -244, -244, -244, -244,
     -244, -244, -244, -244, -244, -244, -244, -244, -244, -244,
     -244, -244, -244, -244, -244, -244, -244, -244,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -244, -244,

     -244, -244, -244, -244, -244,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -244, -244, -244, -244,  227, -244,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -244, -244, -244, -244,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -245, -245, -245, -245, -245, -245, -245, -245, -245,
     -245, -245, -245, -245, -245, -245, -245, -245, -245, -245,
     -245, -245, -245, -245, -245, -245, -245, -245, -245, -245,
     -245, -245, -245, -245, -245, -245, -245, -245, -245, -245,
     -245, -245, -245, -245, -245, -245, -245, -245,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -245, -245,
     -245, -245, -245, -245, -245,  227,  227,  227,  227,  227,
      227,  227,  393,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -245, -245, -245, -245,  227, -245,  227,  227,  227,

      227,  227,  227,  227,  393,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -245, -245, -245, -245,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -246, -246, -246, -246, -246, -246, -246, -246, -246,
     -246, -246, -246, -246, -246, -246, -246, -246, -246, -246,
     -246, -246, -246, -246, -246, -246, -246, -246, -246, -246,
     -246, -246, -246, -246, -246, -246, -246, -246, -246, -246,

     -246, -246, -246, -246, -246, -246, -246, -246,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -246, -246,
     -246, -246, -246, -246, -246,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  394,  227,  227,  227,  227,  227,  227,
      227, -246, -246, -246, -246,  227, -246,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  394,  227,  227,  227,  227,
      227,  227,  227, -246, -246, -246, -246,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -247, -247, -247, -247, -247, -247, -247, -247, -247,
     -247, -247, -247, -247, -247, -247, -247, -247, -247, -247,
     -247, -247, -247, -247, -247, -247, -247, -247, -247, -247,
     -247, -247, -247, -247, -247, -247, -247, -247, -247, -247,
     -247, -247, -247, -247, -247, -247, -247, -247,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -247, -247,
     -247, -247, -247, -247, -247,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      395,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -247, -247, -247, -247,  227, -247,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  395,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -247, -247, -247, -247,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -248, -248, -248, -248, -248, -248, -248, -248, -248,
     -248, -248, -248, -248, -248, -248, -248, -248, -248, -248,

     -248, -248, -248, -248, -248, -248, -248, -248, -248, -248,
     -248, -248, -248, -248, -248, -248, -248, -248, -248, -248,
     -248, -248, -248, -248, -248, -248, -248, -248,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -248, -248,
     -248, -248, -248, -248, -248,  227,  227,  227,  396,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  397,  227,  227,  227,  227,
      227, -248, -248, -248, -248,  227, -248,  227,  227,  227,
      396,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  397,  227,  227,

      227,  227,  227, -248, -248, -248, -248,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -249, -249, -249, -249, -249, -249, -249, -249, -249,
     -249, -249, -249, -249, -249, -249, -249, -249, -249, -249,
     -249, -249, -249, -249, -249, -249, -249, -249, -249, -249,
     -249, -249, -249, -249, -249, -249, -249, -249, -249, -249,
     -249, -249, -249, -249, -249, -249, -249, -249,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -249, -249,

     -249, -249, -249, -249, -249,  398,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -249, -249, -249, -249,  227, -249,  398,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -249, -249, -249, -249,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -250, -250, -250, -250, -250, -250, -250, -250, -250,
     -250, -250, -250, -250, -250, -250, -250, -250, -250, -250,
     -250, -250, -250, -250, -250, -250, -250, -250, -250, -250,
     -250, -250, -250, -250, -250, -250, -250, -250, -250, -250,
     -250, -250, -250, -250, -250, -250, -250, -250,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -250, -250,
     -250, -250, -250, -250, -250,  227,  227,  227,  227,  227,
      227,  227,  227,  399,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  400,  227,  227,  227,  227,  227,
      227, -250, -250, -250, -250,  227, -250,  227,  227,  227,

      227,  227,  227,  227,  227,  399,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  400,  227,  227,  227,
      227,  227,  227, -250, -250, -250, -250,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -251, -251, -251, -251, -251, -251, -251, -251, -251,
     -251, -251, -251, -251, -251, -251, -251, -251, -251, -251,
     -251, -251, -251, -251, -251, -251, -251, -251, -251, -251,
     -251, -251, -251, -251, -251, -251, -251, -251, -251, -251,

     -251, -251, -251, -251, -251, -251, -251, -251,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -251, -251,
     -251, -251, -251, -251, -251,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  401,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -251, -251, -251, -251,  227, -251,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      401,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -251, -251, -251, -251,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -252, -252, -252, -252, -252, -252, -252, -252, -252,
     -252, -252, -252, -252, -252, -252, -252, -252, -252, -252,
     -252, -252, -252, -252, -252, -252, -252, -252, -252, -252,
     -252, -252, -252, -252, -252, -252, -252, -252, -252, -252,
     -252, -252, -252, -252, -252, -252, -252, -252,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -252, -252,
     -252, -252, -252, -252, -252,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  402,  227,  227,  227,  227,  227,  227,  227,
      227, -252, -252, -252, -252,  227, -252,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  402,  227,  227,  227,  227,  227,
      227,  227,  227, -252, -252, -252, -252,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -253, -253, -253, -253, -253, -253, -253, -253, -253,
     -253, -253, -253, -253, -253, -253, -253, -253, -253, -253,

     -253, -253, -253, -253, -253, -253, -253, -253, -253, -253,
     -253, -253, -253, -253, -253, -253, -253, -253, -253, -253,
     -253, -253, -253, -253, -253, -253, -253, -253,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -253, -253,
     -253, -253, -253, -253, -253,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  403,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -253, -253, -253, -253,  227, -253,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      403,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -253, -253, -253, -253,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -254, -254, -254, -254, -254, -254, -254, -254, -254,
     -254, -254, -254, -254, -254, -254, -254, -254, -254, -254,
     -254, -254, -254, -254, -254, -254, -254, -254, -254, -254,
     -254, -254, -254, -254, -254, -254, -254, -254, -254, -254,
     -254, -254, -254, -254, -254, -254, -254, -254,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -254, -254,

     -254, -254, -254, -254, -254,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  404,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -254, -254, -254, -254,  227, -254,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  404,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -254, -254, -254, -254,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -255, -255, -255, -255, -255, -255, -255, -255, -255,
     -255, -255, -255, -255, -255, -255, -255, -255, -255, -255,
     -255, -255, -255, -255, -255, -255, -255, -255, -255, -255,
     -255, -255, -255, -255, -255, -255, -255, -255, -255, -255,
     -255, -255, -255, -255, -255, -255, -255, -255,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -255, -255,
     -255, -255, -255, -255, -255,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  405,  227,  227,  227,  227,  227,
      227, -255, -255, -255, -255,  227, -255,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  405,  227,  227,  227,
      227,  227,  227, -255, -255, -255, -255,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -256, -256, -256, -256, -256, -256, -256, -256, -256,
     -256, -256, -256, -256, -256, -256, -256, -256, -256, -256,
     -256, -256, -256, -256, -256, -256, -256, -256, -256, -256,
     -256, -256, -256, -256, -256, -256, -256, -256, -256, -256,

     -256, -256, -256, -256, -256, -256, -256, -256,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -256, -256,
     -256, -256, -256, -256, -256,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -256, -256, -256, -256,  227, -256,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -256, -256, -256, -256,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -257, -257, -257, -257, -257, -257, -257, -257, -257,
     -257, -257, -257, -257, -257, -257, -257, -257, -257, -257,
     -257, -257, -257, -257, -257, -257, -257, -257, -257, -257,
     -257, -257, -257, -257, -257, -257, -257, -257, -257, -257,
     -257, -257, -257, -257, -257, -257, -257, -257,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -257, -257,
     -257, -257, -257, -257, -257,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      406,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -257, -257, -257, -257,  227, -257,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  406,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -257, -257, -257, -257,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -258, -258, -258, -258, -258, -258, -258, -258, -258,
     -258, -258, -258, -258, -258, -258, -258, -258, -258, -258,

     -258, -258, -258, -258, -258, -258, -258, -258, -258, -258,
     -258, -258, -258, -258, -258, -258, -258, -258, -258, -258,
     -258, -258, -258, -258, -258, -258, -258, -258,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -258, -258,
     -258, -258, -258, -258, -258,  227,  227,  407,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  408,  409,  227,  227,  227,  227,  227,
      227, -258, -258, -258, -258,  227, -258,  227,  227,  407,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  408,  409,  227,  227,  227,

      227,  227,  227, -258, -258, -258, -258,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -259, -259, -259, -259, -259, -259, -259, -259, -259,
     -259, -259, -259, -259, -259, -259, -259, -259, -259, -259,
     -259, -259, -259, -259, -259, -259, -259, -259, -259, -259,
     -259, -259, -259, -259, -259, -259, -259, -259, -259, -259,
     -259, -259, -259, -259, -259, -259, -259, -259,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -259, -259,

     -259, -259, -259, -259, -259,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  410,  227,  227,  227,  227,  227,  227,
      227, -259, -259, -259, -259,  227, -259,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  410,  227,  227,  227,  227,
      227,  227,  227, -259, -259, -259, -259,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -260, -260, -260, -260, -260, -260, -260, -260, -260,
     -260, -260, -260, -260, -260, -260, -260, -260, -260, -260,
     -260, -260, -260, -260, -260, -260, -260, -260, -260, -260,
     -260, -260, -260, -260, -260, -260, -260, -260, -260, -260,
     -260, -260, -260, -260, -260, -260, -260, -260,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -260, -260,
     -260, -260, -260, -260, -260,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  411,  227,  227,  227,  227,  227,  227,
      227, -260, -260, -260, -260,  227, -260,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  411,  227,  227,  227,  227,
      227,  227,  227, -260, -260, -260, -260,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -261, -261, -261, -261, -261, -261, -261, -261, -261,
     -261, -261, -261, -261, -261, -261, -261, -261, -261, -261,
     -261, -261, -261, -261, -261, -261, -261, -261, -261, -261,
     -261, -261, -261, -261, -261, -261, -261, -261, -261, -261,

     -261, -261, -261, -261, -261, -261, -261, -261,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -261, -261,
     -261, -261, -261, -261, -261,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  412,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -261, -261, -261, -261,  227, -261,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  412,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -261, -261, -261, -261,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -262, -262, -262, -262, -262, -262, -262, -262, -262,
     -262, -262, -262, -262, -262, -262, -262, -262, -262, -262,
     -262, -262, -262, -262, -262, -262, -262, -262, -262, -262,
     -262, -262, -262, -262, -262, -262, -262, -262, -262, -262,
     -262, -262, -262, -262, -262, -262, -262, -262,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -262, -262,
     -262, -262, -262, -262, -262,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  413,  227,  227,
      227, -262, -262, -262, -262,  227, -262,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  413,
      227,  227,  227, -262, -262, -262, -262,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -263, -263, -263, -263, -263, -263, -263, -263, -263,
     -263, -263, -263, -263, -263, -263, -263, -263, -263, -263,

     -263, -263, -263, -263, -263, -263, -263, -263, -263, -263,
     -263, -263, -263, -263, -263, -263, -263, -263, -263, -263,
     -263, -263, -263, -263, -263, -263, -263, -263,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -263, -263,
     -263, -263, -263, -263, -263,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -263, -263, -263, -263,  227, -263,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -263, -263, -263, -263,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -264, -264, -264, -264, -264, -264, -264, -264, -264,
     -264, -264, -264, -264, -264, -264, -264, -264, -264, -264,
     -264, -264, -264, -264, -264, -264, -264, -264, -264, -264,
     -264, -264, -264, -264, -264, -264, -264, -264, -264, -264,
     -264, -264, -264, -264, -264, -264, -264, -264,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -264, -264,

     -264, -264, -264, -264, -264,  227,  227,  227,  227,  227,
      227,  227,  227,  414,  227,  227,  227,  227,  227,  415,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -264, -264, -264, -264,  227, -264,  227,  227,  227,
      227,  227,  227,  227,  227,  414,  227,  227,  227,  227,
      227,  415,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -264, -264, -264, -264,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -265, -265, -265, -265, -265, -265, -265, -265, -265,
     -265, -265, -265, -265, -265, -265, -265, -265, -265, -265,
     -265, -265, -265, -265, -265, -265, -265, -265, -265, -265,
     -265, -265, -265, -265, -265, -265, -265, -265, -265, -265,
     -265, -265, -265, -265, -265, -265, -265, -265,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -265, -265,
     -265, -265, -265, -265, -265,  227,  416,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -265, -265, -265, -265,  227, -265,  227,  416,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -265, -265, -265, -265,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -266, -266, -266, -266, -266, -266, -266, -266, -266,
     -266, -266, -266, -266, -266, -266, -266, -266, -266, -266,
     -266, -266, -266, -266, -266, -266, -266, -266, -266, -266,
     -266, -266, -266, -266, -266, -266, -266, -266, -266, -266,

     -266, -266, -266, -266, -266, -266, -266, -266,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -266, -266,
     -266, -266, -266, -266, -266,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  417,  227,  227,  418,  227,  227,  227,  227,  227,
      227, -266, -266, -266, -266,  227, -266,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  417,  227,  227,  418,  227,  227,  227,
      227,  227,  227, -266, -266, -266, -266,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -267, -267, -267, -267, -267, -267, -267, -267, -267,
     -267, -267, -267, -267, -267, -267, -267, -267, -267, -267,
     -267, -267, -267, -267, -267, -267, -267, -267, -267, -267,
     -267, -267, -267, -267, -267, -267, -267, -267, -267, -267,
     -267, -267, -267, -267, -267, -267, -267, -267,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -267, -267,
     -267, -267, -267, -267, -267,  419,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -267, -267, -267, -267,  227, -267,  419,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -267, -267, -267, -267,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -268, -268, -268, -268, -268, -268, -268, -268, -268,
     -268, -268, -268, -268, -268, -268, -268, -268, -268, -268,

     -268, -268, -268, -268, -268, -268, -268, -268, -268, -268,
     -268, -268, -268, -268, -268, -268, -268, -268, -268, -268,
     -268, -268, -268, -268, -268, -268, -268, -268,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -268, -268,
     -268, -268, -268, -268, -268,  420,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -268, -268, -268, -268,  227, -268,  420,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -268, -268, -268, -268,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -269, -269, -269, -269, -269, -269, -269, -269, -269,
     -269, -269, -269, -269, -269, -269, -269, -269, -269, -269,
     -269, -269, -269, -269, -269, -269, -269, -269, -269, -269,
     -269, -269, -269, -269, -269, -269, -269, -269, -269, -269,
     -269, -269, -269, -269, -269, -269, -269, -269,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -269, -269,

     -269, -269, -269, -269, -269,  227,  227,  227,  227,  227,
      227,  227,  227,  421,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -269, -269, -269, -269,  227, -269,  227,  227,  227,
      227,  227,  227,  227,  227,  421,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -269, -269, -269, -269,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -270, -270, -270, -270, -270, -270, -270, -270, -270,
     -270, -270, -270, -270, -270, -270, -270, -270, -270, -270,
     -270, -270, -270, -270, -270, -270, -270, -270, -270, -270,
     -270, -270, -270, -270, -270, -270, -270, -270, -270, -270,
     -270, -270, -270, -270, -270, -270, -270, -270,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -270, -270,
     -270, -270, -270, -270, -270,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  422,  227,  227,  227,  227,  227,  227,  227,
      227, -270, -270, -270, -270,  227, -270,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  422,  227,  227,  227,  227,  227,
      227,  227,  227, -270, -270, -270, -270,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -271, -271, -271, -271, -271, -271, -271, -271, -271,
     -271, -271, -271, -271, -271, -271, -271, -271, -271, -271,
     -271, -271, -271, -271, -271, -271, -271, -271, -271, -271,
     -271, -271, -271, -271, -271, -271, -271, -271, -271, -271,

     -271, -271, -271, -271, -271, -271, -271, -271,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -271, -271,
     -271, -271, -271, -271, -271,  423,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  424,
      227, -271, -271, -271, -271,  227, -271,  423,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  424,  227, -271, -271, -271, -271,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -272, -272, -272, -272, -272, -272, -272, -272, -272,
     -272, -272, -272, -272, -272, -272, -272, -272, -272, -272,
     -272, -272, -272, -272, -272, -272, -272, -272, -272, -272,
     -272, -272, -272, -272, -272, -272, -272, -272, -272, -272,
     -272, -272, -272, -272, -272, -272, -272, -272,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -272, -272,
     -272, -272, -272, -272, -272,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      425,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -272, -272, -272, -272,  227, -272,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  425,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -272, -272, -272, -272,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -273, -273, -273, -273, -273, -273, -273, -273, -273,
     -273, -273, -273, -273, -273, -273, -273, -273, -273, -273,

     -273, -273, -273, -273, -273, -273, -273, -273, -273, -273,
     -273, -273, -273, -273, -273, -273, -273, -273, -273, -273,
     -273, -273, -273, -273, -273, -273, -273, -273,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -273, -273,
     -273, -273, -273, -273, -273,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      426,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -273, -273, -273, -273,  227, -273,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  426,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -273, -273, -273, -273,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -274, -274, -274, -274, -274, -274, -274, -274, -274,
     -274, -274, -274, -274, -274, -274, -274, -274, -274, -274,
     -274, -274, -274, -274, -274, -274, -274, -274, -274, -274,
     -274, -274, -274, -274, -274, -274, -274, -274, -274, -274,
     -274, -274, -274, -274, -274, -274, -274, -274,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -274, -274,

     -274, -274, -274, -274, -274,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  427,  227,  227,  227,  227,  227,  227,
      227, -274, -274, -274, -274,  227, -274,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  427,  227,  227,  227,  227,
      227,  227,  227, -274, -274, -274, -274,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -275, -275, -275, -275, -275, -275, -275, -275, -275,
     -275, -275, -275, -275, -275, -275, -275, -275, -275, -275,
     -275, -275, -275, -275, -275, -275, -275, -275, -275, -275,
     -275, -275, -275, -275, -275, -275, -275, -275, -275, -275,
     -275, -275, -275, -275, -275, -275, -275, -275,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -275, -275,
     -275, -275, -275, -275, -275,  227,  227,  227,  227,  428,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -275, -275, -275, -275,  227, -275,  227,  227,  227,

      227,  428,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -275, -275, -275, -275,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -276, -276, -276, -276, -276, -276, -276, -276, -276,
     -276, -276, -276, -276, -276, -276, -276, -276, -276, -276,
     -276, -276, -276, -276, -276, -276, -276, -276, -276, -276,
     -276, -276, -276, -276, -276, -276, -276, -276, -276, -276,

     -276, -276, -276, -276, -276, -276, -276, -276,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -276, -276,
     -276, -276, -276, -276, -276,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  429,  227,  227,  227,  227,  227,  227,  227,
      227, -276, -276, -276, -276,  227, -276,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  429,  227,  227,  227,  227,  227,
      227,  227,  227, -276, -276, -276, -276,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -277, -277, -277, -277, -277, -277, -277, -277, -277,
     -277, -277, -277, -277, -277, -277, -277, -277, -277, -277,
     -277, -277, -277, -277, -277, -277, -277, -277, -277, -277,
     -277, -277, -277, -277, -277, -277, -277, -277, -277, -277,
     -277, -277, -277, -277, -277, -277, -277, -277,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -277, -277,
     -277, -277, -277, -277, -277,  227,  227,  227,  227,  227,
      227,  227,  227,  430,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -277, -277, -277, -277,  227, -277,  227,  227,  227,
      227,  227,  227,  227,  227,  430,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -277, -277, -277, -277,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -278, -278, -278, -278, -278, -278, -278, -278, -278,
     -278, -278, -278, -278, -278, -278, -278, -278, -278, -278,

     -278, -278, -278, -278, -278, -278, -278, -278, -278, -278,
     -278, -278, -278, -278, -278, -278, -278, -278, -278, -278,
     -278, -278, -278, -278, -278, -278, -278, -278,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -278, -278,
     -278, -278, -278, -278, -278,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  431,  227,  227,  227,  227,  227,  227,  227,
      227, -278, -278, -278, -278,  227, -278,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  431,  227,  227,  227,  227,  227,

      227,  227,  227, -278, -278, -278, -278,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -279, -279, -279, -279, -279, -279, -279, -279, -279,
     -279, -279, -279, -279, -279, -279, -279, -279, -279, -279,
     -279, -279, -279, -279, -279, -279, -279, -279, -279, -279,
     -279, -279, -279, -279, -279, -279, -279, -279, -279, -279,
     -279, -279, -279, -279, -279, -279, -279, -279,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -279, -279,

     -279, -279, -279, -279, -279,  227,  227,  227,  227,  432,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -279, -279, -279, -279,  227, -279,  227,  227,  227,
      227,  432,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -279, -279, -279, -279,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,

     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,

     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280, -280, -280, -280, -280,
     -280, -280, -280, -280, -280, -280
    },

    {
       45, -281, -281, -281, -281, -281, -281, -281, -281, -281,
     -281, -281, -281, -281, -281, -281, -281, -281, -281, -281,
     -281, -281, -281, -281, -281, -281, -281, -281, -281, -281,
     -281, -281, -281, -281, -281, -281, -281, -281, -281, -281,

     -281, -281, -281, -281, -281, -281, -281, -281,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -281, -281,
     -281, -281, -281, -281, -281,  227,  227,  433,  434,  227,
      435,  227,  436,  227,  227,  227,  437,  438,  439,  227,
      227,  227,  227,  227,  440,  227,  227,  227,  227,  227,
      227, -281, -281, -281, -281,  227, -281,  227,  227,  433,
      434,  227,  435,  227,  436,  227,  227,  227,  437,  438,
      439,  227,  227,  227,  227,  227,  440,  227,  227,  227,
      227,  227,  227, -281, -281, -281, -281,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,

     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,

     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282, -282, -282, -282, -282,
     -282, -282, -282, -282, -282, -282
    },

    {
       45, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,

     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,

     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,

     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283, -283, -283, -283, -283,
     -283, -283, -283, -283, -283, -283
    },

    {
       45, -284, -284, -284, -284, -284, -284, -284, -284, -284,
     -284, -284, -284, -284, -284, -284, -284, -284, -284, -284,
     -284, -284, -284, -284, -284, -284, -284, -284, -284, -284,
     -284, -284, -284, -284, -284, -284, -284, -284, -284, -284,
     -284, -284, -284, -284, -284, -284, -284, -284, -284, -284,
     -284, -284, -284, -284, -284, -284, -284, -284, -284, -284,

     -284, -284, -284, -284, -284,  441,  441,  441,  441,  441,
      441,  441,  441,  441,  441,  441,  441,  441,  441,  441,
      441,  441,  441,  441,  441,  441,  441,  441,  441,  441,
      441, -284, -284, -284, -284,  441, -284,  441,  441,  441,
      441,  441,  441,  441,  441,  441,  441,  441,  441,  441,
      441,  441,  441,  441,  441,  441,  441,  441,  441,  441,
      441,  441,  441, -284, -284, -284, -284,  441,  441,  441,
      441,  441,  441,  441,  441,  441,  441,  441,  441,  441,
      441,  441,  441,  441,  441,  441,  441,  441,  441,  441,
      441,  441,  441,  441,  441,  441,  441,  441,  441,  441,

      441,  441,  441,  441,  441,  441,  441,  441,  441,  441,
      441,  441,  441,  441,  441,  441,  441,  441,  441,  441,
      441,  441,  441,  441,  441,  441,  441,  441,  441,  441,
      441,  441,  441,  441,  441,  441,  441,  441,  441,  441,
      441,  441,  441,  441,  441,  441,  441,  441,  441,  441,
      441,  441,  441,  441,  441,  441,  441,  441,  441,  441,
      441,  441,  441,  441,  441,  441,  441,  441,  441,  441,
      441,  441,  441,  441,  441,  441,  441,  441,  441,  441,
      441,  441,  441,  441,  441,  441,  441,  441,  441,  441,
      441,  441,  441,  441,  441,  441

    },

    {
       45,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285, -285,  285,  286,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  287,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  288,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285
    },

    {
       45,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  290,  289,  291,  289,  289,  289,

      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289, -286, -286, -286, -286, -286,
     -286, -286, -286, -286, -286, -286, -286, -286, -286, -286,
     -286, -286, -286, -286, -286, -286, -286, -286, -286, -286,
     -286,  289,  293,  289,  289, -286,  289, -286, -286, -286,
     -286, -286, -286, -286, -286, -286, -286, -286, -286, -286,
     -286, -286, -286, -286, -286, -286, -286, -286, -286, -286,
     -286, -286, -286, -286,  289,  289,  289, -286, -286, -286,
     -286, -286, -286, -286, -286, -286, -286, -286, -286, -286,

     -286, -286, -286, -286, -286, -286, -286, -286, -286, -286,
     -286, -286, -286, -286, -286, -286, -286, -286, -286, -286,
     -286, -286, -286, -286, -286, -286, -286, -286, -286, -286,
     -286, -286, -286, -286, -286, -286, -286, -286, -286, -286,
     -286, -286, -286, -286, -286, -286, -286, -286, -286, -286,
     -286, -286, -286, -286, -286, -286, -286, -286, -286, -286,
     -286, -286, -286, -286, -286, -286, -286, -286, -286, -286,
     -286, -286, -286, -286, -286, -286, -286, -286, -286, -286,
     -286, -286, -286, -286, -286, -286, -286, -286, -286, -286,
     -286, -286, -286, -286, -286, -286, -286, -286, -286, -286,

     -286, -286, -286, -286, -286, -286, -286, -286, -286, -286,
     -286, -286, -286, -286, -286, -286
    },

    {
       45,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285
    },

    {
       45,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  290,  285, -288,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  287,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  296,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285
    },

    {
       45,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285, -289,  285,  286,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  287,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  288,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285

    },

    {
       45, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,

     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,

     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290, -290, -290, -290, -290,
     -290, -290, -290, -290, -290, -290
    },

    {
       45,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  290,  289,  442,  289,  289,  289,

      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289, -291, -291, -291, -291, -291,
     -291, -291, -291, -291, -291, -291, -291, -291, -291, -291,
     -291, -291, -291, -291, -291, -291, -291, -291, -291, -291,
     -291,  289,  293,  289,  289, -291,  289, -291, -291, -291,
     -291, -291, -291, -291, -291, -291, -291, -291, -291, -291,
     -291, -291, -291, -291, -291, -291, -291, -291, -291, -291,
     -291, -291, -291, -291,  289,  289,  289, -291, -291, -291,
     -291, -291, -291, -291, -291, -291, -291, -291, -291, -291,

     -291, -291, -291, -291, -291, -291, -291, -291, -291, -291,
     -291, -291, -291, -291, -291, -291, -291, -291, -291, -291,
     -291, -291, -291, -291, -291, -291, -291, -291, -291, -291,
     -291, -291, -291, -291, -291, -291, -291, -291, -291, -291,
     -291, -291, -291, -291, -291, -291, -291, -291, -291, -291,
     -291, -291, -291, -291, -291, -291, -291, -291, -291, -291,
     -291, -291, -291, -291, -291, -291, -291, -291, -291, -291,
     -291, -291, -291, -291, -291, -291, -291, -291, -291, -291,
     -291, -291, -291, -291, -291, -291, -291, -291, -291, -291,
     -291, -291, -291, -291, -291, -291, -291, -291, -291, -291,

     -291, -291, -291, -291, -291, -291, -291, -291, -291, -291,
     -291, -291, -291, -291, -291, -291
    },

    {
       45, -292, -292, -292, -292, -292, -292, -292, -292, -292,
     -292, -292, -292, -292, -292, -292, -292, -292, -292, -292,
     -292, -292, -292, -292, -292, -292, -292, -292, -292, -292,
     -292, -292, -292, -292, -292, -292, -292, -292, -292, -292,
     -292, -292, -292, -292, -292,  443, -292, -292,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444, -292, -292,
     -292, -292, -292, -292, -292,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,

      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  445, -292, -292, -292,  444, -292,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444, -292, -292, -292, -292,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,

      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444
    },

    {
       45,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,

      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,

      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,

      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289
    },

    {
       45, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,

     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,

     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294, -294, -294, -294, -294,
     -294, -294, -294, -294, -294, -294

    },

    {
       45, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,

     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,

     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295, -295, -295, -295, -295,
     -295, -295, -295, -295, -295, -295
    },

    {
       45,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  290,  285, -296,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  287,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  446,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285
    },

    {
       45,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  298,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  299,  297,  297,  297, -297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  300,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297
    },

    {
       45,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,

      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  302,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301, -298, -298, -298, -298, -298,
     -298, -298, -298, -298, -298, -298, -298, -298, -298, -298,
     -298, -298, -298, -298, -298, -298, -298, -298, -298, -298,
     -298,  301,  303,  301,  301, -298,  304, -298, -298, -298,
     -298, -298, -298, -298, -298, -298, -298, -298, -298, -298,
     -298, -298, -298, -298, -298, -298, -298, -298, -298, -298,

     -298, -298, -298, -298,  301,  301,  301, -298, -298, -298,
     -298, -298, -298, -298, -298, -298, -298, -298, -298, -298,
     -298, -298, -298, -298, -298, -298, -298, -298, -298, -298,
     -298, -298, -298, -298, -298, -298, -298, -298, -298, -298,
     -298, -298, -298, -298, -298, -298, -298, -298, -298, -298,
     -298, -298, -298, -298, -298, -298, -298, -298, -298, -298,
     -298, -298, -298, -298, -298, -298, -298, -298, -298, -298,
     -298, -298, -298, -298, -298, -298, -298, -298, -298, -298,
     -298, -298, -298, -298, -298, -298, -298, -298, -298, -298,
     -298, -298, -298, -298, -298, -298, -298, -298, -298, -298,

     -298, -298, -298, -298, -298, -298, -298, -298, -298, -298,
     -298, -298, -298, -298, -298, -298, -298, -298, -298, -298,
     -298, -298, -298, -298, -298, -298, -298, -298, -298, -298,
     -298, -298, -298, -298, -298, -298
    },

    {
       45,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297

    },

    {
       45,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297, -300,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  299,  297,  297,  297,  304,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  305,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297
    },

    {
       45,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  298,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  299,  297,  297,  297, -301,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  300,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297
    },

    {
       45,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  447,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301, -302, -302, -302, -302, -302,
     -302, -302, -302, -302, -302, -302, -302, -302, -302, -302,

     -302, -302, -302, -302, -302, -302, -302, -302, -302, -302,
     -302,  301,  303,  301,  301, -302,  304, -302, -302, -302,
     -302, -302, -302, -302, -302, -302, -302, -302, -302, -302,
     -302, -302, -302, -302, -302, -302, -302, -302, -302, -302,
     -302, -302, -302, -302,  301,  301,  301, -302, -302, -302,
     -302, -302, -302, -302, -302, -302, -302, -302, -302, -302,
     -302, -302, -302, -302, -302, -302, -302, -302, -302, -302,
     -302, -302, -302, -302, -302, -302, -302, -302, -302, -302,
     -302, -302, -302, -302, -302, -302, -302, -302, -302, -302,
     -302, -302, -302, -302, -302, -302, -302, -302, -302, -302,

     -302, -302, -302, -302, -302, -302, -302, -302, -302, -302,
     -302, -302, -302, -302, -302, -302, -302, -302, -302, -302,
     -302, -302, -302, -302, -302, -302, -302, -302, -302, -302,
     -302, -302, -302, -302, -302, -302, -302, -302, -302, -302,
     -302, -302, -302, -302, -302, -302, -302, -302, -302, -302,
     -302, -302, -302, -302, -302, -302, -302, -302, -302, -302,
     -302, -302, -302, -302, -302, -302, -302, -302, -302, -302,
     -302, -302, -302, -302, -302, -302
    },

    {
       45,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,

      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,

      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,

      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301
    },

    {
       45, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,

     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,

     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304, -304, -304, -304, -304,
     -304, -304, -304, -304, -304, -304

    },

    {
       45,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297, -305,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  299,  297,  297,  297,  304,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  448,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297
    },

    {
       45, -306, -306, -306, -306, -306, -306, -306, -306, -306,
     -306, -306, -306, -306, -306, -306, -306, -306, -306, -306,
     -306, -306, -306, -306, -306, -306, -306, -306, -306, -306,
     -306, -306, -306, -306, -306, -306, -306, -306, -306, -306,

     -306, -306, -306, -306, -306, -306, -306, -306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306, -306, -306,
     -306, -306, -306, -306, -306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306, -306, -306, -306, -306,  306, -306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306, -306, -306, -306, -306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,

      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,

      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  306
    },

    {
       45, -307, -307, -307, -307, -307, -307, -307, -307,  307,
      307, -307, -307,  307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307,  307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,

     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,

     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307, -307, -307, -307, -307,
     -307, -307, -307, -307, -307, -307
    },

    {
       45, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,

     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,

     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,

     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308, -308, -308, -308, -308,
     -308, -308, -308, -308, -308, -308
    },

    {
       45, -309, -309, -309, -309, -309, -309, -309, -309, -309,
     -309, -309, -309, -309, -309, -309, -309, -309, -309, -309,
     -309, -309, -309, -309, -309, -309, -309, -309, -309, -309,
     -309, -309, -309, -309, -309, -309, -309, -309, -309, -309,
     -309, -309, -309, -309, -309, -309, -309, -309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309, -309, -309,

     -309, -309, -309, -309, -309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309, -309, -309, -309, -309,  309, -309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309, -309, -309, -309, -309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,

      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309

    },

    {
       45, -310, -310, -310, -310, -310, -310, -310, -310, -310,
     -310, -310, -310, -310, -310, -310, -310, -310, -310, -310,
     -310, -310, -310, -310, -310, -310, -310, -310, -310, -310,
     -310, -310, -310, -310, -310, -310, -310, -310, -310, -310,
     -310, -310, -310, -310, -310, -310, -310, -310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310, -310, -310,
     -310, -310, -310, -310, -310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310, -310, -310, -310, -310,  310, -310,  310,  310,  310,

      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310, -310, -310, -310, -310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,

      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310
    },

    {
       45, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,

     -311, -311, -311, -311, -311, -311, -311, -311,  311,  311,
      311,  311,  311,  311,  311,  311,  311,  311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,

     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,

     -311, -311, -311, -311, -311, -311, -311, -311, -311, -311,
     -311, -311, -311, -311, -311, -311
    },

    {
       45, -312, -312, -312, -312, -312, -312, -312, -312, -312,
     -312, -312, -312, -312, -312, -312, -312, -312, -312, -312,
     -312, -312, -312, -312, -312, -312, -312, -312, -312, -312,
     -312, -312, -312, -312, -312, -312, -312, -312, -312, -312,
     -312, -312, -312, -312, -312, -312, -312, -312,  449,  449,
      449,  449,  449,  449,  449,  449,  449,  449, -312, -312,
     -312, -312, -312, -312, -312,  449,  449,  449,  449,  449,
      449, -312, -312, -312, -312, -312, -312, -312, -312, -312,

     -312, -312, -312, -312, -312, -312, -312, -312, -312, -312,
     -312, -312, -312, -312, -312, -312, -312,  449,  449,  449,
      449,  449,  449, -312, -312, -312, -312, -312, -312, -312,
     -312, -312, -312, -312, -312, -312, -312, -312, -312, -312,
     -312, -312, -312, -312, -312, -312, -312, -312, -312, -312,
     -312, -312, -312, -312, -312, -312, -312, -312, -312, -312,
     -312, -312, -312, -312, -312, -312, -312, -312, -312, -312,
     -312, -312, -312, -312, -312, -312, -312, -312, -312, -312,
     -312, -312, -312, -312, -312, -312, -312, -312, -312, -312,
     -312, -312, -312, -312, -312, -312, -312, -312, -312, -312,

     -312, -312, -312, -312, -312, -312, -312, -312, -312, -312,
     -312, -312, -312, -312, -312, -312, -312, -312, -312, -312,
     -312, -312, -312, -312, -312, -312, -312, -312, -312, -312,
     -312, -312, -312, -312, -312, -312, -312, -312, -312, -312,
     -312, -312, -312, -312, -312, -312, -312, -312, -312, -312,
     -312, -312, -312, -312, -312, -312, -312, -312, -312, -312,
     -312, -312, -312, -312, -312, -312, -312, -312, -312, -312,
     -312, -312, -312, -312, -312, -312
    },

    {
       45, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,

     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313,  313,  313,
      313,  313,  313,  313,  313,  313,  313,  313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,

     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,

     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313, -313, -313, -313, -313,
     -313, -313, -313, -313, -313, -313
    },

    {
       45, -314, -314, -314, -314, -314, -314, -314, -314,  450,
      450, -314, -314,  450, -314, -314, -314, -314, -314, -314,
     -314, -314, -314, -314, -314, -314, -314, -314, -314, -314,
     -314, -314,  450, -314, -314,  451, -314, -314, -314, -314,
     -314, -314, -314, -314, -314,  452, -314,  453,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  452, -314,

     -314, -314,  455, -314, -314,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454, -314, -314, -314, -314,  454, -314,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454, -314, -314, -314, -314,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,

      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454

    },

    {
       45,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315, -315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,

      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,

      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
      315,  315,  315,  315,  315,  315
    },

    {
       45, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,

     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,

     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,

     -316, -316, -316, -316, -316, -316, -316, -316, -316, -316,
     -316, -316, -316, -316, -316, -316
    },

    {
       45, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,

     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,

     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317, -317, -317, -317, -317,
     -317, -317, -317, -317, -317, -317
    },

    {
       45,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      319,  318,  318,  319,  318,  318,  318,  318,  318,  318,

      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  319,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  319,  319,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,

      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,

      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  318,  318
    },

    {
       45, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,

     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,

     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319, -319, -319, -319, -319,
     -319, -319, -319, -319, -319, -319

    },

    {
       45, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,

     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,

     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320, -320, -320, -320, -320,
     -320, -320, -320, -320, -320, -320
    },

    {
       45, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,

     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,

     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,

     -321, -321, -321, -321, -321, -321, -321, -321, -321, -321,
     -321, -321, -321, -321, -321, -321
    },

    {
       45,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  323,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,

      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,

      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322,  322,  322,  322,  322,
      322,  322,  322,  322,  322,  322
    },

    {
       45, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,

     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,

     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,

     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323, -323, -323, -323, -323,
     -323, -323, -323, -323, -323, -323
    },

    {
       45, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,

     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,

     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324, -324, -324, -324, -324,
     -324, -324, -324, -324, -324, -324

    },

    {
       45, -325, -325, -325, -325, -325, -325, -325, -325, -325,
     -325, -325, -325, -325, -325, -325, -325, -325, -325, -325,
     -325, -325, -325, -325, -325, -325, -325, -325, -325, -325,
     -325, -325, -325, -325, -325, -325, -325, -325, -325, -325,
     -325, -325, -325, -325, -325, -325, -325, -325, -325, -325,
     -325, -325, -325, -325, -325, -325, -325, -325, -325, -325,
     -325, -325, -325, -325, -325,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456, -325, -325, -325, -325,  456, -325,  456,  456,  456,

      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456, -325, -325, -325, -325,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,

      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456
    },

    {
       45, -326, -326, -326, -326, -326, -326, -326, -326, -326,
     -326, -326, -326, -326, -326, -326, -326, -326, -326, -326,
     -326, -326, -326, -326, -326, -326, -326, -326, -326, -326,
     -326, -326, -326, -326, -326, -326, -326, -326, -326, -326,

     -326, -326, -326, -326, -326,  325, -326, -326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  325, -326,
     -326, -326, -326, -326, -326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326, -326, -326, -326, -326,  326, -326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326, -326, -326, -326, -326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,

      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,

      326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  326,  326,  326
    },

    {
       45, -327, -327, -327, -327, -327, -327, -327, -327, -327,
     -327, -327, -327, -327, -327, -327, -327, -327, -327, -327,
     -327, -327, -327, -327, -327, -327, -327, -327, -327, -327,
     -327, -327, -327, -327, -327, -327, -327, -327, -327, -327,
     -327, -327, -327, -327, -327, -327, -327, -327, -327, -327,
     -327, -327, -327, -327, -327, -327, -327, -327, -327, -327,
     -327, -327, -327, -327, -327,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,

      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457, -327, -327, -327, -327,  457, -327,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457, -327, -327, -327, -327,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,

      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457
    },

    {
       45, -328, -328, -328, -328, -328, -328, -328, -328, -328,
     -328, -328, -328, -328, -328, -328, -328, -328, -328, -328,

     -328, -328, -328, -328, -328, -328, -328, -328, -328, -328,
     -328, -328, -328, -328, -328, -328, -328, -328, -328, -328,
     -328, -328, -328, -328, -328,  327, -328, -328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  327, -328,
     -328, -328, -328, -328, -328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328, -328, -328, -328, -328,  328, -328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,

      328,  328,  328, -328, -328, -328, -328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,

      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328
    },

    {
       45,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,

     -329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329, -329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,

      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329

    },

    {
       45, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330,  458, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,

     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,

     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330, -330, -330, -330, -330,
     -330, -330, -330, -330, -330, -330
    },

    {
       45, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,

     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,

     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,

     -331, -331, -331, -331, -331, -331, -331, -331, -331, -331,
     -331, -331, -331, -331, -331, -331
    },

    {
       45,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332, -332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,

      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,

      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332
    },

    {
       45, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,

     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333,  459, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,

     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,

     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333, -333, -333, -333, -333,
     -333, -333, -333, -333, -333, -333
    },

    {
       45,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460, -334,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,

      461,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,

      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460

    },

    {
       45,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334, -335,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
     -335,  334,  334, -335,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334, -335,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,

      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334, -335,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,

      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334
    },

    {
       45, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,

     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,

     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,

     -336, -336, -336, -336, -336, -336, -336, -336, -336, -336,
     -336, -336, -336, -336, -336, -336
    },

    {
       45, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337,  462, -337, -337, -337, -337, -337, -337, -337,

     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337,  462, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,

     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337, -337, -337, -337, -337,
     -337, -337, -337, -337, -337, -337
    },

    {
       45, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,

     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338,  463, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338,  463, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,

     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,

     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338, -338, -338, -338, -338,
     -338, -338, -338, -338, -338, -338
    },

    {
       45, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,

     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339,  464, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339,  464, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,

     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339, -339, -339, -339, -339,
     -339, -339, -339, -339, -339, -339

    },

    {
       45,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      466,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,

      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,

      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465
    },

    {
       45,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340, -341,  340,  340,

      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
     -341,  340,  340, -341,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340, -341,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340, -341,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,

      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,

      340,  340,  340,  340,  340,  340,  340,  340,  340,  340,
      340,  340,  340,  340,  340,  340
    },

    {
       45, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,

     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,

     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342, -342, -342, -342, -342,
     -342, -342, -342, -342, -342, -342
    },

    {
       45,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,

      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  175,  174,  176,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  177,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,

      174,  174,  174,  178,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,

      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174
    },

    {
       45,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,

      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,

      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  343,  343

    },

    {
       45, -345, -345, -345, -345, -345, -345, -345, -345, -345,
     -345, -345, -345, -345, -345, -345, -345, -345, -345, -345,
     -345, -345, -345, -345, -345, -345, -345, -345, -345, -345,
     -345, -345, -345, -345, -345, -345, -345, -345, -345, -345,
     -345, -345, -345, -345, -345, -345, -345, -345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345, -345, -345,
     -345, -345, -345, -345, -345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345, -345, -345, -345, -345,  345, -345,  345,  345,  345,

      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345, -345, -345, -345, -345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,

      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345,  345,  345,  345,  345,
      345,  345,  345,  345,  345,  345
    },

    {
       45, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,

     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,

     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,

     -346, -346, -346, -346, -346, -346, -346, -346, -346, -346,
     -346, -346, -346, -346, -346, -346
    },

    {
       45, -347, -347, -347, -347, -347, -347, -347, -347, -347,
      346, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,

     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,

     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347, -347, -347, -347, -347,
     -347, -347, -347, -347, -347, -347
    },

    {
       45, -348, -348, -348, -348, -348, -348, -348, -348, -348,
     -348, -348, -348, -348, -348, -348, -348, -348, -348, -348,

     -348, -348, -348, -348, -348, -348, -348, -348, -348, -348,
     -348, -348, -348, -348, -348, -348, -348, -348, -348, -348,
     -348, -348, -348, -348, -348, -348, -348, -348, -348, -348,
     -348, -348, -348, -348, -348, -348, -348, -348, -348, -348,
     -348, -348, -348, -348, -348,  467,  467,  467,  467,  467,
      467,  467,  467,  467,  467,  467,  467,  467,  467,  467,
      467,  467,  467,  467,  467,  467,  467,  467,  467,  467,
      467, -348, -348, -348, -348,  467, -348,  467,  467,  467,
      467,  467,  467,  467,  467,  467,  467,  467,  467,  467,
      467,  467,  467,  467,  467,  467,  467,  467,  467,  467,

      467,  467,  467, -348, -348, -348, -348,  467,  467,  467,
      467,  467,  467,  467,  467,  467,  467,  467,  467,  467,
      467,  467,  467,  467,  467,  467,  467,  467,  467,  467,
      467,  467,  467,  467,  467,  467,  467,  467,  467,  467,
      467,  467,  467,  467,  467,  467,  467,  467,  467,  467,
      467,  467,  467,  467,  467,  467,  467,  467,  467,  467,
      467,  467,  467,  467,  467,  467,  467,  467,  467,  467,
      467,  467,  467,  467,  467,  467,  467,  467,  467,  467,
      467,  467,  467,  467,  467,  467,  467,  467,  467,  467,
      467,  467,  467,  467,  467,  467,  467,  467,  467,  467,

      467,  467,  467,  467,  467,  467,  467,  467,  467,  467,
      467,  467,  467,  467,  467,  467,  467,  467,  467,  467,
      467,  467,  467,  467,  467,  467,  467,  467,  467,  467,
      467,  467,  467,  467,  467,  467
    },

    {
       45, -349, -349, -349, -349, -349, -349, -349, -349, -349,
     -349, -349, -349, -349, -349, -349, -349, -349, -349, -349,
     -349, -349, -349, -349, -349, -349, -349, -349, -349, -349,
     -349, -349, -349, -349, -349, -349, -349, -349, -349, -349,
     -349, -349, -349, -349, -349,  348, -349, -349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  348, -349,

     -349, -349, -349, -349, -349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349, -349, -349, -349, -349,  349, -349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349, -349, -349, -349, -349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,

      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  349

    },

    {
       45, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350,  468, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,

     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350,  468, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,

     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350, -350, -350, -350, -350,
     -350, -350, -350, -350, -350, -350
    },

    {
       45, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,

     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351, -351, -351,  469, -351,
     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,
      469, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,

     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,

     -351, -351, -351, -351, -351, -351, -351, -351, -351, -351,
     -351, -351, -351, -351, -351, -351
    },

    {
       45, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352,  470,

     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352,  470, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,

     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352, -352, -352, -352, -352,
     -352, -352, -352, -352, -352, -352
    },

    {
       45, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,

     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353,  471, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353,  471, -353, -353,

     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,

     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353, -353, -353, -353, -353,
     -353, -353, -353, -353, -353, -353
    },

    {
       45, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,

     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354,  472,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354,  472, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,

     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354, -354, -354, -354, -354,
     -354, -354, -354, -354, -354, -354

    },

    {
       45, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355,  473, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,

     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355,  473, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,

     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355, -355, -355, -355, -355,
     -355, -355, -355, -355, -355, -355
    },

    {
       45, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,

     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356,  474, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356,  474, -356, -356, -356,
     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,

     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,

     -356, -356, -356, -356, -356, -356, -356, -356, -356, -356,
     -356, -356, -356, -356, -356, -356
    },

    {
       45, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357,  475, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,

     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357,  475, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,

     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357, -357, -357, -357, -357,
     -357, -357, -357, -357, -357, -357
    },

    {
       45, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,

     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358,  476, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358,  476, -358, -358, -358, -358, -358,

     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,

     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358, -358, -358, -358, -358,
     -358, -358, -358, -358, -358, -358
    },

    {
       45, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,

     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359,  477, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359,  477, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,

     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359, -359, -359, -359, -359,
     -359, -359, -359, -359, -359, -359

    },

    {
       45, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,

     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,

     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360, -360, -360, -360, -360,
     -360, -360, -360, -360, -360, -360
    },

    {
       45, -361, -361, -361, -361, -361, -361, -361, -361,  478,
      478, -361, -361,  478, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361,  478, -361, -361, -361, -361, -361, -361, -361,

     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,

     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,

     -361, -361, -361, -361, -361, -361, -361, -361, -361, -361,
     -361, -361, -361, -361, -361, -361
    },

    {
       45, -362, -362, -362, -362, -362, -362, -362, -362, -362,
     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,
     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,
     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,
     -362, -362, -362, -362, -362, -362, -362, -362,  362,  362,
      362,  362,  362,  362,  362,  362,  362,  362, -362, -362,
     -362, -362, -362, -362, -362, -362, -362, -362, -362,  212,
     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,

     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,
     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,
     -362,  212, -362, -362, -362, -362, -362, -362, -362, -362,
     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,
     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,
     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,
     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,
     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,
     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,
     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,

     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,
     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,
     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,
     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,
     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,
     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,
     -362, -362, -362, -362, -362, -362, -362, -362, -362, -362,
     -362, -362, -362, -362, -362, -362
    },

    {
       45, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,

     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363,  364,  364,
      364,  364,  364,  364,  364,  364,  364,  364, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,

     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,

     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363, -363, -363, -363, -363,
     -363, -363, -363, -363, -363, -363
    },

    {
       45, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364,  364,  364,
      364,  364,  364,  364,  364,  364,  364,  364, -364, -364,

     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,

     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364, -364, -364, -364, -364,
     -364, -364, -364, -364, -364, -364

    },

    {
       45, -365, -365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365, -365, -365,  365,  365,
      365,  365,  365,  365,  365,  365,  365,  365, -365, -365,
     -365, -365, -365, -365, -365,  365,  365,  365,  365,  365,
      365, -365, -365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365, -365,  365,  365,  365,

      365,  365,  365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365, -365, -365, -365, -365,

     -365, -365, -365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365, -365, -365, -365, -365,
     -365, -365, -365, -365, -365, -365
    },

    {
       45, -366, -366, -366, -366, -366, -366, -366, -366, -366,
     -366, -366, -366, -366, -366, -366, -366, -366, -366, -366,
     -366, -366, -366, -366, -366, -366, -366, -366, -366, -366,
     -366, -366, -366, -366, -366, -366, -366, -366, -366, -366,

     -366, -366, -366, -366, -366, -366, -366, -366, -366, -366,
     -366, -366, -366, -366, -366, -366, -366, -366, -366, -366,
     -366, -366, -366, -366, -366,  479,  479,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,
      479, -366, -366, -366, -366,  479, -366,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,
      479,  479,  479, -366, -366, -366, -366,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,

      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,

      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,
      479,  479,  479,  479,  479,  479
    },

    {
       45, -367, -367, -367, -367, -367, -367, -367, -367, -367,
     -367, -367, -367, -367, -367, -367, -367, -367, -367, -367,
     -367, -367, -367, -367, -367, -367, -367, -367, -367, -367,
     -367, -367, -367, -367, -367, -367, -367, -367, -367, -367,
     -367, -367, -367, -367, -367,  366, -367, -367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  366, -367,
     -367, -367, -367, -367, -367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,

      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367, -367, -367, -367, -367,  367, -367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367, -367, -367, -367, -367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,

      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
      367,  367,  367,  367,  367,  367
    },

    {
       45, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,

     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368, -368,  480, -368, -368,
     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368, -368, -368, -368,  480,
     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,

     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,

     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368, -368, -368, -368, -368,
     -368, -368, -368, -368, -368, -368
    },

    {
       45, -369, -369, -369, -369, -369, -369, -369, -369,  481,
     -369, -369, -369, -369, -369, -369, -369, -369, -369, -369,
     -369, -369, -369, -369, -369, -369, -369, -369, -369, -369,
     -369, -369,  481, -369,  482, -369, -369, -369, -369,  483,
     -369, -369, -369, -369, -369, -369, -369, -369, -369, -369,
     -369, -369, -369, -369, -369, -369, -369, -369, -369, -369,

     -369, -369, -369, -369, -369,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484, -369, -369, -369, -369,  484, -369,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484, -369, -369, -369, -369,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,

      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484

    },

    {
       45, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,

     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,

     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370, -370, -370, -370, -370,
     -370, -370, -370, -370, -370, -370
    },

    {
       45, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,

     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,

     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,

     -371, -371, -371, -371, -371, -371, -371, -371, -371, -371,
     -371, -371, -371, -371, -371, -371
    },

    {
       45, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,

     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,

     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372, -372, -372, -372, -372,
     -372, -372, -372, -372, -372, -372
    },

    {
       45, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,

     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,

     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,

     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373, -373, -373, -373, -373,
     -373, -373, -373, -373, -373, -373
    },

    {
       45, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,

     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,

     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374, -374, -374, -374, -374,
     -374, -374, -374, -374, -374, -374

    },

    {
       45, -375, -375, -375, -375, -375, -375, -375, -375, -375,
      374, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,

     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,

     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375, -375, -375, -375, -375,
     -375, -375, -375, -375, -375, -375
    },

    {
       45, -376, -376, -376, -376, -376, -376, -376, -376, -376,
     -376, -376, -376, -376, -376, -376, -376, -376, -376, -376,
     -376, -376, -376, -376, -376, -376, -376, -376, -376, -376,
     -376, -376, -376, -376, -376, -376, -376, -376, -376, -376,

     -376, -376, -376, -376, -376, -376, -376, -376,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -376, -376,
     -376, -376, -376, -376, -376,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  485,  227,  227,  227,  227,  227,
      227, -376, -376, -376, -376,  227, -376,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  485,  227,  227,  227,
      227,  227,  227, -376, -376, -376, -376,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -377, -377, -377, -377, -377, -377, -377, -377, -377,
     -377, -377, -377, -377, -377, -377, -377, -377, -377, -377,
     -377, -377, -377, -377, -377, -377, -377, -377, -377, -377,
     -377, -377, -377, -377, -377, -377, -377, -377, -377, -377,
     -377, -377, -377, -377, -377, -377, -377, -377,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -377, -377,
     -377, -377, -377, -377, -377,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -377, -377, -377, -377,  227, -377,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -377, -377, -377, -377,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -378, -378, -378, -378, -378, -378, -378, -378, -378,
     -378, -378, -378, -378, -378, -378, -378, -378, -378, -378,

     -378, -378, -378, -378, -378, -378, -378, -378, -378, -378,
     -378, -378, -378, -378, -378, -378, -378, -378, -378, -378,
     -378, -378, -378, -378, -378, -378, -378, -378,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -378, -378,
     -378, -378, -378, -378, -378,  486,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -378, -378, -378, -378,  227, -378,  486,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -378, -378, -378, -378,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -379, -379, -379, -379, -379, -379, -379, -379, -379,
     -379, -379, -379, -379, -379, -379, -379, -379, -379, -379,
     -379, -379, -379, -379, -379, -379, -379, -379, -379, -379,
     -379, -379, -379, -379, -379, -379, -379, -379, -379, -379,
     -379, -379, -379, -379, -379, -379, -379, -379,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -379, -379,

     -379, -379, -379, -379, -379,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  487,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -379, -379, -379, -379,  227, -379,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      487,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -379, -379, -379, -379,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -380, -380, -380, -380, -380, -380, -380, -380, -380,
     -380, -380, -380, -380, -380, -380, -380, -380, -380, -380,
     -380, -380, -380, -380, -380, -380, -380, -380, -380, -380,
     -380, -380, -380, -380, -380, -380, -380, -380, -380, -380,
     -380, -380, -380, -380, -380, -380, -380, -380,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -380, -380,
     -380, -380, -380, -380, -380,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  488,  227,  227,  227,  227,  227,  227,  227,
      227, -380, -380, -380, -380,  227, -380,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  488,  227,  227,  227,  227,  227,
      227,  227,  227, -380, -380, -380, -380,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -381, -381, -381, -381, -381, -381, -381, -381, -381,
     -381, -381, -381, -381, -381, -381, -381, -381, -381, -381,
     -381, -381, -381, -381, -381, -381, -381, -381, -381, -381,
     -381, -381, -381, -381, -381, -381, -381, -381, -381, -381,

     -381, -381, -381, -381, -381, -381, -381, -381,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -381, -381,
     -381, -381, -381, -381, -381,  227,  227,  227,  227,  227,
      227,  227,  227,  489,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -381, -381, -381, -381,  227, -381,  227,  227,  227,
      227,  227,  227,  227,  227,  489,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -381, -381, -381, -381,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
      369, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,

     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,

     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382, -382, -382, -382, -382,
     -382, -382, -382, -382, -382, -382
    },

    {
       45, -383, -383, -383, -383, -383, -383, -383, -383, -383,
     -383, -383, -383, -383, -383, -383, -383, -383, -383, -383,

     -383, -383, -383, -383, -383, -383, -383, -383, -383, -383,
     -383, -383, -383, -383, -383, -383, -383, -383, -383, -383,
     -383, -383, -383, -383, -383, -383, -383, -383,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -383, -383,
     -383, -383, -383, -383, -383,  490,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -383, -383, -383, -383,  227, -383,  490,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -383, -383, -383, -383,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -384, -384, -384, -384, -384, -384, -384, -384, -384,
     -384, -384, -384, -384, -384, -384, -384, -384, -384, -384,
     -384, -384, -384, -384, -384, -384, -384, -384, -384, -384,
     -384, -384, -384, -384, -384, -384, -384, -384, -384, -384,
     -384, -384, -384, -384, -384, -384, -384, -384,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -384, -384,

     -384, -384, -384, -384, -384,  227,  227,  227,  227,  491,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -384, -384, -384, -384,  227, -384,  227,  227,  227,
      227,  491,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -384, -384, -384, -384,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -385, -385, -385, -385, -385, -385, -385, -385, -385,
     -385, -385, -385, -385, -385, -385, -385, -385, -385, -385,
     -385, -385, -385, -385, -385, -385, -385, -385, -385, -385,
     -385, -385, -385, -385, -385, -385, -385, -385, -385, -385,
     -385, -385, -385, -385, -385, -385, -385, -385,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -385, -385,
     -385, -385, -385, -385, -385,  227,  227,  492,  227,  493,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -385, -385, -385, -385,  227, -385,  227,  227,  492,

      227,  493,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -385, -385, -385, -385,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -386, -386, -386, -386, -386, -386, -386, -386, -386,
     -386, -386, -386, -386, -386, -386, -386, -386, -386, -386,
     -386, -386, -386, -386, -386, -386, -386, -386, -386, -386,
     -386, -386, -386, -386, -386, -386, -386, -386, -386, -386,

     -386, -386, -386, -386, -386, -386, -386, -386,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -386, -386,
     -386, -386, -386, -386, -386,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  494,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -386, -386, -386, -386,  227, -386,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  494,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -386, -386, -386, -386,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -387, -387, -387, -387, -387, -387, -387, -387, -387,
     -387, -387, -387, -387, -387, -387, -387, -387, -387, -387,
     -387, -387, -387, -387, -387, -387, -387, -387, -387, -387,
     -387, -387, -387, -387, -387, -387, -387, -387, -387, -387,
     -387, -387, -387, -387, -387, -387, -387, -387,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -387, -387,
     -387, -387, -387, -387, -387,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  495,  227,  227,  227,  227,  227,  227,
      227, -387, -387, -387, -387,  227, -387,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  495,  227,  227,  227,  227,
      227,  227,  227, -387, -387, -387, -387,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -388, -388, -388, -388, -388, -388, -388, -388, -388,
     -388, -388, -388, -388, -388, -388, -388, -388, -388, -388,

     -388, -388, -388, -388, -388, -388, -388, -388, -388, -388,
     -388, -388, -388, -388, -388, -388, -388, -388, -388, -388,
     -388, -388, -388, -388, -388, -388, -388, -388,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -388, -388,
     -388, -388, -388, -388, -388,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  496,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -388, -388, -388, -388,  227, -388,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      496,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -388, -388, -388, -388,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -389, -389, -389, -389, -389, -389, -389, -389, -389,
     -389, -389, -389, -389, -389, -389, -389, -389, -389, -389,
     -389, -389, -389, -389, -389, -389, -389, -389, -389, -389,
     -389, -389, -389, -389, -389, -389, -389, -389, -389, -389,
     -389, -389, -389, -389, -389, -389, -389, -389,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -389, -389,

     -389, -389, -389, -389, -389,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  497,  498,  227,  227,  227,  227,  227,
      227, -389, -389, -389, -389,  227, -389,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  497,  498,  227,  227,  227,
      227,  227,  227, -389, -389, -389, -389,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -390, -390, -390, -390, -390, -390, -390, -390, -390,
     -390, -390, -390, -390, -390, -390, -390, -390, -390, -390,
     -390, -390, -390, -390, -390, -390, -390, -390, -390, -390,
     -390, -390, -390, -390, -390, -390, -390, -390, -390, -390,
     -390, -390, -390, -390, -390, -390, -390, -390,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -390, -390,
     -390, -390, -390, -390, -390,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  499,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -390, -390, -390, -390,  227, -390,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  499,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -390, -390, -390, -390,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -391, -391, -391, -391, -391, -391, -391, -391, -391,
     -391, -391, -391, -391, -391, -391, -391, -391, -391, -391,
     -391, -391, -391, -391, -391, -391, -391, -391, -391, -391,
     -391, -391, -391, -391, -391, -391, -391, -391, -391, -391,

     -391, -391, -391, -391, -391, -391, -391, -391,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -391, -391,
     -391, -391, -391, -391, -391,  500,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -391, -391, -391, -391,  227, -391,  500,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -391, -391, -391, -391,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -392, -392, -392, -392, -392, -392, -392, -392, -392,
     -392, -392, -392, -392, -392, -392, -392, -392, -392, -392,
     -392, -392, -392, -392, -392, -392, -392, -392, -392, -392,
     -392, -392, -392, -392, -392, -392, -392, -392, -392, -392,
     -392, -392, -392, -392, -392, -392, -392, -392,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -392, -392,
     -392, -392, -392, -392, -392,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -392, -392, -392, -392,  227, -392,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -392, -392, -392, -392,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -393, -393, -393, -393, -393, -393, -393, -393, -393,
     -393, -393, -393, -393, -393, -393, -393, -393, -393, -393,

     -393, -393, -393, -393, -393, -393, -393, -393, -393, -393,
     -393, -393, -393, -393, -393, -393, -393, -393, -393, -393,
     -393, -393, -393, -393, -393, -393, -393, -393,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -393, -393,
     -393, -393, -393, -393, -393,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  501,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -393, -393, -393, -393,  227, -393,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  501,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -393, -393, -393, -393,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -394, -394, -394, -394, -394, -394, -394, -394, -394,
     -394, -394, -394, -394, -394, -394, -394, -394, -394, -394,
     -394, -394, -394, -394, -394, -394, -394, -394, -394, -394,
     -394, -394, -394, -394, -394, -394, -394, -394, -394, -394,
     -394, -394, -394, -394, -394, -394, -394, -394,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -394, -394,

     -394, -394, -394, -394, -394,  227,  227,  227,  227,  502,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -394, -394, -394, -394,  227, -394,  227,  227,  227,
      227,  502,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -394, -394, -394, -394,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -395, -395, -395, -395, -395, -395, -395, -395, -395,
     -395, -395, -395, -395, -395, -395, -395, -395, -395, -395,
     -395, -395, -395, -395, -395, -395, -395, -395, -395, -395,
     -395, -395, -395, -395, -395, -395, -395, -395, -395, -395,
     -395, -395, -395, -395, -395, -395, -395, -395,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -395, -395,
     -395, -395, -395, -395, -395,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  503,  227,  227,  227,  227,  227,
      227, -395, -395, -395, -395,  227, -395,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  503,  227,  227,  227,
      227,  227,  227, -395, -395, -395, -395,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -396, -396, -396, -396, -396, -396, -396, -396, -396,
     -396, -396, -396, -396, -396, -396, -396, -396, -396, -396,
     -396, -396, -396, -396, -396, -396, -396, -396, -396, -396,
     -396, -396, -396, -396, -396, -396, -396, -396, -396, -396,

     -396, -396, -396, -396, -396, -396, -396, -396,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -396, -396,
     -396, -396, -396, -396, -396,  227,  227,  227,  504,  227,
      505,  227,  227,  506,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  507,  227,  227,  227,  508,  227,  227,
      227, -396, -396, -396, -396,  227, -396,  227,  227,  227,
      504,  227,  505,  227,  227,  506,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  507,  227,  227,  227,  508,
      227,  227,  227, -396, -396, -396, -396,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -397, -397, -397, -397, -397, -397, -397, -397, -397,
     -397, -397, -397, -397, -397, -397, -397, -397, -397, -397,
     -397, -397, -397, -397, -397, -397, -397, -397, -397, -397,
     -397, -397, -397, -397, -397, -397, -397, -397, -397, -397,
     -397, -397, -397, -397, -397, -397, -397, -397,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -397, -397,
     -397, -397, -397, -397, -397,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  509,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -397, -397, -397, -397,  227, -397,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  509,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -397, -397, -397, -397,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -398, -398, -398, -398, -398, -398, -398, -398, -398,
     -398, -398, -398, -398, -398, -398, -398, -398, -398, -398,

     -398, -398, -398, -398, -398, -398, -398, -398, -398, -398,
     -398, -398, -398, -398, -398, -398, -398, -398, -398, -398,
     -398, -398, -398, -398, -398, -398, -398, -398,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -398, -398,
     -398, -398, -398, -398, -398,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  510,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -398, -398, -398, -398,  227, -398,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  510,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -398, -398, -398, -398,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -399, -399, -399, -399, -399, -399, -399, -399, -399,
     -399, -399, -399, -399, -399, -399, -399, -399, -399, -399,
     -399, -399, -399, -399, -399, -399, -399, -399, -399, -399,
     -399, -399, -399, -399, -399, -399, -399, -399, -399, -399,
     -399, -399, -399, -399, -399, -399, -399, -399,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -399, -399,

     -399, -399, -399, -399, -399,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  511,  227,  227,  227,  227,  227,
      227, -399, -399, -399, -399,  227, -399,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  511,  227,  227,  227,
      227,  227,  227, -399, -399, -399, -399,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -400, -400, -400, -400, -400, -400, -400, -400, -400,
     -400, -400, -400, -400, -400, -400, -400, -400, -400, -400,
     -400, -400, -400, -400, -400, -400, -400, -400, -400, -400,
     -400, -400, -400, -400, -400, -400, -400, -400, -400, -400,
     -400, -400, -400, -400, -400, -400, -400, -400,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -400, -400,
     -400, -400, -400, -400, -400,  227,  227,  227,  227,  512,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -400, -400, -400, -400,  227, -400,  227,  227,  227,

      227,  512,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -400, -400, -400, -400,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -401, -401, -401, -401, -401, -401, -401, -401, -401,
     -401, -401, -401, -401, -401, -401, -401, -401, -401, -401,
     -401, -401, -401, -401, -401, -401, -401, -401, -401, -401,
     -401, -401, -401, -401, -401, -401, -401, -401, -401, -401,

     -401, -401, -401, -401, -401, -401, -401, -401,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -401, -401,
     -401, -401, -401, -401, -401,  513,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -401, -401, -401, -401,  227, -401,  513,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -401, -401, -401, -401,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -402, -402, -402, -402, -402, -402, -402, -402, -402,
     -402, -402, -402, -402, -402, -402, -402, -402, -402, -402,
     -402, -402, -402, -402, -402, -402, -402, -402, -402, -402,
     -402, -402, -402, -402, -402, -402, -402, -402, -402, -402,
     -402, -402, -402, -402, -402, -402, -402, -402,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -402, -402,
     -402, -402, -402, -402, -402,  227,  227,  227,  227,  514,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -402, -402, -402, -402,  227, -402,  227,  227,  227,
      227,  514,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -402, -402, -402, -402,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -403, -403, -403, -403, -403, -403, -403, -403, -403,
     -403, -403, -403, -403, -403, -403, -403, -403, -403, -403,

     -403, -403, -403, -403, -403, -403, -403, -403, -403, -403,
     -403, -403, -403, -403, -403, -403, -403, -403, -403, -403,
     -403, -403, -403, -403, -403, -403, -403, -403,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -403, -403,
     -403, -403, -403, -403, -403,  227,  227,  515,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -403, -403, -403, -403,  227, -403,  227,  227,  515,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -403, -403, -403, -403,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -404, -404, -404, -404, -404, -404, -404, -404, -404,
     -404, -404, -404, -404, -404, -404, -404, -404, -404, -404,
     -404, -404, -404, -404, -404, -404, -404, -404, -404, -404,
     -404, -404, -404, -404, -404, -404, -404, -404, -404, -404,
     -404, -404, -404, -404, -404, -404, -404, -404,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -404, -404,

     -404, -404, -404, -404, -404,  227,  516,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -404, -404, -404, -404,  227, -404,  227,  516,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -404, -404, -404, -404,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -405, -405, -405, -405, -405, -405, -405, -405, -405,
     -405, -405, -405, -405, -405, -405, -405, -405, -405, -405,
     -405, -405, -405, -405, -405, -405, -405, -405, -405, -405,
     -405, -405, -405, -405, -405, -405, -405, -405, -405, -405,
     -405, -405, -405, -405, -405, -405, -405, -405,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -405, -405,
     -405, -405, -405, -405, -405,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  517,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -405, -405, -405, -405,  227, -405,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  517,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -405, -405, -405, -405,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -406, -406, -406, -406, -406, -406, -406, -406, -406,
     -406, -406, -406, -406, -406, -406, -406, -406, -406, -406,
     -406, -406, -406, -406, -406, -406, -406, -406, -406, -406,
     -406, -406, -406, -406, -406, -406, -406, -406, -406, -406,

     -406, -406, -406, -406, -406, -406, -406, -406,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -406, -406,
     -406, -406, -406, -406, -406,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  518,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -406, -406, -406, -406,  227, -406,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  518,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -406, -406, -406, -406,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -407, -407, -407, -407, -407, -407, -407, -407, -407,
     -407, -407, -407, -407, -407, -407, -407, -407, -407, -407,
     -407, -407, -407, -407, -407, -407, -407, -407, -407, -407,
     -407, -407, -407, -407, -407, -407, -407, -407, -407, -407,
     -407, -407, -407, -407, -407, -407, -407, -407,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -407, -407,
     -407, -407, -407, -407, -407,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  519,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -407, -407, -407, -407,  227, -407,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  519,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -407, -407, -407, -407,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -408, -408, -408, -408, -408, -408, -408, -408, -408,
     -408, -408, -408, -408, -408, -408, -408, -408, -408, -408,

     -408, -408, -408, -408, -408, -408, -408, -408, -408, -408,
     -408, -408, -408, -408, -408, -408, -408, -408, -408, -408,
     -408, -408, -408, -408, -408, -408, -408, -408,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -408, -408,
     -408, -408, -408, -408, -408,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  520,  227,  227,  227,  227,  227,
      227, -408, -408, -408, -408,  227, -408,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  520,  227,  227,  227,

      227,  227,  227, -408, -408, -408, -408,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -409, -409, -409, -409, -409, -409, -409, -409, -409,
     -409, -409, -409, -409, -409, -409, -409, -409, -409, -409,
     -409, -409, -409, -409, -409, -409, -409, -409, -409, -409,
     -409, -409, -409, -409, -409, -409, -409, -409, -409, -409,
     -409, -409, -409, -409, -409, -409, -409, -409,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -409, -409,

     -409, -409, -409, -409, -409,  227,  227,  227,  227,  521,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -409, -409, -409, -409,  227, -409,  227,  227,  227,
      227,  521,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -409, -409, -409, -409,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -410, -410, -410, -410, -410, -410, -410, -410, -410,
     -410, -410, -410, -410, -410, -410, -410, -410, -410, -410,
     -410, -410, -410, -410, -410, -410, -410, -410, -410, -410,
     -410, -410, -410, -410, -410, -410, -410, -410, -410, -410,
     -410, -410, -410, -410, -410, -410, -410, -410,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -410, -410,
     -410, -410, -410, -410, -410,  227,  227,  227,  227,  522,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -410, -410, -410, -410,  227, -410,  227,  227,  227,

      227,  522,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -410, -410, -410, -410,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -411, -411, -411, -411, -411, -411, -411, -411, -411,
     -411, -411, -411, -411, -411, -411, -411, -411, -411, -411,
     -411, -411, -411, -411, -411, -411, -411, -411, -411, -411,
     -411, -411, -411, -411, -411, -411, -411, -411, -411, -411,

     -411, -411, -411, -411, -411, -411, -411, -411,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -411, -411,
     -411, -411, -411, -411, -411,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  523,  227,  227,  227,  227,  227,
      227, -411, -411, -411, -411,  227, -411,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  523,  227,  227,  227,
      227,  227,  227, -411, -411, -411, -411,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -412, -412, -412, -412, -412, -412, -412, -412, -412,
     -412, -412, -412, -412, -412, -412, -412, -412, -412, -412,
     -412, -412, -412, -412, -412, -412, -412, -412, -412, -412,
     -412, -412, -412, -412, -412, -412, -412, -412, -412, -412,
     -412, -412, -412, -412, -412, -412, -412, -412,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -412, -412,
     -412, -412, -412, -412, -412,  227,  227,  227,  227,  524,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -412, -412, -412, -412,  227, -412,  227,  227,  227,
      227,  524,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -412, -412, -412, -412,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -413, -413, -413, -413, -413, -413, -413, -413, -413,
     -413, -413, -413, -413, -413, -413, -413, -413, -413, -413,

     -413, -413, -413, -413, -413, -413, -413, -413, -413, -413,
     -413, -413, -413, -413, -413, -413, -413, -413, -413, -413,
     -413, -413, -413, -413, -413, -413, -413, -413,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -413, -413,
     -413, -413, -413, -413, -413,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  525,  227,  227,  227,  227,  227,
      227, -413, -413, -413, -413,  227, -413,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  525,  227,  227,  227,

      227,  227,  227, -413, -413, -413, -413,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -414, -414, -414, -414, -414, -414, -414, -414, -414,
     -414, -414, -414, -414, -414, -414, -414, -414, -414, -414,
     -414, -414, -414, -414, -414, -414, -414, -414, -414, -414,
     -414, -414, -414, -414, -414, -414, -414, -414, -414, -414,
     -414, -414, -414, -414, -414, -414, -414, -414,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -414, -414,

     -414, -414, -414, -414, -414,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  526,  227,
      227,  227,  227,  227,  227,  227,  527,  227,  227,  227,
      227, -414, -414, -414, -414,  227, -414,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      526,  227,  227,  227,  227,  227,  227,  227,  527,  227,
      227,  227,  227, -414, -414, -414, -414,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -415, -415, -415, -415, -415, -415, -415, -415, -415,
     -415, -415, -415, -415, -415, -415, -415, -415, -415, -415,
     -415, -415, -415, -415, -415, -415, -415, -415, -415, -415,
     -415, -415, -415, -415, -415, -415, -415, -415, -415, -415,
     -415, -415, -415, -415, -415, -415, -415, -415,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -415, -415,
     -415, -415, -415, -415, -415,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  528,  227,  227,  227,  227,  227,
      227, -415, -415, -415, -415,  227, -415,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  528,  227,  227,  227,
      227,  227,  227, -415, -415, -415, -415,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -416, -416, -416, -416, -416, -416, -416, -416, -416,
     -416, -416, -416, -416, -416, -416, -416, -416, -416, -416,
     -416, -416, -416, -416, -416, -416, -416, -416, -416, -416,
     -416, -416, -416, -416, -416, -416, -416, -416, -416, -416,

     -416, -416, -416, -416, -416, -416, -416, -416,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -416, -416,
     -416, -416, -416, -416, -416,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  529,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -416, -416, -416, -416,  227, -416,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  529,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -416, -416, -416, -416,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -417, -417, -417, -417, -417, -417, -417, -417, -417,
     -417, -417, -417, -417, -417, -417, -417, -417, -417, -417,
     -417, -417, -417, -417, -417, -417, -417, -417, -417, -417,
     -417, -417, -417, -417, -417, -417, -417, -417, -417, -417,
     -417, -417, -417, -417, -417, -417, -417, -417,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -417, -417,
     -417, -417, -417, -417, -417,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  530,  227,  227,  227,  227,
      227, -417, -417, -417, -417,  227, -417,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  530,  227,  227,
      227,  227,  227, -417, -417, -417, -417,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -418, -418, -418, -418, -418, -418, -418, -418, -418,
     -418, -418, -418, -418, -418, -418, -418, -418, -418, -418,

     -418, -418, -418, -418, -418, -418, -418, -418, -418, -418,
     -418, -418, -418, -418, -418, -418, -418, -418, -418, -418,
     -418, -418, -418, -418, -418, -418, -418, -418,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -418, -418,
     -418, -418, -418, -418, -418,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  531,  227,  227,  227,  227,
      227, -418, -418, -418, -418,  227, -418,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  531,  227,  227,

      227,  227,  227, -418, -418, -418, -418,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -419, -419, -419, -419, -419, -419, -419, -419, -419,
     -419, -419, -419, -419, -419, -419, -419, -419, -419, -419,
     -419, -419, -419, -419, -419, -419, -419, -419, -419, -419,
     -419, -419, -419, -419, -419, -419, -419, -419, -419, -419,
     -419, -419, -419, -419, -419, -419, -419, -419,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -419, -419,

     -419, -419, -419, -419, -419,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      532,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -419, -419, -419, -419,  227, -419,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  532,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -419, -419, -419, -419,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -420, -420, -420, -420, -420, -420, -420, -420, -420,
     -420, -420, -420, -420, -420, -420, -420, -420, -420, -420,
     -420, -420, -420, -420, -420, -420, -420, -420, -420, -420,
     -420, -420, -420, -420, -420, -420, -420, -420, -420, -420,
     -420, -420, -420, -420, -420, -420, -420, -420,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -420, -420,
     -420, -420, -420, -420, -420,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  533,  227,  227,  227,  227,  227,
      227, -420, -420, -420, -420,  227, -420,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  533,  227,  227,  227,
      227,  227,  227, -420, -420, -420, -420,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -421, -421, -421, -421, -421, -421, -421, -421, -421,
     -421, -421, -421, -421, -421, -421, -421, -421, -421, -421,
     -421, -421, -421, -421, -421, -421, -421, -421, -421, -421,
     -421, -421, -421, -421, -421, -421, -421, -421, -421, -421,

     -421, -421, -421, -421, -421, -421, -421, -421,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -421, -421,
     -421, -421, -421, -421, -421,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  534,  227,  227,  227,  227,  227,
      227, -421, -421, -421, -421,  227, -421,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  534,  227,  227,  227,
      227,  227,  227, -421, -421, -421, -421,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -422, -422, -422, -422, -422, -422, -422, -422, -422,
     -422, -422, -422, -422, -422, -422, -422, -422, -422, -422,
     -422, -422, -422, -422, -422, -422, -422, -422, -422, -422,
     -422, -422, -422, -422, -422, -422, -422, -422, -422, -422,
     -422, -422, -422, -422, -422, -422, -422, -422,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -422, -422,
     -422, -422, -422, -422, -422,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  535,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -422, -422, -422, -422,  227, -422,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  535,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -422, -422, -422, -422,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -423, -423, -423, -423, -423, -423, -423, -423, -423,
     -423, -423, -423, -423, -423, -423, -423, -423, -423, -423,

     -423, -423, -423, -423, -423, -423, -423, -423, -423, -423,
     -423, -423, -423, -423, -423, -423, -423, -423, -423, -423,
     -423, -423, -423, -423, -423, -423, -423, -423,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -423, -423,
     -423, -423, -423, -423, -423,  227,  227,  227,  227,  227,
      227,  227,  227,  536,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -423, -423, -423, -423,  227, -423,  227,  227,  227,
      227,  227,  227,  227,  227,  536,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -423, -423, -423, -423,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -424, -424, -424, -424, -424, -424, -424, -424, -424,
     -424, -424, -424, -424, -424, -424, -424, -424, -424, -424,
     -424, -424, -424, -424, -424, -424, -424, -424, -424, -424,
     -424, -424, -424, -424, -424, -424, -424, -424, -424, -424,
     -424, -424, -424, -424, -424, -424, -424, -424,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -424, -424,

     -424, -424, -424, -424, -424,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -424, -424, -424, -424,  227, -424,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -424, -424, -424, -424,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -425, -425, -425, -425, -425, -425, -425, -425, -425,
     -425, -425, -425, -425, -425, -425, -425, -425, -425, -425,
     -425, -425, -425, -425, -425, -425, -425, -425, -425, -425,
     -425, -425, -425, -425, -425, -425, -425, -425, -425, -425,
     -425, -425, -425, -425, -425, -425, -425, -425,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -425, -425,
     -425, -425, -425, -425, -425,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  537,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -425, -425, -425, -425,  227, -425,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  537,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -425, -425, -425, -425,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -426, -426, -426, -426, -426, -426, -426, -426, -426,
     -426, -426, -426, -426, -426, -426, -426, -426, -426, -426,
     -426, -426, -426, -426, -426, -426, -426, -426, -426, -426,
     -426, -426, -426, -426, -426, -426, -426, -426, -426, -426,

     -426, -426, -426, -426, -426, -426, -426, -426,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -426, -426,
     -426, -426, -426, -426, -426,  227,  227,  227,  227,  538,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -426, -426, -426, -426,  227, -426,  227,  227,  227,
      227,  538,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -426, -426, -426, -426,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -427, -427, -427, -427, -427, -427, -427, -427, -427,
     -427, -427, -427, -427, -427, -427, -427, -427, -427, -427,
     -427, -427, -427, -427, -427, -427, -427, -427, -427, -427,
     -427, -427, -427, -427, -427, -427, -427, -427, -427, -427,
     -427, -427, -427, -427, -427, -427, -427, -427,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -427, -427,
     -427, -427, -427, -427, -427,  227,  227,  227,  227,  539,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -427, -427, -427, -427,  227, -427,  227,  227,  227,
      227,  539,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -427, -427, -427, -427,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -428, -428, -428, -428, -428, -428, -428, -428, -428,
     -428, -428, -428, -428, -428, -428, -428, -428, -428, -428,

     -428, -428, -428, -428, -428, -428, -428, -428, -428, -428,
     -428, -428, -428, -428, -428, -428, -428, -428, -428, -428,
     -428, -428, -428, -428, -428, -428, -428, -428,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -428, -428,
     -428, -428, -428, -428, -428,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -428, -428, -428, -428,  227, -428,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -428, -428, -428, -428,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -429, -429, -429, -429, -429, -429, -429, -429, -429,
     -429, -429, -429, -429, -429, -429, -429, -429, -429, -429,
     -429, -429, -429, -429, -429, -429, -429, -429, -429, -429,
     -429, -429, -429, -429, -429, -429, -429, -429, -429, -429,
     -429, -429, -429, -429, -429, -429, -429, -429,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -429, -429,

     -429, -429, -429, -429, -429,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -429, -429, -429, -429,  227, -429,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -429, -429, -429, -429,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -430, -430, -430, -430, -430, -430, -430, -430, -430,
     -430, -430, -430, -430, -430, -430, -430, -430, -430, -430,
     -430, -430, -430, -430, -430, -430, -430, -430, -430, -430,
     -430, -430, -430, -430, -430, -430, -430, -430, -430, -430,
     -430, -430, -430, -430, -430, -430, -430, -430,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -430, -430,
     -430, -430, -430, -430, -430,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  540,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -430, -430, -430, -430,  227, -430,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  540,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -430, -430, -430, -430,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -431, -431, -431, -431, -431, -431, -431, -431, -431,
     -431, -431, -431, -431, -431, -431, -431, -431, -431, -431,
     -431, -431, -431, -431, -431, -431, -431, -431, -431, -431,
     -431, -431, -431, -431, -431, -431, -431, -431, -431, -431,

     -431, -431, -431, -431, -431, -431, -431, -431,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -431, -431,
     -431, -431, -431, -431, -431,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -431, -431, -431, -431,  227, -431,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -431, -431, -431, -431,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -432, -432, -432, -432, -432, -432, -432, -432, -432,
     -432, -432, -432, -432, -432, -432, -432, -432, -432, -432,
     -432, -432, -432, -432, -432, -432, -432, -432, -432, -432,
     -432, -432, -432, -432, -432, -432, -432, -432, -432, -432,
     -432, -432, -432, -432, -432, -432, -432, -432,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -432, -432,
     -432, -432, -432, -432, -432,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  541,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -432, -432, -432, -432,  227, -432,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  541,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -432, -432, -432, -432,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -433, -433, -433, -433, -433, -433, -433, -433, -433,
     -433, -433, -433, -433, -433, -433, -433, -433, -433, -433,

     -433, -433, -433, -433, -433, -433, -433, -433, -433, -433,
     -433, -433, -433, -433, -433, -433, -433, -433, -433, -433,
     -433, -433, -433, -433, -433, -433, -433, -433,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -433, -433,
     -433, -433, -433, -433, -433,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  542,  227,  227,  543,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -433, -433, -433, -433,  227, -433,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  542,  227,
      227,  543,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -433, -433, -433, -433,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -434, -434, -434, -434, -434, -434, -434, -434, -434,
     -434, -434, -434, -434, -434, -434, -434, -434, -434, -434,
     -434, -434, -434, -434, -434, -434, -434, -434, -434, -434,
     -434, -434, -434, -434, -434, -434, -434, -434, -434, -434,
     -434, -434, -434, -434, -434, -434, -434, -434,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -434, -434,

     -434, -434, -434, -434, -434,  227,  227,  227,  227,  227,
      227,  227,  227,  544,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -434, -434, -434, -434,  227, -434,  227,  227,  227,
      227,  227,  227,  227,  227,  544,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -434, -434, -434, -434,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -435, -435, -435, -435, -435, -435, -435, -435, -435,
     -435, -435, -435, -435, -435, -435, -435, -435, -435, -435,
     -435, -435, -435, -435, -435, -435, -435, -435, -435, -435,
     -435, -435, -435, -435, -435, -435, -435, -435, -435, -435,
     -435, -435, -435, -435, -435, -435, -435, -435,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -435, -435,
     -435, -435, -435, -435, -435,  227,  227,  227,  227,  227,
      227,  227,  227,  545,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  546,  227,  227,  227,  227,
      227, -435, -435, -435, -435,  227, -435,  227,  227,  227,

      227,  227,  227,  227,  227,  545,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  546,  227,  227,
      227,  227,  227, -435, -435, -435, -435,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -436, -436, -436, -436, -436, -436, -436, -436, -436,
     -436, -436, -436, -436, -436, -436, -436, -436, -436, -436,
     -436, -436, -436, -436, -436, -436, -436, -436, -436, -436,
     -436, -436, -436, -436, -436, -436, -436, -436, -436, -436,

     -436, -436, -436, -436, -436, -436, -436, -436,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -436, -436,
     -436, -436, -436, -436, -436,  547,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -436, -436, -436, -436,  227, -436,  547,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -436, -436, -436, -436,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -437, -437, -437, -437, -437, -437, -437, -437, -437,
     -437, -437, -437, -437, -437, -437, -437, -437, -437, -437,
     -437, -437, -437, -437, -437, -437, -437, -437, -437, -437,
     -437, -437, -437, -437, -437, -437, -437, -437, -437, -437,
     -437, -437, -437, -437, -437, -437, -437, -437,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -437, -437,
     -437, -437, -437, -437, -437,  227,  227,  227,  227,  227,
      227,  227,  227,  548,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -437, -437, -437, -437,  227, -437,  227,  227,  227,
      227,  227,  227,  227,  227,  548,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -437, -437, -437, -437,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -438, -438, -438, -438, -438, -438, -438, -438, -438,
     -438, -438, -438, -438, -438, -438, -438, -438, -438, -438,

     -438, -438, -438, -438, -438, -438, -438, -438, -438, -438,
     -438, -438, -438, -438, -438, -438, -438, -438, -438, -438,
     -438, -438, -438, -438, -438, -438, -438, -438,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -438, -438,
     -438, -438, -438, -438, -438,  227,  227,  227,  227,  549,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -438, -438, -438, -438,  227, -438,  227,  227,  227,
      227,  549,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -438, -438, -438, -438,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -439, -439, -439, -439, -439, -439, -439, -439, -439,
     -439, -439, -439, -439, -439, -439, -439, -439, -439, -439,
     -439, -439, -439, -439, -439, -439, -439, -439, -439, -439,
     -439, -439, -439, -439, -439, -439, -439, -439, -439, -439,
     -439, -439, -439, -439, -439, -439, -439, -439,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -439, -439,

     -439, -439, -439, -439, -439,  550,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -439, -439, -439, -439,  227, -439,  550,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -439, -439, -439, -439,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -440, -440, -440, -440, -440, -440, -440, -440, -440,
     -440, -440, -440, -440, -440, -440, -440, -440, -440, -440,
     -440, -440, -440, -440, -440, -440, -440, -440, -440, -440,
     -440, -440, -440, -440, -440, -440, -440, -440, -440, -440,
     -440, -440, -440, -440, -440, -440, -440, -440,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -440, -440,
     -440, -440, -440, -440, -440,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  551,  227,  227,  227,  227,  227,  227,  227,
      227, -440, -440, -440, -440,  227, -440,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  551,  227,  227,  227,  227,  227,
      227,  227,  227, -440, -440, -440, -440,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,

     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,

     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,

     -441, -441, -441, -441, -441, -441, -441, -441, -441, -441,
     -441, -441, -441, -441, -441, -441
    },

    {
       45,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  290,  289,  442,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289, -442, -442, -442, -442, -442,
     -442, -442, -442, -442, -442, -442, -442, -442, -442, -442,

     -442, -442, -442, -442, -442, -442, -442, -442, -442, -442,
     -442,  289,  293,  289,  289, -442,  289, -442, -442, -442,
     -442, -442, -442, -442, -442, -442, -442, -442, -442, -442,
     -442, -442, -442, -442, -442, -442, -442, -442, -442, -442,
     -442, -442, -442, -442,  289,  289,  289, -442, -442, -442,
     -442, -442, -442, -442, -442, -442, -442, -442, -442, -442,
     -442, -442, -442, -442, -442, -442, -442, -442, -442, -442,
     -442, -442, -442, -442, -442, -442, -442, -442, -442, -442,
     -442, -442, -442, -442, -442, -442, -442, -442, -442, -442,
     -442, -442, -442, -442, -442, -442, -442, -442, -442, -442,

     -442, -442, -442, -442, -442, -442, -442, -442, -442, -442,
     -442, -442, -442, -442, -442, -442, -442, -442, -442, -442,
     -442, -442, -442, -442, -442, -442, -442, -442, -442, -442,
     -442, -442, -442, -442, -442, -442, -442, -442, -442, -442,
     -442, -442, -442, -442, -442, -442, -442, -442, -442, -442,
     -442, -442, -442, -442, -442, -442, -442, -442, -442, -442,
     -442, -442, -442, -442, -442, -442, -442, -442, -442, -442,
     -442, -442, -442, -442, -442, -442
    },

    {
       45, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,

     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443,  552, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,

     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,

     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443, -443, -443, -443, -443,
     -443, -443, -443, -443, -443, -443
    },

    {
       45, -444, -444, -444, -444, -444, -444, -444, -444, -444,
     -444, -444, -444, -444, -444, -444, -444, -444, -444, -444,
     -444, -444, -444, -444, -444, -444, -444, -444, -444, -444,
     -444, -444, -444, -444, -444, -444, -444, -444, -444, -444,
     -444, -444, -444, -444, -444,  443, -444, -444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444, -444, -444,

     -444, -444, -444, -444, -444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  445, -444, -444, -444,  444, -444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444, -444, -444, -444, -444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,

      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444

    },

    {
       45, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,

     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,

     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445, -445, -445, -445, -445,
     -445, -445, -445, -445, -445, -445
    },

    {
       45,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  290,  285, -446,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  287,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  446,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,

      285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
      285,  285,  285,  285,  285,  285
    },

    {
       45,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  447,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
      301,  301,  301,  301,  301, -447, -447, -447, -447, -447,
     -447, -447, -447, -447, -447, -447, -447, -447, -447, -447,

     -447, -447, -447, -447, -447, -447, -447, -447, -447, -447,
     -447,  301,  303,  301,  301, -447,  304, -447, -447, -447,
     -447, -447, -447, -447, -447, -447, -447, -447, -447, -447,
     -447, -447, -447, -447, -447, -447, -447, -447, -447, -447,
     -447, -447, -447, -447,  301,  301,  301, -447, -447, -447,
     -447, -447, -447, -447, -447, -447, -447, -447, -447, -447,
     -447, -447, -447, -447, -447, -447, -447, -447, -447, -447,
     -447, -447, -447, -447, -447, -447, -447, -447, -447, -447,
     -447, -447, -447, -447, -447, -447, -447, -447, -447, -447,
     -447, -447, -447, -447, -447, -447, -447, -447, -447, -447,

     -447, -447, -447, -447, -447, -447, -447, -447, -447, -447,
     -447, -447, -447, -447, -447, -447, -447, -447, -447, -447,
     -447, -447, -447, -447, -447, -447, -447, -447, -447, -447,
     -447, -447, -447, -447, -447, -447, -447, -447, -447, -447,
     -447, -447, -447, -447, -447, -447, -447, -447, -447, -447,
     -447, -447, -447, -447, -447, -447, -447, -447, -447, -447,
     -447, -447, -447, -447, -447, -447, -447, -447, -447, -447,
     -447, -447, -447, -447, -447, -447
    },

    {
       45,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297, -448,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  299,  297,  297,  297,  304,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,

      297,  297,  297,  448,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,

      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297
    },

    {
       45, -449, -449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449, -449, -449,  449,  449,
      449,  449,  449,  449,  449,  449,  449,  449, -449, -449,

     -449, -449, -449, -449, -449,  449,  449,  449,  449,  449,
      449, -449, -449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449, -449,  449,  449,  449,
      449,  449,  449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449, -449, -449, -449, -449,

     -449, -449, -449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449, -449, -449, -449, -449,
     -449, -449, -449, -449, -449, -449

    },

    {
       45, -450, -450, -450, -450, -450, -450, -450, -450,  450,
      450, -450, -450,  450, -450, -450, -450, -450, -450, -450,
     -450, -450, -450, -450, -450, -450, -450, -450, -450, -450,
     -450, -450,  450, -450, -450,  451, -450, -450, -450, -450,
     -450, -450, -450, -450, -450, -450, -450,  553, -450, -450,
     -450, -450, -450, -450, -450, -450, -450, -450, -450, -450,
     -450, -450,  554, -450, -450,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554, -450, -450, -450, -450,  554, -450,  554,  554,  554,

      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554, -450, -450, -450, -450,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,

      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554
    },

    {
       45,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      450,  555,  555,  556,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,

      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,

      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,

      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555
    },

    {
       45, -452, -452, -452, -452, -452, -452, -452, -452, -452,
     -452, -452, -452, -452, -452, -452, -452, -452, -452, -452,
     -452, -452, -452, -452, -452, -452, -452, -452, -452, -452,
     -452, -452, -452, -452, -452, -452, -452, -452, -452, -452,
     -452, -452, -452, -452, -452, -452, -452, -452, -452, -452,
     -452, -452, -452, -452, -452, -452, -452, -452, -452, -452,
     -452, -452, -452, -452, -452,  557,  557,  557,  557,  557,
      557,  557,  557,  557,  557,  557,  557,  557,  557,  557,

      557,  557,  557,  557,  557,  557,  557,  557,  557,  557,
      557, -452, -452, -452, -452,  557, -452,  557,  557,  557,
      557,  557,  557,  557,  557,  557,  557,  557,  557,  557,
      557,  557,  557,  557,  557,  557,  557,  557,  557,  557,
      557,  557,  557, -452, -452, -452, -452,  557,  557,  557,
      557,  557,  557,  557,  557,  557,  557,  557,  557,  557,
      557,  557,  557,  557,  557,  557,  557,  557,  557,  557,
      557,  557,  557,  557,  557,  557,  557,  557,  557,  557,
      557,  557,  557,  557,  557,  557,  557,  557,  557,  557,
      557,  557,  557,  557,  557,  557,  557,  557,  557,  557,

      557,  557,  557,  557,  557,  557,  557,  557,  557,  557,
      557,  557,  557,  557,  557,  557,  557,  557,  557,  557,
      557,  557,  557,  557,  557,  557,  557,  557,  557,  557,
      557,  557,  557,  557,  557,  557,  557,  557,  557,  557,
      557,  557,  557,  557,  557,  557,  557,  557,  557,  557,
      557,  557,  557,  557,  557,  557,  557,  557,  557,  557,
      557,  557,  557,  557,  557,  557,  557,  557,  557,  557,
      557,  557,  557,  557,  557,  557
    },

    {
       45, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,

     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453,  558, -453, -453, -453, -453,  451, -453, -453,
     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453,  455, -453, -453, -453, -453, -453, -453, -453,
     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,

     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,

     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453, -453, -453, -453, -453, -453, -453, -453, -453,
     -453, -453, -453, -453, -453, -453
    },

    {
       45, -454, -454, -454, -454, -454, -454, -454, -454,  450,
      450, -454, -454,  450, -454, -454, -454, -454, -454, -454,
     -454, -454, -454, -454, -454, -454, -454, -454, -454, -454,
     -454, -454,  450, -454, -454,  451, -454, -454, -454, -454,
     -454, -454, -454, -454, -454,  452, -454,  453,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  452, -454,

     -454, -454,  455, -454, -454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454, -454, -454, -454, -454,  454, -454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454, -454, -454, -454, -454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,

      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  454,  454,  454,  454

    },

    {
       45, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,

     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,

     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455, -455, -455, -455, -455,
     -455, -455, -455, -455, -455, -455
    },

    {
       45, -456, -456, -456, -456, -456, -456, -456, -456, -456,
     -456, -456, -456, -456, -456, -456, -456, -456, -456, -456,
     -456, -456, -456, -456, -456, -456, -456, -456, -456, -456,
     -456, -456, -456, -456, -456, -456, -456, -456, -456, -456,

     -456, -456, -456, -456, -456,  325, -456, -456,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  325, -456,
     -456, -456, -456, -456, -456,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559, -456, -456, -456, -456,  559, -456,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559, -456, -456, -456, -456,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,

      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,

      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559
    },

    {
       45, -457, -457, -457, -457, -457, -457, -457, -457, -457,
     -457, -457, -457, -457, -457, -457, -457, -457, -457, -457,
     -457, -457, -457, -457, -457, -457, -457, -457, -457, -457,
     -457, -457, -457, -457, -457, -457, -457, -457, -457, -457,
     -457, -457, -457, -457, -457,  327, -457, -457,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  327, -457,
     -457, -457, -457, -457, -457,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,

      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560, -457, -457, -457, -457,  560, -457,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560, -457, -457, -457, -457,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,

      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560
    },

    {
       45, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,

     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458,  561, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,

     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,

     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458, -458, -458, -458, -458,
     -458, -458, -458, -458, -458, -458
    },

    {
       45, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,

     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,

     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459, -459, -459, -459, -459,
     -459, -459, -459, -459, -459, -459

    },

    {
       45,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562, -460,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      563,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,

      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,

      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562
    },

    {
       45,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460, -461,  460,  460,

      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
     -461,  460,  460, -461,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460, -461,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460, -461,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,

      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,

      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460
    },

    {
       45, -462, -462, -462, -462, -462, -462, -462, -462,  564,
      564, -462, -462,  565, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462,  564, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,

     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,

     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462, -462, -462, -462, -462,
     -462, -462, -462, -462, -462, -462
    },

    {
       45, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,

     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
      566, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463,  566, -463, -463, -463, -463, -463, -463, -463,

     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,

     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463, -463, -463, -463, -463,
     -463, -463, -463, -463, -463, -463
    },

    {
       45, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,

     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464,  567, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464,  567, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,

     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464, -464, -464, -464, -464,
     -464, -464, -464, -464, -464, -464

    },

    {
       45,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      569,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,

      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,

      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568
    },

    {
       45,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465, -466,  465,  465,

      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
     -466,  465,  465, -466,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465, -466,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465, -466,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,

      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,

      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465
    },

    {
       45, -467, -467, -467, -467, -467, -467, -467, -467, -467,
     -467, -467, -467, -467, -467, -467, -467, -467, -467, -467,
     -467, -467, -467, -467, -467, -467, -467, -467, -467, -467,
     -467, -467, -467, -467, -467, -467, -467, -467, -467, -467,
     -467, -467, -467, -467, -467,  348, -467, -467,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  348, -467,
     -467, -467, -467, -467, -467,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,

      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570, -467, -467, -467, -467,  570, -467,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570, -467, -467, -467, -467,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,

      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570
    },

    {
       45, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,

     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468,  571, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468, -468,  571, -468, -468,
     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,

     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,

     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468, -468, -468, -468, -468,
     -468, -468, -468, -468, -468, -468
    },

    {
       45, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,

     -469, -469, -469, -469, -469,  572, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469,  572, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,

     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469, -469, -469, -469, -469,
     -469, -469, -469, -469, -469, -469

    },

    {
       45, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470,  573, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,

     -470, -470, -470, -470, -470, -470, -470, -470,  573, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,

     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470, -470, -470, -470, -470,
     -470, -470, -470, -470, -470, -470
    },

    {
       45, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,

     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471,  574, -471, -471, -471,
     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471, -471, -471,  574, -471,
     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,

     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,

     -471, -471, -471, -471, -471, -471, -471, -471, -471, -471,
     -471, -471, -471, -471, -471, -471
    },

    {
       45, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472,  575, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,

     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472,  575, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,

     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472, -472, -472, -472, -472,
     -472, -472, -472, -472, -472, -472
    },

    {
       45, -473, -473, -473, -473, -473, -473, -473, -473,  576,
     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,

     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,
     -473, -473,  576, -473, -473, -473, -473, -473, -473, -473,
     -473,  577, -473, -473, -473, -473, -473, -473, -473, -473,
     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,
     -473, -473, -473, -473, -473, -473, -473, -473, -473,  578,
     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,
     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,
     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,
     -473,  578, -473, -473, -473, -473, -473, -473, -473, -473,
     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,

     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,
     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,
     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,
     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,
     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,
     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,
     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,
     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,
     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,
     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,

     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,
     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,
     -473, -473, -473, -473, -473, -473, -473, -473, -473, -473,
     -473, -473, -473, -473, -473, -473
    },

    {
       45, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,

     -474, -474, -474, -474, -474, -474, -474, -474, -474,  579,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474,  579, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,

     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474, -474, -474, -474, -474,
     -474, -474, -474, -474, -474, -474

    },

    {
       45, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475,  580, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,

     -475, -475, -475, -475, -475, -475, -475, -475,  580, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,

     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475, -475, -475, -475, -475,
     -475, -475, -475, -475, -475, -475
    },

    {
       45, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,

     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476,  581, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476,  581, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,

     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,

     -476, -476, -476, -476, -476, -476, -476, -476, -476, -476,
     -476, -476, -476, -476, -476, -476
    },

    {
       45, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477,  582,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,

     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477,  582, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,

     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477, -477, -477, -477, -477,
     -477, -477, -477, -477, -477, -477
    },

    {
       45, -478, -478, -478, -478, -478, -478, -478, -478,  478,
      478, -478, -478,  478, -478, -478, -478, -478, -478, -478,

     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478,  478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,

     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,

     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478, -478, -478, -478, -478,
     -478, -478, -478, -478, -478, -478
    },

    {
       45, -479, -479, -479, -479, -479, -479, -479, -479, -479,
     -479, -479, -479, -479, -479, -479, -479, -479, -479, -479,
     -479, -479, -479, -479, -479, -479, -479, -479, -479, -479,
     -479, -479, -479, -479, -479, -479, -479, -479, -479, -479,
     -479, -479, -479, -479, -479,  366, -479, -479,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  366, -479,

     -479, -479, -479, -479, -479,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583, -479, -479, -479, -479,  583, -479,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583, -479, -479, -479, -479,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,

      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583

    },

    {
       45, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480,  584, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,

     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480,  584, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,

     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480, -480, -480, -480, -480,
     -480, -480, -480, -480, -480, -480
    },

    {
       45, -481, -481, -481, -481, -481, -481, -481, -481,  481,
     -481, -481, -481, -481, -481, -481, -481, -481, -481, -481,
     -481, -481, -481, -481, -481, -481, -481, -481, -481, -481,
     -481, -481,  481, -481,  482, -481, -481, -481, -481,  483,

     -481, -481, -481, -481, -481, -481, -481, -481, -481, -481,
     -481, -481, -481, -481, -481, -481, -481, -481, -481, -481,
     -481, -481, -481, -481, -481,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484, -481, -481, -481, -481,  484, -481,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484, -481, -481, -481, -481,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,

      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,

      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484
    },

    {
       45, -482, -482, -482, -482, -482, -482, -482, -482, -482,
     -482, -482, -482, -482, -482, -482, -482, -482, -482, -482,
     -482, -482, -482, -482, -482, -482, -482, -482, -482, -482,
     -482, -482, -482, -482, -482, -482, -482, -482, -482, -482,
     -482, -482, -482, -482, -482, -482, -482, -482, -482, -482,
     -482, -482, -482, -482, -482, -482, -482, -482, -482, -482,
     -482, -482, -482, -482, -482,  585,  585,  585,  585,  585,
      585,  585,  585,  585,  585,  585,  585,  585,  585,  585,

      585,  585,  585,  585,  585,  585,  585,  585,  585,  585,
      585, -482, -482, -482, -482,  585, -482,  585,  585,  585,
      585,  585,  585,  585,  585,  585,  585,  585,  585,  585,
      585,  585,  585,  585,  585,  585,  585,  585,  585,  585,
      585,  585,  585, -482, -482, -482, -482,  585,  585,  585,
      585,  585,  585,  585,  585,  585,  585,  585,  585,  585,
      585,  585,  585,  585,  585,  585,  585,  585,  585,  585,
      585,  585,  585,  585,  585,  585,  585,  585,  585,  585,
      585,  585,  585,  585,  585,  585,  585,  585,  585,  585,
      585,  585,  585,  585,  585,  585,  585,  585,  585,  585,

      585,  585,  585,  585,  585,  585,  585,  585,  585,  585,
      585,  585,  585,  585,  585,  585,  585,  585,  585,  585,
      585,  585,  585,  585,  585,  585,  585,  585,  585,  585,
      585,  585,  585,  585,  585,  585,  585,  585,  585,  585,
      585,  585,  585,  585,  585,  585,  585,  585,  585,  585,
      585,  585,  585,  585,  585,  585,  585,  585,  585,  585,
      585,  585,  585,  585,  585,  585,  585,  585,  585,  585,
      585,  585,  585,  585,  585,  585
    },

    {
       45, -483, -483, -483, -483, -483, -483, -483, -483, -483,
     -483, -483, -483, -483, -483, -483, -483, -483, -483, -483,

     -483, -483, -483, -483, -483, -483, -483, -483, -483, -483,
     -483, -483, -483, -483, -483, -483, -483, -483, -483, -483,
     -483, -483, -483, -483, -483, -483, -483, -483, -483, -483,
     -483, -483, -483, -483, -483, -483, -483, -483, -483, -483,
     -483, -483, -483, -483, -483,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586, -483, -483, -483, -483,  586, -483,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,

      586,  586,  586, -483, -483, -483, -483,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,

      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586
    },

    {
       45, -484, -484, -484, -484, -484, -484, -484, -484, -484,
      587, -484, -484,  588, -484, -484, -484, -484, -484, -484,
     -484, -484, -484, -484, -484, -484, -484, -484, -484, -484,
     -484, -484, -484, -484, -484, -484, -484, -484, -484, -484,
     -484, -484, -484, -484, -484, -484, -484, -484,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589, -484, -484,

     -484, -484, -484, -484, -484,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589, -484, -484, -484, -484,  589, -484,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589, -484, -484, -484, -484,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,

      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589

    },

    {
       45, -485, -485, -485, -485, -485, -485, -485, -485, -485,
     -485, -485, -485, -485, -485, -485, -485, -485, -485, -485,
     -485, -485, -485, -485, -485, -485, -485, -485, -485, -485,
     -485, -485, -485, -485, -485, -485, -485, -485, -485, -485,
     -485, -485, -485, -485, -485, -485, -485, -485,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -485, -485,
     -485, -485, -485, -485, -485,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  590,  227,  227,  227,  227,  227,  227,  227,
      227, -485, -485, -485, -485,  227, -485,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  590,  227,  227,  227,  227,  227,
      227,  227,  227, -485, -485, -485, -485,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -486, -486, -486, -486, -486, -486, -486, -486, -486,
     -486, -486, -486, -486, -486, -486, -486, -486, -486, -486,
     -486, -486, -486, -486, -486, -486, -486, -486, -486, -486,
     -486, -486, -486, -486, -486, -486, -486, -486, -486, -486,

     -486, -486, -486, -486, -486, -486, -486, -486,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -486, -486,
     -486, -486, -486, -486, -486,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  591,
      227, -486, -486, -486, -486,  227, -486,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  591,  227, -486, -486, -486, -486,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -487, -487, -487, -487, -487, -487, -487, -487, -487,
     -487, -487, -487, -487, -487, -487, -487, -487, -487, -487,
     -487, -487, -487, -487, -487, -487, -487, -487, -487, -487,
     -487, -487, -487, -487, -487, -487, -487, -487, -487, -487,
     -487, -487, -487, -487, -487, -487, -487, -487,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -487, -487,
     -487, -487, -487, -487, -487,  227,  227,  592,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -487, -487, -487, -487,  227, -487,  227,  227,  592,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -487, -487, -487, -487,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -488, -488, -488, -488, -488, -488, -488, -488, -488,
     -488, -488, -488, -488, -488, -488, -488, -488, -488, -488,

     -488, -488, -488, -488, -488, -488, -488, -488, -488, -488,
     -488, -488, -488, -488, -488, -488, -488, -488, -488, -488,
     -488, -488, -488, -488, -488, -488, -488, -488,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -488, -488,
     -488, -488, -488, -488, -488,  227,  227,  227,  227,  227,
      227,  227,  227,  593,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -488, -488, -488, -488,  227, -488,  227,  227,  227,
      227,  227,  227,  227,  227,  593,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -488, -488, -488, -488,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -489, -489, -489, -489, -489, -489, -489, -489, -489,
     -489, -489, -489, -489, -489, -489, -489, -489, -489, -489,
     -489, -489, -489, -489, -489, -489, -489, -489, -489, -489,
     -489, -489, -489, -489, -489, -489, -489, -489, -489, -489,
     -489, -489, -489, -489, -489, -489, -489, -489,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -489, -489,

     -489, -489, -489, -489, -489,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  594,  227,  227,  227,  227,  227,
      227, -489, -489, -489, -489,  227, -489,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  594,  227,  227,  227,
      227,  227,  227, -489, -489, -489, -489,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -490, -490, -490, -490, -490, -490, -490, -490, -490,
     -490, -490, -490, -490, -490, -490, -490, -490, -490, -490,
     -490, -490, -490, -490, -490, -490, -490, -490, -490, -490,
     -490, -490, -490, -490, -490, -490, -490, -490, -490, -490,
     -490, -490, -490, -490, -490, -490, -490, -490,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -490, -490,
     -490, -490, -490, -490, -490,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  595,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -490, -490, -490, -490,  227, -490,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  595,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -490, -490, -490, -490,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -491, -491, -491, -491, -491, -491, -491, -491, -491,
     -491, -491, -491, -491, -491, -491, -491, -491, -491, -491,
     -491, -491, -491, -491, -491, -491, -491, -491, -491, -491,
     -491, -491, -491, -491, -491, -491, -491, -491, -491, -491,

     -491, -491, -491, -491, -491, -491, -491, -491,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -491, -491,
     -491, -491, -491, -491, -491,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -491, -491, -491, -491,  227, -491,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -491, -491, -491, -491,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -492, -492, -492, -492, -492, -492, -492, -492, -492,
     -492, -492, -492, -492, -492, -492, -492, -492, -492, -492,
     -492, -492, -492, -492, -492, -492, -492, -492, -492, -492,
     -492, -492, -492, -492, -492, -492, -492, -492, -492, -492,
     -492, -492, -492, -492, -492, -492, -492, -492,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -492, -492,
     -492, -492, -492, -492, -492,  227,  227,  227,  227,  227,
      227,  227,  596,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -492, -492, -492, -492,  227, -492,  227,  227,  227,
      227,  227,  227,  227,  596,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -492, -492, -492, -492,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -493, -493, -493, -493, -493, -493, -493, -493, -493,
     -493, -493, -493, -493, -493, -493, -493, -493, -493, -493,

     -493, -493, -493, -493, -493, -493, -493, -493, -493, -493,
     -493, -493, -493, -493, -493, -493, -493, -493, -493, -493,
     -493, -493, -493, -493, -493, -493, -493, -493,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -493, -493,
     -493, -493, -493, -493, -493,  227,  227,  227,  227,  227,
      227,  597,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -493, -493, -493, -493,  227, -493,  227,  227,  227,
      227,  227,  227,  597,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -493, -493, -493, -493,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -494, -494, -494, -494, -494, -494, -494, -494, -494,
     -494, -494, -494, -494, -494, -494, -494, -494, -494, -494,
     -494, -494, -494, -494, -494, -494, -494, -494, -494, -494,
     -494, -494, -494, -494, -494, -494, -494, -494, -494, -494,
     -494, -494, -494, -494, -494, -494, -494, -494,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -494, -494,

     -494, -494, -494, -494, -494,  227,  227,  227,  598,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -494, -494, -494, -494,  227, -494,  227,  227,  227,
      598,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -494, -494, -494, -494,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -495, -495, -495, -495, -495, -495, -495, -495, -495,
     -495, -495, -495, -495, -495, -495, -495, -495, -495, -495,
     -495, -495, -495, -495, -495, -495, -495, -495, -495, -495,
     -495, -495, -495, -495, -495, -495, -495, -495, -495, -495,
     -495, -495, -495, -495, -495, -495, -495, -495,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -495, -495,
     -495, -495, -495, -495, -495,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  599,  227,  227,  227,  227,  227,  227,
      227, -495, -495, -495, -495,  227, -495,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  599,  227,  227,  227,  227,
      227,  227,  227, -495, -495, -495, -495,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -496, -496, -496, -496, -496, -496, -496, -496, -496,
     -496, -496, -496, -496, -496, -496, -496, -496, -496, -496,
     -496, -496, -496, -496, -496, -496, -496, -496, -496, -496,
     -496, -496, -496, -496, -496, -496, -496, -496, -496, -496,

     -496, -496, -496, -496, -496, -496, -496, -496,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -496, -496,
     -496, -496, -496, -496, -496,  227,  227,  227,  227,  600,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -496, -496, -496, -496,  227, -496,  227,  227,  227,
      227,  600,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -496, -496, -496, -496,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -497, -497, -497, -497, -497, -497, -497, -497, -497,
     -497, -497, -497, -497, -497, -497, -497, -497, -497, -497,
     -497, -497, -497, -497, -497, -497, -497, -497, -497, -497,
     -497, -497, -497, -497, -497, -497, -497, -497, -497, -497,
     -497, -497, -497, -497, -497, -497, -497, -497,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -497, -497,
     -497, -497, -497, -497, -497,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  601,  227,  227,  227,  227,  227,
      227, -497, -497, -497, -497,  227, -497,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  601,  227,  227,  227,
      227,  227,  227, -497, -497, -497, -497,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -498, -498, -498, -498, -498, -498, -498, -498, -498,
     -498, -498, -498, -498, -498, -498, -498, -498, -498, -498,

     -498, -498, -498, -498, -498, -498, -498, -498, -498, -498,
     -498, -498, -498, -498, -498, -498, -498, -498, -498, -498,
     -498, -498, -498, -498, -498, -498, -498, -498,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -498, -498,
     -498, -498, -498, -498, -498,  227,  227,  227,  227,  227,
      227,  227,  227,  602,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -498, -498, -498, -498,  227, -498,  227,  227,  227,
      227,  227,  227,  227,  227,  602,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -498, -498, -498, -498,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -499, -499, -499, -499, -499, -499, -499, -499, -499,
     -499, -499, -499, -499, -499, -499, -499, -499, -499, -499,
     -499, -499, -499, -499, -499, -499, -499, -499, -499, -499,
     -499, -499, -499, -499, -499, -499, -499, -499, -499, -499,
     -499, -499, -499, -499, -499, -499, -499, -499,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -499, -499,

     -499, -499, -499, -499, -499,  603,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -499, -499, -499, -499,  227, -499,  603,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -499, -499, -499, -499,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -500, -500, -500, -500, -500, -500, -500, -500, -500,
     -500, -500, -500, -500, -500, -500, -500, -500, -500, -500,
     -500, -500, -500, -500, -500, -500, -500, -500, -500, -500,
     -500, -500, -500, -500, -500, -500, -500, -500, -500, -500,
     -500, -500, -500, -500, -500, -500, -500, -500,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -500, -500,
     -500, -500, -500, -500, -500,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  604,  227,  227,  227,  227,
      227, -500, -500, -500, -500,  227, -500,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  604,  227,  227,
      227,  227,  227, -500, -500, -500, -500,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -501, -501, -501, -501, -501, -501, -501, -501, -501,
     -501, -501, -501, -501, -501, -501, -501, -501, -501, -501,
     -501, -501, -501, -501, -501, -501, -501, -501, -501, -501,
     -501, -501, -501, -501, -501, -501, -501, -501, -501, -501,

     -501, -501, -501, -501, -501, -501, -501, -501,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -501, -501,
     -501, -501, -501, -501, -501,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -501, -501, -501, -501,  227, -501,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -501, -501, -501, -501,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -502, -502, -502, -502, -502, -502, -502, -502, -502,
     -502, -502, -502, -502, -502, -502, -502, -502, -502, -502,
     -502, -502, -502, -502, -502, -502, -502, -502, -502, -502,
     -502, -502, -502, -502, -502, -502, -502, -502, -502, -502,
     -502, -502, -502, -502, -502, -502, -502, -502,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -502, -502,
     -502, -502, -502, -502, -502,  227,  227,  227,  227,  227,
      227,  227,  227,  605,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -502, -502, -502, -502,  227, -502,  227,  227,  227,
      227,  227,  227,  227,  227,  605,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -502, -502, -502, -502,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -503, -503, -503, -503, -503, -503, -503, -503, -503,
     -503, -503, -503, -503, -503, -503, -503, -503, -503, -503,

     -503, -503, -503, -503, -503, -503, -503, -503, -503, -503,
     -503, -503, -503, -503, -503, -503, -503, -503, -503, -503,
     -503, -503, -503, -503, -503, -503, -503, -503,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -503, -503,
     -503, -503, -503, -503, -503,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  606,
      227, -503, -503, -503, -503,  227, -503,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  606,  227, -503, -503, -503, -503,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -504, -504, -504, -504, -504, -504, -504, -504, -504,
     -504, -504, -504, -504, -504, -504, -504, -504, -504, -504,
     -504, -504, -504, -504, -504, -504, -504, -504, -504, -504,
     -504, -504, -504, -504, -504, -504, -504, -504, -504, -504,
     -504, -504, -504, -504, -504, -504, -504, -504,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -504, -504,

     -504, -504, -504, -504, -504,  227,  227,  227,  227,  607,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -504, -504, -504, -504,  227, -504,  227,  227,  227,
      227,  607,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -504, -504, -504, -504,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -505, -505, -505, -505, -505, -505, -505, -505, -505,
     -505, -505, -505, -505, -505, -505, -505, -505, -505, -505,
     -505, -505, -505, -505, -505, -505, -505, -505, -505, -505,
     -505, -505, -505, -505, -505, -505, -505, -505, -505, -505,
     -505, -505, -505, -505, -505, -505, -505, -505,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -505, -505,
     -505, -505, -505, -505, -505,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  608,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -505, -505, -505, -505,  227, -505,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  608,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -505, -505, -505, -505,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -506, -506, -506, -506, -506, -506, -506, -506, -506,
     -506, -506, -506, -506, -506, -506, -506, -506, -506, -506,
     -506, -506, -506, -506, -506, -506, -506, -506, -506, -506,
     -506, -506, -506, -506, -506, -506, -506, -506, -506, -506,

     -506, -506, -506, -506, -506, -506, -506, -506,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -506, -506,
     -506, -506, -506, -506, -506,  227,  227,  227,  227,  227,
      609,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -506, -506, -506, -506,  227, -506,  227,  227,  227,
      227,  227,  609,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -506, -506, -506, -506,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -507, -507, -507, -507, -507, -507, -507, -507, -507,
     -507, -507, -507, -507, -507, -507, -507, -507, -507, -507,
     -507, -507, -507, -507, -507, -507, -507, -507, -507, -507,
     -507, -507, -507, -507, -507, -507, -507, -507, -507, -507,
     -507, -507, -507, -507, -507, -507, -507, -507,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -507, -507,
     -507, -507, -507, -507, -507,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  610,  227,  227,
      227, -507, -507, -507, -507,  227, -507,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  610,
      227,  227,  227, -507, -507, -507, -507,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -508, -508, -508, -508, -508, -508, -508, -508, -508,
     -508, -508, -508, -508, -508, -508, -508, -508, -508, -508,

     -508, -508, -508, -508, -508, -508, -508, -508, -508, -508,
     -508, -508, -508, -508, -508, -508, -508, -508, -508, -508,
     -508, -508, -508, -508, -508, -508, -508, -508,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -508, -508,
     -508, -508, -508, -508, -508,  227,  227,  227,  227,  227,
      227,  227,  611,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -508, -508, -508, -508,  227, -508,  227,  227,  227,
      227,  227,  227,  227,  611,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -508, -508, -508, -508,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -509, -509, -509, -509, -509, -509, -509, -509, -509,
     -509, -509, -509, -509, -509, -509, -509, -509, -509, -509,
     -509, -509, -509, -509, -509, -509, -509, -509, -509, -509,
     -509, -509, -509, -509, -509, -509, -509, -509, -509, -509,
     -509, -509, -509, -509, -509, -509, -509, -509,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -509, -509,

     -509, -509, -509, -509, -509,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -509, -509, -509, -509,  227, -509,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -509, -509, -509, -509,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -510, -510, -510, -510, -510, -510, -510, -510, -510,
     -510, -510, -510, -510, -510, -510, -510, -510, -510, -510,
     -510, -510, -510, -510, -510, -510, -510, -510, -510, -510,
     -510, -510, -510, -510, -510, -510, -510, -510, -510, -510,
     -510, -510, -510, -510, -510, -510, -510, -510,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -510, -510,
     -510, -510, -510, -510, -510,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -510, -510, -510, -510,  227, -510,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -510, -510, -510, -510,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -511, -511, -511, -511, -511, -511, -511, -511, -511,
     -511, -511, -511, -511, -511, -511, -511, -511, -511, -511,
     -511, -511, -511, -511, -511, -511, -511, -511, -511, -511,
     -511, -511, -511, -511, -511, -511, -511, -511, -511, -511,

     -511, -511, -511, -511, -511, -511, -511, -511,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -511, -511,
     -511, -511, -511, -511, -511,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -511, -511, -511, -511,  227, -511,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -511, -511, -511, -511,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -512, -512, -512, -512, -512, -512, -512, -512, -512,
     -512, -512, -512, -512, -512, -512, -512, -512, -512, -512,
     -512, -512, -512, -512, -512, -512, -512, -512, -512, -512,
     -512, -512, -512, -512, -512, -512, -512, -512, -512, -512,
     -512, -512, -512, -512, -512, -512, -512, -512,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -512, -512,
     -512, -512, -512, -512, -512,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  612,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -512, -512, -512, -512,  227, -512,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      612,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -512, -512, -512, -512,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -513, -513, -513, -513, -513, -513, -513, -513, -513,
     -513, -513, -513, -513, -513, -513, -513, -513, -513, -513,

     -513, -513, -513, -513, -513, -513, -513, -513, -513, -513,
     -513, -513, -513, -513, -513, -513, -513, -513, -513, -513,
     -513, -513, -513, -513, -513, -513, -513, -513,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -513, -513,
     -513, -513, -513, -513, -513,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  613,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -513, -513, -513, -513,  227, -513,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  613,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -513, -513, -513, -513,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -514, -514, -514, -514, -514, -514, -514, -514, -514,
     -514, -514, -514, -514, -514, -514, -514, -514, -514, -514,
     -514, -514, -514, -514, -514, -514, -514, -514, -514, -514,
     -514, -514, -514, -514, -514, -514, -514, -514, -514, -514,
     -514, -514, -514, -514, -514, -514, -514, -514,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -514, -514,

     -514, -514, -514, -514, -514,  614,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -514, -514, -514, -514,  227, -514,  614,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -514, -514, -514, -514,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -515, -515, -515, -515, -515, -515, -515, -515, -515,
     -515, -515, -515, -515, -515, -515, -515, -515, -515, -515,
     -515, -515, -515, -515, -515, -515, -515, -515, -515, -515,
     -515, -515, -515, -515, -515, -515, -515, -515, -515, -515,
     -515, -515, -515, -515, -515, -515, -515, -515,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -515, -515,
     -515, -515, -515, -515, -515,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  615,  227,  227,  227,  227,  227,
      227, -515, -515, -515, -515,  227, -515,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  615,  227,  227,  227,
      227,  227,  227, -515, -515, -515, -515,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -516, -516, -516, -516, -516, -516, -516, -516, -516,
     -516, -516, -516, -516, -516, -516, -516, -516, -516, -516,
     -516, -516, -516, -516, -516, -516, -516, -516, -516, -516,
     -516, -516, -516, -516, -516, -516, -516, -516, -516, -516,

     -516, -516, -516, -516, -516, -516, -516, -516,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -516, -516,
     -516, -516, -516, -516, -516,  616,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -516, -516, -516, -516,  227, -516,  616,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -516, -516, -516, -516,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -517, -517, -517, -517, -517, -517, -517, -517, -517,
     -517, -517, -517, -517, -517, -517, -517, -517, -517, -517,
     -517, -517, -517, -517, -517, -517, -517, -517, -517, -517,
     -517, -517, -517, -517, -517, -517, -517, -517, -517, -517,
     -517, -517, -517, -517, -517, -517, -517, -517,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -517, -517,
     -517, -517, -517, -517, -517,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -517, -517, -517, -517,  227, -517,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -517, -517, -517, -517,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -518, -518, -518, -518, -518, -518, -518, -518, -518,
     -518, -518, -518, -518, -518, -518, -518, -518, -518, -518,

     -518, -518, -518, -518, -518, -518, -518, -518, -518, -518,
     -518, -518, -518, -518, -518, -518, -518, -518, -518, -518,
     -518, -518, -518, -518, -518, -518, -518, -518,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -518, -518,
     -518, -518, -518, -518, -518,  227,  227,  227,  227,  617,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -518, -518, -518, -518,  227, -518,  227,  227,  227,
      227,  617,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -518, -518, -518, -518,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -519, -519, -519, -519, -519, -519, -519, -519, -519,
     -519, -519, -519, -519, -519, -519, -519, -519, -519, -519,
     -519, -519, -519, -519, -519, -519, -519, -519, -519, -519,
     -519, -519, -519, -519, -519, -519, -519, -519, -519, -519,
     -519, -519, -519, -519, -519, -519, -519, -519,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -519, -519,

     -519, -519, -519, -519, -519,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  618,  227,  227,  227,  227,
      227, -519, -519, -519, -519,  227, -519,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  618,  227,  227,
      227,  227,  227, -519, -519, -519, -519,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -520, -520, -520, -520, -520, -520, -520, -520, -520,
     -520, -520, -520, -520, -520, -520, -520, -520, -520, -520,
     -520, -520, -520, -520, -520, -520, -520, -520, -520, -520,
     -520, -520, -520, -520, -520, -520, -520, -520, -520, -520,
     -520, -520, -520, -520, -520, -520, -520, -520,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -520, -520,
     -520, -520, -520, -520, -520,  619,  227,  227,  227,  620,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -520, -520, -520, -520,  227, -520,  619,  227,  227,

      227,  620,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -520, -520, -520, -520,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -521, -521, -521, -521, -521, -521, -521, -521, -521,
     -521, -521, -521, -521, -521, -521, -521, -521, -521, -521,
     -521, -521, -521, -521, -521, -521, -521, -521, -521, -521,
     -521, -521, -521, -521, -521, -521, -521, -521, -521, -521,

     -521, -521, -521, -521, -521, -521, -521, -521,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -521, -521,
     -521, -521, -521, -521, -521,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  621,  227,  227,  227,  227,  227,  227,  227,
      227, -521, -521, -521, -521,  227, -521,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  621,  227,  227,  227,  227,  227,
      227,  227,  227, -521, -521, -521, -521,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -522, -522, -522, -522, -522, -522, -522, -522, -522,
     -522, -522, -522, -522, -522, -522, -522, -522, -522, -522,
     -522, -522, -522, -522, -522, -522, -522, -522, -522, -522,
     -522, -522, -522, -522, -522, -522, -522, -522, -522, -522,
     -522, -522, -522, -522, -522, -522, -522, -522,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -522, -522,
     -522, -522, -522, -522, -522,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  622,  227,  227,  227,  227,  227,
      227, -522, -522, -522, -522,  227, -522,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  622,  227,  227,  227,
      227,  227,  227, -522, -522, -522, -522,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -523, -523, -523, -523, -523, -523, -523, -523, -523,
     -523, -523, -523, -523, -523, -523, -523, -523, -523, -523,

     -523, -523, -523, -523, -523, -523, -523, -523, -523, -523,
     -523, -523, -523, -523, -523, -523, -523, -523, -523, -523,
     -523, -523, -523, -523, -523, -523, -523, -523,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -523, -523,
     -523, -523, -523, -523, -523,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -523, -523, -523, -523,  227, -523,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -523, -523, -523, -523,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -524, -524, -524, -524, -524, -524, -524, -524, -524,
     -524, -524, -524, -524, -524, -524, -524, -524, -524, -524,
     -524, -524, -524, -524, -524, -524, -524, -524, -524, -524,
     -524, -524, -524, -524, -524, -524, -524, -524, -524, -524,
     -524, -524, -524, -524, -524, -524, -524, -524,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -524, -524,

     -524, -524, -524, -524, -524,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  623,  227,  227,  227,  227,  227,  227,
      227, -524, -524, -524, -524,  227, -524,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  623,  227,  227,  227,  227,
      227,  227,  227, -524, -524, -524, -524,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -525, -525, -525, -525, -525, -525, -525, -525, -525,
     -525, -525, -525, -525, -525, -525, -525, -525, -525, -525,
     -525, -525, -525, -525, -525, -525, -525, -525, -525, -525,
     -525, -525, -525, -525, -525, -525, -525, -525, -525, -525,
     -525, -525, -525, -525, -525, -525, -525, -525,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -525, -525,
     -525, -525, -525, -525, -525,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  624,
      227, -525, -525, -525, -525,  227, -525,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  624,  227, -525, -525, -525, -525,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -526, -526, -526, -526, -526, -526, -526, -526, -526,
     -526, -526, -526, -526, -526, -526, -526, -526, -526, -526,
     -526, -526, -526, -526, -526, -526, -526, -526, -526, -526,
     -526, -526, -526, -526, -526, -526, -526, -526, -526, -526,

     -526, -526, -526, -526, -526, -526, -526, -526,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -526, -526,
     -526, -526, -526, -526, -526,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  625,  227,  227,  227,  227,  227,
      227, -526, -526, -526, -526,  227, -526,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  625,  227,  227,  227,
      227,  227,  227, -526, -526, -526, -526,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -527, -527, -527, -527, -527, -527, -527, -527, -527,
     -527, -527, -527, -527, -527, -527, -527, -527, -527, -527,
     -527, -527, -527, -527, -527, -527, -527, -527, -527, -527,
     -527, -527, -527, -527, -527, -527, -527, -527, -527, -527,
     -527, -527, -527, -527, -527, -527, -527, -527,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -527, -527,
     -527, -527, -527, -527, -527,  626,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -527, -527, -527, -527,  227, -527,  626,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -527, -527, -527, -527,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -528, -528, -528, -528, -528, -528, -528, -528, -528,
     -528, -528, -528, -528, -528, -528, -528, -528, -528, -528,

     -528, -528, -528, -528, -528, -528, -528, -528, -528, -528,
     -528, -528, -528, -528, -528, -528, -528, -528, -528, -528,
     -528, -528, -528, -528, -528, -528, -528, -528,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -528, -528,
     -528, -528, -528, -528, -528,  227,  227,  227,  227,  627,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -528, -528, -528, -528,  227, -528,  227,  227,  227,
      227,  627,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -528, -528, -528, -528,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -529, -529, -529, -529, -529, -529, -529, -529, -529,
     -529, -529, -529, -529, -529, -529, -529, -529, -529, -529,
     -529, -529, -529, -529, -529, -529, -529, -529, -529, -529,
     -529, -529, -529, -529, -529, -529, -529, -529, -529, -529,
     -529, -529, -529, -529, -529, -529, -529, -529,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -529, -529,

     -529, -529, -529, -529, -529,  227,  227,  227,  227,  227,
      227,  227,  227,  628,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -529, -529, -529, -529,  227, -529,  227,  227,  227,
      227,  227,  227,  227,  227,  628,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -529, -529, -529, -529,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -530, -530, -530, -530, -530, -530, -530, -530, -530,
     -530, -530, -530, -530, -530, -530, -530, -530, -530, -530,
     -530, -530, -530, -530, -530, -530, -530, -530, -530, -530,
     -530, -530, -530, -530, -530, -530, -530, -530, -530, -530,
     -530, -530, -530, -530, -530, -530, -530, -530,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -530, -530,
     -530, -530, -530, -530, -530,  227,  227,  227,  227,  227,
      227,  227,  227,  629,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -530, -530, -530, -530,  227, -530,  227,  227,  227,

      227,  227,  227,  227,  227,  629,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -530, -530, -530, -530,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -531, -531, -531, -531, -531, -531, -531, -531, -531,
     -531, -531, -531, -531, -531, -531, -531, -531, -531, -531,
     -531, -531, -531, -531, -531, -531, -531, -531, -531, -531,
     -531, -531, -531, -531, -531, -531, -531, -531, -531, -531,

     -531, -531, -531, -531, -531, -531, -531, -531,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -531, -531,
     -531, -531, -531, -531, -531,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  630,  227,  227,  227,  227,  227,  227,  227,
      227, -531, -531, -531, -531,  227, -531,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  630,  227,  227,  227,  227,  227,
      227,  227,  227, -531, -531, -531, -531,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -532, -532, -532, -532, -532, -532, -532, -532, -532,
     -532, -532, -532, -532, -532, -532, -532, -532, -532, -532,
     -532, -532, -532, -532, -532, -532, -532, -532, -532, -532,
     -532, -532, -532, -532, -532, -532, -532, -532, -532, -532,
     -532, -532, -532, -532, -532, -532, -532, -532,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -532, -532,
     -532, -532, -532, -532, -532,  227,  227,  227,  227,  631,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -532, -532, -532, -532,  227, -532,  227,  227,  227,
      227,  631,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -532, -532, -532, -532,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -533, -533, -533, -533, -533, -533, -533, -533, -533,
     -533, -533, -533, -533, -533, -533, -533, -533, -533, -533,

     -533, -533, -533, -533, -533, -533, -533, -533, -533, -533,
     -533, -533, -533, -533, -533, -533, -533, -533, -533, -533,
     -533, -533, -533, -533, -533, -533, -533, -533,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -533, -533,
     -533, -533, -533, -533, -533,  227,  227,  227,  227,  227,
      227,  227,  227,  632,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -533, -533, -533, -533,  227, -533,  227,  227,  227,
      227,  227,  227,  227,  227,  632,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -533, -533, -533, -533,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -534, -534, -534, -534, -534, -534, -534, -534, -534,
     -534, -534, -534, -534, -534, -534, -534, -534, -534, -534,
     -534, -534, -534, -534, -534, -534, -534, -534, -534, -534,
     -534, -534, -534, -534, -534, -534, -534, -534, -534, -534,
     -534, -534, -534, -534, -534, -534, -534, -534,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -534, -534,

     -534, -534, -534, -534, -534,  227,  227,  633,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -534, -534, -534, -534,  227, -534,  227,  227,  633,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -534, -534, -534, -534,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -535, -535, -535, -535, -535, -535, -535, -535, -535,
     -535, -535, -535, -535, -535, -535, -535, -535, -535, -535,
     -535, -535, -535, -535, -535, -535, -535, -535, -535, -535,
     -535, -535, -535, -535, -535, -535, -535, -535, -535, -535,
     -535, -535, -535, -535, -535, -535, -535, -535,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -535, -535,
     -535, -535, -535, -535, -535,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  634,  227,  227,
      227, -535, -535, -535, -535,  227, -535,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  634,
      227,  227,  227, -535, -535, -535, -535,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -536, -536, -536, -536, -536, -536, -536, -536, -536,
     -536, -536, -536, -536, -536, -536, -536, -536, -536, -536,
     -536, -536, -536, -536, -536, -536, -536, -536, -536, -536,
     -536, -536, -536, -536, -536, -536, -536, -536, -536, -536,

     -536, -536, -536, -536, -536, -536, -536, -536,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -536, -536,
     -536, -536, -536, -536, -536,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  635,  227,  227,  227,  227,  227,
      227, -536, -536, -536, -536,  227, -536,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  635,  227,  227,  227,
      227,  227,  227, -536, -536, -536, -536,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -537, -537, -537, -537, -537, -537, -537, -537, -537,
     -537, -537, -537, -537, -537, -537, -537, -537, -537, -537,
     -537, -537, -537, -537, -537, -537, -537, -537, -537, -537,
     -537, -537, -537, -537, -537, -537, -537, -537, -537, -537,
     -537, -537, -537, -537, -537, -537, -537, -537,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -537, -537,
     -537, -537, -537, -537, -537,  227,  227,  227,  227,  636,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -537, -537, -537, -537,  227, -537,  227,  227,  227,
      227,  636,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -537, -537, -537, -537,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -538, -538, -538, -538, -538, -538, -538, -538, -538,
     -538, -538, -538, -538, -538, -538, -538, -538, -538, -538,

     -538, -538, -538, -538, -538, -538, -538, -538, -538, -538,
     -538, -538, -538, -538, -538, -538, -538, -538, -538, -538,
     -538, -538, -538, -538, -538, -538, -538, -538,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -538, -538,
     -538, -538, -538, -538, -538,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -538, -538, -538, -538,  227, -538,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -538, -538, -538, -538,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -539, -539, -539, -539, -539, -539, -539, -539, -539,
     -539, -539, -539, -539, -539, -539, -539, -539, -539, -539,
     -539, -539, -539, -539, -539, -539, -539, -539, -539, -539,
     -539, -539, -539, -539, -539, -539, -539, -539, -539, -539,
     -539, -539, -539, -539, -539, -539, -539, -539,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -539, -539,

     -539, -539, -539, -539, -539,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  637,  227,  227,  227,  227,  227,
      227, -539, -539, -539, -539,  227, -539,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  637,  227,  227,  227,
      227,  227,  227, -539, -539, -539, -539,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -540, -540, -540, -540, -540, -540, -540, -540, -540,
     -540, -540, -540, -540, -540, -540, -540, -540, -540, -540,
     -540, -540, -540, -540, -540, -540, -540, -540, -540, -540,
     -540, -540, -540, -540, -540, -540, -540, -540, -540, -540,
     -540, -540, -540, -540, -540, -540, -540, -540,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -540, -540,
     -540, -540, -540, -540, -540,  227,  227,  227,  227,  638,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -540, -540, -540, -540,  227, -540,  227,  227,  227,

      227,  638,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -540, -540, -540, -540,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -541, -541, -541, -541, -541, -541, -541, -541, -541,
     -541, -541, -541, -541, -541, -541, -541, -541, -541, -541,
     -541, -541, -541, -541, -541, -541, -541, -541, -541, -541,
     -541, -541, -541, -541, -541, -541, -541, -541, -541, -541,

     -541, -541, -541, -541, -541, -541, -541, -541,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -541, -541,
     -541, -541, -541, -541, -541,  227,  227,  227,  639,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -541, -541, -541, -541,  227, -541,  227,  227,  227,
      639,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -541, -541, -541, -541,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -542, -542, -542, -542, -542, -542, -542, -542, -542,
     -542, -542, -542, -542, -542, -542, -542, -542, -542, -542,
     -542, -542, -542, -542, -542, -542, -542, -542, -542, -542,
     -542, -542, -542, -542, -542, -542, -542, -542, -542, -542,
     -542, -542, -542, -542, -542, -542, -542, -542,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -542, -542,
     -542, -542, -542, -542, -542,  640,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -542, -542, -542, -542,  227, -542,  640,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -542, -542, -542, -542,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -543, -543, -543, -543, -543, -543, -543, -543, -543,
     -543, -543, -543, -543, -543, -543, -543, -543, -543, -543,

     -543, -543, -543, -543, -543, -543, -543, -543, -543, -543,
     -543, -543, -543, -543, -543, -543, -543, -543, -543, -543,
     -543, -543, -543, -543, -543, -543, -543, -543,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -543, -543,
     -543, -543, -543, -543, -543,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  641,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -543, -543, -543, -543,  227, -543,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  641,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -543, -543, -543, -543,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -544, -544, -544, -544, -544, -544, -544, -544, -544,
     -544, -544, -544, -544, -544, -544, -544, -544, -544, -544,
     -544, -544, -544, -544, -544, -544, -544, -544, -544, -544,
     -544, -544, -544, -544, -544, -544, -544, -544, -544, -544,
     -544, -544, -544, -544, -544, -544, -544, -544,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -544, -544,

     -544, -544, -544, -544, -544,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  642,  227,  227,  227,  227,  227,  227,  227,
      227, -544, -544, -544, -544,  227, -544,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  642,  227,  227,  227,  227,  227,
      227,  227,  227, -544, -544, -544, -544,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -545, -545, -545, -545, -545, -545, -545, -545, -545,
     -545, -545, -545, -545, -545, -545, -545, -545, -545, -545,
     -545, -545, -545, -545, -545, -545, -545, -545, -545, -545,
     -545, -545, -545, -545, -545, -545, -545, -545, -545, -545,
     -545, -545, -545, -545, -545, -545, -545, -545,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -545, -545,
     -545, -545, -545, -545, -545,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  643,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -545, -545, -545, -545,  227, -545,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  643,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -545, -545, -545, -545,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -546, -546, -546, -546, -546, -546, -546, -546, -546,
     -546, -546, -546, -546, -546, -546, -546, -546, -546, -546,
     -546, -546, -546, -546, -546, -546, -546, -546, -546, -546,
     -546, -546, -546, -546, -546, -546, -546, -546, -546, -546,

     -546, -546, -546, -546, -546, -546, -546, -546,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -546, -546,
     -546, -546, -546, -546, -546,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  644,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -546, -546, -546, -546,  227, -546,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      644,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -546, -546, -546, -546,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -547, -547, -547, -547, -547, -547, -547, -547, -547,
     -547, -547, -547, -547, -547, -547, -547, -547, -547, -547,
     -547, -547, -547, -547, -547, -547, -547, -547, -547, -547,
     -547, -547, -547, -547, -547, -547, -547, -547, -547, -547,
     -547, -547, -547, -547, -547, -547, -547, -547,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -547, -547,
     -547, -547, -547, -547, -547,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  645,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -547, -547, -547, -547,  227, -547,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  645,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -547, -547, -547, -547,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -548, -548, -548, -548, -548, -548, -548, -548, -548,
     -548, -548, -548, -548, -548, -548, -548, -548, -548, -548,

     -548, -548, -548, -548, -548, -548, -548, -548, -548, -548,
     -548, -548, -548, -548, -548, -548, -548, -548, -548, -548,
     -548, -548, -548, -548, -548, -548, -548, -548,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -548, -548,
     -548, -548, -548, -548, -548,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  646,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -548, -548, -548, -548,  227, -548,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      646,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -548, -548, -548, -548,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -549, -549, -549, -549, -549, -549, -549, -549, -549,
     -549, -549, -549, -549, -549, -549, -549, -549, -549, -549,
     -549, -549, -549, -549, -549, -549, -549, -549, -549, -549,
     -549, -549, -549, -549, -549, -549, -549, -549, -549, -549,
     -549, -549, -549, -549, -549, -549, -549, -549,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -549, -549,

     -549, -549, -549, -549, -549,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  647,  227,  227,  227,  227,  227,
      227, -549, -549, -549, -549,  227, -549,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  647,  227,  227,  227,
      227,  227,  227, -549, -549, -549, -549,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -550, -550, -550, -550, -550, -550, -550, -550, -550,
     -550, -550, -550, -550, -550, -550, -550, -550, -550, -550,
     -550, -550, -550, -550, -550, -550, -550, -550, -550, -550,
     -550, -550, -550, -550, -550, -550, -550, -550, -550, -550,
     -550, -550, -550, -550, -550, -550, -550, -550,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -550, -550,
     -550, -550, -550, -550, -550,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  648,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -550, -550, -550, -550,  227, -550,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  648,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -550, -550, -550, -550,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -551, -551, -551, -551, -551, -551, -551, -551, -551,
     -551, -551, -551, -551, -551, -551, -551, -551, -551, -551,
     -551, -551, -551, -551, -551, -551, -551, -551, -551, -551,
     -551, -551, -551, -551, -551, -551, -551, -551, -551, -551,

     -551, -551, -551, -551, -551, -551, -551, -551,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -551, -551,
     -551, -551, -551, -551, -551,  649,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -551, -551, -551, -551,  227, -551,  649,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -551, -551, -551, -551,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -552, -552, -552, -552, -552, -552, -552, -552, -552,
     -552, -552, -552, -552, -552, -552, -552, -552, -552, -552,
     -552, -552, -552, -552, -552, -552, -552, -552, -552, -552,
     -552, -552, -552, -552, -552, -552, -552, -552, -552, -552,
     -552, -552, -552, -552, -552, -552, -552, -552, -552, -552,
     -552, -552, -552, -552, -552, -552, -552, -552, -552, -552,
     -552, -552, -552, -552, -552,  650,  650,  650,  650,  650,
      650,  650,  650,  650,  650,  650,  650,  650,  650,  650,

      650,  650,  650,  650,  650,  650,  650,  650,  650,  650,
      650, -552, -552, -552, -552,  650, -552,  650,  650,  650,
      650,  650,  650,  650,  650,  650,  650,  650,  650,  650,
      650,  650,  650,  650,  650,  650,  650,  650,  650,  650,
      650,  650,  650, -552, -552, -552, -552,  650,  650,  650,
      650,  650,  650,  650,  650,  650,  650,  650,  650,  650,
      650,  650,  650,  650,  650,  650,  650,  650,  650,  650,
      650,  650,  650,  650,  650,  650,  650,  650,  650,  650,
      650,  650,  650,  650,  650,  650,  650,  650,  650,  650,
      650,  650,  650,  650,  650,  650,  650,  650,  650,  650,

      650,  650,  650,  650,  650,  650,  650,  650,  650,  650,
      650,  650,  650,  650,  650,  650,  650,  650,  650,  650,
      650,  650,  650,  650,  650,  650,  650,  650,  650,  650,
      650,  650,  650,  650,  650,  650,  650,  650,  650,  650,
      650,  650,  650,  650,  650,  650,  650,  650,  650,  650,
      650,  650,  650,  650,  650,  650,  650,  650,  650,  650,
      650,  650,  650,  650,  650,  650,  650,  650,  650,  650,
      650,  650,  650,  650,  650,  650
    },

    {
       45, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,

     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553,  558, -553, -553, -553, -553,  451, -553, -553,
     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553,  554, -553, -553, -553, -553, -553, -553, -553,
     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,

     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,

     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553, -553, -553, -553, -553, -553, -553, -553, -553,
     -553, -553, -553, -553, -553, -553
    },

    {
       45, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,

     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,

     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554, -554, -554, -554, -554,
     -554, -554, -554, -554, -554, -554

    },

    {
       45,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      450,  555,  555,  556,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,

      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,

      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555,  555,  555,  555,  555,
      555,  555,  555,  555,  555,  555
    },

    {
       45, -556, -556, -556, -556, -556, -556, -556, -556,  450,
      651, -556, -556,  450, -556, -556, -556, -556, -556, -556,
     -556, -556, -556, -556, -556, -556, -556, -556, -556, -556,
     -556, -556,  450, -556, -556,  451, -556, -556, -556, -556,

     -556, -556, -556, -556, -556, -556, -556,  553, -556, -556,
     -556, -556, -556, -556, -556, -556, -556, -556, -556, -556,
     -556, -556,  554, -556, -556,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554, -556, -556, -556, -556,  554, -556,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554, -556, -556, -556, -556,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,

      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,

      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554
    },

    {
       45, -557, -557, -557, -557, -557, -557, -557, -557,  450,
      450, -557, -557,  450, -557, -557, -557, -557, -557, -557,
     -557, -557, -557, -557, -557, -557, -557, -557, -557, -557,
     -557, -557,  450, -557, -557,  451, -557, -557, -557, -557,
     -557, -557, -557, -557, -557,  452, -557,  453,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  452, -557,
     -557, -557,  455, -557, -557,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,

      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652, -557, -557, -557, -557,  652, -557,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652, -557, -557, -557, -557,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,

      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652
    },

    {
       45,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,

      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  654,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,

      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,

      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653
    },

    {
       45, -559, -559, -559, -559, -559, -559, -559, -559, -559,
     -559, -559, -559, -559, -559, -559, -559, -559, -559, -559,
     -559, -559, -559, -559, -559, -559, -559, -559, -559, -559,
     -559, -559, -559, -559, -559, -559, -559, -559, -559, -559,
     -559, -559, -559, -559, -559,  325, -559, -559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  325, -559,

     -559, -559, -559, -559, -559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559, -559, -559, -559, -559,  559, -559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559, -559, -559, -559, -559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,

      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559,  559,  559,  559,  559,
      559,  559,  559,  559,  559,  559

    },

    {
       45, -560, -560, -560, -560, -560, -560, -560, -560, -560,
     -560, -560, -560, -560, -560, -560, -560, -560, -560, -560,
     -560, -560, -560, -560, -560, -560, -560, -560, -560, -560,
     -560, -560, -560, -560, -560, -560, -560, -560, -560, -560,
     -560, -560, -560, -560, -560,  327, -560, -560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  327, -560,
     -560, -560, -560, -560, -560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560, -560, -560, -560, -560,  560, -560,  560,  560,  560,

      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560, -560, -560, -560, -560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,

      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560,  560,  560,  560,  560,
      560,  560,  560,  560,  560,  560
    },

    {
       45, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,

     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,

     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,

     -561, -561, -561, -561, -561, -561, -561, -561, -561, -561,
     -561, -561, -561, -561, -561, -561
    },

    {
       45,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655, -562,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      656,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,

      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,

      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655
    },

    {
       45,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,

      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562, -563,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
     -563,  562,  562, -563,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562, -563,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562, -563,  562,  562,  562,  562,

      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,

      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562
    },

    {
       45, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,

     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,

     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564, -564, -564, -564, -564,
     -564, -564, -564, -564, -564, -564

    },

    {
       45, -565, -565, -565, -565, -565, -565, -565, -565, -565,
      564, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,

     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,

     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565, -565, -565, -565, -565,
     -565, -565, -565, -565, -565, -565
    },

    {
       45, -566, -566, -566, -566, -566, -566, -566, -566,  657,
      657, -566, -566,  658, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566,  657, -566, -566, -566, -566, -566, -566, -566,

     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,

     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,

     -566, -566, -566, -566, -566, -566, -566, -566, -566, -566,
     -566, -566, -566, -566, -566, -566
    },

    {
       45, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,

      659, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567,  659, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,

     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567, -567, -567, -567, -567,
     -567, -567, -567, -567, -567, -567
    },

    {
       45,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,

      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      661,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,

      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,

      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660
    },

    {
       45,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568, -569,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,

     -569,  568,  568, -569,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568, -569,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568, -569,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,

      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568

    },

    {
       45, -570, -570, -570, -570, -570, -570, -570, -570, -570,
     -570, -570, -570, -570, -570, -570, -570, -570, -570, -570,
     -570, -570, -570, -570, -570, -570, -570, -570, -570, -570,
     -570, -570, -570, -570, -570, -570, -570, -570, -570, -570,
     -570, -570, -570, -570, -570,  348, -570, -570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  348, -570,
     -570, -570, -570, -570, -570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570, -570, -570, -570, -570,  570, -570,  570,  570,  570,

      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570, -570, -570, -570, -570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,

      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570
    },

    {
       45, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,

     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571, -571, -571, -571,  662,
     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571,  662, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,

     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,

     -571, -571, -571, -571, -571, -571, -571, -571, -571, -571,
     -571, -571, -571, -571, -571, -571
    },

    {
       45, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,

     -572, -572,  663, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572,  663, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,

     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572, -572, -572, -572, -572,
     -572, -572, -572, -572, -572, -572
    },

    {
       45, -573, -573, -573, -573, -573, -573, -573, -573,  664,
     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,

     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,
     -573, -573,  664, -573, -573, -573, -573, -573, -573, -573,
     -573,  665, -573, -573, -573, -573, -573, -573, -573, -573,
     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,
     -573, -573, -573, -573, -573, -573, -573, -573, -573,  666,
     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,
     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,
     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,
     -573,  666, -573, -573, -573, -573, -573, -573, -573, -573,
     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,

     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,
     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,
     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,
     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,
     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,
     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,
     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,
     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,
     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,
     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,

     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,
     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,
     -573, -573, -573, -573, -573, -573, -573, -573, -573, -573,
     -573, -573, -573, -573, -573, -573
    },

    {
       45, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,

     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574,  667, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574,  667, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,

     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574, -574, -574, -574, -574,
     -574, -574, -574, -574, -574, -574

    },

    {
       45, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575,  668, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,

     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575,  668, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,

     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575, -575, -575, -575, -575,
     -575, -575, -575, -575, -575, -575
    },

    {
       45, -576, -576, -576, -576, -576, -576, -576, -576,  576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576,  576, -576, -576, -576, -576, -576, -576, -576,

     -576,  577, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,

     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,

     -576, -576, -576, -576, -576, -576, -576, -576, -576, -576,
     -576, -576, -576, -576, -576, -576
    },

    {
       45, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,

     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,

     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577, -577, -577, -577, -577,
     -577, -577, -577, -577, -577, -577
    },

    {
       45, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,

     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578,  669, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578,  669, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,

     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,

     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578, -578, -578, -578, -578,
     -578, -578, -578, -578, -578, -578
    },

    {
       45, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,

     -579, -579, -579, -579, -579, -579, -579,  670, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579,  670,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,

     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579, -579, -579, -579, -579,
     -579, -579, -579, -579, -579, -579

    },

    {
       45, -580, -580, -580, -580, -580, -580, -580, -580,  671,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580,  671, -580, -580, -580, -580, -580, -580, -580,
     -580,  672, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,

     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,

     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580, -580, -580, -580, -580,
     -580, -580, -580, -580, -580, -580
    },

    {
       45, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,

     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581, -581, -581,  673, -581,
     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,
      673, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,

     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,

     -581, -581, -581, -581, -581, -581, -581, -581, -581, -581,
     -581, -581, -581, -581, -581, -581
    },

    {
       45, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,

     -582, -582, -582, -582,  674, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582,  674, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,

     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582, -582, -582, -582, -582,
     -582, -582, -582, -582, -582, -582
    },

    {
       45, -583, -583, -583, -583, -583, -583, -583, -583, -583,
     -583, -583, -583, -583, -583, -583, -583, -583, -583, -583,

     -583, -583, -583, -583, -583, -583, -583, -583, -583, -583,
     -583, -583, -583, -583, -583, -583, -583, -583, -583, -583,
     -583, -583, -583, -583, -583,  366, -583, -583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  366, -583,
     -583, -583, -583, -583, -583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583, -583, -583, -583, -583,  583, -583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,

      583,  583,  583, -583, -583, -583, -583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,

      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
      583,  583,  583,  583,  583,  583
    },

    {
       45, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,

     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584,  675, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584,  675, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,

     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584, -584, -584, -584, -584,
     -584, -584, -584, -584, -584, -584

    },

    {
       45, -585, -585, -585, -585, -585, -585, -585, -585, -585,
     -585, -585, -585, -585, -585, -585, -585, -585, -585, -585,
     -585, -585, -585, -585, -585, -585, -585, -585, -585, -585,
     -585, -585, -585, -585,  676, -585, -585, -585, -585, -585,
     -585, -585, -585, -585, -585, -585, -585, -585,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677, -585, -585,
     -585, -585, -585, -585, -585,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677, -585, -585, -585, -585,  677, -585,  677,  677,  677,

      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677, -585, -585, -585, -585,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,

      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677
    },

    {
       45, -586, -586, -586, -586, -586, -586, -586, -586, -586,
     -586, -586, -586, -586, -586, -586, -586, -586, -586, -586,
     -586, -586, -586, -586, -586, -586, -586, -586, -586, -586,
     -586, -586, -586, -586, -586, -586, -586, -586, -586,  676,

     -586, -586, -586, -586, -586, -586, -586, -586,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678, -586, -586,
     -586, -586, -586, -586, -586,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678, -586, -586, -586, -586,  678, -586,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678, -586, -586, -586, -586,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,

      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,

      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678
    },

    {
       45, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,

     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,

     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587, -587, -587, -587, -587,
     -587, -587, -587, -587, -587, -587
    },

    {
       45, -588, -588, -588, -588, -588, -588, -588, -588, -588,
      587, -588, -588, -588, -588, -588, -588, -588, -588, -588,

     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,

     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,

     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588, -588, -588, -588, -588,
     -588, -588, -588, -588, -588, -588
    },

    {
       45, -589, -589, -589, -589, -589, -589, -589, -589, -589,
      587, -589, -589,  588, -589, -589, -589, -589, -589, -589,
     -589, -589, -589, -589, -589, -589, -589, -589, -589, -589,
     -589, -589, -589, -589, -589, -589, -589, -589, -589, -589,
     -589, -589, -589, -589, -589, -589, -589, -589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589, -589, -589,

     -589, -589, -589, -589, -589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589, -589, -589, -589, -589,  589, -589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589, -589, -589, -589, -589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,

      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589

    },

    {
       45, -590, -590, -590, -590, -590, -590, -590, -590, -590,
     -590, -590, -590, -590, -590, -590, -590, -590, -590, -590,
     -590, -590, -590, -590, -590, -590, -590, -590, -590, -590,
     -590, -590, -590, -590, -590, -590, -590, -590, -590, -590,
     -590, -590, -590, -590, -590, -590, -590, -590,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -590, -590,
     -590, -590, -590, -590, -590,  679,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -590, -590, -590, -590,  227, -590,  679,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -590, -590, -590, -590,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -591, -591, -591, -591, -591, -591, -591, -591, -591,
     -591, -591, -591, -591, -591, -591, -591, -591, -591, -591,
     -591, -591, -591, -591, -591, -591, -591, -591, -591, -591,
     -591, -591, -591, -591, -591, -591, -591, -591, -591, -591,

     -591, -591, -591, -591, -591, -591, -591, -591,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -591, -591,
     -591, -591, -591, -591, -591,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -591, -591, -591, -591,  227, -591,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -591, -591, -591, -591,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -592, -592, -592, -592, -592, -592, -592, -592,  680,
      680, -592, -592,  680, -592, -592, -592, -592, -592, -592,
     -592, -592, -592, -592, -592, -592, -592, -592, -592, -592,
     -592, -592,  680, -592, -592,  681, -592, -592, -592, -592,
     -592, -592, -592, -592, -592, -592, -592,  682,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -592, -592,
     -592, -592, -592, -592, -592,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -592, -592, -592, -592,  227, -592,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -592, -592, -592, -592,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -593, -593, -593, -593, -593, -593, -593, -593, -593,
     -593, -593, -593, -593, -593, -593, -593, -593, -593, -593,

     -593, -593, -593, -593, -593, -593, -593, -593, -593, -593,
     -593, -593, -593, -593, -593, -593, -593, -593, -593, -593,
     -593, -593, -593, -593, -593, -593, -593, -593,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -593, -593,
     -593, -593, -593, -593, -593,  227,  683,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -593, -593, -593, -593,  227, -593,  227,  683,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -593, -593, -593, -593,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -594, -594, -594, -594, -594, -594, -594, -594, -594,
     -594, -594, -594, -594, -594, -594, -594, -594, -594, -594,
     -594, -594, -594, -594, -594, -594, -594, -594, -594, -594,
     -594, -594, -594, -594, -594, -594, -594, -594, -594, -594,
     -594, -594, -594, -594, -594, -594, -594, -594,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -594, -594,

     -594, -594, -594, -594, -594,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -594, -594, -594, -594,  227, -594,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -594, -594, -594, -594,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -595, -595, -595, -595, -595, -595, -595, -595, -595,
     -595, -595, -595, -595, -595, -595, -595, -595, -595, -595,
     -595, -595, -595, -595, -595, -595, -595, -595, -595, -595,
     -595, -595, -595, -595, -595, -595, -595, -595, -595, -595,
     -595, -595, -595, -595, -595, -595, -595, -595,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -595, -595,
     -595, -595, -595, -595, -595,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -595, -595, -595, -595,  227, -595,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -595, -595, -595, -595,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -596, -596, -596, -596, -596, -596, -596, -596, -596,
     -596, -596, -596, -596, -596, -596, -596, -596, -596, -596,
     -596, -596, -596, -596, -596, -596, -596, -596, -596, -596,
     -596, -596, -596, -596, -596, -596, -596, -596, -596, -596,

     -596, -596, -596, -596, -596, -596, -596, -596,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -596, -596,
     -596, -596, -596, -596, -596,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -596, -596, -596, -596,  227, -596,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -596, -596, -596, -596,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -597, -597, -597, -597, -597, -597, -597, -597, -597,
     -597, -597, -597, -597, -597, -597, -597, -597, -597, -597,
     -597, -597, -597, -597, -597, -597, -597, -597, -597, -597,
     -597, -597, -597, -597, -597, -597, -597, -597, -597, -597,
     -597, -597, -597, -597, -597, -597, -597, -597,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -597, -597,
     -597, -597, -597, -597, -597,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  684,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -597, -597, -597, -597,  227, -597,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  684,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -597, -597, -597, -597,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -598, -598, -598, -598, -598, -598, -598, -598, -598,
     -598, -598, -598, -598, -598, -598, -598, -598, -598, -598,

     -598, -598, -598, -598, -598, -598, -598, -598, -598, -598,
     -598, -598, -598, -598, -598, -598, -598, -598, -598, -598,
     -598, -598, -598, -598, -598, -598, -598, -598,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -598, -598,
     -598, -598, -598, -598, -598,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  685,  227,  227,  227,  227,  227,  227,  227,
      227, -598, -598, -598, -598,  227, -598,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  685,  227,  227,  227,  227,  227,

      227,  227,  227, -598, -598, -598, -598,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -599, -599, -599, -599, -599, -599, -599, -599, -599,
     -599, -599, -599, -599, -599, -599, -599, -599, -599, -599,
     -599, -599, -599, -599, -599, -599, -599, -599, -599, -599,
     -599, -599, -599, -599, -599, -599, -599, -599, -599, -599,
     -599, -599, -599, -599, -599, -599, -599, -599,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -599, -599,

     -599, -599, -599, -599, -599,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -599, -599, -599, -599,  227, -599,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -599, -599, -599, -599,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -600, -600, -600, -600, -600, -600, -600, -600, -600,
     -600, -600, -600, -600, -600, -600, -600, -600, -600, -600,
     -600, -600, -600, -600, -600, -600, -600, -600, -600, -600,
     -600, -600, -600, -600, -600, -600, -600, -600, -600, -600,
     -600, -600, -600, -600, -600, -600, -600, -600,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -600, -600,
     -600, -600, -600, -600, -600,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -600, -600, -600, -600,  227, -600,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -600, -600, -600, -600,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -601, -601, -601, -601, -601, -601, -601, -601, -601,
     -601, -601, -601, -601, -601, -601, -601, -601, -601, -601,
     -601, -601, -601, -601, -601, -601, -601, -601, -601, -601,
     -601, -601, -601, -601, -601, -601, -601, -601, -601, -601,

     -601, -601, -601, -601, -601, -601, -601, -601,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -601, -601,
     -601, -601, -601, -601, -601,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -601, -601, -601, -601,  227, -601,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -601, -601, -601, -601,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -602, -602, -602, -602, -602, -602, -602, -602, -602,
     -602, -602, -602, -602, -602, -602, -602, -602, -602, -602,
     -602, -602, -602, -602, -602, -602, -602, -602, -602, -602,
     -602, -602, -602, -602, -602, -602, -602, -602, -602, -602,
     -602, -602, -602, -602, -602, -602, -602, -602,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -602, -602,
     -602, -602, -602, -602, -602,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  686,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -602, -602, -602, -602,  227, -602,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      686,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -602, -602, -602, -602,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -603, -603, -603, -603, -603, -603, -603, -603, -603,
     -603, -603, -603, -603, -603, -603, -603, -603, -603, -603,

     -603, -603, -603, -603, -603, -603, -603, -603, -603, -603,
     -603, -603, -603, -603, -603, -603, -603, -603, -603, -603,
     -603, -603, -603, -603, -603, -603, -603, -603,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -603, -603,
     -603, -603, -603, -603, -603,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  687,  227,  227,  227,  227,  227,  227,  227,
      227, -603, -603, -603, -603,  227, -603,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  687,  227,  227,  227,  227,  227,

      227,  227,  227, -603, -603, -603, -603,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -604, -604, -604, -604, -604, -604, -604, -604, -604,
     -604, -604, -604, -604, -604, -604, -604, -604, -604, -604,
     -604, -604, -604, -604, -604, -604, -604, -604, -604, -604,
     -604, -604, -604, -604, -604, -604, -604, -604, -604, -604,
     -604, -604, -604, -604, -604, -604, -604, -604,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -604, -604,

     -604, -604, -604, -604, -604,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  688,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -604, -604, -604, -604,  227, -604,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  688,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -604, -604, -604, -604,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -605, -605, -605, -605, -605, -605, -605, -605, -605,
     -605, -605, -605, -605, -605, -605, -605, -605, -605, -605,
     -605, -605, -605, -605, -605, -605, -605, -605, -605, -605,
     -605, -605, -605, -605, -605, -605, -605, -605, -605, -605,
     -605, -605, -605, -605, -605, -605, -605, -605,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -605, -605,
     -605, -605, -605, -605, -605,  227,  227,  227,  227,  227,
      689,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -605, -605, -605, -605,  227, -605,  227,  227,  227,

      227,  227,  689,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -605, -605, -605, -605,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -606, -606, -606, -606, -606, -606, -606, -606, -606,
     -606, -606, -606, -606, -606, -606, -606, -606, -606, -606,
     -606, -606, -606, -606, -606, -606, -606, -606, -606, -606,
     -606, -606, -606, -606, -606, -606, -606, -606, -606, -606,

     -606, -606, -606, -606, -606, -606, -606, -606,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -606, -606,
     -606, -606, -606, -606, -606,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -606, -606, -606, -606,  227, -606,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -606, -606, -606, -606,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -607, -607, -607, -607, -607, -607, -607, -607, -607,
     -607, -607, -607, -607, -607, -607, -607, -607, -607, -607,
     -607, -607, -607, -607, -607, -607, -607, -607, -607, -607,
     -607, -607, -607, -607, -607, -607, -607, -607, -607, -607,
     -607, -607, -607, -607, -607, -607, -607, -607,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -607, -607,
     -607, -607, -607, -607, -607,  227,  227,  690,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -607, -607, -607, -607,  227, -607,  227,  227,  690,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -607, -607, -607, -607,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -608, -608, -608, -608, -608, -608, -608, -608, -608,
     -608, -608, -608, -608, -608, -608, -608, -608, -608, -608,

     -608, -608, -608, -608, -608, -608, -608, -608, -608, -608,
     -608, -608, -608, -608, -608, -608, -608, -608, -608, -608,
     -608, -608, -608, -608, -608, -608, -608, -608,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -608, -608,
     -608, -608, -608, -608, -608,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  691,  227,  227,  227,  227,  227,  227,  227,
      227, -608, -608, -608, -608,  227, -608,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  691,  227,  227,  227,  227,  227,

      227,  227,  227, -608, -608, -608, -608,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -609, -609, -609, -609, -609, -609, -609, -609, -609,
     -609, -609, -609, -609, -609, -609, -609, -609, -609, -609,
     -609, -609, -609, -609, -609, -609, -609, -609, -609, -609,
     -609, -609, -609, -609, -609, -609, -609, -609, -609, -609,
     -609, -609, -609, -609, -609, -609, -609, -609,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -609, -609,

     -609, -609, -609, -609, -609,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -609, -609, -609, -609,  227, -609,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -609, -609, -609, -609,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -610, -610, -610, -610, -610, -610, -610, -610, -610,
     -610, -610, -610, -610, -610, -610, -610, -610, -610, -610,
     -610, -610, -610, -610, -610, -610, -610, -610, -610, -610,
     -610, -610, -610, -610, -610, -610, -610, -610, -610, -610,
     -610, -610, -610, -610, -610, -610, -610, -610,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -610, -610,
     -610, -610, -610, -610, -610,  227,  227,  227,  227,  227,
      227,  227,  227,  692,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -610, -610, -610, -610,  227, -610,  227,  227,  227,

      227,  227,  227,  227,  227,  692,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -610, -610, -610, -610,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -611, -611, -611, -611, -611, -611, -611, -611, -611,
     -611, -611, -611, -611, -611, -611, -611, -611, -611, -611,
     -611, -611, -611, -611, -611, -611, -611, -611, -611, -611,
     -611, -611, -611, -611, -611, -611, -611, -611, -611, -611,

     -611, -611, -611, -611, -611, -611, -611, -611,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -611, -611,
     -611, -611, -611, -611, -611,  227,  227,  227,  227,  227,
      227,  227,  227,  693,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -611, -611, -611, -611,  227, -611,  227,  227,  227,
      227,  227,  227,  227,  227,  693,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -611, -611, -611, -611,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -612, -612, -612, -612, -612, -612, -612, -612, -612,
     -612, -612, -612, -612, -612, -612, -612, -612, -612, -612,
     -612, -612, -612, -612, -612, -612, -612, -612, -612, -612,
     -612, -612, -612, -612, -612, -612, -612, -612, -612, -612,
     -612, -612, -612, -612, -612, -612, -612, -612,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -612, -612,
     -612, -612, -612, -612, -612,  227,  227,  227,  694,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -612, -612, -612, -612,  227, -612,  227,  227,  227,
      694,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -612, -612, -612, -612,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -613, -613, -613, -613, -613, -613, -613, -613, -613,
     -613, -613, -613, -613, -613, -613, -613, -613, -613, -613,

     -613, -613, -613, -613, -613, -613, -613, -613, -613, -613,
     -613, -613, -613, -613, -613, -613, -613, -613, -613, -613,
     -613, -613, -613, -613, -613, -613, -613, -613,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -613, -613,
     -613, -613, -613, -613, -613,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  695,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -613, -613, -613, -613,  227, -613,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  695,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -613, -613, -613, -613,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -614, -614, -614, -614, -614, -614, -614, -614, -614,
     -614, -614, -614, -614, -614, -614, -614, -614, -614, -614,
     -614, -614, -614, -614, -614, -614, -614, -614, -614, -614,
     -614, -614, -614, -614, -614, -614, -614, -614, -614, -614,
     -614, -614, -614, -614, -614, -614, -614, -614,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -614, -614,

     -614, -614, -614, -614, -614,  227,  227,  696,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -614, -614, -614, -614,  227, -614,  227,  227,  696,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -614, -614, -614, -614,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -615, -615, -615, -615, -615, -615, -615, -615, -615,
     -615, -615, -615, -615, -615, -615, -615, -615, -615, -615,
     -615, -615, -615, -615, -615, -615, -615, -615, -615, -615,
     -615, -615, -615, -615, -615, -615, -615, -615, -615, -615,
     -615, -615, -615, -615, -615, -615, -615, -615,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -615, -615,
     -615, -615, -615, -615, -615,  227,  227,  227,  227,  227,
      227,  227,  227,  697,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -615, -615, -615, -615,  227, -615,  227,  227,  227,

      227,  227,  227,  227,  227,  697,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -615, -615, -615, -615,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -616, -616, -616, -616, -616, -616, -616, -616, -616,
     -616, -616, -616, -616, -616, -616, -616, -616, -616, -616,
     -616, -616, -616, -616, -616, -616, -616, -616, -616, -616,
     -616, -616, -616, -616, -616, -616, -616, -616, -616, -616,

     -616, -616, -616, -616, -616, -616, -616, -616,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -616, -616,
     -616, -616, -616, -616, -616,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  698,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -616, -616, -616, -616,  227, -616,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  698,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -616, -616, -616, -616,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -617, -617, -617, -617, -617, -617, -617, -617, -617,
     -617, -617, -617, -617, -617, -617, -617, -617, -617, -617,
     -617, -617, -617, -617, -617, -617, -617, -617, -617, -617,
     -617, -617, -617, -617, -617, -617, -617, -617, -617, -617,
     -617, -617, -617, -617, -617, -617, -617, -617,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -617, -617,
     -617, -617, -617, -617, -617,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  699,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -617, -617, -617, -617,  227, -617,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  699,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -617, -617, -617, -617,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -618, -618, -618, -618, -618, -618, -618, -618, -618,
     -618, -618, -618, -618, -618, -618, -618, -618, -618, -618,

     -618, -618, -618, -618, -618, -618, -618, -618, -618, -618,
     -618, -618, -618, -618, -618, -618, -618, -618, -618, -618,
     -618, -618, -618, -618, -618, -618, -618, -618,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -618, -618,
     -618, -618, -618, -618, -618,  227,  227,  227,  700,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -618, -618, -618, -618,  227, -618,  227,  227,  227,
      700,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -618, -618, -618, -618,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -619, -619, -619, -619, -619, -619, -619, -619, -619,
     -619, -619, -619, -619, -619, -619, -619, -619, -619, -619,
     -619, -619, -619, -619, -619, -619, -619, -619, -619, -619,
     -619, -619, -619, -619, -619, -619, -619, -619, -619, -619,
     -619, -619, -619, -619, -619, -619, -619, -619,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -619, -619,

     -619, -619, -619, -619, -619,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  701,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -619, -619, -619, -619,  227, -619,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      701,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -619, -619, -619, -619,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -620, -620, -620, -620, -620, -620, -620, -620, -620,
     -620, -620, -620, -620, -620, -620, -620, -620, -620, -620,
     -620, -620, -620, -620, -620, -620, -620, -620, -620, -620,
     -620, -620, -620, -620, -620, -620, -620, -620, -620, -620,
     -620, -620, -620, -620, -620, -620, -620, -620,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -620, -620,
     -620, -620, -620, -620, -620,  702,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -620, -620, -620, -620,  227, -620,  702,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -620, -620, -620, -620,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -621, -621, -621, -621, -621, -621, -621, -621, -621,
     -621, -621, -621, -621, -621, -621, -621, -621, -621, -621,
     -621, -621, -621, -621, -621, -621, -621, -621, -621, -621,
     -621, -621, -621, -621, -621, -621, -621, -621, -621, -621,

     -621, -621, -621, -621, -621, -621, -621, -621,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -621, -621,
     -621, -621, -621, -621, -621,  227,  227,  227,  227,  227,
      703,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -621, -621, -621, -621,  227, -621,  227,  227,  227,
      227,  227,  703,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -621, -621, -621, -621,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -622, -622, -622, -622, -622, -622, -622, -622, -622,
     -622, -622, -622, -622, -622, -622, -622, -622, -622, -622,
     -622, -622, -622, -622, -622, -622, -622, -622, -622, -622,
     -622, -622, -622, -622, -622, -622, -622, -622, -622, -622,
     -622, -622, -622, -622, -622, -622, -622, -622,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -622, -622,
     -622, -622, -622, -622, -622,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -622, -622, -622, -622,  227, -622,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -622, -622, -622, -622,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -623, -623, -623, -623, -623, -623, -623, -623, -623,
     -623, -623, -623, -623, -623, -623, -623, -623, -623, -623,

     -623, -623, -623, -623, -623, -623, -623, -623, -623, -623,
     -623, -623, -623, -623, -623, -623, -623, -623, -623, -623,
     -623, -623, -623, -623, -623, -623, -623, -623,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -623, -623,
     -623, -623, -623, -623, -623,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      704,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -623, -623, -623, -623,  227, -623,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  704,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -623, -623, -623, -623,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -624, -624, -624, -624, -624, -624, -624, -624, -624,
     -624, -624, -624, -624, -624, -624, -624, -624, -624, -624,
     -624, -624, -624, -624, -624, -624, -624, -624, -624, -624,
     -624, -624, -624, -624, -624, -624, -624, -624, -624, -624,
     -624, -624, -624, -624, -624, -624, -624, -624,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -624, -624,

     -624, -624, -624, -624, -624,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      705,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -624, -624, -624, -624,  227, -624,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  705,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -624, -624, -624, -624,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -625, -625, -625, -625, -625, -625, -625, -625, -625,
     -625, -625, -625, -625, -625, -625, -625, -625, -625, -625,
     -625, -625, -625, -625, -625, -625, -625, -625, -625, -625,
     -625, -625, -625, -625, -625, -625, -625, -625, -625, -625,
     -625, -625, -625, -625, -625, -625, -625, -625,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -625, -625,
     -625, -625, -625, -625, -625,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -625, -625, -625, -625,  227, -625,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -625, -625, -625, -625,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -626, -626, -626, -626, -626, -626, -626, -626, -626,
     -626, -626, -626, -626, -626, -626, -626, -626, -626, -626,
     -626, -626, -626, -626, -626, -626, -626, -626, -626, -626,
     -626, -626, -626, -626, -626, -626, -626, -626, -626, -626,

     -626, -626, -626, -626, -626, -626, -626, -626,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -626, -626,
     -626, -626, -626, -626, -626,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  706,  227,  227,  227,  227,  227,
      227, -626, -626, -626, -626,  227, -626,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  706,  227,  227,  227,
      227,  227,  227, -626, -626, -626, -626,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -627, -627, -627, -627, -627, -627, -627, -627, -627,
     -627, -627, -627, -627, -627, -627, -627, -627, -627, -627,
     -627, -627, -627, -627, -627, -627, -627, -627, -627, -627,
     -627, -627, -627, -627, -627, -627, -627, -627, -627, -627,
     -627, -627, -627, -627, -627, -627, -627, -627,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -627, -627,
     -627, -627, -627, -627, -627,  227,  227,  707,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -627, -627, -627, -627,  227, -627,  227,  227,  707,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -627, -627, -627, -627,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -628, -628, -628, -628, -628, -628, -628, -628, -628,
     -628, -628, -628, -628, -628, -628, -628, -628, -628, -628,

     -628, -628, -628, -628, -628, -628, -628, -628, -628, -628,
     -628, -628, -628, -628, -628, -628, -628, -628, -628, -628,
     -628, -628, -628, -628, -628, -628, -628, -628,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -628, -628,
     -628, -628, -628, -628, -628,  227,  227,  708,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -628, -628, -628, -628,  227, -628,  227,  227,  708,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -628, -628, -628, -628,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -629, -629, -629, -629, -629, -629, -629, -629, -629,
     -629, -629, -629, -629, -629, -629, -629, -629, -629, -629,
     -629, -629, -629, -629, -629, -629, -629, -629, -629, -629,
     -629, -629, -629, -629, -629, -629, -629, -629, -629, -629,
     -629, -629, -629, -629, -629, -629, -629, -629,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -629, -629,

     -629, -629, -629, -629, -629,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  709,  227,  227,  227,  227,  227,  227,  227,
      227, -629, -629, -629, -629,  227, -629,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  709,  227,  227,  227,  227,  227,
      227,  227,  227, -629, -629, -629, -629,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -630, -630, -630, -630, -630, -630, -630, -630, -630,
     -630, -630, -630, -630, -630, -630, -630, -630, -630, -630,
     -630, -630, -630, -630, -630, -630, -630, -630, -630, -630,
     -630, -630, -630, -630, -630, -630, -630, -630, -630, -630,
     -630, -630, -630, -630, -630, -630, -630, -630,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -630, -630,
     -630, -630, -630, -630, -630,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  710,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -630, -630, -630, -630,  227, -630,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      710,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -630, -630, -630, -630,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -631, -631, -631, -631, -631, -631, -631, -631, -631,
     -631, -631, -631, -631, -631, -631, -631, -631, -631, -631,
     -631, -631, -631, -631, -631, -631, -631, -631, -631, -631,
     -631, -631, -631, -631, -631, -631, -631, -631, -631, -631,

     -631, -631, -631, -631, -631, -631, -631, -631,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -631, -631,
     -631, -631, -631, -631, -631,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -631, -631, -631, -631,  227, -631,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -631, -631, -631, -631,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -632, -632, -632, -632, -632, -632, -632, -632, -632,
     -632, -632, -632, -632, -632, -632, -632, -632, -632, -632,
     -632, -632, -632, -632, -632, -632, -632, -632, -632, -632,
     -632, -632, -632, -632, -632, -632, -632, -632, -632, -632,
     -632, -632, -632, -632, -632, -632, -632, -632,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -632, -632,
     -632, -632, -632, -632, -632,  227,  227,  711,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -632, -632, -632, -632,  227, -632,  227,  227,  711,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -632, -632, -632, -632,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -633, -633, -633, -633, -633, -633, -633, -633, -633,
     -633, -633, -633, -633, -633, -633, -633, -633, -633, -633,

     -633, -633, -633, -633, -633, -633, -633, -633, -633, -633,
     -633, -633, -633, -633, -633, -633, -633, -633, -633, -633,
     -633, -633, -633, -633, -633, -633, -633, -633,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -633, -633,
     -633, -633, -633, -633, -633,  227,  227,  227,  227,  227,
      227,  227,  712,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -633, -633, -633, -633,  227, -633,  227,  227,  227,
      227,  227,  227,  227,  712,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -633, -633, -633, -633,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -634, -634, -634, -634, -634, -634, -634, -634, -634,
     -634, -634, -634, -634, -634, -634, -634, -634, -634, -634,
     -634, -634, -634, -634, -634, -634, -634, -634, -634, -634,
     -634, -634, -634, -634, -634, -634, -634, -634, -634, -634,
     -634, -634, -634, -634, -634, -634, -634, -634,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -634, -634,

     -634, -634, -634, -634, -634,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -634, -634, -634, -634,  227, -634,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -634, -634, -634, -634,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -635, -635, -635, -635, -635, -635, -635, -635, -635,
     -635, -635, -635, -635, -635, -635, -635, -635, -635, -635,
     -635, -635, -635, -635, -635, -635, -635, -635, -635, -635,
     -635, -635, -635, -635, -635, -635, -635, -635, -635, -635,
     -635, -635, -635, -635, -635, -635, -635, -635,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -635, -635,
     -635, -635, -635, -635, -635,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -635, -635, -635, -635,  227, -635,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -635, -635, -635, -635,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -636, -636, -636, -636, -636, -636, -636, -636,  713,
      713, -636, -636,  713, -636, -636, -636, -636, -636, -636,
     -636, -636, -636, -636, -636, -636, -636, -636, -636, -636,
     -636, -636,  713, -636, -636,  714, -636, -636, -636, -636,

      715, -636, -636, -636, -636, -636, -636,  716,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -636, -636,
     -636, -636, -636, -636, -636,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -636, -636, -636, -636,  227, -636,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -636, -636, -636, -636,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -637, -637, -637, -637, -637, -637, -637, -637, -637,
     -637, -637, -637, -637, -637, -637, -637, -637, -637, -637,
     -637, -637, -637, -637, -637, -637, -637, -637, -637, -637,
     -637, -637, -637, -637, -637, -637, -637, -637, -637, -637,
     -637, -637, -637, -637, -637, -637, -637, -637,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -637, -637,
     -637, -637, -637, -637, -637,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -637, -637, -637, -637,  227, -637,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -637, -637, -637, -637,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -638, -638, -638, -638, -638, -638, -638, -638, -638,
     -638, -638, -638, -638, -638, -638, -638, -638, -638, -638,

     -638, -638, -638, -638, -638, -638, -638, -638, -638, -638,
     -638, -638, -638, -638, -638, -638, -638, -638, -638, -638,
     -638, -638, -638, -638, -638, -638, -638, -638,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -638, -638,
     -638, -638, -638, -638, -638,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -638, -638, -638, -638,  227, -638,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -638, -638, -638, -638,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -639, -639, -639, -639, -639, -639, -639, -639, -639,
     -639, -639, -639, -639, -639, -639, -639, -639, -639, -639,
     -639, -639, -639, -639, -639, -639, -639, -639, -639, -639,
     -639, -639, -639, -639, -639, -639, -639, -639, -639, -639,
     -639, -639, -639, -639, -639, -639, -639, -639,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -639, -639,

     -639, -639, -639, -639, -639,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -639, -639, -639, -639,  227, -639,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -639, -639, -639, -639,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -640, -640, -640, -640, -640, -640, -640, -640, -640,
     -640, -640, -640, -640, -640, -640, -640, -640, -640, -640,
     -640, -640, -640, -640, -640, -640, -640, -640, -640, -640,
     -640, -640, -640, -640, -640, -640, -640, -640, -640, -640,
     -640, -640, -640, -640, -640, -640, -640, -640,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -640, -640,
     -640, -640, -640, -640, -640,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  717,  227,  227,  227,  227,  227,  227,
      227, -640, -640, -640, -640,  227, -640,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  717,  227,  227,  227,  227,
      227,  227,  227, -640, -640, -640, -640,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -641, -641, -641, -641, -641, -641, -641, -641, -641,
     -641, -641, -641, -641, -641, -641, -641, -641, -641, -641,
     -641, -641, -641, -641, -641, -641, -641, -641, -641, -641,
     -641, -641, -641, -641, -641, -641, -641, -641, -641, -641,

     -641, -641, -641, -641, -641, -641, -641, -641,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -641, -641,
     -641, -641, -641, -641, -641,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      718,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -641, -641, -641, -641,  227, -641,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  718,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -641, -641, -641, -641,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -642, -642, -642, -642, -642, -642, -642, -642, -642,
     -642, -642, -642, -642, -642, -642, -642, -642, -642, -642,
     -642, -642, -642, -642, -642, -642, -642, -642, -642, -642,
     -642, -642, -642, -642, -642, -642, -642, -642, -642, -642,
     -642, -642, -642, -642, -642, -642, -642, -642,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -642, -642,
     -642, -642, -642, -642, -642,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -642, -642, -642, -642,  719, -642,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -642, -642, -642, -642,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -643, -643, -643, -643, -643, -643, -643, -643, -643,
     -643, -643, -643, -643, -643, -643, -643, -643, -643, -643,

     -643, -643, -643, -643, -643, -643, -643, -643, -643, -643,
     -643, -643, -643, -643, -643, -643, -643, -643, -643, -643,
     -643, -643, -643, -643, -643, -643, -643, -643,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -643, -643,
     -643, -643, -643, -643, -643,  227,  227,  227,  227,  720,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -643, -643, -643, -643,  227, -643,  227,  227,  227,
      227,  720,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -643, -643, -643, -643,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -644, -644, -644, -644, -644, -644, -644, -644, -644,
     -644, -644, -644, -644, -644, -644, -644, -644, -644, -644,
     -644, -644, -644, -644, -644, -644, -644, -644, -644, -644,
     -644, -644, -644, -644, -644, -644, -644, -644, -644, -644,
     -644, -644, -644, -644, -644, -644, -644, -644,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -644, -644,

     -644, -644, -644, -644, -644,  227,  227,  721,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -644, -644, -644, -644,  227, -644,  227,  227,  721,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -644, -644, -644, -644,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -645, -645, -645, -645, -645, -645, -645, -645, -645,
     -645, -645, -645, -645, -645, -645, -645, -645, -645, -645,
     -645, -645, -645, -645, -645, -645, -645, -645, -645, -645,
     -645, -645, -645, -645, -645, -645, -645, -645, -645, -645,
     -645, -645, -645, -645, -645, -645, -645, -645,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -645, -645,
     -645, -645, -645, -645, -645,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  722,  227,  227,  227,  227,  227,
      227, -645, -645, -645, -645,  227, -645,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  722,  227,  227,  227,
      227,  227,  227, -645, -645, -645, -645,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -646, -646, -646, -646, -646, -646, -646, -646, -646,
     -646, -646, -646, -646, -646, -646, -646, -646, -646, -646,
     -646, -646, -646, -646, -646, -646, -646, -646, -646, -646,
     -646, -646, -646, -646, -646, -646, -646, -646, -646, -646,

     -646, -646, -646, -646, -646, -646, -646, -646,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -646, -646,
     -646, -646, -646, -646, -646,  227,  227,  227,  227,  723,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -646, -646, -646, -646,  227, -646,  227,  227,  227,
      227,  723,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -646, -646, -646, -646,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -647, -647, -647, -647, -647, -647, -647, -647, -647,
     -647, -647, -647, -647, -647, -647, -647, -647, -647, -647,
     -647, -647, -647, -647, -647, -647, -647, -647, -647, -647,
     -647, -647, -647, -647, -647, -647, -647, -647, -647, -647,
     -647, -647, -647, -647, -647, -647, -647, -647,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -647, -647,
     -647, -647, -647, -647, -647,  227,  227,  227,  227,  227,
      227,  227,  724,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -647, -647, -647, -647,  227, -647,  227,  227,  227,
      227,  227,  227,  227,  724,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -647, -647, -647, -647,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -648, -648, -648, -648, -648, -648, -648, -648, -648,
     -648, -648, -648, -648, -648, -648, -648, -648, -648, -648,

     -648, -648, -648, -648, -648, -648, -648, -648, -648, -648,
     -648, -648, -648, -648, -648, -648, -648, -648, -648, -648,
     -648, -648, -648, -648, -648, -648, -648, -648,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -648, -648,
     -648, -648, -648, -648, -648,  227,  227,  227,  227,  725,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -648, -648, -648, -648,  227, -648,  227,  227,  227,
      227,  725,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -648, -648, -648, -648,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -649, -649, -649, -649, -649, -649, -649, -649, -649,
     -649, -649, -649, -649, -649, -649, -649, -649, -649, -649,
     -649, -649, -649, -649, -649, -649, -649, -649, -649, -649,
     -649, -649, -649, -649, -649, -649, -649, -649, -649, -649,
     -649, -649, -649, -649, -649, -649, -649, -649,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -649, -649,

     -649, -649, -649, -649, -649,  227,  227,  227,  227,  227,
      227,  227,  227,  726,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -649, -649, -649, -649,  227, -649,  227,  227,  227,
      227,  227,  227,  227,  227,  726,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -649, -649, -649, -649,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,

     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,

     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650, -650, -650, -650, -650,
     -650, -650, -650, -650, -650, -650
    },

    {
       45, -651, -651, -651, -651, -651, -651, -651, -651,  450,
      450, -651, -651,  450, -651, -651, -651, -651, -651, -651,
     -651, -651, -651, -651, -651, -651, -651, -651, -651, -651,
     -651, -651,  450, -651, -651,  451, -651, -651, -651, -651,

     -651, -651, -651, -651, -651, -651, -651,  553, -651, -651,
     -651, -651, -651, -651, -651, -651, -651, -651, -651, -651,
     -651, -651,  554, -651, -651,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554, -651, -651, -651, -651,  554, -651,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554, -651, -651, -651, -651,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,

      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,

      554,  554,  554,  554,  554,  554,  554,  554,  554,  554,
      554,  554,  554,  554,  554,  554
    },

    {
       45, -652, -652, -652, -652, -652, -652, -652, -652,  450,
      450, -652, -652,  450, -652, -652, -652, -652, -652, -652,
     -652, -652, -652, -652, -652, -652, -652, -652, -652, -652,
     -652, -652,  450, -652, -652,  451, -652, -652, -652, -652,
     -652, -652, -652, -652, -652,  452, -652,  453,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  452, -652,
     -652, -652,  455, -652, -652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,

      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652, -652, -652, -652, -652,  652, -652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652, -652, -652, -652, -652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,

      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652
    },

    {
       45,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,

      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  654,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,

      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,

      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653
    },

    {
       45,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  450,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,

      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,

      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653

    },

    {
       45,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727, -655,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      728,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,

      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,

      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727
    },

    {
       45,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655, -656,  655,  655,

      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
     -656,  655,  655, -656,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655, -656,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655, -656,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,

      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,

      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655
    },

    {
       45, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,

     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,

     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657, -657, -657, -657, -657,
     -657, -657, -657, -657, -657, -657
    },

    {
       45, -658, -658, -658, -658, -658, -658, -658, -658, -658,
      657, -658, -658, -658, -658, -658, -658, -658, -658, -658,

     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,

     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,

     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658, -658, -658, -658, -658,
     -658, -658, -658, -658, -658, -658
    },

    {
       45, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,

     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659,  729, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659,  729, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,

     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659, -659, -659, -659, -659,
     -659, -659, -659, -659, -659, -659

    },

    {
       45,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      731,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,

      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,

      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730
    },

    {
       45,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660, -661,  660,  660,

      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
     -661,  660,  660, -661,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660, -661,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660, -661,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,

      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,

      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660
    },

    {
       45, -662, -662, -662, -662, -662, -662, -662, -662,  732,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662,  732, -662, -662, -662, -662, -662, -662, -662,
     -662,  733, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,

     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,

     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662, -662, -662, -662, -662,
     -662, -662, -662, -662, -662, -662
    },

    {
       45, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,

     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663,  734,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,

     -663,  734, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,

     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663, -663, -663, -663, -663,
     -663, -663, -663, -663, -663, -663
    },

    {
       45, -664, -664, -664, -664, -664, -664, -664, -664,  664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664,  664, -664, -664, -664, -664, -664, -664, -664,
     -664,  665, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,

     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,

     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664, -664, -664, -664, -664,
     -664, -664, -664, -664, -664, -664

    },

    {
       45, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,

     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,

     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665, -665, -665, -665, -665,
     -665, -665, -665, -665, -665, -665
    },

    {
       45, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,

     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666,  735, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666, -666,  735, -666, -666,
     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,

     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,

     -666, -666, -666, -666, -666, -666, -666, -666, -666, -666,
     -666, -666, -666, -666, -666, -666
    },

    {
       45, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667,  736,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,

     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667,  736, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,

     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667, -667, -667, -667, -667,
     -667, -667, -667, -667, -667, -667
    },

    {
       45, -668, -668, -668, -668, -668, -668, -668, -668,  671,
     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,

     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668,  671, -668, -668, -668, -668, -668, -668, -668,
     -668,  672, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,

     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,

     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668, -668, -668, -668, -668, -668, -668, -668, -668,
     -668, -668, -668, -668, -668, -668
    },

    {
       45, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,

     -669, -669, -669, -669, -669, -669, -669, -669, -669,  737,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669,  737, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,

     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669, -669, -669, -669, -669,
     -669, -669, -669, -669, -669, -669

    },

    {
       45, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670,  738, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,

     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670,  738, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,

     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670, -670, -670, -670, -670,
     -670, -670, -670, -670, -670, -670
    },

    {
       45, -671, -671, -671, -671, -671, -671, -671, -671,  671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671,  671, -671, -671, -671, -671, -671, -671, -671,

     -671,  672, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,

     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,

     -671, -671, -671, -671, -671, -671, -671, -671, -671, -671,
     -671, -671, -671, -671, -671, -671
    },

    {
       45, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,

     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,

     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672, -672, -672, -672, -672,
     -672, -672, -672, -672, -672, -672
    },

    {
       45, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,

     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673,  739, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673,  739, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,

     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,

     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673, -673, -673, -673, -673,
     -673, -673, -673, -673, -673, -673
    },

    {
       45, -674, -674, -674, -674, -674, -674, -674, -674,  740,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674,  740, -674, -674, -674, -674, -674, -674, -674,
     -674,  741, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,

     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,

     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
     -674, -674, -674, -674, -674, -674

    },

    {
       45, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
      742, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,

     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675,  742, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,

     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
     -675, -675, -675, -675, -675, -675
    },

    {
       45, -676, -676, -676, -676, -676, -676, -676, -676, -676,
      587, -676, -676,  588, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,

     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,

     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,

     -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
     -676, -676, -676, -676, -676, -676
    },

    {
       45, -677, -677, -677, -677, -677, -677, -677, -677, -677,
     -677, -677, -677, -677, -677, -677, -677, -677, -677, -677,
     -677, -677, -677, -677, -677, -677, -677, -677, -677, -677,
     -677, -677, -677, -677,  676, -677, -677, -677, -677, -677,
     -677, -677, -677, -677, -677, -677, -677, -677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677, -677, -677,
     -677, -677, -677, -677, -677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,

      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677, -677, -677, -677, -677,  677, -677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677, -677, -677, -677, -677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,

      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677,  677,  677,  677,  677,
      677,  677,  677,  677,  677,  677
    },

    {
       45, -678, -678, -678, -678, -678, -678, -678, -678, -678,
     -678, -678, -678, -678, -678, -678, -678, -678, -678, -678,

     -678, -678, -678, -678, -678, -678, -678, -678, -678, -678,
     -678, -678, -678, -678, -678, -678, -678, -678, -678,  676,
     -678, -678, -678, -678, -678, -678, -678, -678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678, -678, -678,
     -678, -678, -678, -678, -678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678, -678, -678, -678, -678,  678, -678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,

      678,  678,  678, -678, -678, -678, -678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,

      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678
    },

    {
       45, -679, -679, -679, -679, -679, -679, -679, -679, -679,
     -679, -679, -679, -679, -679, -679, -679, -679, -679, -679,
     -679, -679, -679, -679, -679, -679, -679, -679, -679, -679,
     -679, -679, -679, -679, -679, -679, -679, -679, -679, -679,
     -679, -679, -679, -679, -679, -679, -679, -679,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -679, -679,

     -679, -679, -679, -679, -679,  227,  227,  743,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -679, -679, -679, -679,  227, -679,  227,  227,  743,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -679, -679, -679, -679,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -680, -680, -680, -680, -680, -680, -680, -680,  680,
      680, -680, -680,  680, -680, -680, -680, -680, -680, -680,
     -680, -680, -680, -680, -680, -680, -680, -680, -680, -680,
     -680, -680,  680, -680, -680,  681, -680, -680, -680, -680,
     -680, -680, -680, -680, -680, -680, -680,  682,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744, -680, -680,
     -680, -680, -680, -680, -680,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744, -680, -680, -680, -680,  744, -680,  744,  744,  744,

      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744, -680, -680, -680, -680,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,

      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744
    },

    {
       45,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      680,  745,  745,  746,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,

      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,

      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,

      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745
    },

    {
       45, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682,  747, -682, -682, -682, -682,  681, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,

     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,

     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
     -682, -682, -682, -682, -682, -682
    },

    {
       45, -683, -683, -683, -683, -683, -683, -683, -683, -683,
     -683, -683, -683, -683, -683, -683, -683, -683, -683, -683,

     -683, -683, -683, -683, -683, -683, -683, -683, -683, -683,
     -683, -683, -683, -683, -683, -683, -683, -683, -683, -683,
     -683, -683, -683, -683, -683, -683, -683, -683,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -683, -683,
     -683, -683, -683, -683, -683,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  748,  227,  227,  227,  227,
      227, -683, -683, -683, -683,  227, -683,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  748,  227,  227,

      227,  227,  227, -683, -683, -683, -683,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -684, -684, -684, -684, -684, -684, -684, -684, -684,
     -684, -684, -684, -684, -684, -684, -684, -684, -684, -684,
     -684, -684, -684, -684, -684, -684, -684, -684, -684, -684,
     -684, -684, -684, -684, -684, -684, -684, -684, -684, -684,
     -684, -684, -684, -684, -684, -684, -684, -684,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -684, -684,

     -684, -684, -684, -684, -684,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  749,  227,  227,  227,  227,  227,  227,  227,
      227, -684, -684, -684, -684,  227, -684,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  749,  227,  227,  227,  227,  227,
      227,  227,  227, -684, -684, -684, -684,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -685, -685, -685, -685, -685, -685, -685, -685, -685,
     -685, -685, -685, -685, -685, -685, -685, -685, -685, -685,
     -685, -685, -685, -685, -685, -685, -685, -685, -685, -685,
     -685, -685, -685, -685, -685, -685, -685, -685, -685, -685,
     -685, -685, -685, -685, -685, -685, -685, -685,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -685, -685,
     -685, -685, -685, -685, -685,  227,  227,  227,  227,  750,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -685, -685, -685, -685,  227, -685,  227,  227,  227,

      227,  750,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -685, -685, -685, -685,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -686, -686, -686, -686, -686, -686, -686, -686, -686,
     -686, -686, -686, -686, -686, -686, -686, -686, -686, -686,
     -686, -686, -686, -686, -686, -686, -686, -686, -686, -686,
     -686, -686, -686, -686, -686, -686, -686, -686, -686, -686,

     -686, -686, -686, -686, -686, -686, -686, -686,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -686, -686,
     -686, -686, -686, -686, -686,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  751,  227,  227,  227,  227,
      227, -686, -686, -686, -686,  227, -686,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  751,  227,  227,
      227,  227,  227, -686, -686, -686, -686,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -687, -687, -687, -687, -687, -687, -687, -687, -687,
     -687, -687, -687, -687, -687, -687, -687, -687, -687, -687,
     -687, -687, -687, -687, -687, -687, -687, -687, -687, -687,
     -687, -687, -687, -687, -687, -687, -687, -687, -687, -687,
     -687, -687, -687, -687, -687, -687, -687, -687,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -687, -687,
     -687, -687, -687, -687, -687,  227,  227,  227,  227,  752,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -687, -687, -687, -687,  227, -687,  227,  227,  227,
      227,  752,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -687, -687, -687, -687,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -688, -688, -688, -688, -688, -688, -688, -688, -688,
     -688, -688, -688, -688, -688, -688, -688, -688, -688, -688,

     -688, -688, -688, -688, -688, -688, -688, -688, -688, -688,
     -688, -688, -688, -688, -688, -688, -688, -688, -688, -688,
     -688, -688, -688, -688, -688, -688, -688, -688,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -688, -688,
     -688, -688, -688, -688, -688,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  753,  227,  227,  227,  227,  227,
      227, -688, -688, -688, -688,  227, -688,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  753,  227,  227,  227,

      227,  227,  227, -688, -688, -688, -688,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -689, -689, -689, -689, -689, -689, -689, -689, -689,
     -689, -689, -689, -689, -689, -689, -689, -689, -689, -689,
     -689, -689, -689, -689, -689, -689, -689, -689, -689, -689,
     -689, -689, -689, -689, -689, -689, -689, -689, -689, -689,
     -689, -689, -689, -689, -689, -689, -689, -689,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -689, -689,

     -689, -689, -689, -689, -689,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -689, -689, -689, -689,  227, -689,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -689, -689, -689, -689,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -690, -690, -690, -690, -690, -690, -690, -690, -690,
     -690, -690, -690, -690, -690, -690, -690, -690, -690, -690,
     -690, -690, -690, -690, -690, -690, -690, -690, -690, -690,
     -690, -690, -690, -690, -690, -690, -690, -690, -690, -690,
     -690, -690, -690, -690, -690, -690, -690, -690,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -690, -690,
     -690, -690, -690, -690, -690,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  754,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -690, -690, -690, -690,  227, -690,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  754,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -690, -690, -690, -690,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -691, -691, -691, -691, -691, -691, -691, -691, -691,
     -691, -691, -691, -691, -691, -691, -691, -691, -691, -691,
     -691, -691, -691, -691, -691, -691, -691, -691, -691, -691,
     -691, -691, -691, -691, -691, -691, -691, -691, -691, -691,

     -691, -691, -691, -691, -691, -691, -691, -691,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -691, -691,
     -691, -691, -691, -691, -691,  227,  227,  227,  227,  755,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -691, -691, -691, -691,  227, -691,  227,  227,  227,
      227,  755,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -691, -691, -691, -691,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -692, -692, -692, -692, -692, -692, -692, -692, -692,
     -692, -692, -692, -692, -692, -692, -692, -692, -692, -692,
     -692, -692, -692, -692, -692, -692, -692, -692, -692, -692,
     -692, -692, -692, -692, -692, -692, -692, -692, -692, -692,
     -692, -692, -692, -692, -692, -692, -692, -692,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -692, -692,
     -692, -692, -692, -692, -692,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  756,  227,  227,  227,  227,  227,
      227, -692, -692, -692, -692,  227, -692,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  756,  227,  227,  227,
      227,  227,  227, -692, -692, -692, -692,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -693, -693, -693, -693, -693, -693, -693, -693, -693,
     -693, -693, -693, -693, -693, -693, -693, -693, -693, -693,

     -693, -693, -693, -693, -693, -693, -693, -693, -693, -693,
     -693, -693, -693, -693, -693, -693, -693, -693, -693, -693,
     -693, -693, -693, -693, -693, -693, -693, -693,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -693, -693,
     -693, -693, -693, -693, -693,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  757,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -693, -693, -693, -693,  227, -693,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  757,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -693, -693, -693, -693,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -694, -694, -694, -694, -694, -694, -694, -694, -694,
     -694, -694, -694, -694, -694, -694, -694, -694, -694, -694,
     -694, -694, -694, -694, -694, -694, -694, -694, -694, -694,
     -694, -694, -694, -694, -694, -694, -694, -694, -694, -694,
     -694, -694, -694, -694, -694, -694, -694, -694,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -694, -694,

     -694, -694, -694, -694, -694,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  758,  227,  227,  227,  227,  227,  227,
      227, -694, -694, -694, -694,  227, -694,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  758,  227,  227,  227,  227,
      227,  227,  227, -694, -694, -694, -694,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -695, -695, -695, -695, -695, -695, -695, -695, -695,
     -695, -695, -695, -695, -695, -695, -695, -695, -695, -695,
     -695, -695, -695, -695, -695, -695, -695, -695, -695, -695,
     -695, -695, -695, -695, -695, -695, -695, -695, -695, -695,
     -695, -695, -695, -695, -695, -695, -695, -695,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -695, -695,
     -695, -695, -695, -695, -695,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  759,
      227, -695, -695, -695, -695,  227, -695,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  759,  227, -695, -695, -695, -695,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -696, -696, -696, -696, -696, -696, -696, -696, -696,
     -696, -696, -696, -696, -696, -696, -696, -696, -696, -696,
     -696, -696, -696, -696, -696, -696, -696, -696, -696, -696,
     -696, -696, -696, -696, -696, -696, -696, -696, -696, -696,

     -696, -696, -696, -696, -696, -696, -696, -696,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -696, -696,
     -696, -696, -696, -696, -696,  227,  227,  227,  227,  227,
      227,  227,  760,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -696, -696, -696, -696,  227, -696,  227,  227,  227,
      227,  227,  227,  227,  760,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -696, -696, -696, -696,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -697, -697, -697, -697, -697, -697, -697, -697, -697,
     -697, -697, -697, -697, -697, -697, -697, -697, -697, -697,
     -697, -697, -697, -697, -697, -697, -697, -697, -697, -697,
     -697, -697, -697, -697, -697, -697, -697, -697, -697, -697,
     -697, -697, -697, -697, -697, -697, -697, -697,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -697, -697,
     -697, -697, -697, -697, -697,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  761,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -697, -697, -697, -697,  227, -697,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  761,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -697, -697, -697, -697,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -698, -698, -698, -698, -698, -698, -698, -698, -698,
     -698, -698, -698, -698, -698, -698, -698, -698, -698, -698,

     -698, -698, -698, -698, -698, -698, -698, -698, -698, -698,
     -698, -698, -698, -698, -698, -698, -698, -698, -698, -698,
     -698, -698, -698, -698, -698, -698, -698, -698,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -698, -698,
     -698, -698, -698, -698, -698,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -698, -698, -698, -698,  227, -698,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -698, -698, -698, -698,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -699, -699, -699, -699, -699, -699, -699, -699, -699,
     -699, -699, -699, -699, -699, -699, -699, -699, -699, -699,
     -699, -699, -699, -699, -699, -699, -699, -699, -699, -699,
     -699, -699, -699, -699, -699, -699, -699, -699, -699, -699,
     -699, -699, -699, -699, -699, -699, -699, -699,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -699, -699,

     -699, -699, -699, -699, -699,  227,  227,  227,  227,  762,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -699, -699, -699, -699,  227, -699,  227,  227,  227,
      227,  762,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -699, -699, -699, -699,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -700, -700, -700, -700, -700, -700, -700, -700, -700,
     -700, -700, -700, -700, -700, -700, -700, -700, -700, -700,
     -700, -700, -700, -700, -700, -700, -700, -700, -700, -700,
     -700, -700, -700, -700, -700, -700, -700, -700, -700, -700,
     -700, -700, -700, -700, -700, -700, -700, -700,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -700, -700,
     -700, -700, -700, -700, -700,  227,  227,  227,  227,  763,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -700, -700, -700, -700,  227, -700,  227,  227,  227,

      227,  763,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -700, -700, -700, -700,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -701, -701, -701, -701, -701, -701, -701, -701, -701,
     -701, -701, -701, -701, -701, -701, -701, -701, -701, -701,
     -701, -701, -701, -701, -701, -701, -701, -701, -701, -701,
     -701, -701, -701, -701, -701, -701, -701, -701, -701, -701,

     -701, -701, -701, -701, -701, -701, -701, -701,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -701, -701,
     -701, -701, -701, -701, -701,  227,  227,  764,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -701, -701, -701, -701,  227, -701,  227,  227,  764,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -701, -701, -701, -701,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -702, -702, -702, -702, -702, -702, -702, -702, -702,
     -702, -702, -702, -702, -702, -702, -702, -702, -702, -702,
     -702, -702, -702, -702, -702, -702, -702, -702, -702, -702,
     -702, -702, -702, -702, -702, -702, -702, -702, -702, -702,
     -702, -702, -702, -702, -702, -702, -702, -702,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -702, -702,
     -702, -702, -702, -702, -702,  227,  227,  227,  765,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -702, -702, -702, -702,  227, -702,  227,  227,  227,
      765,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -702, -702, -702, -702,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -703, -703, -703, -703, -703, -703, -703, -703, -703,
     -703, -703, -703, -703, -703, -703, -703, -703, -703, -703,

     -703, -703, -703, -703, -703, -703, -703, -703, -703, -703,
     -703, -703, -703, -703, -703, -703, -703, -703, -703, -703,
     -703, -703, -703, -703, -703, -703, -703, -703,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -703, -703,
     -703, -703, -703, -703, -703,  766,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -703, -703, -703, -703,  227, -703,  766,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -703, -703, -703, -703,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -704, -704, -704, -704, -704, -704, -704, -704, -704,
     -704, -704, -704, -704, -704, -704, -704, -704, -704, -704,
     -704, -704, -704, -704, -704, -704, -704, -704, -704, -704,
     -704, -704, -704, -704, -704, -704, -704, -704, -704, -704,
     -704, -704, -704, -704, -704, -704, -704, -704,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -704, -704,

     -704, -704, -704, -704, -704,  767,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -704, -704, -704, -704,  227, -704,  767,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -704, -704, -704, -704,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -705, -705, -705, -705, -705, -705, -705, -705, -705,
     -705, -705, -705, -705, -705, -705, -705, -705, -705, -705,
     -705, -705, -705, -705, -705, -705, -705, -705, -705, -705,
     -705, -705, -705, -705, -705, -705, -705, -705, -705, -705,
     -705, -705, -705, -705, -705, -705, -705, -705,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -705, -705,
     -705, -705, -705, -705, -705,  227,  227,  227,  227,  768,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -705, -705, -705, -705,  227, -705,  227,  227,  227,

      227,  768,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -705, -705, -705, -705,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -706, -706, -706, -706, -706, -706, -706, -706, -706,
     -706, -706, -706, -706, -706, -706, -706, -706, -706, -706,
     -706, -706, -706, -706, -706, -706, -706, -706, -706, -706,
     -706, -706, -706, -706, -706, -706, -706, -706, -706, -706,

     -706, -706, -706, -706, -706, -706, -706, -706,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -706, -706,
     -706, -706, -706, -706, -706,  227,  227,  227,  227,  769,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -706, -706, -706, -706,  227, -706,  227,  227,  227,
      227,  769,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -706, -706, -706, -706,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -707, -707, -707, -707, -707, -707, -707, -707, -707,
     -707, -707, -707, -707, -707, -707, -707, -707, -707, -707,
     -707, -707, -707, -707, -707, -707, -707, -707, -707, -707,
     -707, -707, -707, -707, -707, -707, -707, -707, -707, -707,
     -707, -707, -707, -707, -707, -707, -707, -707,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -707, -707,
     -707, -707, -707, -707, -707,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  770,  227,  227,  227,  227,  227,
      227, -707, -707, -707, -707,  227, -707,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  770,  227,  227,  227,
      227,  227,  227, -707, -707, -707, -707,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -708, -708, -708, -708, -708, -708, -708, -708, -708,
     -708, -708, -708, -708, -708, -708, -708, -708, -708, -708,

     -708, -708, -708, -708, -708, -708, -708, -708, -708, -708,
     -708, -708, -708, -708, -708, -708, -708, -708, -708, -708,
     -708, -708, -708, -708, -708, -708, -708, -708,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -708, -708,
     -708, -708, -708, -708, -708,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -708, -708, -708, -708,  227, -708,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -708, -708, -708, -708,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -709, -709, -709, -709, -709, -709, -709, -709, -709,
     -709, -709, -709, -709, -709, -709, -709, -709, -709, -709,
     -709, -709, -709, -709, -709, -709, -709, -709, -709, -709,
     -709, -709, -709, -709, -709, -709, -709, -709, -709, -709,
     -709, -709, -709, -709, -709, -709, -709, -709,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -709, -709,

     -709, -709, -709, -709, -709,  227,  227,  227,  227,  771,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -709, -709, -709, -709,  227, -709,  227,  227,  227,
      227,  771,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -709, -709, -709, -709,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -710, -710, -710, -710, -710, -710, -710, -710, -710,
     -710, -710, -710, -710, -710, -710, -710, -710, -710, -710,
     -710, -710, -710, -710, -710, -710, -710, -710, -710, -710,
     -710, -710, -710, -710, -710, -710, -710, -710, -710, -710,
     -710, -710, -710, -710, -710, -710, -710, -710,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -710, -710,
     -710, -710, -710, -710, -710,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -710, -710, -710, -710,  227, -710,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -710, -710, -710, -710,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -711, -711, -711, -711, -711, -711, -711, -711, -711,
     -711, -711, -711, -711, -711, -711, -711, -711, -711, -711,
     -711, -711, -711, -711, -711, -711, -711, -711, -711, -711,
     -711, -711, -711, -711, -711, -711, -711, -711, -711, -711,

     -711, -711, -711, -711, -711, -711, -711, -711,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -711, -711,
     -711, -711, -711, -711, -711,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -711, -711, -711, -711,  227, -711,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -711, -711, -711, -711,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -712, -712, -712, -712, -712, -712, -712, -712, -712,
     -712, -712, -712, -712, -712, -712, -712, -712, -712, -712,
     -712, -712, -712, -712, -712, -712, -712, -712, -712, -712,
     -712, -712, -712, -712, -712, -712, -712, -712, -712, -712,
     -712, -712, -712, -712, -712, -712, -712, -712,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -712, -712,
     -712, -712, -712, -712, -712,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -712, -712, -712, -712,  227, -712,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -712, -712, -712, -712,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -713, -713, -713, -713, -713, -713, -713, -713,  713,
      713, -713, -713,  713, -713, -713, -713, -713, -713, -713,

     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,
     -713, -713,  713, -713, -713,  714, -713, -713, -713, -713,
      715, -713, -713, -713, -713, -713, -713,  716, -713, -713,
     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,
     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,
     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,
     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,
     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,
     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,
     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,

     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,
     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,
     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,
     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,
     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,
     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,
     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,
     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,
     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,
     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,

     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,
     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,
     -713, -713, -713, -713, -713, -713, -713, -713, -713, -713,
     -713, -713, -713, -713, -713, -713
    },

    {
       45,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      713,  772,  772,  773,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,

      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,

      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772

    },

    {
       45, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,

     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,

     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715, -715, -715, -715, -715,
     -715, -715, -715, -715, -715, -715
    },

    {
       45, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,

     -716, -716,  774, -716, -716, -716, -716,  714, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,

     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,

     -716, -716, -716, -716, -716, -716, -716, -716, -716, -716,
     -716, -716, -716, -716, -716, -716
    },

    {
       45, -717, -717, -717, -717, -717, -717, -717, -717, -717,
     -717, -717, -717, -717, -717, -717, -717, -717, -717, -717,
     -717, -717, -717, -717, -717, -717, -717, -717, -717, -717,
     -717, -717, -717, -717, -717, -717, -717, -717, -717, -717,
     -717, -717, -717, -717, -717, -717, -717, -717,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -717, -717,
     -717, -717, -717, -717, -717,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  775,  227,  227,  227,  227,  227,  227,
      227, -717, -717, -717, -717,  227, -717,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  775,  227,  227,  227,  227,
      227,  227,  227, -717, -717, -717, -717,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -718, -718, -718, -718, -718, -718, -718, -718, -718,
     -718, -718, -718, -718, -718, -718, -718, -718, -718, -718,

     -718, -718, -718, -718, -718, -718, -718, -718, -718, -718,
     -718, -718, -718, -718, -718, -718, -718, -718, -718, -718,
     -718, -718, -718, -718, -718, -718, -718, -718,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -718, -718,
     -718, -718, -718, -718, -718,  227,  227,  227,  227,  227,
      227,  227,  227,  776,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -718, -718, -718, -718,  227, -718,  227,  227,  227,
      227,  227,  227,  227,  227,  776,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -718, -718, -718, -718,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -719, -719, -719, -719, -719, -719, -719, -719, -719,
     -719, -719, -719, -719, -719, -719, -719, -719, -719, -719,
     -719, -719, -719, -719, -719, -719, -719, -719, -719, -719,
     -719, -719, -719, -719, -719, -719, -719, -719, -719, -719,
     -719, -719, -719, -719, -719, -719, -719, -719,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -719, -719,

     -719, -719, -719, -719, -719,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -719, -719, -719, -719,  777, -719,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -719, -719, -719, -719,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -720, -720, -720, -720, -720, -720, -720, -720, -720,
     -720, -720, -720, -720, -720, -720, -720, -720, -720, -720,
     -720, -720, -720, -720, -720, -720, -720, -720, -720, -720,
     -720, -720, -720, -720, -720, -720, -720, -720, -720, -720,
     -720, -720, -720, -720, -720, -720, -720, -720,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -720, -720,
     -720, -720, -720, -720, -720,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -720, -720, -720, -720,  778, -720,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -720, -720, -720, -720,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -721, -721, -721, -721, -721, -721, -721, -721, -721,
     -721, -721, -721, -721, -721, -721, -721, -721, -721, -721,
     -721, -721, -721, -721, -721, -721, -721, -721, -721, -721,
     -721, -721, -721, -721, -721, -721, -721, -721, -721, -721,

     -721, -721, -721, -721, -721, -721, -721, -721,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -721, -721,
     -721, -721, -721, -721, -721,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  779,  227,  227,  227,  227,  227,
      227, -721, -721, -721, -721,  227, -721,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  779,  227,  227,  227,
      227,  227,  227, -721, -721, -721, -721,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -722, -722, -722, -722, -722, -722, -722, -722, -722,
     -722, -722, -722, -722, -722, -722, -722, -722, -722, -722,
     -722, -722, -722, -722, -722, -722, -722, -722, -722, -722,
     -722, -722, -722, -722, -722, -722, -722, -722, -722, -722,
     -722, -722, -722, -722, -722, -722, -722, -722,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -722, -722,
     -722, -722, -722, -722, -722,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -722, -722, -722, -722,  780, -722,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -722, -722, -722, -722,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -723, -723, -723, -723, -723, -723, -723, -723, -723,
     -723, -723, -723, -723, -723, -723, -723, -723, -723, -723,

     -723, -723, -723, -723, -723, -723, -723, -723, -723, -723,
     -723, -723, -723, -723, -723, -723, -723, -723, -723, -723,
     -723, -723, -723, -723, -723, -723, -723, -723,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -723, -723,
     -723, -723, -723, -723, -723,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -723, -723, -723, -723,  781, -723,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -723, -723, -723, -723,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -724, -724, -724, -724, -724, -724, -724, -724, -724,
     -724, -724, -724, -724, -724, -724, -724, -724, -724, -724,
     -724, -724, -724, -724, -724, -724, -724, -724, -724, -724,
     -724, -724, -724, -724, -724, -724, -724, -724, -724, -724,
     -724, -724, -724, -724, -724, -724, -724, -724,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -724, -724,

     -724, -724, -724, -724, -724,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  782,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -724, -724, -724, -724,  227, -724,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  782,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -724, -724, -724, -724,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -725, -725, -725, -725, -725, -725, -725, -725, -725,
     -725, -725, -725, -725, -725, -725, -725, -725, -725, -725,
     -725, -725, -725, -725, -725, -725, -725, -725, -725, -725,
     -725, -725, -725, -725, -725, -725, -725, -725, -725, -725,
     -725, -725, -725, -725, -725, -725, -725, -725,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -725, -725,
     -725, -725, -725, -725, -725,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  783,  227,  227,  227,  227,  227,  227,
      227, -725, -725, -725, -725,  227, -725,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  783,  227,  227,  227,  227,
      227,  227,  227, -725, -725, -725, -725,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -726, -726, -726, -726, -726, -726, -726, -726, -726,
     -726, -726, -726, -726, -726, -726, -726, -726, -726, -726,
     -726, -726, -726, -726, -726, -726, -726, -726, -726, -726,
     -726, -726, -726, -726, -726, -726, -726, -726, -726, -726,

     -726, -726, -726, -726, -726, -726, -726, -726,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -726, -726,
     -726, -726, -726, -726, -726,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  784,  227,  227,  227,  227,  227,
      227, -726, -726, -726, -726,  227, -726,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  784,  227,  227,  227,
      227,  227,  227, -726, -726, -726, -726,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785, -727,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      786,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,

      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,

      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785
    },

    {
       45,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,

      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727, -728,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
     -728,  727,  727, -728,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727, -728,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727, -728,  727,  727,  727,  727,

      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,

      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727
    },

    {
       45, -729, -729, -729, -729, -729, -729, -729, -729,  787,
      787, -729, -729,  787, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729,  787, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,

     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,

     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729, -729, -729, -729, -729,
     -729, -729, -729, -729, -729, -729

    },

    {
       45,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      789,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,

      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,

      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788
    },

    {
       45,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730, -731,  730,  730,

      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
     -731,  730,  730, -731,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730, -731,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730, -731,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,

      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,

      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730
    },

    {
       45, -732, -732, -732, -732, -732, -732, -732, -732,  732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732,  732, -732, -732, -732, -732, -732, -732, -732,
     -732,  733, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,

     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,

     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732, -732, -732, -732, -732,
     -732, -732, -732, -732, -732, -732
    },

    {
       45, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,

     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,

     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,

     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733, -733, -733, -733, -733,
     -733, -733, -733, -733, -733, -733
    },

    {
       45, -734, -734, -734, -734, -734, -734, -734, -734,  790,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734,  790, -734, -734, -734, -734, -734, -734, -734,
     -734,  791, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,

     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,

     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734, -734, -734, -734, -734,
     -734, -734, -734, -734, -734, -734

    },

    {
       45, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735,  792, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,

     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
      792, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,

     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735, -735, -735, -735, -735,
     -735, -735, -735, -735, -735, -735
    },

    {
       45, -736, -736, -736, -736, -736, -736, -736, -736,  671,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736,  671, -736, -736, -736, -736, -736, -736, -736,

     -736,  672, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,

     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,

     -736, -736, -736, -736, -736, -736, -736, -736, -736, -736,
     -736, -736, -736, -736, -736, -736
    },

    {
       45, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,

     -737, -737,  793, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737,  793, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,

     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737, -737, -737, -737, -737,
     -737, -737, -737, -737, -737, -737
    },

    {
       45, -738, -738, -738, -738, -738, -738, -738, -738,  794,
     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,

     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738,  794, -738, -738, -738, -738, -738, -738, -738,
     -738,  795, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,

     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,

     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738, -738, -738, -738, -738, -738, -738, -738, -738,
     -738, -738, -738, -738, -738, -738
    },

    {
       45, -739, -739, -739, -739, -739, -739, -739, -739,  790,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739,  790, -739, -739, -739, -739, -739, -739, -739,
     -739,  791, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,

     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,

     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739, -739, -739, -739, -739,
     -739, -739, -739, -739, -739, -739

    },

    {
       45, -740, -740, -740, -740, -740, -740, -740, -740,  740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740,  740, -740, -740, -740, -740, -740, -740, -740,
     -740,  741, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,

     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,

     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740, -740, -740, -740, -740,
     -740, -740, -740, -740, -740, -740
    },

    {
       45, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,

     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,

     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,

     -741, -741, -741, -741, -741, -741, -741, -741, -741, -741,
     -741, -741, -741, -741, -741, -741
    },

    {
       45, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,

     -742, -742, -742, -742,  796, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742,  796, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,

     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742, -742, -742, -742, -742,
     -742, -742, -742, -742, -742, -742
    },

    {
       45, -743, -743, -743, -743, -743, -743, -743, -743, -743,
     -743, -743, -743, -743, -743, -743, -743, -743, -743, -743,

     -743, -743, -743, -743, -743, -743, -743, -743, -743, -743,
     -743, -743, -743, -743, -743, -743, -743, -743, -743, -743,
     -743, -743, -743, -743, -743, -743, -743, -743,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -743, -743,
     -743, -743, -743, -743, -743,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  797,  227,  227,  227,  227,  227,
      227, -743, -743, -743, -743,  227, -743,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  797,  227,  227,  227,

      227,  227,  227, -743, -743, -743, -743,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,

     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,

     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744, -744, -744, -744, -744,
     -744, -744, -744, -744, -744, -744

    },

    {
       45,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      680,  745,  745,  746,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,

      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,

      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745,  745,  745,  745,  745,
      745,  745,  745,  745,  745,  745
    },

    {
       45, -746, -746, -746, -746, -746, -746, -746, -746,  680,
      798, -746, -746,  680, -746, -746, -746, -746, -746, -746,
     -746, -746, -746, -746, -746, -746, -746, -746, -746, -746,
     -746, -746,  680, -746, -746,  681, -746, -746, -746, -746,

     -746, -746, -746, -746, -746, -746, -746,  682,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744, -746, -746,
     -746, -746, -746, -746, -746,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744, -746, -746, -746, -746,  744, -746,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744, -746, -746, -746, -746,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,

      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,

      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744
    },

    {
       45,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  800,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,

      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,

      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799
    },

    {
       45, -748, -748, -748, -748, -748, -748, -748, -748, -748,
     -748, -748, -748, -748, -748, -748, -748, -748, -748, -748,

     -748, -748, -748, -748, -748, -748, -748, -748, -748, -748,
     -748, -748, -748, -748, -748, -748, -748, -748, -748, -748,
     -748, -748, -748, -748, -748, -748, -748, -748,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -748, -748,
     -748, -748, -748, -748, -748,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  801,  227,  227,  227,  227,  227,
      227, -748, -748, -748, -748,  227, -748,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  801,  227,  227,  227,

      227,  227,  227, -748, -748, -748, -748,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -749, -749, -749, -749, -749, -749, -749, -749, -749,
     -749, -749, -749, -749, -749, -749, -749, -749, -749, -749,
     -749, -749, -749, -749, -749, -749, -749, -749, -749, -749,
     -749, -749, -749, -749, -749, -749, -749, -749, -749, -749,
     -749, -749, -749, -749, -749, -749, -749, -749,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -749, -749,

     -749, -749, -749, -749, -749,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  802,
      227, -749, -749, -749, -749,  227, -749,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  802,  227, -749, -749, -749, -749,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -750, -750, -750, -750, -750, -750, -750, -750, -750,
     -750, -750, -750, -750, -750, -750, -750, -750, -750, -750,
     -750, -750, -750, -750, -750, -750, -750, -750, -750, -750,
     -750, -750, -750, -750, -750, -750, -750, -750, -750, -750,
     -750, -750, -750, -750, -750, -750, -750, -750,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -750, -750,
     -750, -750, -750, -750, -750,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  803,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -750, -750, -750, -750,  227, -750,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      803,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -750, -750, -750, -750,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -751, -751, -751, -751, -751, -751, -751, -751, -751,
     -751, -751, -751, -751, -751, -751, -751, -751, -751, -751,
     -751, -751, -751, -751, -751, -751, -751, -751, -751, -751,
     -751, -751, -751, -751, -751, -751, -751, -751, -751, -751,

     -751, -751, -751, -751, -751, -751, -751, -751,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -751, -751,
     -751, -751, -751, -751, -751,  227,  227,  227,  227,  804,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -751, -751, -751, -751,  227, -751,  227,  227,  227,
      227,  804,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -751, -751, -751, -751,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -752, -752, -752, -752, -752, -752, -752, -752, -752,
     -752, -752, -752, -752, -752, -752, -752, -752, -752, -752,
     -752, -752, -752, -752, -752, -752, -752, -752, -752, -752,
     -752, -752, -752, -752, -752, -752, -752, -752, -752, -752,
     -752, -752, -752, -752, -752, -752, -752, -752,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -752, -752,
     -752, -752, -752, -752, -752,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -752, -752, -752, -752,  227, -752,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -752, -752, -752, -752,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -753, -753, -753, -753, -753, -753, -753, -753, -753,
     -753, -753, -753, -753, -753, -753, -753, -753, -753, -753,

     -753, -753, -753, -753, -753, -753, -753, -753, -753, -753,
     -753, -753, -753, -753, -753, -753, -753, -753, -753, -753,
     -753, -753, -753, -753, -753, -753, -753, -753,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -753, -753,
     -753, -753, -753, -753, -753,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -753, -753, -753, -753,  227, -753,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -753, -753, -753, -753,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -754, -754, -754, -754, -754, -754, -754, -754, -754,
     -754, -754, -754, -754, -754, -754, -754, -754, -754, -754,
     -754, -754, -754, -754, -754, -754, -754, -754, -754, -754,
     -754, -754, -754, -754, -754, -754, -754, -754, -754, -754,
     -754, -754, -754, -754, -754, -754, -754, -754,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -754, -754,

     -754, -754, -754, -754, -754,  805,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -754, -754, -754, -754,  227, -754,  805,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -754, -754, -754, -754,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -755, -755, -755, -755, -755, -755, -755, -755, -755,
     -755, -755, -755, -755, -755, -755, -755, -755, -755, -755,
     -755, -755, -755, -755, -755, -755, -755, -755, -755, -755,
     -755, -755, -755, -755, -755, -755, -755, -755, -755, -755,
     -755, -755, -755, -755, -755, -755, -755, -755,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -755, -755,
     -755, -755, -755, -755, -755,  806,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -755, -755, -755, -755,  227, -755,  806,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -755, -755, -755, -755,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -756, -756, -756, -756, -756, -756, -756, -756, -756,
     -756, -756, -756, -756, -756, -756, -756, -756, -756, -756,
     -756, -756, -756, -756, -756, -756, -756, -756, -756, -756,
     -756, -756, -756, -756, -756, -756, -756, -756, -756, -756,

     -756, -756, -756, -756, -756, -756, -756, -756,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -756, -756,
     -756, -756, -756, -756, -756,  227,  227,  807,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -756, -756, -756, -756,  227, -756,  227,  227,  807,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -756, -756, -756, -756,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -757, -757, -757, -757, -757, -757, -757, -757, -757,
     -757, -757, -757, -757, -757, -757, -757, -757, -757, -757,
     -757, -757, -757, -757, -757, -757, -757, -757, -757, -757,
     -757, -757, -757, -757, -757, -757, -757, -757, -757, -757,
     -757, -757, -757, -757, -757, -757, -757, -757,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -757, -757,
     -757, -757, -757, -757, -757,  227,  227,  227,  227,  808,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -757, -757, -757, -757,  227, -757,  227,  227,  227,
      227,  808,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -757, -757, -757, -757,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -758, -758, -758, -758, -758, -758, -758, -758, -758,
     -758, -758, -758, -758, -758, -758, -758, -758, -758, -758,

     -758, -758, -758, -758, -758, -758, -758, -758, -758, -758,
     -758, -758, -758, -758, -758, -758, -758, -758, -758, -758,
     -758, -758, -758, -758, -758, -758, -758, -758,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -758, -758,
     -758, -758, -758, -758, -758,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -758, -758, -758, -758,  227, -758,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -758, -758, -758, -758,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -759, -759, -759, -759, -759, -759, -759, -759, -759,
     -759, -759, -759, -759, -759, -759, -759, -759, -759, -759,
     -759, -759, -759, -759, -759, -759, -759, -759, -759, -759,
     -759, -759, -759, -759, -759, -759, -759, -759, -759, -759,
     -759, -759, -759, -759, -759, -759, -759, -759,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -759, -759,

     -759, -759, -759, -759, -759,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -759, -759, -759, -759,  227, -759,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -759, -759, -759, -759,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -760, -760, -760, -760, -760, -760, -760, -760, -760,
     -760, -760, -760, -760, -760, -760, -760, -760, -760, -760,
     -760, -760, -760, -760, -760, -760, -760, -760, -760, -760,
     -760, -760, -760, -760, -760, -760, -760, -760, -760, -760,
     -760, -760, -760, -760, -760, -760, -760, -760,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -760, -760,
     -760, -760, -760, -760, -760,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -760, -760, -760, -760,  227, -760,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -760, -760, -760, -760,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -761, -761, -761, -761, -761, -761, -761, -761, -761,
     -761, -761, -761, -761, -761, -761, -761, -761, -761, -761,
     -761, -761, -761, -761, -761, -761, -761, -761, -761, -761,
     -761, -761, -761, -761, -761, -761, -761, -761, -761, -761,

     -761, -761, -761, -761, -761, -761, -761, -761,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -761, -761,
     -761, -761, -761, -761, -761,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  809,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -761, -761, -761, -761,  227, -761,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      809,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -761, -761, -761, -761,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -762, -762, -762, -762, -762, -762, -762, -762, -762,
     -762, -762, -762, -762, -762, -762, -762, -762, -762, -762,
     -762, -762, -762, -762, -762, -762, -762, -762, -762, -762,
     -762, -762, -762, -762, -762, -762, -762, -762, -762, -762,
     -762, -762, -762, -762, -762, -762, -762, -762,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -762, -762,
     -762, -762, -762, -762, -762,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  810,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -762, -762, -762, -762,  227, -762,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      810,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -762, -762, -762, -762,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -763, -763, -763, -763, -763, -763, -763, -763, -763,
     -763, -763, -763, -763, -763, -763, -763, -763, -763, -763,

     -763, -763, -763, -763, -763, -763, -763, -763, -763, -763,
     -763, -763, -763, -763, -763, -763, -763, -763, -763, -763,
     -763, -763, -763, -763, -763, -763, -763, -763,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -763, -763,
     -763, -763, -763, -763, -763,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -763, -763, -763, -763,  811, -763,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -763, -763, -763, -763,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -764, -764, -764, -764, -764, -764, -764, -764, -764,
     -764, -764, -764, -764, -764, -764, -764, -764, -764, -764,
     -764, -764, -764, -764, -764, -764, -764, -764, -764, -764,
     -764, -764, -764, -764, -764, -764, -764, -764, -764, -764,
     -764, -764, -764, -764, -764, -764, -764, -764,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -764, -764,

     -764, -764, -764, -764, -764,  227,  227,  227,  227,  812,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -764, -764, -764, -764,  227, -764,  227,  227,  227,
      227,  812,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -764, -764, -764, -764,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -765, -765, -765, -765, -765, -765, -765, -765, -765,
     -765, -765, -765, -765, -765, -765, -765, -765, -765, -765,
     -765, -765, -765, -765, -765, -765, -765, -765, -765, -765,
     -765, -765, -765, -765, -765, -765, -765, -765, -765, -765,
     -765, -765, -765, -765, -765, -765, -765, -765,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -765, -765,
     -765, -765, -765, -765, -765,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  813,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -765, -765, -765, -765,  227, -765,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  813,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -765, -765, -765, -765,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -766, -766, -766, -766, -766, -766, -766, -766, -766,
     -766, -766, -766, -766, -766, -766, -766, -766, -766, -766,
     -766, -766, -766, -766, -766, -766, -766, -766, -766, -766,
     -766, -766, -766, -766, -766, -766, -766, -766, -766, -766,

     -766, -766, -766, -766, -766, -766, -766, -766,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -766, -766,
     -766, -766, -766, -766, -766,  227,  227,  814,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -766, -766, -766, -766,  227, -766,  227,  227,  814,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -766, -766, -766, -766,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -767, -767, -767, -767, -767, -767, -767, -767, -767,
     -767, -767, -767, -767, -767, -767, -767, -767, -767, -767,
     -767, -767, -767, -767, -767, -767, -767, -767, -767, -767,
     -767, -767, -767, -767, -767, -767, -767, -767, -767, -767,
     -767, -767, -767, -767, -767, -767, -767, -767,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -767, -767,
     -767, -767, -767, -767, -767,  227,  227,  815,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -767, -767, -767, -767,  227, -767,  227,  227,  815,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -767, -767, -767, -767,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -768, -768, -768, -768, -768, -768, -768, -768, -768,
     -768, -768, -768, -768, -768, -768, -768, -768, -768, -768,

     -768, -768, -768, -768, -768, -768, -768, -768, -768, -768,
     -768, -768, -768, -768, -768, -768, -768, -768, -768, -768,
     -768, -768, -768, -768, -768, -768, -768, -768,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -768, -768,
     -768, -768, -768, -768, -768,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -768, -768, -768, -768,  227, -768,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -768, -768, -768, -768,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -769, -769, -769, -769, -769, -769, -769, -769, -769,
     -769, -769, -769, -769, -769, -769, -769, -769, -769, -769,
     -769, -769, -769, -769, -769, -769, -769, -769, -769, -769,
     -769, -769, -769, -769, -769, -769, -769, -769, -769, -769,
     -769, -769, -769, -769, -769, -769, -769, -769,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -769, -769,

     -769, -769, -769, -769, -769,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -769, -769, -769, -769,  227, -769,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -769, -769, -769, -769,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -770, -770, -770, -770, -770, -770, -770, -770, -770,
     -770, -770, -770, -770, -770, -770, -770, -770, -770, -770,
     -770, -770, -770, -770, -770, -770, -770, -770, -770, -770,
     -770, -770, -770, -770, -770, -770, -770, -770, -770, -770,
     -770, -770, -770, -770, -770, -770, -770, -770,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -770, -770,
     -770, -770, -770, -770, -770,  227,  227,  227,  227,  816,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -770, -770, -770, -770,  227, -770,  227,  227,  227,

      227,  816,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -770, -770, -770, -770,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -771, -771, -771, -771, -771, -771, -771, -771, -771,
     -771, -771, -771, -771, -771, -771, -771, -771, -771, -771,
     -771, -771, -771, -771, -771, -771, -771, -771, -771, -771,
     -771, -771, -771, -771, -771, -771, -771, -771, -771, -771,

     -771, -771, -771, -771, -771, -771, -771, -771,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -771, -771,
     -771, -771, -771, -771, -771,  227,  227,  227,  817,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -771, -771, -771, -771,  818, -771,  227,  227,  227,
      817,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -771, -771, -771, -771,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      713,  772,  772,  773,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,

      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,

      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772,  772,  772,  772,  772,
      772,  772,  772,  772,  772,  772
    },

    {
       45, -773, -773, -773, -773, -773, -773, -773, -773,  713,
      819, -773, -773,  713, -773, -773, -773, -773, -773, -773,

     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,
     -773, -773,  713, -773, -773,  714, -773, -773, -773, -773,
      715, -773, -773, -773, -773, -773, -773,  716, -773, -773,
     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,
     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,
     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,
     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,
     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,
     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,
     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,

     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,
     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,
     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,
     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,
     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,
     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,
     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,
     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,
     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,
     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,

     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,
     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,
     -773, -773, -773, -773, -773, -773, -773, -773, -773, -773,
     -773, -773, -773, -773, -773, -773
    },

    {
       45,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  821,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,

      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,

      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820

    },

    {
       45, -775, -775, -775, -775, -775, -775, -775, -775, -775,
     -775, -775, -775, -775, -775, -775, -775, -775, -775, -775,
     -775, -775, -775, -775, -775, -775, -775, -775, -775, -775,
     -775, -775, -775, -775, -775, -775, -775, -775, -775, -775,
     -775, -775, -775, -775, -775, -775, -775, -775,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -775, -775,
     -775, -775, -775, -775, -775,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -775, -775, -775, -775,  822, -775,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -775, -775, -775, -775,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -776, -776, -776, -776, -776, -776, -776, -776, -776,
     -776, -776, -776, -776, -776, -776, -776, -776, -776, -776,
     -776, -776, -776, -776, -776, -776, -776, -776, -776, -776,
     -776, -776, -776, -776, -776, -776, -776, -776, -776, -776,

     -776, -776, -776, -776, -776, -776, -776, -776,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -776, -776,
     -776, -776, -776, -776, -776,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  823,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -776, -776, -776, -776,  227, -776,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  823,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -776, -776, -776, -776,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -777, -777, -777, -777, -777, -777, -777, -777, -777,
     -777, -777, -777, -777, -777, -777, -777, -777, -777, -777,
     -777, -777, -777, -777, -777, -777, -777, -777, -777, -777,
     -777, -777, -777, -777, -777, -777, -777, -777, -777, -777,
     -777, -777, -777, -777, -777, -777, -777, -777,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -777, -777,
     -777, -777, -777, -777, -777,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -777, -777, -777, -777,  227, -777,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -777, -777, -777, -777,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -778, -778, -778, -778, -778, -778, -778, -778, -778,
     -778, -778, -778, -778, -778, -778, -778, -778, -778, -778,

     -778, -778, -778, -778, -778, -778, -778, -778, -778, -778,
     -778, -778, -778, -778, -778, -778, -778, -778, -778, -778,
     -778, -778, -778, -778, -778, -778, -778, -778,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -778, -778,
     -778, -778, -778, -778, -778,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -778, -778, -778, -778,  824, -778,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -778, -778, -778, -778,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -779, -779, -779, -779, -779, -779, -779, -779, -779,
     -779, -779, -779, -779, -779, -779, -779, -779, -779, -779,
     -779, -779, -779, -779, -779, -779, -779, -779, -779, -779,
     -779, -779, -779, -779, -779, -779, -779, -779, -779, -779,
     -779, -779, -779, -779, -779, -779, -779, -779,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -779, -779,

     -779, -779, -779, -779, -779,  227,  227,  227,  227,  227,
      227,  227,  227,  825,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -779, -779, -779, -779,  227, -779,  227,  227,  227,
      227,  227,  227,  227,  227,  825,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -779, -779, -779, -779,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -780, -780, -780, -780, -780, -780, -780, -780, -780,
     -780, -780, -780, -780, -780, -780, -780, -780, -780, -780,
     -780, -780, -780, -780, -780, -780, -780, -780, -780, -780,
     -780, -780, -780, -780, -780, -780, -780, -780, -780, -780,
     -780, -780, -780, -780, -780, -780, -780, -780,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -780, -780,
     -780, -780, -780, -780, -780,  227,  227,  826,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -780, -780, -780, -780,  227, -780,  227,  227,  826,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -780, -780, -780, -780,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -781, -781, -781, -781, -781, -781, -781, -781, -781,
     -781, -781, -781, -781, -781, -781, -781, -781, -781, -781,
     -781, -781, -781, -781, -781, -781, -781, -781, -781, -781,
     -781, -781, -781, -781, -781, -781, -781, -781, -781, -781,

     -781, -781, -781, -781, -781, -781, -781, -781,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -781, -781,
     -781, -781, -781, -781, -781,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -781, -781, -781, -781,  827, -781,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -781, -781, -781, -781,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -782, -782, -782, -782, -782, -782, -782, -782, -782,
     -782, -782, -782, -782, -782, -782, -782, -782, -782, -782,
     -782, -782, -782, -782, -782, -782, -782, -782, -782, -782,
     -782, -782, -782, -782, -782, -782, -782, -782, -782, -782,
     -782, -782, -782, -782, -782, -782, -782, -782,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -782, -782,
     -782, -782, -782, -782, -782,  227,  227,  227,  828,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -782, -782, -782, -782,  227, -782,  227,  227,  227,
      828,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -782, -782, -782, -782,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -783, -783, -783, -783, -783, -783, -783, -783, -783,
     -783, -783, -783, -783, -783, -783, -783, -783, -783, -783,

     -783, -783, -783, -783, -783, -783, -783, -783, -783, -783,
     -783, -783, -783, -783, -783, -783, -783, -783, -783, -783,
     -783, -783, -783, -783, -783, -783, -783, -783,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -783, -783,
     -783, -783, -783, -783, -783,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      829,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -783, -783, -783, -783,  227, -783,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  829,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -783, -783, -783, -783,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -784, -784, -784, -784, -784, -784, -784, -784, -784,
     -784, -784, -784, -784, -784, -784, -784, -784, -784, -784,
     -784, -784, -784, -784, -784, -784, -784, -784, -784, -784,
     -784, -784, -784, -784, -784, -784, -784, -784, -784, -784,
     -784, -784, -784, -784, -784, -784, -784, -784,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -784, -784,

     -784, -784, -784, -784, -784,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -784, -784, -784, -784,  830, -784,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -784, -784, -784, -784,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831, -785,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      832,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,

      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,

      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831
    },

    {
       45,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785, -786,  785,  785,

      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
     -786,  785,  785, -786,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785, -786,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785, -786,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,

      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,

      785,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      785,  785,  785,  785,  785,  785
    },

    {
       45, -787, -787, -787, -787, -787, -787, -787, -787,  787,
      787, -787, -787,  787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787,  787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787,  833, -787, -787, -787,

     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787, -787, -787,  833, -787,
     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,

     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787, -787, -787, -787, -787,
     -787, -787, -787, -787, -787, -787
    },

    {
       45,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,

      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      835,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,

      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,

      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834
    },

    {
       45,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788, -789,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,

     -789,  788,  788, -789,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788, -789,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788, -789,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,

      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788,  788,  788,  788,  788,
      788,  788,  788,  788,  788,  788

    },

    {
       45, -790, -790, -790, -790, -790, -790, -790, -790,  790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790,  790, -790, -790, -790, -790, -790, -790, -790,
     -790,  791, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,

     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,

     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790, -790, -790, -790, -790,
     -790, -790, -790, -790, -790, -790
    },

    {
       45, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,

     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,

     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,

     -791, -791, -791, -791, -791, -791, -791, -791, -791, -791,
     -791, -791, -791, -791, -791, -791
    },

    {
       45, -792, -792, -792, -792, -792, -792, -792, -792,  664,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792,  664, -792, -792, -792, -792, -792, -792, -792,
     -792,  665, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,

     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,

     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792, -792, -792, -792, -792,
     -792, -792, -792, -792, -792, -792
    },

    {
       45, -793, -793, -793, -793, -793, -793, -793, -793,  576,
     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,

     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793,  576, -793, -793, -793, -793, -793, -793, -793,
     -793,  577, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,

     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,

     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793, -793, -793, -793, -793, -793, -793, -793, -793,
     -793, -793, -793, -793, -793, -793
    },

    {
       45, -794, -794, -794, -794, -794, -794, -794, -794,  794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794,  794, -794, -794, -794, -794, -794, -794, -794,
     -794,  795, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,

     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,

     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794, -794, -794, -794, -794,
     -794, -794, -794, -794, -794, -794

    },

    {
       45, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,

     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,

     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795, -795, -795, -795, -795,
     -795, -795, -795, -795, -795, -795
    },

    {
       45, -796, -796, -796, -796, -796, -796, -796, -796,  836,
      836, -796, -796,  836, -796, -796, -796, -796, -796, -796,
     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,
     -796, -796,  836, -796, -796, -796, -796, -796, -796, -796,

     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,
     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,
     -796, -796,  837, -796, -796, -796, -796, -796, -796, -796,
     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,
     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,
     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,
     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,
     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,
     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,
     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,

     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,
     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,
     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,
     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,
     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,
     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,
     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,
     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,
     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,
     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,

     -796, -796, -796, -796, -796, -796, -796, -796, -796, -796,
     -796, -796, -796, -796, -796, -796
    },

    {
       45, -797, -797, -797, -797, -797, -797, -797, -797, -797,
     -797, -797, -797, -797, -797, -797, -797, -797, -797, -797,
     -797, -797, -797, -797, -797, -797, -797, -797, -797, -797,
     -797, -797, -797, -797, -797, -797, -797, -797, -797, -797,
     -797, -797, -797, -797, -797, -797, -797, -797,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -797, -797,
     -797, -797, -797, -797, -797,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -797, -797, -797, -797,  227, -797,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -797, -797, -797, -797,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -798, -798, -798, -798, -798, -798, -798, -798,  680,
      680, -798, -798,  680, -798, -798, -798, -798, -798, -798,

     -798, -798, -798, -798, -798, -798, -798, -798, -798, -798,
     -798, -798,  680, -798, -798,  681, -798, -798, -798, -798,
     -798, -798, -798, -798, -798, -798, -798,  682,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744, -798, -798,
     -798, -798, -798, -798, -798,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744, -798, -798, -798, -798,  744, -798,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,

      744,  744,  744, -798, -798, -798, -798,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,

      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744,  744,  744,  744,  744,
      744,  744,  744,  744,  744,  744
    },

    {
       45,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  800,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,

      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,

      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799

    },

    {
       45,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  680,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,

      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,

      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799,  799,  799,  799,  799,
      799,  799,  799,  799,  799,  799
    },

    {
       45, -801, -801, -801, -801, -801, -801, -801, -801, -801,
     -801, -801, -801, -801, -801, -801, -801, -801, -801, -801,
     -801, -801, -801, -801, -801, -801, -801, -801, -801, -801,
     -801, -801, -801, -801, -801, -801, -801, -801, -801, -801,

     -801, -801, -801, -801, -801, -801, -801, -801,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -801, -801,
     -801, -801, -801, -801, -801,  227,  227,  227,  227,  838,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -801, -801, -801, -801,  227, -801,  227,  227,  227,
      227,  838,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -801, -801, -801, -801,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -802, -802, -802, -802, -802, -802, -802, -802, -802,
     -802, -802, -802, -802, -802, -802, -802, -802, -802, -802,
     -802, -802, -802, -802, -802, -802, -802, -802, -802, -802,
     -802, -802, -802, -802, -802, -802, -802, -802, -802, -802,
     -802, -802, -802, -802, -802, -802, -802, -802,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -802, -802,
     -802, -802, -802, -802, -802,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -802, -802, -802, -802,  227, -802,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -802, -802, -802, -802,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -803, -803, -803, -803, -803, -803, -803, -803, -803,
     -803, -803, -803, -803, -803, -803, -803, -803, -803, -803,

     -803, -803, -803, -803, -803, -803, -803, -803, -803, -803,
     -803, -803, -803, -803, -803, -803, -803, -803, -803, -803,
     -803, -803, -803, -803, -803, -803, -803, -803,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -803, -803,
     -803, -803, -803, -803, -803,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -803, -803, -803, -803,  227, -803,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -803, -803, -803, -803,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -804, -804, -804, -804, -804, -804, -804, -804, -804,
     -804, -804, -804, -804, -804, -804, -804, -804, -804, -804,
     -804, -804, -804, -804, -804, -804, -804, -804, -804, -804,
     -804, -804, -804, -804, -804, -804, -804, -804, -804, -804,
     -804, -804, -804, -804, -804, -804, -804, -804,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -804, -804,

     -804, -804, -804, -804, -804,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -804, -804, -804, -804,  227, -804,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -804, -804, -804, -804,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -805, -805, -805, -805, -805, -805, -805, -805, -805,
     -805, -805, -805, -805, -805, -805, -805, -805, -805, -805,
     -805, -805, -805, -805, -805, -805, -805, -805, -805, -805,
     -805, -805, -805, -805, -805, -805, -805, -805, -805, -805,
     -805, -805, -805, -805, -805, -805, -805, -805,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -805, -805,
     -805, -805, -805, -805, -805,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  839,  227,  227,  227,  227,  227,  227,  227,
      227, -805, -805, -805, -805,  227, -805,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  839,  227,  227,  227,  227,  227,
      227,  227,  227, -805, -805, -805, -805,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -806, -806, -806, -806, -806, -806, -806, -806, -806,
     -806, -806, -806, -806, -806, -806, -806, -806, -806, -806,
     -806, -806, -806, -806, -806, -806, -806, -806, -806, -806,
     -806, -806, -806, -806, -806, -806, -806, -806, -806, -806,

     -806, -806, -806, -806, -806, -806, -806, -806,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -806, -806,
     -806, -806, -806, -806, -806,  227,  227,  840,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -806, -806, -806, -806,  227, -806,  227,  227,  840,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -806, -806, -806, -806,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -807, -807, -807, -807, -807, -807, -807, -807, -807,
     -807, -807, -807, -807, -807, -807, -807, -807, -807, -807,
     -807, -807, -807, -807, -807, -807, -807, -807, -807, -807,
     -807, -807, -807, -807, -807, -807, -807, -807, -807, -807,
     -807, -807, -807, -807, -807, -807, -807, -807,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -807, -807,
     -807, -807, -807, -807, -807,  227,  227,  227,  227,  227,
      227,  227,  841,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -807, -807, -807, -807,  227, -807,  227,  227,  227,
      227,  227,  227,  227,  841,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -807, -807, -807, -807,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -808, -808, -808, -808, -808, -808, -808, -808, -808,
     -808, -808, -808, -808, -808, -808, -808, -808, -808, -808,

     -808, -808, -808, -808, -808, -808, -808, -808, -808, -808,
     -808, -808, -808, -808, -808, -808, -808, -808, -808, -808,
     -808, -808, -808, -808, -808, -808, -808, -808,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -808, -808,
     -808, -808, -808, -808, -808,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -808, -808, -808, -808,  227, -808,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -808, -808, -808, -808,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -809, -809, -809, -809, -809, -809, -809, -809, -809,
     -809, -809, -809, -809, -809, -809, -809, -809, -809, -809,
     -809, -809, -809, -809, -809, -809, -809, -809, -809, -809,
     -809, -809, -809, -809, -809, -809, -809, -809, -809, -809,
     -809, -809, -809, -809, -809, -809, -809, -809,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -809, -809,

     -809, -809, -809, -809, -809,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -809, -809, -809, -809,  227, -809,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -809, -809, -809, -809,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -810, -810, -810, -810, -810, -810, -810, -810, -810,
     -810, -810, -810, -810, -810, -810, -810, -810, -810, -810,
     -810, -810, -810, -810, -810, -810, -810, -810, -810, -810,
     -810, -810, -810, -810, -810, -810, -810, -810, -810, -810,
     -810, -810, -810, -810, -810, -810, -810, -810,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -810, -810,
     -810, -810, -810, -810, -810,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  842,  227,  227,  227,  227,  227,
      227, -810, -810, -810, -810,  227, -810,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  842,  227,  227,  227,
      227,  227,  227, -810, -810, -810, -810,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -811, -811, -811, -811, -811, -811, -811, -811, -811,
     -811, -811, -811, -811, -811, -811, -811, -811, -811, -811,
     -811, -811, -811, -811, -811, -811, -811, -811, -811, -811,
     -811, -811, -811, -811, -811, -811, -811, -811, -811, -811,

     -811, -811, -811, -811, -811, -811, -811, -811,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -811, -811,
     -811, -811, -811, -811, -811,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  843,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -811, -811, -811, -811,  227, -811,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  843,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -811, -811, -811, -811,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -812, -812, -812, -812, -812, -812, -812, -812, -812,
     -812, -812, -812, -812, -812, -812, -812, -812, -812, -812,
     -812, -812, -812, -812, -812, -812, -812, -812, -812, -812,
     -812, -812, -812, -812, -812, -812, -812, -812, -812, -812,
     -812, -812, -812, -812, -812, -812, -812, -812,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -812, -812,
     -812, -812, -812, -812, -812,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  844,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -812, -812, -812, -812,  227, -812,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  844,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -812, -812, -812, -812,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -813, -813, -813, -813, -813, -813, -813, -813, -813,
     -813, -813, -813, -813, -813, -813, -813, -813, -813, -813,

     -813, -813, -813, -813, -813, -813, -813, -813, -813, -813,
     -813, -813, -813, -813, -813, -813, -813, -813, -813, -813,
     -813, -813, -813, -813, -813, -813, -813, -813,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -813, -813,
     -813, -813, -813, -813, -813,  227,  227,  227,  227,  227,
      845,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -813, -813, -813, -813,  227, -813,  227,  227,  227,
      227,  227,  845,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -813, -813, -813, -813,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -814, -814, -814, -814, -814, -814, -814, -814, -814,
     -814, -814, -814, -814, -814, -814, -814, -814, -814, -814,
     -814, -814, -814, -814, -814, -814, -814, -814, -814, -814,
     -814, -814, -814, -814, -814, -814, -814, -814, -814, -814,
     -814, -814, -814, -814, -814, -814, -814, -814,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -814, -814,

     -814, -814, -814, -814, -814,  227,  227,  227,  227,  846,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -814, -814, -814, -814,  227, -814,  227,  227,  227,
      227,  846,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -814, -814, -814, -814,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -815, -815, -815, -815, -815, -815, -815, -815, -815,
     -815, -815, -815, -815, -815, -815, -815, -815, -815, -815,
     -815, -815, -815, -815, -815, -815, -815, -815, -815, -815,
     -815, -815, -815, -815, -815, -815, -815, -815, -815, -815,
     -815, -815, -815, -815, -815, -815, -815, -815,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -815, -815,
     -815, -815, -815, -815, -815,  227,  227,  227,  227,  847,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -815, -815, -815, -815,  227, -815,  227,  227,  227,

      227,  847,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -815, -815, -815, -815,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -816, -816, -816, -816, -816, -816, -816, -816, -816,
     -816, -816, -816, -816, -816, -816, -816, -816, -816, -816,
     -816, -816, -816, -816, -816, -816, -816, -816, -816, -816,
     -816, -816, -816, -816, -816, -816, -816, -816, -816, -816,

     -816, -816, -816, -816, -816, -816, -816, -816,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -816, -816,
     -816, -816, -816, -816, -816,  227,  227,  227,  848,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -816, -816, -816, -816,  227, -816,  227,  227,  227,
      848,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -816, -816, -816, -816,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -817, -817, -817, -817, -817, -817, -817, -817, -817,
     -817, -817, -817, -817, -817, -817, -817, -817, -817, -817,
     -817, -817, -817, -817, -817, -817, -817, -817, -817, -817,
     -817, -817, -817, -817, -817, -817, -817, -817, -817, -817,
     -817, -817, -817, -817, -817, -817, -817, -817,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -817, -817,
     -817, -817, -817, -817, -817,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -817, -817, -817, -817,  227, -817,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -817, -817, -817, -817,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -818, -818, -818, -818, -818, -818, -818, -818, -818,
     -818, -818, -818, -818, -818, -818, -818, -818, -818, -818,

     -818, -818, -818, -818, -818, -818, -818, -818, -818, -818,
     -818, -818, -818, -818, -818, -818, -818, -818, -818, -818,
     -818, -818, -818, -818, -818, -818, -818, -818,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -818, -818,
     -818, -818, -818, -818, -818,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  849,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -818, -818, -818, -818,  227, -818,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  849,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -818, -818, -818, -818,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -819, -819, -819, -819, -819, -819, -819, -819,  713,
      713, -819, -819,  713, -819, -819, -819, -819, -819, -819,
     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,
     -819, -819,  713, -819, -819,  714, -819, -819, -819, -819,
      715, -819, -819, -819, -819, -819, -819,  716, -819, -819,
     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,

     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,
     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,
     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,
     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,
     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,
     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,
     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,
     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,
     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,
     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,

     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,
     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,
     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,
     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,
     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,
     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,
     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,
     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,
     -819, -819, -819, -819, -819, -819, -819, -819, -819, -819,
     -819, -819, -819, -819, -819, -819

    },

    {
       45,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  821,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,

      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,

      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820
    },

    {
       45,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,

      820,  820,  820,  820,  820,  820,  820,  713,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,

      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,

      820,  820,  820,  820,  820,  820,  820,  820,  820,  820,
      820,  820,  820,  820,  820,  820
    },

    {
       45, -822, -822, -822, -822, -822, -822, -822, -822, -822,
     -822, -822, -822, -822, -822, -822, -822, -822, -822, -822,
     -822, -822, -822, -822, -822, -822, -822, -822, -822, -822,
     -822, -822, -822, -822, -822, -822, -822, -822, -822, -822,
     -822, -822, -822, -822, -822, -822, -822, -822,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -822, -822,
     -822, -822, -822, -822, -822,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -822, -822, -822, -822,  850, -822,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -822, -822, -822, -822,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -823, -823, -823, -823, -823, -823, -823, -823, -823,
     -823, -823, -823, -823, -823, -823, -823, -823, -823, -823,

     -823, -823, -823, -823, -823, -823, -823, -823, -823, -823,
     -823, -823, -823, -823, -823, -823, -823, -823, -823, -823,
     -823, -823, -823, -823, -823, -823, -823, -823,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -823, -823,
     -823, -823, -823, -823, -823,  227,  227,  227,  227,  851,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -823, -823, -823, -823,  227, -823,  227,  227,  227,
      227,  851,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -823, -823, -823, -823,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -824, -824, -824, -824, -824, -824, -824, -824, -824,
     -824, -824, -824, -824, -824, -824, -824, -824, -824, -824,
     -824, -824, -824, -824, -824, -824, -824, -824, -824, -824,
     -824, -824, -824, -824, -824, -824, -824, -824, -824, -824,
     -824, -824, -824, -824, -824, -824, -824, -824,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -824, -824,

     -824, -824, -824, -824, -824,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -824, -824, -824, -824,  227, -824,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -824, -824, -824, -824,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -825, -825, -825, -825, -825, -825, -825, -825, -825,
     -825, -825, -825, -825, -825, -825, -825, -825, -825, -825,
     -825, -825, -825, -825, -825, -825, -825, -825, -825, -825,
     -825, -825, -825, -825, -825, -825, -825, -825, -825, -825,
     -825, -825, -825, -825, -825, -825, -825, -825,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -825, -825,
     -825, -825, -825, -825, -825,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  852,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -825, -825, -825, -825,  227, -825,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  852,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -825, -825, -825, -825,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -826, -826, -826, -826, -826, -826, -826, -826, -826,
     -826, -826, -826, -826, -826, -826, -826, -826, -826, -826,
     -826, -826, -826, -826, -826, -826, -826, -826, -826, -826,
     -826, -826, -826, -826, -826, -826, -826, -826, -826, -826,

     -826, -826, -826, -826, -826, -826, -826, -826,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -826, -826,
     -826, -826, -826, -826, -826,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  853,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -826, -826, -826, -826,  227, -826,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  853,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -826, -826, -826, -826,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -827, -827, -827, -827, -827, -827, -827, -827, -827,
     -827, -827, -827, -827, -827, -827, -827, -827, -827, -827,
     -827, -827, -827, -827, -827, -827, -827, -827, -827, -827,
     -827, -827, -827, -827, -827, -827, -827, -827, -827, -827,
     -827, -827, -827, -827, -827, -827, -827, -827,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -827, -827,
     -827, -827, -827, -827, -827,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -827, -827, -827, -827,  227, -827,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -827, -827, -827, -827,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -828, -828, -828, -828, -828, -828, -828, -828, -828,
     -828, -828, -828, -828, -828, -828, -828, -828, -828, -828,

     -828, -828, -828, -828, -828, -828, -828, -828, -828, -828,
     -828, -828, -828, -828, -828, -828, -828, -828, -828, -828,
     -828, -828, -828, -828, -828, -828, -828, -828,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -828, -828,
     -828, -828, -828, -828, -828,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -828, -828, -828, -828,  854, -828,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -828, -828, -828, -828,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -829, -829, -829, -829, -829, -829, -829, -829, -829,
     -829, -829, -829, -829, -829, -829, -829, -829, -829, -829,
     -829, -829, -829, -829, -829, -829, -829, -829, -829, -829,
     -829, -829, -829, -829, -829, -829, -829, -829, -829, -829,
     -829, -829, -829, -829, -829, -829, -829, -829,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -829, -829,

     -829, -829, -829, -829, -829,  855,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -829, -829, -829, -829,  227, -829,  855,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -829, -829, -829, -829,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -830, -830, -830, -830, -830, -830, -830, -830, -830,
     -830, -830, -830, -830, -830, -830, -830, -830, -830, -830,
     -830, -830, -830, -830, -830, -830, -830, -830, -830, -830,
     -830, -830, -830, -830, -830, -830, -830, -830, -830, -830,
     -830, -830, -830, -830, -830, -830, -830, -830,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -830, -830,
     -830, -830, -830, -830, -830,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -830, -830, -830, -830,  856, -830,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -830, -830, -830, -830,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857, -831,  857,  857,  857,  857,

      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      858,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,

      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,

      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857
    },

    {
       45,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831, -832,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
     -832,  831,  831, -832,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,

      831,  831,  831, -832,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831, -832,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,

      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831,  831,  831,  831,  831,
      831,  831,  831,  831,  831,  831
    },

    {
       45, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,

     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833,  859, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833, -833,  859, -833, -833,
     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,

     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,

     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833, -833, -833, -833, -833,
     -833, -833, -833, -833, -833, -833
    },

    {
       45,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,

      861,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,

      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860

    },

    {
       45,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834, -835,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
     -835,  834,  834, -835,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834, -835,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,

      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834, -835,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,

      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834,  834,  834,  834,  834,
      834,  834,  834,  834,  834,  834
    },

    {
       45, -836, -836, -836, -836, -836, -836, -836, -836,  836,
      836, -836, -836,  836, -836, -836, -836, -836, -836, -836,
     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,
     -836, -836,  836, -836, -836, -836, -836, -836, -836, -836,

     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,
     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,
     -836, -836,  837, -836, -836, -836, -836, -836, -836, -836,
     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,
     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,
     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,
     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,
     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,
     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,
     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,

     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,
     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,
     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,
     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,
     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,
     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,
     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,
     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,
     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,
     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,

     -836, -836, -836, -836, -836, -836, -836, -836, -836, -836,
     -836, -836, -836, -836, -836, -836
    },

    {
       45, -837, -837, -837, -837, -837, -837, -837, -837, -837,
      862, -837, -837,  863, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,

     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,

     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837, -837, -837, -837, -837,
     -837, -837, -837, -837, -837, -837
    },

    {
       45, -838, -838, -838, -838, -838, -838, -838, -838, -838,
     -838, -838, -838, -838, -838, -838, -838, -838, -838, -838,

     -838, -838, -838, -838, -838, -838, -838, -838, -838, -838,
     -838, -838, -838, -838, -838, -838, -838, -838, -838, -838,
     -838, -838, -838, -838, -838, -838, -838, -838,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -838, -838,
     -838, -838, -838, -838, -838,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -838, -838, -838, -838,  227, -838,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -838, -838, -838, -838,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -839, -839, -839, -839, -839, -839, -839, -839, -839,
     -839, -839, -839, -839, -839, -839, -839, -839, -839, -839,
     -839, -839, -839, -839, -839, -839, -839, -839, -839, -839,
     -839, -839, -839, -839, -839, -839, -839, -839, -839, -839,
     -839, -839, -839, -839, -839, -839, -839, -839,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -839, -839,

     -839, -839, -839, -839, -839,  227,  227,  227,  227,  864,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -839, -839, -839, -839,  227, -839,  227,  227,  227,
      227,  864,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -839, -839, -839, -839,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -840, -840, -840, -840, -840, -840, -840, -840, -840,
     -840, -840, -840, -840, -840, -840, -840, -840, -840, -840,
     -840, -840, -840, -840, -840, -840, -840, -840, -840, -840,
     -840, -840, -840, -840, -840, -840, -840, -840, -840, -840,
     -840, -840, -840, -840, -840, -840, -840, -840,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -840, -840,
     -840, -840, -840, -840, -840,  227,  227,  227,  227,  227,
      227,  227,  865,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -840, -840, -840, -840,  227, -840,  227,  227,  227,

      227,  227,  227,  227,  865,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -840, -840, -840, -840,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -841, -841, -841, -841, -841, -841, -841, -841, -841,
     -841, -841, -841, -841, -841, -841, -841, -841, -841, -841,
     -841, -841, -841, -841, -841, -841, -841, -841, -841, -841,
     -841, -841, -841, -841, -841, -841, -841, -841, -841, -841,

     -841, -841, -841, -841, -841, -841, -841, -841,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -841, -841,
     -841, -841, -841, -841, -841,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -841, -841, -841, -841,  227, -841,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -841, -841, -841, -841,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -842, -842, -842, -842, -842, -842, -842, -842, -842,
     -842, -842, -842, -842, -842, -842, -842, -842, -842, -842,
     -842, -842, -842, -842, -842, -842, -842, -842, -842, -842,
     -842, -842, -842, -842, -842, -842, -842, -842, -842, -842,
     -842, -842, -842, -842, -842, -842, -842, -842,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -842, -842,
     -842, -842, -842, -842, -842,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  866,  227,  227,  227,  227,  227,  227,
      227, -842, -842, -842, -842,  227, -842,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  866,  227,  227,  227,  227,
      227,  227,  227, -842, -842, -842, -842,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -843, -843, -843, -843, -843, -843, -843, -843, -843,
     -843, -843, -843, -843, -843, -843, -843, -843, -843, -843,

     -843, -843, -843, -843, -843, -843, -843, -843, -843, -843,
     -843, -843, -843, -843, -843, -843, -843, -843, -843, -843,
     -843, -843, -843, -843, -843, -843, -843, -843,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -843, -843,
     -843, -843, -843, -843, -843,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  867,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -843, -843, -843, -843,  227, -843,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      867,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -843, -843, -843, -843,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -844, -844, -844, -844, -844, -844, -844, -844, -844,
     -844, -844, -844, -844, -844, -844, -844, -844, -844, -844,
     -844, -844, -844, -844, -844, -844, -844, -844, -844, -844,
     -844, -844, -844, -844, -844, -844, -844, -844, -844, -844,
     -844, -844, -844, -844, -844, -844, -844, -844,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -844, -844,

     -844, -844, -844, -844, -844,  227,  227,  227,  227,  227,
      868,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -844, -844, -844, -844,  227, -844,  227,  227,  227,
      227,  227,  868,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -844, -844, -844, -844,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -845, -845, -845, -845, -845, -845, -845, -845, -845,
     -845, -845, -845, -845, -845, -845, -845, -845, -845, -845,
     -845, -845, -845, -845, -845, -845, -845, -845, -845, -845,
     -845, -845, -845, -845, -845, -845, -845, -845, -845, -845,
     -845, -845, -845, -845, -845, -845, -845, -845,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -845, -845,
     -845, -845, -845, -845, -845,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -845, -845, -845, -845,  227, -845,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -845, -845, -845, -845,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -846, -846, -846, -846, -846, -846, -846, -846, -846,
     -846, -846, -846, -846, -846, -846, -846, -846, -846, -846,
     -846, -846, -846, -846, -846, -846, -846, -846, -846, -846,
     -846, -846, -846, -846, -846, -846, -846, -846, -846, -846,

     -846, -846, -846, -846, -846, -846, -846, -846,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -846, -846,
     -846, -846, -846, -846, -846,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -846, -846, -846, -846,  227, -846,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -846, -846, -846, -846,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -847, -847, -847, -847, -847, -847, -847, -847, -847,
     -847, -847, -847, -847, -847, -847, -847, -847, -847, -847,
     -847, -847, -847, -847, -847, -847, -847, -847, -847, -847,
     -847, -847, -847, -847, -847, -847, -847, -847, -847, -847,
     -847, -847, -847, -847, -847, -847, -847, -847,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -847, -847,
     -847, -847, -847, -847, -847,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -847, -847, -847, -847,  227, -847,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -847, -847, -847, -847,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -848, -848, -848, -848, -848, -848, -848, -848, -848,
     -848, -848, -848, -848, -848, -848, -848, -848, -848, -848,

     -848, -848, -848, -848, -848, -848, -848, -848, -848, -848,
     -848, -848, -848, -848, -848, -848, -848, -848, -848, -848,
     -848, -848, -848, -848, -848, -848, -848, -848,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -848, -848,
     -848, -848, -848, -848, -848,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -848, -848, -848, -848,  227, -848,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -848, -848, -848, -848,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -849, -849, -849, -849, -849, -849, -849, -849, -849,
     -849, -849, -849, -849, -849, -849, -849, -849, -849, -849,
     -849, -849, -849, -849, -849, -849, -849, -849, -849, -849,
     -849, -849, -849, -849, -849, -849, -849, -849, -849, -849,
     -849, -849, -849, -849, -849, -849, -849, -849,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -849, -849,

     -849, -849, -849, -849, -849,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  869,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -849, -849, -849, -849,  227, -849,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      869,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -849, -849, -849, -849,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -850, -850, -850, -850, -850, -850, -850, -850, -850,
     -850, -850, -850, -850, -850, -850, -850, -850, -850, -850,
     -850, -850, -850, -850, -850, -850, -850, -850, -850, -850,
     -850, -850, -850, -850, -850, -850, -850, -850, -850, -850,
     -850, -850, -850, -850, -850, -850, -850, -850,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -850, -850,
     -850, -850, -850, -850, -850,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -850, -850, -850, -850,  227, -850,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -850, -850, -850, -850,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -851, -851, -851, -851, -851, -851, -851, -851, -851,
     -851, -851, -851, -851, -851, -851, -851, -851, -851, -851,
     -851, -851, -851, -851, -851, -851, -851, -851, -851, -851,
     -851, -851, -851, -851, -851, -851, -851, -851, -851, -851,

     -851, -851, -851, -851, -851, -851, -851, -851,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -851, -851,
     -851, -851, -851, -851, -851,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  870,  227,  227,  227,  227,  227,  227,  227,
      227, -851, -851, -851, -851,  227, -851,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  870,  227,  227,  227,  227,  227,
      227,  227,  227, -851, -851, -851, -851,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -852, -852, -852, -852, -852, -852, -852, -852, -852,
     -852, -852, -852, -852, -852, -852, -852, -852, -852, -852,
     -852, -852, -852, -852, -852, -852, -852, -852, -852, -852,
     -852, -852, -852, -852, -852, -852, -852, -852, -852, -852,
     -852, -852, -852, -852, -852, -852, -852, -852,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -852, -852,
     -852, -852, -852, -852, -852,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  871,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -852, -852, -852, -852,  227, -852,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      871,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -852, -852, -852, -852,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -853, -853, -853, -853, -853, -853, -853, -853, -853,
     -853, -853, -853, -853, -853, -853, -853, -853, -853, -853,

     -853, -853, -853, -853, -853, -853, -853, -853, -853, -853,
     -853, -853, -853, -853, -853, -853, -853, -853, -853, -853,
     -853, -853, -853, -853, -853, -853, -853, -853,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -853, -853,
     -853, -853, -853, -853, -853,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  872,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -853, -853, -853, -853,  227, -853,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  872,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -853, -853, -853, -853,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -854, -854, -854, -854, -854, -854, -854, -854, -854,
     -854, -854, -854, -854, -854, -854, -854, -854, -854, -854,
     -854, -854, -854, -854, -854, -854, -854, -854, -854, -854,
     -854, -854, -854, -854, -854, -854, -854, -854, -854, -854,
     -854, -854, -854, -854, -854, -854, -854, -854,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -854, -854,

     -854, -854, -854, -854, -854,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -854, -854, -854, -854,  873, -854,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -854, -854, -854, -854,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -855, -855, -855, -855, -855, -855, -855, -855, -855,
     -855, -855, -855, -855, -855, -855, -855, -855, -855, -855,
     -855, -855, -855, -855, -855, -855, -855, -855, -855, -855,
     -855, -855, -855, -855, -855, -855, -855, -855, -855, -855,
     -855, -855, -855, -855, -855, -855, -855, -855,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -855, -855,
     -855, -855, -855, -855, -855,  227,  227,  874,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -855, -855, -855, -855,  227, -855,  227,  227,  874,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -855, -855, -855, -855,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -856, -856, -856, -856, -856, -856, -856, -856, -856,
     -856, -856, -856, -856, -856, -856, -856, -856, -856, -856,
     -856, -856, -856, -856, -856, -856, -856, -856, -856, -856,
     -856, -856, -856, -856, -856, -856, -856, -856, -856, -856,

     -856, -856, -856, -856, -856, -856, -856, -856,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -856, -856,
     -856, -856, -856, -856, -856,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -856, -856, -856, -856,  227, -856,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -856, -856, -856, -856,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875, -857,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      876,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,

      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,

      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875
    },

    {
       45,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,

      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857, -858,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
     -858,  857,  857, -858,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857, -858,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857, -858,  857,  857,  857,  857,

      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,

      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857
    },

    {
       45, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,

     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859,  877, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
      877, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,

     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859, -859, -859, -859, -859,
     -859, -859, -859, -859, -859, -859

    },

    {
       45,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      879,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,

      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,

      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878
    },

    {
       45,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860, -861,  860,  860,

      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
     -861,  860,  860, -861,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860, -861,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860, -861,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,

      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,

      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860
    },

    {
       45, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,

     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,

     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862, -862, -862, -862, -862,
     -862, -862, -862, -862, -862, -862
    },

    {
       45, -863, -863, -863, -863, -863, -863, -863, -863, -863,
      862, -863, -863, -863, -863, -863, -863, -863, -863, -863,

     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,

     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,

     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863, -863, -863, -863, -863,
     -863, -863, -863, -863, -863, -863
    },

    {
       45, -864, -864, -864, -864, -864, -864, -864, -864, -864,
     -864, -864, -864, -864, -864, -864, -864, -864, -864, -864,
     -864, -864, -864, -864, -864, -864, -864, -864, -864, -864,
     -864, -864, -864, -864, -864, -864, -864, -864, -864, -864,
     -864, -864, -864, -864, -864, -864, -864, -864,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -864, -864,

     -864, -864, -864, -864, -864,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -864, -864, -864, -864,  227, -864,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -864, -864, -864, -864,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -865, -865, -865, -865, -865, -865, -865, -865, -865,
     -865, -865, -865, -865, -865, -865, -865, -865, -865, -865,
     -865, -865, -865, -865, -865, -865, -865, -865, -865, -865,
     -865, -865, -865, -865, -865, -865, -865, -865, -865, -865,
     -865, -865, -865, -865, -865, -865, -865, -865,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -865, -865,
     -865, -865, -865, -865, -865,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -865, -865, -865, -865,  227, -865,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -865, -865, -865, -865,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -866, -866, -866, -866, -866, -866, -866, -866, -866,
     -866, -866, -866, -866, -866, -866, -866, -866, -866, -866,
     -866, -866, -866, -866, -866, -866, -866, -866, -866, -866,
     -866, -866, -866, -866, -866, -866, -866, -866, -866, -866,

     -866, -866, -866, -866, -866, -866, -866, -866,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -866, -866,
     -866, -866, -866, -866, -866,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -866, -866, -866, -866,  227, -866,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -866, -866, -866, -866,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -867, -867, -867, -867, -867, -867, -867, -867, -867,
     -867, -867, -867, -867, -867, -867, -867, -867, -867, -867,
     -867, -867, -867, -867, -867, -867, -867, -867, -867, -867,
     -867, -867, -867, -867, -867, -867, -867, -867, -867, -867,
     -867, -867, -867, -867, -867, -867, -867, -867,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -867, -867,
     -867, -867, -867, -867, -867,  227,  227,  880,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -867, -867, -867, -867,  227, -867,  227,  227,  880,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -867, -867, -867, -867,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -868, -868, -868, -868, -868, -868, -868, -868, -868,
     -868, -868, -868, -868, -868, -868, -868, -868, -868, -868,

     -868, -868, -868, -868, -868, -868, -868, -868, -868, -868,
     -868, -868, -868, -868, -868, -868, -868, -868, -868, -868,
     -868, -868, -868, -868, -868, -868, -868, -868,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -868, -868,
     -868, -868, -868, -868, -868,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -868, -868, -868, -868,  227, -868,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -868, -868, -868, -868,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -869, -869, -869, -869, -869, -869, -869, -869, -869,
     -869, -869, -869, -869, -869, -869, -869, -869, -869, -869,
     -869, -869, -869, -869, -869, -869, -869, -869, -869, -869,
     -869, -869, -869, -869, -869, -869, -869, -869, -869, -869,
     -869, -869, -869, -869, -869, -869, -869, -869,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -869, -869,

     -869, -869, -869, -869, -869,  227,  227,  881,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -869, -869, -869, -869,  227, -869,  227,  227,  881,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -869, -869, -869, -869,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -870, -870, -870, -870, -870, -870, -870, -870, -870,
     -870, -870, -870, -870, -870, -870, -870, -870, -870, -870,
     -870, -870, -870, -870, -870, -870, -870, -870, -870, -870,
     -870, -870, -870, -870, -870, -870, -870, -870, -870, -870,
     -870, -870, -870, -870, -870, -870, -870, -870,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -870, -870,
     -870, -870, -870, -870, -870,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -870, -870, -870, -870,  882, -870,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -870, -870, -870, -870,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -871, -871, -871, -871, -871, -871, -871, -871, -871,
     -871, -871, -871, -871, -871, -871, -871, -871, -871, -871,
     -871, -871, -871, -871, -871, -871, -871, -871, -871, -871,
     -871, -871, -871, -871, -871, -871, -871, -871, -871, -871,

     -871, -871, -871, -871, -871, -871, -871, -871,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -871, -871,
     -871, -871, -871, -871, -871,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -871, -871, -871, -871,  883, -871,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -871, -871, -871, -871,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -872, -872, -872, -872, -872, -872, -872, -872, -872,
     -872, -872, -872, -872, -872, -872, -872, -872, -872, -872,
     -872, -872, -872, -872, -872, -872, -872, -872, -872, -872,
     -872, -872, -872, -872, -872, -872, -872, -872, -872, -872,
     -872, -872, -872, -872, -872, -872, -872, -872,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -872, -872,
     -872, -872, -872, -872, -872,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      884,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -872, -872, -872, -872,  227, -872,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  884,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -872, -872, -872, -872,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -873, -873, -873, -873, -873, -873, -873, -873, -873,
     -873, -873, -873, -873, -873, -873, -873, -873, -873, -873,

     -873, -873, -873, -873, -873, -873, -873, -873, -873, -873,
     -873, -873, -873, -873, -873, -873, -873, -873, -873, -873,
     -873, -873, -873, -873, -873, -873, -873, -873,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -873, -873,
     -873, -873, -873, -873, -873,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -873, -873, -873, -873,  227, -873,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -873, -873, -873, -873,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -874, -874, -874, -874, -874, -874, -874, -874, -874,
     -874, -874, -874, -874, -874, -874, -874, -874, -874, -874,
     -874, -874, -874, -874, -874, -874, -874, -874, -874, -874,
     -874, -874, -874, -874, -874, -874, -874, -874, -874, -874,
     -874, -874, -874, -874, -874, -874, -874, -874,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -874, -874,

     -874, -874, -874, -874, -874,  227,  227,  227,  227,  885,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -874, -874, -874, -874,  227, -874,  227,  227,  227,
      227,  885,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -874, -874, -874, -874,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886, -875,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      887,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,

      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,

      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886
    },

    {
       45,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875, -876,  875,  875,

      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
     -876,  875,  875, -876,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875, -876,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875, -876,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,

      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,

      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875
    },

    {
       45, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877,  888, -877, -877, -877, -877, -877, -877, -877, -877,

     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877,  888, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,

     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877, -877, -877, -877, -877,
     -877, -877, -877, -877, -877, -877
    },

    {
       45,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,

      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      890,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,

      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,

      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889
    },

    {
       45,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878, -879,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,

     -879,  878,  878, -879,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878, -879,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878, -879,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,

      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  878,  878

    },

    {
       45, -880, -880, -880, -880, -880, -880, -880, -880, -880,
     -880, -880, -880, -880, -880, -880, -880, -880, -880, -880,
     -880, -880, -880, -880, -880, -880, -880, -880, -880, -880,
     -880, -880, -880, -880, -880, -880, -880, -880, -880, -880,
     -880, -880, -880, -880, -880, -880, -880, -880,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -880, -880,
     -880, -880, -880, -880, -880,  227,  227,  227,  227,  891,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -880, -880, -880, -880,  227, -880,  227,  227,  227,

      227,  891,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -880, -880, -880, -880,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -881, -881, -881, -881, -881, -881, -881, -881, -881,
     -881, -881, -881, -881, -881, -881, -881, -881, -881, -881,
     -881, -881, -881, -881, -881, -881, -881, -881, -881, -881,
     -881, -881, -881, -881, -881, -881, -881, -881, -881, -881,

     -881, -881, -881, -881, -881, -881, -881, -881,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -881, -881,
     -881, -881, -881, -881, -881,  227,  227,  227,  227,  892,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -881, -881, -881, -881,  227, -881,  227,  227,  227,
      227,  892,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -881, -881, -881, -881,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -882, -882, -882, -882, -882, -882, -882, -882, -882,
     -882, -882, -882, -882, -882, -882, -882, -882, -882, -882,
     -882, -882, -882, -882, -882, -882, -882, -882, -882, -882,
     -882, -882, -882, -882, -882, -882, -882, -882, -882, -882,
     -882, -882, -882, -882, -882, -882, -882, -882,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -882, -882,
     -882, -882, -882, -882, -882,  227,  227,  227,  227,  227,
      227,  227,  893,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -882, -882, -882, -882,  227, -882,  227,  227,  227,
      227,  227,  227,  227,  893,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -882, -882, -882, -882,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -883, -883, -883, -883, -883, -883, -883, -883, -883,
     -883, -883, -883, -883, -883, -883, -883, -883, -883, -883,

     -883, -883, -883, -883, -883, -883, -883, -883, -883, -883,
     -883, -883, -883, -883, -883, -883, -883, -883, -883, -883,
     -883, -883, -883, -883, -883, -883, -883, -883,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -883, -883,
     -883, -883, -883, -883, -883,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -883, -883, -883, -883,  894, -883,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -883, -883, -883, -883,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -884, -884, -884, -884, -884, -884, -884, -884, -884,
     -884, -884, -884, -884, -884, -884, -884, -884, -884, -884,
     -884, -884, -884, -884, -884, -884, -884, -884, -884, -884,
     -884, -884, -884, -884, -884, -884, -884, -884, -884, -884,
     -884, -884, -884, -884, -884, -884, -884, -884,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -884, -884,

     -884, -884, -884, -884, -884,  227,  227,  227,  227,  227,
      227,  227,  227,  895,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -884, -884, -884, -884,  227, -884,  227,  227,  227,
      227,  227,  227,  227,  227,  895,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -884, -884, -884, -884,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -885, -885, -885, -885, -885, -885, -885, -885, -885,
     -885, -885, -885, -885, -885, -885, -885, -885, -885, -885,
     -885, -885, -885, -885, -885, -885, -885, -885, -885, -885,
     -885, -885, -885, -885, -885, -885, -885, -885, -885, -885,
     -885, -885, -885, -885, -885, -885, -885, -885,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -885, -885,
     -885, -885, -885, -885, -885,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -885, -885, -885, -885,  896, -885,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -885, -885, -885, -885,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897, -886,  897,  897,  897,  897,

      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      898,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,

      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,

      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897
    },

    {
       45,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886, -887,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
     -887,  886,  886, -887,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,

      886,  886,  886, -887,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886, -887,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,

      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886,  886,  886,  886,  886,
      886,  886,  886,  886,  886,  886
    },

    {
       45, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,

     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888,  899, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888,  899, -888, -888,

     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,

     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888, -888, -888, -888, -888,
     -888, -888, -888, -888, -888, -888
    },

    {
       45,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,

      901,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,

      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900

    },

    {
       45,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889, -890,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
     -890,  889,  889, -890,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889, -890,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,

      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889, -890,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,

      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889,  889,  889,  889,  889,
      889,  889,  889,  889,  889,  889
    },

    {
       45, -891, -891, -891, -891, -891, -891, -891, -891, -891,
     -891, -891, -891, -891, -891, -891, -891, -891, -891, -891,
     -891, -891, -891, -891, -891, -891, -891, -891, -891, -891,
     -891, -891, -891, -891, -891, -891, -891, -891, -891, -891,

     -891, -891, -891, -891, -891, -891, -891, -891,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -891, -891,
     -891, -891, -891, -891, -891,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -891, -891, -891, -891,  227, -891,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -891, -891, -891, -891,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -892, -892, -892, -892, -892, -892, -892, -892, -892,
     -892, -892, -892, -892, -892, -892, -892, -892, -892, -892,
     -892, -892, -892, -892, -892, -892, -892, -892, -892, -892,
     -892, -892, -892, -892, -892, -892, -892, -892, -892, -892,
     -892, -892, -892, -892, -892, -892, -892, -892,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -892, -892,
     -892, -892, -892, -892, -892,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -892, -892, -892, -892,  227, -892,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -892, -892, -892, -892,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -893, -893, -893, -893, -893, -893, -893, -893, -893,
     -893, -893, -893, -893, -893, -893, -893, -893, -893, -893,

     -893, -893, -893, -893, -893, -893, -893, -893, -893, -893,
     -893, -893, -893, -893, -893, -893, -893, -893, -893, -893,
     -893, -893, -893, -893, -893, -893, -893, -893,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -893, -893,
     -893, -893, -893, -893, -893,  902,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -893, -893, -893, -893,  227, -893,  902,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -893, -893, -893, -893,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -894, -894, -894, -894, -894, -894, -894, -894, -894,
     -894, -894, -894, -894, -894, -894, -894, -894, -894, -894,
     -894, -894, -894, -894, -894, -894, -894, -894, -894, -894,
     -894, -894, -894, -894, -894, -894, -894, -894, -894, -894,
     -894, -894, -894, -894, -894, -894, -894, -894,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -894, -894,

     -894, -894, -894, -894, -894,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -894, -894, -894, -894,  227, -894,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -894, -894, -894, -894,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45, -895, -895, -895, -895, -895, -895, -895, -895, -895,
     -895, -895, -895, -895, -895, -895, -895, -895, -895, -895,
     -895, -895, -895, -895, -895, -895, -895, -895, -895, -895,
     -895, -895, -895, -895, -895, -895, -895, -895, -895, -895,
     -895, -895, -895, -895, -895, -895, -895, -895,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -895, -895,
     -895, -895, -895, -895, -895,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  903,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -895, -895, -895, -895,  227, -895,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  903,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -895, -895, -895, -895,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -896, -896, -896, -896, -896, -896, -896, -896, -896,
     -896, -896, -896, -896, -896, -896, -896, -896, -896, -896,
     -896, -896, -896, -896, -896, -896, -896, -896, -896, -896,
     -896, -896, -896, -896, -896, -896, -896, -896, -896, -896,

     -896, -896, -896, -896, -896, -896, -896, -896,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -896, -896,
     -896, -896, -896, -896, -896,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -896, -896, -896, -896,  904, -896,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -896, -896, -896, -896,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905, -897,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      906,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,

      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,

      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905
    },

    {
       45,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,

      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897, -898,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
     -898,  897,  897, -898,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897, -898,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897, -898,  897,  897,  897,  897,

      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,

      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897,  897,  897,  897,  897,
      897,  897,  897,  897,  897,  897
    },

    {
       45, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,

     -899, -899, -899, -899, -899,  907, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899,  907, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,

     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899, -899, -899, -899, -899,
     -899, -899, -899, -899, -899, -899

    },

    {
       45,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      909,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,

      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,

      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908
    },

    {
       45,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900, -901,  900,  900,

      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
     -901,  900,  900, -901,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900, -901,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900, -901,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,

      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,

      900,  900,  900,  900,  900,  900,  900,  900,  900,  900,
      900,  900,  900,  900,  900,  900
    },

    {
       45, -902, -902, -902, -902, -902, -902, -902, -902, -902,
     -902, -902, -902, -902, -902, -902, -902, -902, -902, -902,
     -902, -902, -902, -902, -902, -902, -902, -902, -902, -902,
     -902, -902, -902, -902, -902, -902, -902, -902, -902, -902,
     -902, -902, -902, -902, -902, -902, -902, -902,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -902, -902,
     -902, -902, -902, -902, -902,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  910,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -902, -902, -902, -902,  227, -902,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  910,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -902, -902, -902, -902,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -903, -903, -903, -903, -903, -903, -903, -903, -903,
     -903, -903, -903, -903, -903, -903, -903, -903, -903, -903,

     -903, -903, -903, -903, -903, -903, -903, -903, -903, -903,
     -903, -903, -903, -903, -903, -903, -903, -903, -903, -903,
     -903, -903, -903, -903, -903, -903, -903, -903,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -903, -903,
     -903, -903, -903, -903, -903,  227,  227,  227,  227,  911,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -903, -903, -903, -903,  227, -903,  227,  227,  227,
      227,  911,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -903, -903, -903, -903,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -904, -904, -904, -904, -904, -904, -904, -904, -904,
     -904, -904, -904, -904, -904, -904, -904, -904, -904, -904,
     -904, -904, -904, -904, -904, -904, -904, -904, -904, -904,
     -904, -904, -904, -904, -904, -904, -904, -904, -904, -904,
     -904, -904, -904, -904, -904, -904, -904, -904,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -904, -904,

     -904, -904, -904, -904, -904,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -904, -904, -904, -904,  227, -904,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -904, -904, -904, -904,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912, -905,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      913,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,

      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,

      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912
    },

    {
       45,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905, -906,  905,  905,

      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
     -906,  905,  905, -906,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905, -906,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905, -906,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,

      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,

      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905
    },

    {
       45, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907,  914, -907, -907, -907, -907, -907, -907, -907, -907,

     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907,  914, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,

     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907, -907, -907, -907, -907,
     -907, -907, -907, -907, -907, -907
    },

    {
       45,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,

      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      916,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,

      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,

      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915
    },

    {
       45,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908, -909,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,

     -909,  908,  908, -909,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908, -909,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908, -909,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,

      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908,  908,  908,  908,  908,
      908,  908,  908,  908,  908,  908

    },

    {
       45, -910, -910, -910, -910, -910, -910, -910, -910, -910,
     -910, -910, -910, -910, -910, -910, -910, -910, -910, -910,
     -910, -910, -910, -910, -910, -910, -910, -910, -910, -910,
     -910, -910, -910, -910, -910, -910, -910, -910, -910, -910,
     -910, -910, -910, -910, -910, -910, -910, -910,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -910, -910,
     -910, -910, -910, -910, -910,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  917,  227,  227,  227,  227,  227,
      227, -910, -910, -910, -910,  227, -910,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  917,  227,  227,  227,
      227,  227,  227, -910, -910, -910, -910,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -911, -911, -911, -911, -911, -911, -911, -911, -911,
     -911, -911, -911, -911, -911, -911, -911, -911, -911, -911,
     -911, -911, -911, -911, -911, -911, -911, -911, -911, -911,
     -911, -911, -911, -911, -911, -911, -911, -911, -911, -911,

     -911, -911, -911, -911, -911, -911, -911, -911,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -911, -911,
     -911, -911, -911, -911, -911,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  918,  227,  227,  227,  227,  227,  227,  227,
      227, -911, -911, -911, -911,  227, -911,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  918,  227,  227,  227,  227,  227,
      227,  227,  227, -911, -911, -911, -911,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919, -912,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      920,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,

      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,

      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919
    },

    {
       45,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,

      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912, -913,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
     -913,  912,  912, -913,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912, -913,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912, -913,  912,  912,  912,  912,

      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,

      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912
    },

    {
       45, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,

     -914, -914, -914, -914, -914, -914, -914, -914, -914,  921,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914,  921, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,

     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914, -914, -914, -914, -914,
     -914, -914, -914, -914, -914, -914

    },

    {
       45,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      923,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,

      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,

      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922
    },

    {
       45,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915, -916,  915,  915,

      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
     -916,  915,  915, -916,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915, -916,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915, -916,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,

      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,

      915,  915,  915,  915,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  915,  915,  915
    },

    {
       45, -917, -917, -917, -917, -917, -917, -917, -917, -917,
     -917, -917, -917, -917, -917, -917, -917, -917, -917, -917,
     -917, -917, -917, -917, -917, -917, -917, -917, -917, -917,
     -917, -917, -917, -917, -917, -917, -917, -917, -917, -917,
     -917, -917, -917, -917, -917, -917, -917, -917,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -917, -917,
     -917, -917, -917, -917, -917,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -917, -917, -917, -917,  924, -917,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -917, -917, -917, -917,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45, -918, -918, -918, -918, -918, -918, -918, -918, -918,
     -918, -918, -918, -918, -918, -918, -918, -918, -918, -918,

     -918, -918, -918, -918, -918, -918, -918, -918, -918, -918,
     -918, -918, -918, -918, -918, -918, -918, -918, -918, -918,
     -918, -918, -918, -918, -918, -918, -918, -918,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -918, -918,
     -918, -918, -918, -918, -918,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -918, -918, -918, -918,  227, -918,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227, -918, -918, -918, -918,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925, -919,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,

      926,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,

      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925

    },

    {
       45,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919, -920,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
     -920,  919,  919, -920,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919, -920,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,

      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919, -920,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,

      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  919,  919
    },

    {
       45, -921, -921, -921, -921, -921, -921, -921, -921,  927,
      927, -921, -921,  927, -921, -921, -921, -921, -921, -921,
     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,
     -921, -921,  927, -921, -921, -921, -921, -921, -921, -921,

     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,
     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,
     -921,  928, -921, -921, -921, -921, -921, -921, -921, -921,
     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,
     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,
     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,
     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,
     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,
     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,
     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,

     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,
     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,
     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,
     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,
     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,
     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,
     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,
     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,
     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,
     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,

     -921, -921, -921, -921, -921, -921, -921, -921, -921, -921,
     -921, -921, -921, -921, -921, -921
    },

    {
       45,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      930,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,

      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,

      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929
    },

    {
       45,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,

      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922, -923,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
     -923,  922,  922, -923,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922, -923,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922, -923,  922,  922,  922,  922,

      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,

      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922,  922,  922,  922,  922,
      922,  922,  922,  922,  922,  922
    },

    {
       45, -924, -924, -924, -924, -924, -924, -924, -924, -924,
     -924, -924, -924, -924, -924, -924, -924, -924, -924, -924,
     -924, -924, -924, -924, -924, -924, -924, -924, -924, -924,
     -924, -924, -924, -924, -924, -924, -924, -924, -924, -924,
     -924, -924, -924, -924, -924, -924, -924, -924,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -924, -924,

     -924, -924, -924, -924, -924,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  931,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -924, -924, -924, -924,  227, -924,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  931,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -924, -924, -924, -924,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932, -925,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      933,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,

      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,

      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932
    },

    {
       45,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925, -926,  925,  925,

      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
     -926,  925,  925, -926,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925, -926,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925, -926,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,

      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,

      925,  925,  925,  925,  925,  925,  925,  925,  925,  925,
      925,  925,  925,  925,  925,  925
    },

    {
       45, -927, -927, -927, -927, -927, -927, -927, -927,  927,
      927, -927, -927,  927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927,  927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,
     -927,  928, -927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,

     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,

     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927, -927, -927, -927, -927,
     -927, -927, -927, -927, -927, -927
    },

    {
       45, -928, -928, -928, -928, -928, -928, -928, -928,  934,
      934, -928, -928,  934, -928, -928, -928, -928, -928, -928,

     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,
     -928, -928,  934, -928,  935, -928, -928, -928, -928,  936,
     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,
     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,
     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,
     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,
      937, -928, -928, -928, -928, -928, -928, -928, -928, -928,
     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,
     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,
     -928, -928,  937, -928, -928, -928, -928, -928, -928, -928,

     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,
     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,
     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,
     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,
     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,
     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,
     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,
     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,
     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,
     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,

     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,
     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,
     -928, -928, -928, -928, -928, -928, -928, -928, -928, -928,
     -928, -928, -928, -928, -928, -928
    },

    {
       45,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,

      939,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,

      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938

    },

    {
       45,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929, -930,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
     -930,  929,  929, -930,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929, -930,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,

      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929, -930,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,

      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929,  929,  929,  929,  929,
      929,  929,  929,  929,  929,  929
    },

    {
       45, -931, -931, -931, -931, -931, -931, -931, -931, -931,
     -931, -931, -931, -931, -931, -931, -931, -931, -931, -931,
     -931, -931, -931, -931, -931, -931, -931, -931, -931, -931,
     -931, -931, -931, -931, -931, -931, -931, -931, -931, -931,

     -931, -931, -931, -931, -931, -931, -931, -931,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -931, -931,
     -931, -931, -931, -931, -931,  227,  227,  227,  227,  227,
      940,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -931, -931, -931, -931,  227, -931,  227,  227,  227,
      227,  227,  940,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -931, -931, -931, -931,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941, -932,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      942,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,

      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,

      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941
    },

    {
       45,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,

      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932, -933,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
     -933,  932,  932, -933,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932, -933,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932, -933,  932,  932,  932,  932,

      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,

      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932
    },

    {
       45, -934, -934, -934, -934, -934, -934, -934, -934,  934,
      934, -934, -934,  934, -934, -934, -934, -934, -934, -934,
     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,
     -934, -934,  934, -934,  935, -934, -934, -934, -934,  936,
     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,
     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,

     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,
     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,
      937, -934, -934, -934, -934, -934, -934, -934, -934, -934,
     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,
     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,
     -934, -934,  937, -934, -934, -934, -934, -934, -934, -934,
     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,
     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,
     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,
     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,

     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,
     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,
     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,
     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,
     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,
     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,
     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,
     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,
     -934, -934, -934, -934, -934, -934, -934, -934, -934, -934,
     -934, -934, -934, -934, -934, -934

    },

    {
       45, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
      943, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,

     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935,  943, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,

     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935, -935, -935, -935, -935,
     -935, -935, -935, -935, -935, -935
    },

    {
       45, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,

     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,
      944, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936,  944, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,

     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,

     -936, -936, -936, -936, -936, -936, -936, -936, -936, -936,
     -936, -936, -936, -936, -936, -936
    },

    {
       45, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937,  945, -937, -937, -937, -937, -937, -937, -937,

     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937,  945, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,

     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937, -937, -937, -937, -937,
     -937, -937, -937, -937, -937, -937
    },

    {
       45,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,

      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      947,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,

      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,

      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946
    },

    {
       45,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938, -939,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,

     -939,  938,  938, -939,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938, -939,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938, -939,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,

      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938

    },

    {
       45, -940, -940, -940, -940, -940, -940, -940, -940, -940,
     -940, -940, -940, -940, -940, -940, -940, -940, -940, -940,
     -940, -940, -940, -940, -940, -940, -940, -940, -940, -940,
     -940, -940, -940, -940, -940, -940, -940, -940, -940, -940,
     -940, -940, -940, -940, -940, -940, -940, -940,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -940, -940,
     -940, -940, -940, -940, -940,  227,  227,  227,  227,  227,
      948,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -940, -940, -940, -940,  227, -940,  227,  227,  227,

      227,  227,  948,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -940, -940, -940, -940,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949, -941,  949,  949,  949,  949,

      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      950,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,

      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,

      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949
    },

    {
       45,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941, -942,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
     -942,  941,  941, -942,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,

      941,  941,  941, -942,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941, -942,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,

      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941
    },

    {
       45, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,

     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943,  951, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943,  951, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,

     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,

     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943, -943, -943, -943, -943,
     -943, -943, -943, -943, -943, -943
    },

    {
       45, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,

     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944,  952, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944,  952, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,

     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944, -944, -944, -944, -944,
     -944, -944, -944, -944, -944, -944

    },

    {
       45, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
      953, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,

     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945,  953, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,

     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945, -945, -945, -945, -945,
     -945, -945, -945, -945, -945, -945
    },

    {
       45,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,

      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      955,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,

      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,

      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954
    },

    {
       45,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946, -947,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
     -947,  946,  946, -947,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,

      946,  946,  946, -947,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946, -947,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,

      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946,  946,  946,  946,  946,
      946,  946,  946,  946,  946,  946
    },

    {
       45, -948, -948, -948, -948, -948, -948, -948, -948, -948,
     -948, -948, -948, -948, -948, -948, -948, -948, -948, -948,

     -948, -948, -948, -948, -948, -948, -948, -948, -948, -948,
     -948, -948, -948, -948, -948, -948, -948, -948, -948, -948,
     -948, -948, -948, -948, -948, -948, -948, -948,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -948, -948,
     -948, -948, -948, -948, -948,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  956,  227,  227,  227,  227,  227,  227,
      227, -948, -948, -948, -948,  227, -948,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  956,  227,  227,  227,  227,

      227,  227,  227, -948, -948, -948, -948,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957, -949,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,

      958,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,

      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957

    },

    {
       45,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949, -950,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
     -950,  949,  949, -950,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949, -950,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,

      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949, -950,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,

      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949,  949,  949,  949,  949,
      949,  949,  949,  949,  949,  949
    },

    {
       45, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,

     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,
      959, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951,  959, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,

     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,

     -951, -951, -951, -951, -951, -951, -951, -951, -951, -951,
     -951, -951, -951, -951, -951, -951
    },

    {
       45, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,

      960, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952,  960, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,

     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952, -952, -952, -952, -952,
     -952, -952, -952, -952, -952, -952
    },

    {
       45, -953, -953, -953, -953, -953, -953, -953, -953,  961,
      961, -953, -953,  961, -953, -953, -953, -953, -953, -953,

     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,
     -953, -953,  961, -953, -953, -953, -953, -953, -953, -953,
     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,
     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,
     -953, -953,  657, -953, -953, -953, -953, -953, -953, -953,
     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,
     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,
     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,
     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,
     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,

     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,
     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,
     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,
     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,
     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,
     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,
     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,
     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,
     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,
     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,

     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,
     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,
     -953, -953, -953, -953, -953, -953, -953, -953, -953, -953,
     -953, -953, -953, -953, -953, -953
    },

    {
       45,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,

      963,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,

      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962

    },

    {
       45,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954, -955,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
     -955,  954,  954, -955,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954, -955,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,

      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954, -955,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,

      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954,  954,  954,  954,  954,
      954,  954,  954,  954,  954,  954
    },

    {
       45, -956, -956, -956, -956, -956, -956, -956, -956, -956,
     -956, -956, -956, -956, -956, -956, -956, -956, -956, -956,
     -956, -956, -956, -956, -956, -956, -956, -956, -956, -956,
     -956, -956, -956, -956, -956, -956, -956, -956, -956, -956,

     -956, -956, -956, -956, -956, -956, -956, -956,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -956, -956,
     -956, -956, -956, -956, -956,  227,  227,  227,  227,  964,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -956, -956, -956, -956,  227, -956,  227,  227,  227,
      227,  964,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -956, -956, -956, -956,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227
    },

    {
       45,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965, -957,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      966,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,

      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,

      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965
    },

    {
       45,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,

      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957, -958,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
     -958,  957,  957, -958,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957, -958,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957, -958,  957,  957,  957,  957,

      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,

      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  957,  957
    },

    {
       45, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959,  953, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,

     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,

     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959, -959, -959, -959, -959,
     -959, -959, -959, -959, -959, -959

    },

    {
       45, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960,  953,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,

     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,

     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960, -960, -960, -960, -960,
     -960, -960, -960, -960, -960, -960
    },

    {
       45, -961, -961, -961, -961, -961, -961, -961, -961,  961,
      961, -961, -961,  961, -961, -961, -961, -961, -961, -961,
     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,
     -961, -961,  961, -961, -961, -961, -961, -961, -961, -961,

     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,
     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,
     -961, -961,  657, -961, -961, -961, -961, -961, -961, -961,
     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,
     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,
     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,
     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,
     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,
     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,
     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,

     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,
     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,
     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,
     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,
     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,
     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,
     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,
     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,
     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,
     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,

     -961, -961, -961, -961, -961, -961, -961, -961, -961, -961,
     -961, -961, -961, -961, -961, -961
    },

    {
       45,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      968,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,

      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,

      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967
    },

    {
       45,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,

      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962, -963,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
     -963,  962,  962, -963,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962, -963,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962, -963,  962,  962,  962,  962,

      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,

      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962
    },

    {
       45, -964, -964, -964, -964, -964, -964, -964, -964, -964,
     -964, -964, -964, -964, -964, -964, -964, -964, -964, -964,
     -964, -964, -964, -964, -964, -964, -964, -964, -964, -964,
     -964, -964, -964, -964, -964, -964, -964, -964, -964, -964,
     -964, -964, -964, -964, -964, -964, -964, -964,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -964, -964,

     -964, -964, -964, -964, -964,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  969,  227,  227,  227,  227,  227,
      227, -964, -964, -964, -964,  227, -964,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  969,  227,  227,  227,
      227,  227,  227, -964, -964, -964, -964,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970, -965,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      971,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,

      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,

      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970
    },

    {
       45,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965, -966,  965,  965,

      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
     -966,  965,  965, -966,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965, -966,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965, -966,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,

      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,

      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965
    },

    {
       45,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      973,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,

      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,

      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972
    },

    {
       45,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,

      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967, -968,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
     -968,  967,  967, -968,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967, -968,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967, -968,  967,  967,  967,  967,

      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,

      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  967,  967,  967,
      967,  967,  967,  967,  967,  967
    },

    {
       45, -969, -969, -969, -969, -969, -969, -969, -969, -969,
     -969, -969, -969, -969, -969, -969, -969, -969, -969, -969,
     -969, -969, -969, -969, -969, -969, -969, -969, -969, -969,
     -969, -969, -969, -969, -969, -969, -969, -969, -969, -969,
     -969, -969, -969, -969, -969, -969, -969, -969,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -969, -969,

     -969, -969, -969, -969, -969,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -969, -969, -969, -969,  974, -969,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -969, -969, -969, -969,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975, -970,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      976,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,

      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,

      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975
    },

    {
       45,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970, -971,  970,  970,

      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
     -971,  970,  970, -971,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970, -971,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970, -971,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,

      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,

      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970
    },

    {
       45,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      978,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,

      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,

      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977
    },

    {
       45,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,

      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972, -973,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
     -973,  972,  972, -973,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972, -973,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972, -973,  972,  972,  972,  972,

      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,

      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  972
    },

    {
       45, -974, -974, -974, -974, -974, -974, -974, -974, -974,
     -974, -974, -974, -974, -974, -974, -974, -974, -974, -974,
     -974, -974, -974, -974, -974, -974, -974, -974, -974, -974,
     -974, -974, -974, -974, -974, -974, -974, -974, -974, -974,
     -974, -974, -974, -974, -974, -974, -974, -974,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -974, -974,

     -974, -974, -974, -974, -974,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -974, -974, -974, -974,  979, -974,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -974, -974, -974, -974,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980, -975,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      981,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,

      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,

      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980
    },

    {
       45,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975, -976,  975,  975,

      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
     -976,  975,  975, -976,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975, -976,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975, -976,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,

      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,

      975,  975,  975,  975,  975,  975,  975,  975,  975,  975,
      975,  975,  975,  975,  975,  975
    },

    {
       45,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      983,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,

      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,

      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982
    },

    {
       45,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,

      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977, -978,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
     -978,  977,  977, -978,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977, -978,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977, -978,  977,  977,  977,  977,

      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,

      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977
    },

    {
       45, -979, -979, -979, -979, -979, -979, -979, -979, -979,
     -979, -979, -979, -979, -979, -979, -979, -979, -979, -979,
     -979, -979, -979, -979, -979, -979, -979, -979, -979, -979,
     -979, -979, -979, -979, -979, -979, -979, -979, -979, -979,
     -979, -979, -979, -979, -979, -979, -979, -979,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227, -979, -979,

     -979, -979, -979, -979, -979,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227, -979, -979, -979, -979,  227, -979,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227, -979, -979, -979, -979,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227

    },

    {
       45,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984, -980,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      985,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,

      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,

      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984
    },

    {
       45,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980, -981,  980,  980,

      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
     -981,  980,  980, -981,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980, -981,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980, -981,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,

      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,

      980,  980,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980
    },

    {
       45,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      987,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,

      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,

      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986
    },

    {
       45,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,

      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982, -983,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
     -983,  982,  982, -983,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982, -983,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982, -983,  982,  982,  982,  982,

      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,

      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  982,  982
    },

    {
       45,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988, -984,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,

      989,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,

      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988

    },

    {
       45,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984, -985,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
     -985,  984,  984, -985,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984, -985,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,

      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984, -985,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,

      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984
    },

    {
       45,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,

      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      991,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,

      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,

      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990
    },

    {
       45,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986, -987,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
     -987,  986,  986, -987,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,

      986,  986,  986, -987,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986, -987,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,

      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986
    },

    {
       45,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,

      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992, -988,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      993,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,

      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,

      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992
    },

    {
       45,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988, -989,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,

     -989,  988,  988, -989,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988, -989,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988, -989,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,

      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988

    },

    {
       45,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      995,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,

      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,

      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994
    },

    {
       45,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990, -991,  990,  990,

      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
     -991,  990,  990, -991,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990, -991,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990, -991,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,

      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,

      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  990
    },

    {
       45,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996, -992,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      997,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,

      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,

      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996
    },

    {
       45,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,

      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992, -993,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
     -993,  992,  992, -993,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992, -993,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992, -993,  992,  992,  992,  992,

      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,

      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992
    },

    {
       45,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,

      999,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,

      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998

    },

    {
       45,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994, -995,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
     -995,  994,  994, -995,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994, -995,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,

      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994, -995,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,

      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994
    },

    {
       45, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, -996, 1000, 1000, 1000, 1000,

     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1001, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,

     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,

     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000
    },

    {
       45,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996, -997,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
     -997,  996,  996, -997,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,

      996,  996,  996, -997,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996, -997,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,

      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  996,  996,  996,  996
    },

    {
       45, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,

     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1003, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,

     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,

     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002
    },

    {
       45,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998, -999,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,

     -999,  998,  998, -999,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998, -999,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998, -999,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,

      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998

    },

    {
       45, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004,-1000, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1005, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,

     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,

     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004
    },

    {
       45, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000,-1001, 1000, 1000,

     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
    -1001, 1000, 1000,-1001, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000,-1001, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000,-1001, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,

     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,

     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1000, 1000, 1000, 1000, 1000
    },

    {
       45, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1007, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,

     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,

     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006
    },

    {
       45, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,

     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002,-1003, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
    -1003, 1002, 1002,-1003, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002,-1003, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002,-1003, 1002, 1002, 1002, 1002,

     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,

     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002
    },

    {
       45, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008,-1004, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,

     1009, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,

     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008

    },

    {
       45, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004,-1005, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
    -1005, 1004, 1004,-1005, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004,-1005, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,

     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004,-1005, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,

     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004
    },

    {
       45, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,

     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1011, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,

     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,

     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010
    },

    {
       45, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006,-1007, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
    -1007, 1006, 1006,-1007, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,

     1006, 1006, 1006,-1007, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006,-1007, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,

     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006
    },

    {
       45, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,

     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012,-1008, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1013, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,

     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,

     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012
    },

    {
       45, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008,-1009, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,

    -1009, 1008, 1008,-1009, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008,-1009, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008,-1009, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,

     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008

    },

    {
       45, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1015, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,

     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,

     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014
    },

    {
       45, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010,-1011, 1010, 1010,

     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
    -1011, 1010, 1010,-1011, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010,-1011, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010,-1011, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,

     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,

     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010
    },

    {
       45, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016,-1012, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1017, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,

     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,

     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016
    },

    {
       45, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,

     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012,-1013, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
    -1013, 1012, 1012,-1013, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012,-1013, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012,-1013, 1012, 1012, 1012, 1012,

     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,

     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012
    },

    {
       45, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,

     1019, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,

     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018

    },

    {
       45, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014,-1015, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
    -1015, 1014, 1014,-1015, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014,-1015, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,

     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014,-1015, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,

     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014
    },

    {
       45, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020,-1016, 1020, 1020, 1020, 1020,

     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1021, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,

     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,

     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020
    },

    {
       45, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016,-1017, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
    -1017, 1016, 1016,-1017, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,

     1016, 1016, 1016,-1017, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016,-1017, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,

     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016
    },

    {
       45, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,

     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1023, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,

     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,

     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022
    },

    {
       45, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018,-1019, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,

    -1019, 1018, 1018,-1019, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018,-1019, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018,-1019, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,

     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018

    },

    {
       45, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024,-1020, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1025, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,

     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,

     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024
    },

    {
       45, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020,-1021, 1020, 1020,

     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
    -1021, 1020, 1020,-1021, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020,-1021, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020,-1021, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,

     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,

     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020
    },

    {
       45, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1027, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,

     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,

     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026
    },

    {
       45, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,

     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022,-1023, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
    -1023, 1022, 1022,-1023, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022,-1023, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022,-1023, 1022, 1022, 1022, 1022,

     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,

     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,
     1022, 1022, 1022, 1022, 1022, 1022
    },

    {
       45, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028,-1024, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,

     1029, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,

     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028

    },

    {
       45, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024,-1025, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
    -1025, 1024, 1024,-1025, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024,-1025, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,

     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024,-1025, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,

     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1024, 1024, 1024, 1024, 1024, 1024
    },

    {
       45, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,

     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1031, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,

     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,

     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030
    },

    {
       45, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026,-1027, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
    -1027, 1026, 1026,-1027, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,

     1026, 1026, 1026,-1027, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026,-1027, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,

     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1026, 1026, 1026, 1026, 1026
    },

    {
       45, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,

     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032,-1028, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1033, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,

     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,

     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032
    },

    {
       45, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028,-1029, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,

    -1029, 1028, 1028,-1029, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028,-1029, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028,-1029, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,

     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028

    },

    {
       45, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1035, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,

     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,

     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034
    },

    {
       45, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030,-1031, 1030, 1030,

     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
    -1031, 1030, 1030,-1031, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030,-1031, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030,-1031, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,

     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,

     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030
    },

    {
       45, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036,-1032, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1037, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,

     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,

     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036
    },

    {
       45, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,

     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032,-1033, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
    -1033, 1032, 1032,-1033, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032,-1033, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032,-1033, 1032, 1032, 1032, 1032,

     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,

     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032
    },

    {
       45, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,

     1039, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,

     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038

    },

    {
       45, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034,-1035, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
    -1035, 1034, 1034,-1035, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034,-1035, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,

     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034,-1035, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,

     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034
    },

    {
       45, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040,-1036, 1040, 1040, 1040, 1040,

     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1041, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,

     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,

     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040
    },

    {
       45, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036,-1037, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
    -1037, 1036, 1036,-1037, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,

     1036, 1036, 1036,-1037, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036,-1037, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,

     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036
    },

    {
       45, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,

     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1043, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,

     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,

     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042
    },

    {
       45, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038,-1039, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,

    -1039, 1038, 1038,-1039, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038,-1039, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038,-1039, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,

     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038

    },

    {
       45, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044,-1040, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1045, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,

     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,

     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044
    },

    {
       45, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040,-1041, 1040, 1040,

     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
    -1041, 1040, 1040,-1041, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040,-1041, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040,-1041, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,

     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,

     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040
    },

    {
       45, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1047, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,

     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,

     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046
    },

    {
       45, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,

     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042,-1043, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
    -1043, 1042, 1042,-1043, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042,-1043, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042,-1043, 1042, 1042, 1042, 1042,

     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,

     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042
    },

    {
       45, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048,-1044, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,

     1049, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,

     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048

    },

    {
       45, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044,-1045, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
    -1045, 1044, 1044,-1045, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044,-1045, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,

     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044,-1045, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,

     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044
    },

    {
       45, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,

     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1051, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,

     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,

     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050
    },

    {
       45, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046,-1047, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
    -1047, 1046, 1046,-1047, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,

     1046, 1046, 1046,-1047, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046,-1047, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,

     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     1046, 1046, 1046, 1046, 1046, 1046
    },

    {
       45, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,

     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052,-1048, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1053, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,

     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,

     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052
    },

    {
       45, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048,-1049, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,

    -1049, 1048, 1048,-1049, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048,-1049, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048,-1049, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,

     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1048, 1048, 1048, 1048, 1048

    },

    {
       45, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1055, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,

     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,

     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054
    },

    {
       45, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050,-1051, 1050, 1050,

     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
    -1051, 1050, 1050,-1051, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050,-1051, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050,-1051, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,

     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,

     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
     1050, 1050, 1050, 1050, 1050, 1050
    },

    {
       45, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056,-1052, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1057, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,

     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,

     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056
    },

    {
       45, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,

     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052,-1053, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
    -1053, 1052, 1052,-1053, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052,-1053, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052,-1053, 1052, 1052, 1052, 1052,

     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,

     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1052
    },

    {
       45, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,

     1059, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,

     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058

    },

    {
       45, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054,-1055, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
    -1055, 1054, 1054,-1055, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054,-1055, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,

     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054,-1055, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,

     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1054, 1054, 1054, 1054, 1054
    },

    {
       45, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060,-1056, 1060, 1060, 1060, 1060,

     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1061, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,

     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,

     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060
    },

    {
       45, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056,-1057, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
    -1057, 1056, 1056,-1057, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,

     1056, 1056, 1056,-1057, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056,-1057, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,

     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056,
     1056, 1056, 1056, 1056, 1056, 1056
    },

    {
       45, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,

     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1063, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,

     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,

     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062
    },

    {
       45, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058,-1059, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,

    -1059, 1058, 1058,-1059, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058,-1059, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058,-1059, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,

     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1058, 1058, 1058

    },

    {
       45, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064,-1060, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1065, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,

     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,

     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064
    },

    {
       45, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060,-1061, 1060, 1060,

     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
    -1061, 1060, 1060,-1061, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060,-1061, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060,-1061, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,

     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,

     1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060,
     1060, 1060, 1060, 1060, 1060, 1060
    },

    {
       45, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1067, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,

     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,

     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066
    },

    {
       45, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,

     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062,-1063, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
    -1063, 1062, 1062,-1063, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062,-1063, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062,-1063, 1062, 1062, 1062, 1062,

     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,

     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1062
    },

    {
       45, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068,-1064, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,

     1069, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,

     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068

    },

    {
       45, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064,-1065, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
    -1065, 1064, 1064,-1065, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064,-1065, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,

     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064,-1065, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,

     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064
    },

    {
       45, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,

     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1071, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,

     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,

     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070
    },

    {
       45, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066,-1067, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
    -1067, 1066, 1066,-1067, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,

     1066, 1066, 1066,-1067, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066,-1067, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,

     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066,
     1066, 1066, 1066, 1066, 1066, 1066
    },

    {
       45, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,

     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072,-1068, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1073, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,

     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,

     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072
    },

    {
       45, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068,-1069, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,

    -1069, 1068, 1068,-1069, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068,-1069, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068,-1069, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,

     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068

    },

    {
       45, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1075, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,

     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,

     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074
    },

    {
       45, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070,-1071, 1070, 1070,

     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
    -1071, 1070, 1070,-1071, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070,-1071, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070,-1071, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,

     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,

     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070
    },

    {
       45, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076,-1072, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1077, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,

     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,

     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076
    },

    {
       45, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,

     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072,-1073, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
    -1073, 1072, 1072,-1073, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072,-1073, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072,-1073, 1072, 1072, 1072, 1072,

     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,

     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1072, 1072, 1072
    },

    {
       45, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,

     1079, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,

     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078

    },

    {
       45, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074,-1075, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
    -1075, 1074, 1074,-1075, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074,-1075, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,

     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074,-1075, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,

     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074
    },

    {
       45, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080,-1076, 1080, 1080, 1080, 1080,

     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1081, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,

     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,

     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080
    },

    {
       45, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076,-1077, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
    -1077, 1076, 1076,-1077, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,

     1076, 1076, 1076,-1077, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076,-1077, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,

     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1076
    },

    {
       45, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,

     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1083, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,

     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,

     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082
    },

    {
       45, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078,-1079, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,

    -1079, 1078, 1078,-1079, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078,-1079, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078,-1079, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,

     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1078, 1078, 1078, 1078, 1078

    },

    {
       45, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084,-1080, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1085, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,

     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,

     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084
    },

    {
       45, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080,-1081, 1080, 1080,

     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
    -1081, 1080, 1080,-1081, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080,-1081, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080,-1081, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,

     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,

     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
     1080, 1080, 1080, 1080, 1080, 1080
    },

    {
       45, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1087, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,

     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,

     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086
    },

    {
       45, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,

     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082,-1083, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
    -1083, 1082, 1082,-1083, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082,-1083, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082,-1083, 1082, 1082, 1082, 1082,

     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,

     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1082, 1082, 1082
    },

    {
       45, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088,-1084, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,

     1089, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,

     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088

    },

    {
       45, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084,-1085, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
    -1085, 1084, 1084,-1085, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084,-1085, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,

     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084,-1085, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,

     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1084, 1084, 1084, 1084, 1084
    },

    {
       45, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,

     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1091, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,

     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,

     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090
    },

    {
       45, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086,-1087, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
    -1087, 1086, 1086,-1087, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,

     1086, 1086, 1086,-1087, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086,-1087, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,

     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
     1086, 1086, 1086, 1086, 1086, 1086
    },

    {
       45, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,

     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092,-1088, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1093, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,

     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,

     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092
    },

    {
       45, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088,-1089, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,

    -1089, 1088, 1088,-1089, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088,-1089, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088,-1089, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,

     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088

    },

    {
       45, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1095, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,

     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,

     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094
    },

    {
       45, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090,-1091, 1090, 1090,

     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
    -1091, 1090, 1090,-1091, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090,-1091, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090,-1091, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,

     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,

     1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 1090,
     1090, 1090, 1090, 1090, 1090, 1090
    },

    {
       45, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096,-1092, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1097, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,

     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,

     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096
    },

    {
       45, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,

     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092,-1093, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
    -1093, 1092, 1092,-1093, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092,-1093, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092,-1093, 1092, 1092, 1092, 1092,

     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,

     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092,
     1092, 1092, 1092, 1092, 1092, 1092
    },

    {
       45, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,

     1099, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,

     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098

    },

    {
       45, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094,-1095, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
    -1095, 1094, 1094,-1095, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094,-1095, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,

     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094,-1095, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,

     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1094
    },

    {
       45, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100,-1096, 1100, 1100, 1100, 1100,

     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1101, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,

     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,

     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100
    },

    {
       45, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096,-1097, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
    -1097, 1096, 1096,-1097, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,

     1096, 1096, 1096,-1097, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096,-1097, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,

     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1096, 1096, 1096, 1096, 1096
    },

    {
       45, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,

     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1103, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,

     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,

     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102
    },

    {
       45, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098,-1099, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,

    -1099, 1098, 1098,-1099, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098,-1099, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098,-1099, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,

     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098,
     1098, 1098, 1098, 1098, 1098, 1098

    },

    {
       45, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104,-1100, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1105, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,

     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,

     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104
    },

    {
       45, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100,-1101, 1100, 1100,

     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
    -1101, 1100, 1100,-1101, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100,-1101, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100,-1101, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,

     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,

     1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1100, 1100, 1100
    },

    {
       45, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1107, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,

     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,

     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106
    },

    {
       45, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,

     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102,-1103, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
    -1103, 1102, 1102,-1103, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102,-1103, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102,-1103, 1102, 1102, 1102, 1102,

     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,

     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102
    },

    {
       45, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108,-1104, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,

     1109, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,

     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108

    },

    {
       45, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104,-1105, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
    -1105, 1104, 1104,-1105, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104,-1105, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,

     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104,-1105, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,

     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104
    },

    {
       45, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,

     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1111, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,

     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,

     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110
    },

    {
       45, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106,-1107, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
    -1107, 1106, 1106,-1107, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,

     1106, 1106, 1106,-1107, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106,-1107, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,

     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1106, 1106, 1106, 1106, 1106
    },

    {
       45, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,

     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112,-1108, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1113, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,

     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,

     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112
    },

    {
       45, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108,-1109, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,

    -1109, 1108, 1108,-1109, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108,-1109, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108,-1109, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,

     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108

    },

    {
       45, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1115, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,

     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,

     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114
    },

    {
       45, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110,-1111, 1110, 1110,

     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
    -1111, 1110, 1110,-1111, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110,-1111, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110,-1111, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,

     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,

     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110
    },

    {
       45, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116,-1112, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1117, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,

     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,

     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116
    },

    {
       45, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,

     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112,-1113, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
    -1113, 1112, 1112,-1113, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112,-1113, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112,-1113, 1112, 1112, 1112, 1112,

     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,

     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112
    },

    {
       45, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,

     1119, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,

     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118

    },

    {
       45, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114,-1115, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
    -1115, 1114, 1114,-1115, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114,-1115, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,

     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114,-1115, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,

     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1114
    },

    {
       45, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120,-1116, 1120, 1120, 1120, 1120,

     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1121, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,

     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,

     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120
    },

    {
       45, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116,-1117, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
    -1117, 1116, 1116,-1117, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,

     1116, 1116, 1116,-1117, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116,-1117, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,

     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116, 1116, 1116, 1116, 1116
    },

    {
       45, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,

     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1123, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,

     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,

     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122
    },

    {
       45, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118,-1119, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,

    -1119, 1118, 1118,-1119, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118,-1119, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118,-1119, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,

     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1118, 1118, 1118, 1118

    },

    {
       45, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124,-1120, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1125, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,

     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,

     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124
    },

    {
       45, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120,-1121, 1120, 1120,

     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
    -1121, 1120, 1120,-1121, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120,-1121, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120,-1121, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,

     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,

     1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120, 1120, 1120, 1120, 1120, 1120
    },

    {
       45, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1127, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,

     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,

     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126
    },

    {
       45, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,

     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122,-1123, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
    -1123, 1122, 1122,-1123, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122,-1123, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122,-1123, 1122, 1122, 1122, 1122,

     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,

     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122
    },

    {
       45, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128,-1124, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,

     1129, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,

     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128

    },

    {
       45, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124,-1125, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
    -1125, 1124, 1124,-1125, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124,-1125, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,

     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124,-1125, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,

     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
     1124, 1124, 1124, 1124, 1124, 1124
    },

    {
       45, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,

     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1131, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,

     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,

     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130
    },

    {
       45, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126,-1127, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
    -1127, 1126, 1126,-1127, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,

     1126, 1126, 1126,-1127, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126,-1127, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,

     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
     1126, 1126, 1126, 1126, 1126, 1126
    },

    {
       45, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,

     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132,-1128, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1133, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,

     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,

     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132
    },

    {
       45, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128,-1129, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,

    -1129, 1128, 1128,-1129, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128,-1129, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128,-1129, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,

     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1128, 1128, 1128

    },

    {
       45, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1135, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,

     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,

     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134
    },

    {
       45, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130,-1131, 1130, 1130,

     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
    -1131, 1130, 1130,-1131, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130,-1131, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130,-1131, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,

     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,

     1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130,
     1130, 1130, 1130, 1130, 1130, 1130
    },

    {
       45, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136,-1132, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1137, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,

     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,

     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136
    },

    {
       45, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,

     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132,-1133, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
    -1133, 1132, 1132,-1133, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132,-1133, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132,-1133, 1132, 1132, 1132, 1132,

     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,

     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1132
    },

    {
       45, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,

     1139, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,

     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138

    },

    {
       45, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134,-1135, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
    -1135, 1134, 1134,-1135, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134,-1135, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,

     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134,-1135, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,

     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1134, 1134, 1134, 1134, 1134
    },

    {
       45, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140,-1136, 1140, 1140, 1140, 1140,

     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1141, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,

     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,

     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140
    },

    {
       45, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136,-1137, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
    -1137, 1136, 1136,-1137, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,

     1136, 1136, 1136,-1137, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136,-1137, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,

     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
     1136, 1136, 1136, 1136, 1136, 1136
    },

    {
       45, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,

     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1143, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,

     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,

     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142
    },

    {
       45, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138,-1139, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,

    -1139, 1138, 1138,-1139, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138,-1139, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138,-1139, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,

     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1138, 1138, 1138

    },

    {
       45, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144,-1140, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1145, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,

     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,

     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144
    },

    {
       45, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140,-1141, 1140, 1140,

     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
    -1141, 1140, 1140,-1141, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140,-1141, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140,-1141, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,

     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,

     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140
    },

    {
       45, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1147, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,

     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,

     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146
    },

    {
       45, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,

     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142,-1143, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
    -1143, 1142, 1142,-1143, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142,-1143, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142,-1143, 1142, 1142, 1142, 1142,

     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,

     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1142
    },

    {
       45, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148,-1144, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,

     1149, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,

     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148

    },

    {
       45, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144,-1145, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
    -1145, 1144, 1144,-1145, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144,-1145, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,

     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144,-1145, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,

     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
     1144, 1144, 1144, 1144, 1144, 1144
    },

    {
       45, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,

     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1151, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,

     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,

     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150
    },

    {
       45, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146,-1147, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
    -1147, 1146, 1146,-1147, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,

     1146, 1146, 1146,-1147, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146,-1147, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,

     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146
    },

    {
       45, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,

     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152,-1148, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1153, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,

     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,

     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152
    },

    {
       45, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148,-1149, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,

    -1149, 1148, 1148,-1149, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148,-1149, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148,-1149, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,

     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148

    },

    {
       45, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1155, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,

     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,

     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154
    },

    {
       45, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150,-1151, 1150, 1150,

     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
    -1151, 1150, 1150,-1151, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150,-1151, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150,-1151, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,

     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,

     1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150
    },

    {
       45, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156,-1152, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1157, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,

     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,

     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156
    },

    {
       45, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,

     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152,-1153, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
    -1153, 1152, 1152,-1153, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152,-1153, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152,-1153, 1152, 1152, 1152, 1152,

     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,

     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1152, 1152, 1152, 1152, 1152
    },

    {
       45, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,

     1159, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,

     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158

    },

    {
       45, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154,-1155, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
    -1155, 1154, 1154,-1155, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154,-1155, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,

     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154,-1155, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,

     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154, 1154,
     1154, 1154, 1154, 1154, 1154, 1154
    },

    {
       45, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160,-1156, 1160, 1160, 1160, 1160,

     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1161, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,

     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,

     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160
    },

    {
       45, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156,-1157, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
    -1157, 1156, 1156,-1157, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,

     1156, 1156, 1156,-1157, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156,-1157, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,

     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1156, 1156, 1156
    },

    {
       45, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,

     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1163, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,

     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,

     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162
    },

    {
       45, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158,-1159, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,

    -1159, 1158, 1158,-1159, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158,-1159, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158,-1159, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,

     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158

    },

    {
       45, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164,-1160, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1165, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,

     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,

     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164
    },

    {
       45, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160,-1161, 1160, 1160,

     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
    -1161, 1160, 1160,-1161, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160,-1161, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160,-1161, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,

     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,

     1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1160
    },

    {
       45, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1167, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,

     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,

     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166
    },

    {
       45, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,

     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162,-1163, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
    -1163, 1162, 1162,-1163, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162,-1163, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162,-1163, 1162, 1162, 1162, 1162,

     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,

     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1162,
     1162, 1162, 1162, 1162, 1162, 1162
    },

    {
       45, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168,-1164, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,

     1169, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,

     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168

    },

    {
       45, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164,-1165, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
    -1165, 1164, 1164,-1165, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164,-1165, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,

     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164,-1165, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,

     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1164
    },

    {
       45, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,

     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1171, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,

     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,

     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170
    },

    {
       45, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166,-1167, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
    -1167, 1166, 1166,-1167, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,

     1166, 1166, 1166,-1167, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166,-1167, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,

     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1166, 1166, 1166
    },

    {
       45, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,

     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172,-1168, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1173, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,

     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,

     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172
    },

    {
       45, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168,-1169, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,

    -1169, 1168, 1168,-1169, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168,-1169, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168,-1169, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,

     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
     1168, 1168, 1168, 1168, 1168, 1168

    },

    {
       45, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1175, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,

     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,

     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174
    },

    {
       45, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170,-1171, 1170, 1170,

     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
    -1171, 1170, 1170,-1171, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170,-1171, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170,-1171, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,

     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,

     1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170,
     1170, 1170, 1170, 1170, 1170, 1170
    },

    {
       45, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176,-1172, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1177, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,

     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,

     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176
    },

    {
       45, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,

     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172,-1173, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
    -1173, 1172, 1172,-1173, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172,-1173, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172,-1173, 1172, 1172, 1172, 1172,

     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,

     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1172,
     1172, 1172, 1172, 1172, 1172, 1172
    },

    {
       45, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,

     1179, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,

     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178

    },

    {
       45, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174,-1175, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
    -1175, 1174, 1174,-1175, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174,-1175, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,

     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174,-1175, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,

     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1174, 1174, 1174
    },

    {
       45, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180,-1176, 1180, 1180, 1180, 1180,

     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1181, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,

     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,

     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180
    },

    {
       45, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176,-1177, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
    -1177, 1176, 1176,-1177, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,

     1176, 1176, 1176,-1177, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176,-1177, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,

     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1176, 1176, 1176, 1176
    },

    {
       45, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,

     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1183, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,

     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,

     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182
    },

    {
       45, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178,-1179, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,

    -1179, 1178, 1178,-1179, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178,-1179, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178,-1179, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,

     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178,
     1178, 1178, 1178, 1178, 1178, 1178

    },

    {
       45, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184,-1180, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1185, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,

     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,

     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184
    },

    {
       45, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180,-1181, 1180, 1180,

     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
    -1181, 1180, 1180,-1181, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180,-1181, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180,-1181, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,

     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,

     1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180, 1180,
     1180, 1180, 1180, 1180, 1180, 1180
    },

    {
       45, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1187, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,

     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,

     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186
    },

    {
       45, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,

     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182,-1183, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
    -1183, 1182, 1182,-1183, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182,-1183, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182,-1183, 1182, 1182, 1182, 1182,

     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,

     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182, 1182,
     1182, 1182, 1182, 1182, 1182, 1182
    },

    {
       45, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188,-1184, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,

     1189, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,

     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188

    },

    {
       45, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184,-1185, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
    -1185, 1184, 1184,-1185, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184,-1185, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,

     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184,-1185, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,

     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1184, 1184, 1184, 1184, 1184
    },

    {
       45, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,

     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1191, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,

     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,

     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190
    },

    {
       45, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186,-1187, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
    -1187, 1186, 1186,-1187, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,

     1186, 1186, 1186,-1187, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186,-1187, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,

     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186,
     1186, 1186, 1186, 1186, 1186, 1186
    },

    {
       45, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,

     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192,-1188, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1193, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,

     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,

     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192
    },

    {
       45, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188,-1189, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,

    -1189, 1188, 1188,-1189, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188,-1189, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188,-1189, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,

     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188, 1188,
     1188, 1188, 1188, 1188, 1188, 1188

    },

    {
       45, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1195, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,

     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,

     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194
    },

    {
       45, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190,-1191, 1190, 1190,

     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
    -1191, 1190, 1190,-1191, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190,-1191, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190,-1191, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,

     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,

     1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1190
    },

    {
       45, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196,-1192, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1197, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,

     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,

     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196
    },

    {
       45, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,

     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192,-1193, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
    -1193, 1192, 1192,-1193, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192,-1193, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192,-1193, 1192, 1192, 1192, 1192,

     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,

     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192, 1192,
     1192, 1192, 1192, 1192, 1192, 1192
    },

    {
       45, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,

     1199, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,

     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198

    },

    {
       45, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194,-1195, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
    -1195, 1194, 1194,-1195, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194,-1195, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,

     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194,-1195, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,

     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194
    },

    {
       45, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200,-1196, 1200, 1200, 1200, 1200,

     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1201, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,

     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,

     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200
    },

    {
       45, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196,-1197, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
    -1197, 1196, 1196,-1197, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,

     1196, 1196, 1196,-1197, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196,-1197, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,

     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196
    },

    {
       45, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,

     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1203, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,

     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,

     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202
    },

    {
       45, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198,-1199, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,

    -1199, 1198, 1198,-1199, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198,-1199, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198,-1199, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,

     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198, 1198,
     1198, 1198, 1198, 1198, 1198, 1198

    },

    {
       45, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204,-1200, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1205, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,

     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,

     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204
    },

    {
       45, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200,-1201, 1200, 1200,

     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
    -1201, 1200, 1200,-1201, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200,-1201, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200,-1201, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,

     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,

     1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200, 1200,
     1200, 1200, 1200, 1200, 1200, 1200
    },

    {
       45, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1207, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,

     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,

     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206
    },

    {
       45, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,

     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202,-1203, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
    -1203, 1202, 1202,-1203, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202,-1203, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202,-1203, 1202, 1202, 1202, 1202,

     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,

     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202, 1202,
     1202, 1202, 1202, 1202, 1202, 1202
    },

    {
       45, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208,-1204, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,

     1209, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,

     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208

    },

    {
       45, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204,-1205, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
    -1205, 1204, 1204,-1205, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204,-1205, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,

     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204,-1205, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,

     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204
    },

    {
       45, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,

     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1211, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,

     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,

     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210
    },

    {
       45, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206,-1207, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
    -1207, 1206, 1206,-1207, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,

     1206, 1206, 1206,-1207, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206,-1207, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,

     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206, 1206,
     1206, 1206, 1206, 1206, 1206, 1206
    },

    {
       45, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,

     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212,-1208, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1213, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,

     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,

     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212
    },

    {
       45, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208,-1209, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,

    -1209, 1208, 1208,-1209, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208,-1209, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208,-1209, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,

     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208, 1208,
     1208, 1208, 1208, 1208, 1208, 1208

    },

    {
       45, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1215, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,

     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,

     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214
    },

    {
       45, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210,-1211, 1210, 1210,

     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
    -1211, 1210, 1210,-1211, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210,-1211, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210,-1211, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,

     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,

     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210
    },

    {
       45, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216,-1212, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1217, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,

     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,

     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216
    },

    {
       45, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,

     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212,-1213, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
    -1213, 1212, 1212,-1213, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212,-1213, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212,-1213, 1212, 1212, 1212, 1212,

     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,

     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212
    },

    {
       45, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,

     1219, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,

     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218

    },

    {
       45, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214,-1215, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
    -1215, 1214, 1214,-1215, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214,-1215, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,

     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214,-1215, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,

     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214, 1214,
     1214, 1214, 1214, 1214, 1214, 1214
    },

    {
       45, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220,-1216, 1220, 1220, 1220, 1220,

     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1221, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,

     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,

     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220
    },

    {
       45, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216,-1217, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
    -1217, 1216, 1216,-1217, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,

     1216, 1216, 1216,-1217, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216,-1217, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,

     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216, 1216,
     1216, 1216, 1216, 1216, 1216, 1216
    },

    {
       45, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,

     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1223, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,

     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,

     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222
    },

    {
       45, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218,-1219, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,

    -1219, 1218, 1218,-1219, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218,-1219, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218,-1219, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,

     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218, 1218,
     1218, 1218, 1218, 1218, 1218, 1218

    },

    {
       45, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224,-1220, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1225, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,

     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,

     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224
    },

    {
       45, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220,-1221, 1220, 1220,

     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
    -1221, 1220, 1220,-1221, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220,-1221, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220,-1221, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,

     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,

     1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220, 1220,
     1220, 1220, 1220, 1220, 1220, 1220
    },

    {
       45, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1227, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,

     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,

     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226
    },

    {
       45, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,

     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222,-1223, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
    -1223, 1222, 1222,-1223, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222,-1223, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222,-1223, 1222, 1222, 1222, 1222,

     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,

     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222
    },

    {
       45, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228,-1224, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,

     1229, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,

     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228

    },

    {
       45, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224,-1225, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
    -1225, 1224, 1224,-1225, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224,-1225, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,

     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224,-1225, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,

     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 1224, 1224, 1224, 1224, 1224
    },

    {
       45, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,

     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1231, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,

     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,

     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230
    },

    {
       45, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226,-1227, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
    -1227, 1226, 1226,-1227, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,

     1226, 1226, 1226,-1227, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226,-1227, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,

     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226, 1226,
     1226, 1226, 1226, 1226, 1226, 1226
    },

    {
       45, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,

     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232,-1228, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1233, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,

     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,

     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232
    },

    {
       45, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228,-1229, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,

    -1229, 1228, 1228,-1229, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228,-1229, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228,-1229, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,

     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228, 1228,
     1228, 1228, 1228, 1228, 1228, 1228

    },

    {
       45, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1235, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,

     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,

     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234
    },

    {
       45, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230,-1231, 1230, 1230,

     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
    -1231, 1230, 1230,-1231, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230,-1231, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230,-1231, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,

     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,

     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230,
     1230, 1230, 1230, 1230, 1230, 1230
    },

    {
       45, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236,-1232, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1237, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,

     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,

     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236
    },

    {
       45, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,

     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232,-1233, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
    -1233, 1232, 1232,-1233, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232,-1233, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232,-1233, 1232, 1232, 1232, 1232,

     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,

     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232, 1232,
     1232, 1232, 1232, 1232, 1232, 1232
    },

    {
       45, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,

     1239, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,

     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238

    },

    {
       45, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234,-1235, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
    -1235, 1234, 1234,-1235, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234,-1235, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,

     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234,-1235, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,

     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
     1234, 1234, 1234, 1234, 1234, 1234
    },

    {
       45, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240,-1236, 1240, 1240, 1240, 1240,

     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1241, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,

     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,

     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240
    },

    {
       45, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236,-1237, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
    -1237, 1236, 1236,-1237, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,

     1236, 1236, 1236,-1237, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236,-1237, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,

     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236, 1236,
     1236, 1236, 1236, 1236, 1236, 1236
    },

    {
       45, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,

     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1243, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,

     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,

     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242
    },

    {
       45, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238,-1239, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,

    -1239, 1238, 1238,-1239, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238,-1239, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238,-1239, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,

     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238,
     1238, 1238, 1238, 1238, 1238, 1238

    },

    {
       45, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244,-1240, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1245, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,

     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,

     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244
    },

    {
       45, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240,-1241, 1240, 1240,

     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
    -1241, 1240, 1240,-1241, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240,-1241, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240,-1241, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,

     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,

     1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240, 1240,
     1240, 1240, 1240, 1240, 1240, 1240
    },

    {
       45, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1247, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,

     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,

     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246
    },

    {
       45, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,

     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242,-1243, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
    -1243, 1242, 1242,-1243, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242,-1243, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242,-1243, 1242, 1242, 1242, 1242,

     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,

     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242
    },

    {
       45, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248,-1244, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,

     1249, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,

     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248

    },

    {
       45, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244,-1245, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
    -1245, 1244, 1244,-1245, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244,-1245, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,

     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244,-1245, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,

     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244
    },

    {
       45, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,

     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1251, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,

     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,

     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250
    },

    {
       45, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246,-1247, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
    -1247, 1246, 1246,-1247, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,

     1246, 1246, 1246,-1247, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246,-1247, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,

     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246, 1246
    },

    {
       45, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,

     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252,-1248, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1253, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,

     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,

     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252
    },

    {
       45, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248,-1249, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,

    -1249, 1248, 1248,-1249, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248,-1249, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248,-1249, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,

     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248, 1248, 1248, 1248, 1248, 1248

    },

    {
       45, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1255, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,

     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,

     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254
    },

    {
       45, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250,-1251, 1250, 1250,

     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
    -1251, 1250, 1250,-1251, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250,-1251, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250,-1251, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,

     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,

     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250
    },

    {
       45, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256,-1252, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1257, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,

     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,

     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256
    },

    {
       45, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,

     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252,-1253, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
    -1253, 1252, 1252,-1253, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252,-1253, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252,-1253, 1252, 1252, 1252, 1252,

     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,

     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252, 1252,
     1252, 1252, 1252, 1252, 1252, 1252
    },

    {
       45, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,

     1259, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,

     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258

    },

    {
       45, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254,-1255, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
    -1255, 1254, 1254,-1255, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254,-1255, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,

     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254,-1255, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,

     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254, 1254,
     1254, 1254, 1254, 1254, 1254, 1254
    },

    {
       45, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260,-1256, 1260, 1260, 1260, 1260,

     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1261, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,

     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,

     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260
    },

    {
       45, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256,-1257, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
    -1257, 1256, 1256,-1257, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,

     1256, 1256, 1256,-1257, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256,-1257, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,

     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256
    },

    {
       45, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,

     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1263, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,

     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,

     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262
    },

    {
       45, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258,-1259, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,

    -1259, 1258, 1258,-1259, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258,-1259, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258,-1259, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,

     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258

    },

    {
       45, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264,-1260, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1265, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,

     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,

     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264
    },

    {
       45, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260,-1261, 1260, 1260,

     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
    -1261, 1260, 1260,-1261, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260,-1261, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260,-1261, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,

     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,

     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260
    },

    {
       45, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1267, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,

     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,

     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266
    },

    {
       45, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,

     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262,-1263, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
    -1263, 1262, 1262,-1263, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262,-1263, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262,-1263, 1262, 1262, 1262, 1262,

     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,

     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
     1262, 1262, 1262, 1262, 1262, 1262
    },

    {
       45, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268,-1264, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,

     1269, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,

     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268

    },

    {
       45, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264,-1265, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
    -1265, 1264, 1264,-1265, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264,-1265, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,

     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264,-1265, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,

     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264
    },

    {
       45, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,

     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1271, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,

     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,

     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270
    },

    {
       45, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266,-1267, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
    -1267, 1266, 1266,-1267, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,

     1266, 1266, 1266,-1267, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266,-1267, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,

     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266
    },

    {
       45, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,

     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272,-1268, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1273, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,

     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,

     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272
    },

    {
       45, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268,-1269, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,

    -1269, 1268, 1268,-1269, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268,-1269, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268,-1269, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,

     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
     1268, 1268, 1268, 1268, 1268, 1268

    },

    {
       45, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1275, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,

     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,

     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274
    },

    {
       45, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270,-1271, 1270, 1270,

     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
    -1271, 1270, 1270,-1271, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270,-1271, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270,-1271, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,

     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,

     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270
    },

    {
       45, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276,-1272, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1277, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,

     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,

     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276
    },

    {
       45, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,

     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272,-1273, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
    -1273, 1272, 1272,-1273, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272,-1273, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272,-1273, 1272, 1272, 1272, 1272,

     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,

     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272
    },

    {
       45, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,

     1279, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,

     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278

    },

    {
       45, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274,-1275, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
    -1275, 1274, 1274,-1275, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274,-1275, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,

     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274,-1275, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,

     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1274, 1274
    },

    {
       45, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280,-1276, 1280, 1280, 1280, 1280,

     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1281, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,

     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,

     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280
    },

    {
       45, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276,-1277, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
    -1277, 1276, 1276,-1277, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,

     1276, 1276, 1276,-1277, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276,-1277, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,

     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276
    },

    {
       45, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,

     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1283, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,

     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,

     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282
    },

    {
       45, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278,-1279, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,

    -1279, 1278, 1278,-1279, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278,-1279, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278,-1279, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,

     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278

    },

    {
       45, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284,-1280, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1285, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,

     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,

     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284
    },

    {
       45, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280,-1281, 1280, 1280,

     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
    -1281, 1280, 1280,-1281, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280,-1281, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280,-1281, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,

     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,

     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280
    },

    {
       45, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1287, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,

     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,

     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286
    },

    {
       45, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,

     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282,-1283, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
    -1283, 1282, 1282,-1283, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282,-1283, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282,-1283, 1282, 1282, 1282, 1282,

     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,

     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282
    },

    {
       45, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288,-1284, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,

     1289, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,

     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288

    },

    {
       45, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284,-1285, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
    -1285, 1284, 1284,-1285, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284,-1285, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,

     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284,-1285, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,

     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284
    },

    {
       45, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,

     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1291, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,

     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,

     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290
    },

    {
       45, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286,-1287, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
    -1287, 1286, 1286,-1287, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,

     1286, 1286, 1286,-1287, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286,-1287, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,

     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286
    },

    {
       45, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,

     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292,-1288, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1293, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,

     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,

     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292
    },

    {
       45, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288,-1289, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,

    -1289, 1288, 1288,-1289, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288,-1289, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288,-1289, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,

     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
     1288, 1288, 1288, 1288, 1288, 1288

    },

    {
       45, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1295, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,

     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,

     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294
    },

    {
       45, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290,-1291, 1290, 1290,

     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
    -1291, 1290, 1290,-1291, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290,-1291, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290,-1291, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,

     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,

     1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
     1290, 1290, 1290, 1290, 1290, 1290
    },

    {
       45, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296,-1292, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1297, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,

     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,

     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296
    },

    {
       45, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,

     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292,-1293, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
    -1293, 1292, 1292,-1293, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292,-1293, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292,-1293, 1292, 1292, 1292, 1292,

     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,

     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
     1292, 1292, 1292, 1292, 1292, 1292
    },

    {
       45, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,

     1299, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,

     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298

    },

    {
       45, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294,-1295, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
    -1295, 1294, 1294,-1295, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294,-1295, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,

     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294,-1295, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,

     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
     1294, 1294, 1294, 1294, 1294, 1294
    },

    {
       45, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300,-1296, 1300, 1300, 1300, 1300,

     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1301, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,

     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,

     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300
    },

    {
       45, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296,-1297, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
    -1297, 1296, 1296,-1297, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,

     1296, 1296, 1296,-1297, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296,-1297, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,

     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1296
    },

    {
       45, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,

     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1303, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,

     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,

     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302
    },

    {
       45, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298,-1299, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,

    -1299, 1298, 1298,-1299, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298,-1299, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298,-1299, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,

     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
     1298, 1298, 1298, 1298, 1298, 1298

    },

    {
       45, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304,-1300, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1305, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,

     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,

     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304
    },

    {
       45, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300,-1301, 1300, 1300,

     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
    -1301, 1300, 1300,-1301, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300,-1301, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300,-1301, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,

     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,

     1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
     1300, 1300, 1300, 1300, 1300, 1300
    },

    {
       45, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1307, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,

     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,

     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306
    },

    {
       45, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,

     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302,-1303, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
    -1303, 1302, 1302,-1303, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302,-1303, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302,-1303, 1302, 1302, 1302, 1302,

     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,

     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
     1302, 1302, 1302, 1302, 1302, 1302
    },

    {
       45, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308,-1304, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,

     1309, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,

     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308

    },

    {
       45, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304,-1305, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
    -1305, 1304, 1304,-1305, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304,-1305, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,

     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304,-1305, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,

     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304
    },

    {
       45, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,

     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1311, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,

     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,

     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310
    },

    {
       45, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306,-1307, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
    -1307, 1306, 1306,-1307, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,

     1306, 1306, 1306,-1307, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306,-1307, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,

     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1306, 1306
    },

    {
       45, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,

     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312,-1308, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1313, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,

     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,

     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312
    },

    {
       45, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308,-1309, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,

    -1309, 1308, 1308,-1309, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308,-1309, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308,-1309, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,

     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
     1308, 1308, 1308, 1308, 1308, 1308

    },

    {
       45, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1315, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,

     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,

     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314
    },

    {
       45, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310,-1311, 1310, 1310,

     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
    -1311, 1310, 1310,-1311, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310,-1311, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310,-1311, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,

     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,

     1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1310
    },

    {
       45, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316,-1312, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1317, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,

     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,

     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316
    },

    {
       45, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,

     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312,-1313, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
    -1313, 1312, 1312,-1313, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312,-1313, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312,-1313, 1312, 1312, 1312, 1312,

     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,

     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1312, 1312, 1312
    },

    {
       45, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,

     1319, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,

     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318

    },

    {
       45, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314,-1315, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
    -1315, 1314, 1314,-1315, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314,-1315, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,

     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314,-1315, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,

     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
     1314, 1314, 1314, 1314, 1314, 1314
    },

    {
       45, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320,-1316, 1320, 1320, 1320, 1320,

     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1321, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,

     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,

     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320
    },

    {
       45, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316,-1317, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
    -1317, 1316, 1316,-1317, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,

     1316, 1316, 1316,-1317, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316,-1317, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,

     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
     1316, 1316, 1316, 1316, 1316, 1316
    },

    {
       45, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,

     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1323, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,

     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,

     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322
    },

    {
       45, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318,-1319, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,

    -1319, 1318, 1318,-1319, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318,-1319, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318,-1319, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,

     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1318, 1318, 1318, 1318

    },

    {
       45, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324,-1320, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1325, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,

     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,

     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324
    },

    {
       45, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320,-1321, 1320, 1320,

     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
    -1321, 1320, 1320,-1321, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320,-1321, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320,-1321, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,

     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,

     1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
     1320, 1320, 1320, 1320, 1320, 1320
    },

    {
       45, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1327, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,

     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,

     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326
    },

    {
       45, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,

     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322,-1323, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
    -1323, 1322, 1322,-1323, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322,-1323, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322,-1323, 1322, 1322, 1322, 1322,

     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,

     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
     1322, 1322, 1322, 1322, 1322, 1322
    },

    {
       45, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328,-1324, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,

     1329, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,

     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328

    },

    {
       45, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324,-1325, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
    -1325, 1324, 1324,-1325, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324,-1325, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,

     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324,-1325, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,

     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
     1324, 1324, 1324, 1324, 1324, 1324
    },

    {
       45, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,

     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1331, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,

     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,

     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330
    },

    {
       45, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326,-1327, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
    -1327, 1326, 1326,-1327, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,

     1326, 1326, 1326,-1327, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326,-1327, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,

     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
     1326, 1326, 1326, 1326, 1326, 1326
    },

    {
       45, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,

     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332,-1328, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1333, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,

     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,

     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332
    },

    {
       45, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328,-1329, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,

    -1329, 1328, 1328,-1329, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328,-1329, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328,-1329, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,

     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1328, 1328

    },

    {
       45, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1335, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,

     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,

     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334
    },

    {
       45, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330,-1331, 1330, 1330,

     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
    -1331, 1330, 1330,-1331, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330,-1331, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330,-1331, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,

     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,

     1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
     1330, 1330, 1330, 1330, 1330, 1330
    },

    {
       45, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336,-1332, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1337, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,

     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,

     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336
    },

    {
       45, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,

     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332,-1333, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
    -1333, 1332, 1332,-1333, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332,-1333, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332,-1333, 1332, 1332, 1332, 1332,

     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,

     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1332
    },

    {
       45, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,

     1339, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,

     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338

    },

    {
       45, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334,-1335, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
    -1335, 1334, 1334,-1335, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334,-1335, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,

     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334,-1335, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,

     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1334
    },

    {
       45, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340,-1336, 1340, 1340, 1340, 1340,

     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1341, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,

     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,

     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340
    },

    {
       45, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336,-1337, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
    -1337, 1336, 1336,-1337, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,

     1336, 1336, 1336,-1337, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336,-1337, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,

     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336
    },

    {
       45, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,

     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1343, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,

     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,

     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342
    },

    {
       45, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338,-1339, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,

    -1339, 1338, 1338,-1339, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338,-1339, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338,-1339, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,

     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338, 1338,
     1338, 1338, 1338, 1338, 1338, 1338

    },

    {
       45, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344,-1340, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1345, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,

     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,

     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344
    },

    {
       45, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340,-1341, 1340, 1340,

     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
    -1341, 1340, 1340,-1341, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340,-1341, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340,-1341, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,

     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,

     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1340, 1340, 1340, 1340, 1340
    },

    {
       45, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1347, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,

     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,

     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346
    },

    {
       45, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,

     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342,-1343, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
    -1343, 1342, 1342,-1343, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342,-1343, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342,-1343, 1342, 1342, 1342, 1342,

     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,

     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342, 1342,
     1342, 1342, 1342, 1342, 1342, 1342
    },

    {
       45, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348,-1344, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,

     1349, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,

     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348

    },

    {
       45, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344,-1345, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
    -1345, 1344, 1344,-1345, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344,-1345, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,

     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344,-1345, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,

     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344
    },

    {
       45, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,

     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1351, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,

     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,

     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350
    },

    {
       45, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346,-1347, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
    -1347, 1346, 1346,-1347, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,

     1346, 1346, 1346,-1347, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346,-1347, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,

     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1346, 1346, 1346
    },

    {
       45, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,

     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352,-1348, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1353, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,

     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,

     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352
    },

    {
       45, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348,-1349, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,

    -1349, 1348, 1348,-1349, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348,-1349, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348,-1349, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,

     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348, 1348,
     1348, 1348, 1348, 1348, 1348, 1348

    },

    {
       45, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1355, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,

     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,

     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354
    },

    {
       45, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350,-1351, 1350, 1350,

     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
    -1351, 1350, 1350,-1351, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350,-1351, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350,-1351, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,

     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,

     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1350
    },

    {
       45, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356,-1352, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1357, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,

     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,

     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356
    },

    {
       45, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,

     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352,-1353, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
    -1353, 1352, 1352,-1353, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352,-1353, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352,-1353, 1352, 1352, 1352, 1352,

     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,

     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352, 1352,
     1352, 1352, 1352, 1352, 1352, 1352
    },

    {
       45, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,

     1359, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,

     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358

    },

    {
       45, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354,-1355, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
    -1355, 1354, 1354,-1355, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354,-1355, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,

     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354,-1355, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,

     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354
    },

    {
       45, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360,-1356, 1360, 1360, 1360, 1360,

     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1361, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,

     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,

     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360
    },

    {
       45, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356,-1357, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
    -1357, 1356, 1356,-1357, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,

     1356, 1356, 1356,-1357, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356,-1357, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,

     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356
    },

    {
       45, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,

     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1363, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,

     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,

     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362
    },

    {
       45, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358,-1359, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,

    -1359, 1358, 1358,-1359, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358,-1359, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358,-1359, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,

     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358

    },

    {
       45, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364,-1360, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1365, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,

     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,

     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364
    },

    {
       45, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360,-1361, 1360, 1360,

     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
    -1361, 1360, 1360,-1361, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360,-1361, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360,-1361, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,

     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,

     1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1360
    },

    {
       45, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1367, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,

     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,

     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366
    },

    {
       45, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,

     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362,-1363, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
    -1363, 1362, 1362,-1363, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362,-1363, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362,-1363, 1362, 1362, 1362, 1362,

     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,

     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362
    },

    {
       45, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368,-1364, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,

     1369, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,

     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368

    },

    {
       45, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364,-1365, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
    -1365, 1364, 1364,-1365, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364,-1365, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,

     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364,-1365, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,

     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364
    },

    {
       45, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,

     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1371, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,

     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,

     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370
    },

    {
       45, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366,-1367, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
    -1367, 1366, 1366,-1367, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,

     1366, 1366, 1366,-1367, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366,-1367, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,

     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
     1366, 1366, 1366, 1366, 1366, 1366
    },

    {
       45, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,

     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372,-1368, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1373, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,

     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,

     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372
    },

    {
       45, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368,-1369, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,

    -1369, 1368, 1368,-1369, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368,-1369, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368,-1369, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,

     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368

    },

    {
       45, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1375, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,

     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,

     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374
    },

    {
       45, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370,-1371, 1370, 1370,

     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
    -1371, 1370, 1370,-1371, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370,-1371, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370,-1371, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,

     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,

     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370
    },

    {
       45, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376,-1372, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1377, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,

     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,

     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376
    },

    {
       45, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,

     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372,-1373, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
    -1373, 1372, 1372,-1373, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372,-1373, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372,-1373, 1372, 1372, 1372, 1372,

     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,

     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1372, 1372, 1372, 1372
    },

    {
       45, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,

     1379, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,

     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378

    },

    {
       45, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374,-1375, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
    -1375, 1374, 1374,-1375, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374,-1375, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,

     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374,-1375, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,

     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374
    },

    {
       45, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380,-1376, 1380, 1380, 1380, 1380,

     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1381, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,

     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,

     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380
    },

    {
       45, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376,-1377, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
    -1377, 1376, 1376,-1377, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,

     1376, 1376, 1376,-1377, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376,-1377, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,

     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376
    },

    {
       45, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,

     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1383, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,

     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,

     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382
    },

    {
       45, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378,-1379, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,

    -1379, 1378, 1378,-1379, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378,-1379, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378,-1379, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,

     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
     1378, 1378, 1378, 1378, 1378, 1378

    },

    {
       45, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384,-1380, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1385, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,

     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,

     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384
    },

    {
       45, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380,-1381, 1380, 1380,

     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
    -1381, 1380, 1380,-1381, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380,-1381, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380,-1381, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,

     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,

     1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380, 1380,
     1380, 1380, 1380, 1380, 1380, 1380
    },

    {
       45, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1387, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,

     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,

     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386
    },

    {
       45, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,

     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382,-1383, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
    -1383, 1382, 1382,-1383, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382,-1383, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382,-1383, 1382, 1382, 1382, 1382,

     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,

     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382
    },

    {
       45, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388,-1384, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,

     1389, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,

     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388

    },

    {
       45, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384,-1385, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
    -1385, 1384, 1384,-1385, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384,-1385, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,

     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384,-1385, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,

     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
     1384, 1384, 1384, 1384, 1384, 1384
    },

    {
       45, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,

     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1391, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,

     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,

     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390
    },

    {
       45, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386,-1387, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
    -1387, 1386, 1386,-1387, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,

     1386, 1386, 1386,-1387, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386,-1387, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,

     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386
    },

    {
       45, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,

     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392,-1388, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1393, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,

     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,

     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392
    },

    {
       45, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388,-1389, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,

    -1389, 1388, 1388,-1389, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388,-1389, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388,-1389, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,

     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388

    },

    {
       45, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1395, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,

     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,

     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394
    },

    {
       45, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390,-1391, 1390, 1390,

     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
    -1391, 1390, 1390,-1391, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390,-1391, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390,-1391, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,

     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,

     1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
     1390, 1390, 1390, 1390, 1390, 1390
    },

    {
       45, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396,-1392, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1397, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,

     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,

     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396
    },

    {
       45, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,

     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392,-1393, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
    -1393, 1392, 1392,-1393, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392,-1393, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392,-1393, 1392, 1392, 1392, 1392,

     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,

     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392
    },

    {
       45, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,

     1399, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,

     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398

    },

    {
       45, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394,-1395, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
    -1395, 1394, 1394,-1395, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394,-1395, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,

     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394,-1395, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,

     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394
    },

    {
       45, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400,-1396, 1400, 1400, 1400, 1400,

     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1401, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,

     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,

     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400
    },

    {
       45, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396,-1397, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
    -1397, 1396, 1396,-1397, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,

     1396, 1396, 1396,-1397, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396,-1397, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,

     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
     1396, 1396, 1396, 1396, 1396, 1396
    },

    {
       45, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,

     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1403, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,

     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,

     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402
    },

    {
       45, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398,-1399, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,

    -1399, 1398, 1398,-1399, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398,-1399, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398,-1399, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,

     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398

    },

    {
       45, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404,-1400, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1405, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,

     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,

     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404
    },

    {
       45, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400,-1401, 1400, 1400,

     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
    -1401, 1400, 1400,-1401, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400,-1401, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400,-1401, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,

     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,

     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400
    },

    {
       45, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1407, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,

     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,

     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406
    },

    {
       45, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,

     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402,-1403, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
    -1403, 1402, 1402,-1403, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402,-1403, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402,-1403, 1402, 1402, 1402, 1402,

     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,

     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402
    },

    {
       45, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408,-1404, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,

     1409, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,

     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408

    },

    {
       45, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404,-1405, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
    -1405, 1404, 1404,-1405, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404,-1405, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,

     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404,-1405, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,

     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1404, 1404, 1404, 1404
    },

    {
       45, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,

     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1411, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,

     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,

     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410
    },

    {
       45, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406,-1407, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
    -1407, 1406, 1406,-1407, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,

     1406, 1406, 1406,-1407, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406,-1407, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,

     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406
    },

    {
       45, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,

     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412,-1408, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1413, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,

     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,

     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412
    },

    {
       45, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408,-1409, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,

    -1409, 1408, 1408,-1409, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408,-1409, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408,-1409, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,

     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1408, 1408, 1408, 1408, 1408

    },

    {
       45, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1415, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,

     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,

     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414
    },

    {
       45, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410,-1411, 1410, 1410,

     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
    -1411, 1410, 1410,-1411, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410,-1411, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410,-1411, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,

     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,

     1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410, 1410
    },

    {
       45, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416,-1412, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1417, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,

     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,

     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416
    },

    {
       45, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,

     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412,-1413, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
    -1413, 1412, 1412,-1413, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412,-1413, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412,-1413, 1412, 1412, 1412, 1412,

     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,

     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412
    },

    {
       45, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,

     1419, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,

     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418

    },

    {
       45, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414,-1415, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
    -1415, 1414, 1414,-1415, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414,-1415, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,

     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414,-1415, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,

     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414
    },

    {
       45, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420,-1416, 1420, 1420, 1420, 1420,

     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1421, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,

     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,

     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420
    },

    {
       45, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416,-1417, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
    -1417, 1416, 1416,-1417, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,

     1416, 1416, 1416,-1417, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416,-1417, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,

     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416
    },

    {
       45, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,

     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1423, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,

     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,

     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422
    },

    {
       45, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418,-1419, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,

    -1419, 1418, 1418,-1419, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418,-1419, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418,-1419, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,

     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418

    },

    {
       45, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424,-1420, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1425, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,

     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,

     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424
    },

    {
       45, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420,-1421, 1420, 1420,

     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
    -1421, 1420, 1420,-1421, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420,-1421, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420,-1421, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,

     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,

     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420
    },

    {
       45, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1427, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,

     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,

     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426
    },

    {
       45, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,

     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422,-1423, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
    -1423, 1422, 1422,-1423, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422,-1423, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422,-1423, 1422, 1422, 1422, 1422,

     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,

     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422
    },

    {
       45, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428,-1424, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,

     1429, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,

     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428

    },

    {
       45, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424,-1425, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
    -1425, 1424, 1424,-1425, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424,-1425, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,

     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424,-1425, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,

     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1424, 1424, 1424, 1424, 1424, 1424
    },

    {
       45, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,

     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1431, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,

     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,

     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430
    },

    {
       45, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426,-1427, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
    -1427, 1426, 1426,-1427, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,

     1426, 1426, 1426,-1427, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426,-1427, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,

     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1426, 1426, 1426
    },

    {
       45, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,

     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432,-1428, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1433, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,

     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,

     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432
    },

    {
       45, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428,-1429, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,

    -1429, 1428, 1428,-1429, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428,-1429, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428,-1429, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,

     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428

    },

    {
       45, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1435, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,

     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,

     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434
    },

    {
       45, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430,-1431, 1430, 1430,

     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
    -1431, 1430, 1430,-1431, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430,-1431, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430,-1431, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,

     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,

     1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1430, 1430
    },

    {
       45, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436,-1432, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1437, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,

     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,

     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436
    },

    {
       45, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,

     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432,-1433, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
    -1433, 1432, 1432,-1433, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432,-1433, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432,-1433, 1432, 1432, 1432, 1432,

     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,

     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432, 1432,
     1432, 1432, 1432, 1432, 1432, 1432
    },

    {
       45, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,

     1439, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,

     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438

    },

    {
       45, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434,-1435, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
    -1435, 1434, 1434,-1435, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434,-1435, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,

     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434,-1435, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,

     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434
    },

    {
       45, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440,-1436, 1440, 1440, 1440, 1440,

     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1441, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,

     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,

     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440
    },

    {
       45, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436,-1437, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
    -1437, 1436, 1436,-1437, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,

     1436, 1436, 1436,-1437, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436,-1437, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,

     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1436, 1436, 1436, 1436
    },

    {
       45, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,

     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1443, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,

     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,

     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442
    },

    {
       45, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438,-1439, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,

    -1439, 1438, 1438,-1439, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438,-1439, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438,-1439, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,

     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1438, 1438

    },

    {
       45, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444,-1440, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1445, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,

     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,

     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444
    },

    {
       45, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440,-1441, 1440, 1440,

     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
    -1441, 1440, 1440,-1441, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440,-1441, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440,-1441, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,

     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,

     1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440
    },

    {
       45, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1447, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,

     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,

     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446
    },

    {
       45, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,

     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442,-1443, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
    -1443, 1442, 1442,-1443, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442,-1443, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442,-1443, 1442, 1442, 1442, 1442,

     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,

     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442
    },

    {
       45, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448,-1444, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,

     1449, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,

     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448

    },

    {
       45, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444,-1445, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
    -1445, 1444, 1444,-1445, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444,-1445, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,

     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444,-1445, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,

     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1444, 1444, 1444, 1444, 1444, 1444
    },

    {
       45, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,

     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1451, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,

     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,

     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450
    },

    {
       45, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446,-1447, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
    -1447, 1446, 1446,-1447, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,

     1446, 1446, 1446,-1447, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446,-1447, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,

     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1446, 1446
    },

    {
       45, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,

     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452,-1448, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1453, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,

     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,

     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452
    },

    {
       45, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448,-1449, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,

    -1449, 1448, 1448,-1449, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448,-1449, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448,-1449, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,

     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
     1448, 1448, 1448, 1448, 1448, 1448

    },

    {
       45, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1455, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,

     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,

     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454
    },

    {
       45, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450,-1451, 1450, 1450,

     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
    -1451, 1450, 1450,-1451, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450,-1451, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450,-1451, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,

     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,

     1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1450,
     1450, 1450, 1450, 1450, 1450, 1450
    },

    {
       45, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456,-1452, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1457, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,

     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,

     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456
    },

    {
       45, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,

     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452,-1453, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
    -1453, 1452, 1452,-1453, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452,-1453, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452,-1453, 1452, 1452, 1452, 1452,

     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,

     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1452, 1452, 1452, 1452, 1452
    },

    {
       45, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,

     1459, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,

     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458

    },

    {
       45, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454,-1455, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
    -1455, 1454, 1454,-1455, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454,-1455, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,

     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454,-1455, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,

     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454
    },

    {
       45, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460,-1456, 1460, 1460, 1460, 1460,

     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1461, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,

     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,

     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460
    },

    {
       45, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456,-1457, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
    -1457, 1456, 1456,-1457, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,

     1456, 1456, 1456,-1457, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456,-1457, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,

     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456
    },

    {
       45, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,

     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1463, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,

     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,

     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462
    },

    {
       45, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458,-1459, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,

    -1459, 1458, 1458,-1459, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458,-1459, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458,-1459, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,

     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458

    },

    {
       45, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464,-1460, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1465, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,

     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,

     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464
    },

    {
       45, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460,-1461, 1460, 1460,

     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
    -1461, 1460, 1460,-1461, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460,-1461, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460,-1461, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,

     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,

     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460
    },

    {
       45, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1467, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,

     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,

     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466
    },

    {
       45, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,

     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462,-1463, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
    -1463, 1462, 1462,-1463, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462,-1463, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462,-1463, 1462, 1462, 1462, 1462,

     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,

     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1462, 1462
    },

    {
       45, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468,-1464, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,

     1469, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,

     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468

    },

    {
       45, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464,-1465, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
    -1465, 1464, 1464,-1465, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464,-1465, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,

     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464,-1465, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,

     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464
    },

    {
       45, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,

     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1471, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,

     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,

     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470
    },

    {
       45, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466,-1467, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
    -1467, 1466, 1466,-1467, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,

     1466, 1466, 1466,-1467, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466,-1467, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,

     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466
    },

    {
       45, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,

     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472,-1468, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1473, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,

     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,

     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472
    },

    {
       45, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468,-1469, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,

    -1469, 1468, 1468,-1469, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468,-1469, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468,-1469, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,

     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468

    },

    {
       45, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1475, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,

     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,

     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474
    },

    {
       45, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470,-1471, 1470, 1470,

     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
    -1471, 1470, 1470,-1471, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470,-1471, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470,-1471, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,

     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,

     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470
    },

    {
       45, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476,-1472, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1477, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,

     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,

     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476
    },

    {
       45, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,

     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472,-1473, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
    -1473, 1472, 1472,-1473, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472,-1473, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472,-1473, 1472, 1472, 1472, 1472,

     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,

     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472
    },

    {
       45, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,

     1479, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,

     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478

    },

    {
       45, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474,-1475, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
    -1475, 1474, 1474,-1475, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474,-1475, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,

     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474,-1475, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,

     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1474, 1474
    },

    {
       45, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480,-1476, 1480, 1480, 1480, 1480,

     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1481, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,

     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,

     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480
    },

    {
       45, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476,-1477, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
    -1477, 1476, 1476,-1477, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,

     1476, 1476, 1476,-1477, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476,-1477, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,

     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476
    },

    {
       45, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,

     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1483, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,

     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,

     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482
    },

    {
       45, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478,-1479, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,

    -1479, 1478, 1478,-1479, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478,-1479, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478,-1479, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,

     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478

    },

    {
       45, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484,-1480, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1485, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,

     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,

     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484
    },

    {
       45, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480,-1481, 1480, 1480,

     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
    -1481, 1480, 1480,-1481, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480,-1481, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480,-1481, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,

     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,

     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480
    },

    {
       45, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1487, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,

     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,

     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486
    },

    {
       45, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,

     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482,-1483, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
    -1483, 1482, 1482,-1483, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482,-1483, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482,-1483, 1482, 1482, 1482, 1482,

     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,

     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1482, 1482, 1482
    },

    {
       45, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488,-1484, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,

     1489, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,

     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488

    },

    {
       45, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484,-1485, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
    -1485, 1484, 1484,-1485, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484,-1485, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,

     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484,-1485, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,

     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484
    },

    {
       45, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,

     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1491, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,

     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,

     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490
    },

    {
       45, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486,-1487, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
    -1487, 1486, 1486,-1487, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,

     1486, 1486, 1486,-1487, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486,-1487, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,

     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1486
    },

    {
       45, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,

     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492,-1488, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1493, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,

     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,

     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492
    },

    {
       45, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488,-1489, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,

    -1489, 1488, 1488,-1489, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488,-1489, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488,-1489, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,

     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488

    },

    {
       45, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1495, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,

     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,

     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494
    },

    {
       45, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490,-1491, 1490, 1490,

     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
    -1491, 1490, 1490,-1491, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490,-1491, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490,-1491, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,

     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,

     1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1490, 1490
    },

    {
       45, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496,-1492, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1497, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,

     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,

     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496
    },

    {
       45, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,

     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492,-1493, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
    -1493, 1492, 1492,-1493, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492,-1493, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492,-1493, 1492, 1492, 1492, 1492,

     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,

     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492
    },

    {
       45, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,

     1499, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,

     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498

    },

    {
       45, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494,-1495, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
    -1495, 1494, 1494,-1495, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494,-1495, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,

     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494,-1495, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,

     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494
    },

    {
       45, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500,-1496, 1500, 1500, 1500, 1500,

     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1501, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,

     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,

     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500
    },

    {
       45, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496,-1497, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
    -1497, 1496, 1496,-1497, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,

     1496, 1496, 1496,-1497, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496,-1497, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,

     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496
    },

    {
       45, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,

     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1503, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,

     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,

     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502
    },

    {
       45, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498,-1499, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,

    -1499, 1498, 1498,-1499, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498,-1499, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498,-1499, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,

     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1498

    },

    {
       45, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504,-1500, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1505, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,

     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,

     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504
    },

    {
       45, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500,-1501, 1500, 1500,

     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
    -1501, 1500, 1500,-1501, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500,-1501, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500,-1501, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,

     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,

     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500
    },

    {
       45, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1507, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,

     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,

     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506
    },

    {
       45, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,

     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502,-1503, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
    -1503, 1502, 1502,-1503, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502,-1503, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502,-1503, 1502, 1502, 1502, 1502,

     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,

     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502
    },

    {
       45, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508,-1504, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,

     1509, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,

     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508

    },

    {
       45, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504,-1505, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
    -1505, 1504, 1504,-1505, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504,-1505, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,

     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504,-1505, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,

     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504
    },

    {
       45, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,

     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1511, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,

     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,

     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510
    },

    {
       45, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506,-1507, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
    -1507, 1506, 1506,-1507, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,

     1506, 1506, 1506,-1507, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506,-1507, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,

     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506
    },

    {
       45, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,

     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512,-1508, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1513, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,

     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,

     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512
    },

    {
       45, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508,-1509, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,

    -1509, 1508, 1508,-1509, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508,-1509, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508,-1509, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,

     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1508

    },

    {
       45, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1515, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,

     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,

     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514
    },

    {
       45, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510,-1511, 1510, 1510,

     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
    -1511, 1510, 1510,-1511, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510,-1511, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510,-1511, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,

     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,

     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510
    },

    {
       45, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516,-1512, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1517, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,

     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,

     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516
    },

    {
       45, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,

     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512,-1513, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
    -1513, 1512, 1512,-1513, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512,-1513, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512,-1513, 1512, 1512, 1512, 1512,

     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,

     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512
    },

    {
       45, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,

     1519, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,

     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518

    },

    {
       45, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514,-1515, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
    -1515, 1514, 1514,-1515, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514,-1515, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,

     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514,-1515, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,

     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514
    },

    {
       45, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520,-1516, 1520, 1520, 1520, 1520,

     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1521, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,

     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,

     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520
    },

    {
       45, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516,-1517, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
    -1517, 1516, 1516,-1517, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,

     1516, 1516, 1516,-1517, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516,-1517, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,

     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1516
    },

    {
       45, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,

     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1523, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,

     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,

     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522
    },

    {
       45, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518,-1519, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,

    -1519, 1518, 1518,-1519, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518,-1519, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518,-1519, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,

     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518, 1518,
     1518, 1518, 1518, 1518, 1518, 1518

    },

    {
       45, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524,-1520, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1525, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,

     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,

     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524
    },

    {
       45, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520,-1521, 1520, 1520,

     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
    -1521, 1520, 1520,-1521, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520,-1521, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520,-1521, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,

     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,

     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520
    },

    {
       45, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1527, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,

     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,

     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526
    },

    {
       45, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,

     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522,-1523, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
    -1523, 1522, 1522,-1523, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522,-1523, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522,-1523, 1522, 1522, 1522, 1522,

     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,

     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522
    },

    {
       45, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528,-1524, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,

     1529, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,

     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528

    },

    {
       45, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524,-1525, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
    -1525, 1524, 1524,-1525, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524,-1525, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,

     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524,-1525, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,

     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524
    },

    {
       45, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,

     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1531, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,

     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,

     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530
    },

    {
       45, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526,-1527, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
    -1527, 1526, 1526,-1527, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,

     1526, 1526, 1526,-1527, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526,-1527, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,

     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526
    },

    {
       45, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,

     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532,-1528, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1533, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,

     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,

     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532
    },

    {
       45, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528,-1529, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,

    -1529, 1528, 1528,-1529, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528,-1529, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528,-1529, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,

     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528

    },

    {
       45, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1535, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,

     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,

     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534
    },

    {
       45, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530,-1531, 1530, 1530,

     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
    -1531, 1530, 1530,-1531, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530,-1531, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530,-1531, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,

     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,

     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530
    },

    {
       45, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536,-1532, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1537, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,

     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,

     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536
    },

    {
       45, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,

     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532,-1533, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
    -1533, 1532, 1532,-1533, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532,-1533, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532,-1533, 1532, 1532, 1532, 1532,

     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,

     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532
    },

    {
       45, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,

     1539, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,

     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538

    },

    {
       45, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534,-1535, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
    -1535, 1534, 1534,-1535, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534,-1535, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,

     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534,-1535, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,

     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1534, 1534, 1534
    },

    {
       45, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540,-1536, 1540, 1540, 1540, 1540,

     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1541, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,

     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,

     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540
    },

    {
       45, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536,-1537, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
    -1537, 1536, 1536,-1537, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,

     1536, 1536, 1536,-1537, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536,-1537, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,

     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536
    },

    {
       45, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,

     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1543, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,

     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,

     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542
    },

    {
       45, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538,-1539, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,

    -1539, 1538, 1538,-1539, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538,-1539, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538,-1539, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,

     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538

    },

    {
       45, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544,-1540, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1545, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,

     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,

     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544
    },

    {
       45, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540,-1541, 1540, 1540,

     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
    -1541, 1540, 1540,-1541, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540,-1541, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540,-1541, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,

     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,

     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540
    },

    {
       45, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1547, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,

     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,

     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546
    },

    {
       45, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,

     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542,-1543, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
    -1543, 1542, 1542,-1543, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542,-1543, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542,-1543, 1542, 1542, 1542, 1542,

     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,

     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1542, 1542, 1542, 1542, 1542
    },

    {
       45, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548,-1544, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,

     1549, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,

     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548

    },

    {
       45, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544,-1545, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
    -1545, 1544, 1544,-1545, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544,-1545, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,

     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544,-1545, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,

     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1544, 1544, 1544
    },

    {
       45, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,

     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1551, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,

     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,

     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550
    },

    {
       45, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546,-1547, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
    -1547, 1546, 1546,-1547, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,

     1546, 1546, 1546,-1547, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546,-1547, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,

     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546
    },

    {
       45, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,

     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552,-1548, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1553, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,

     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,

     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552
    },

    {
       45, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548,-1549, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,

    -1549, 1548, 1548,-1549, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548,-1549, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548,-1549, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,

     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548

    },

    {
       45, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1555, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,

     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,

     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554
    },

    {
       45, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550,-1551, 1550, 1550,

     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
    -1551, 1550, 1550,-1551, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550,-1551, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550,-1551, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,

     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,

     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550
    },

    {
       45, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556,-1552, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1557, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,

     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,

     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556
    },

    {
       45, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,

     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552,-1553, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
    -1553, 1552, 1552,-1553, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552,-1553, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552,-1553, 1552, 1552, 1552, 1552,

     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,

     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552
    },

    {
       45, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,

     1559, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,

     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558

    },

    {
       45, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554,-1555, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
    -1555, 1554, 1554,-1555, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554,-1555, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,

     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554,-1555, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,

     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554
    },

    {
       45, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560,-1556, 1560, 1560, 1560, 1560,

     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1561, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,

     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,

     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560
    },

    {
       45, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556,-1557, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
    -1557, 1556, 1556,-1557, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,

     1556, 1556, 1556,-1557, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556,-1557, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,

     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556
    },

    {
       45, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,

     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1563, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,

     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,

     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562
    },

    {
       45, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558,-1559, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,

    -1559, 1558, 1558,-1559, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558,-1559, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558,-1559, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,

     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558

    },

    {
       45, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564,-1560, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1565, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,

     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,

     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564
    },

    {
       45, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560,-1561, 1560, 1560,

     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
    -1561, 1560, 1560,-1561, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560,-1561, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560,-1561, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,

     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,

     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1560, 1560, 1560, 1560, 1560
    },

    {
       45, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1567, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,

     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,

     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566
    },

    {
       45, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,

     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562,-1563, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
    -1563, 1562, 1562,-1563, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562,-1563, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562,-1563, 1562, 1562, 1562, 1562,

     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,

     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1562, 1562, 1562
    },

    {
       45, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568,-1564, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,

     1569, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,

     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568

    },

    {
       45, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564,-1565, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
    -1565, 1564, 1564,-1565, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564,-1565, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,

     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564,-1565, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,

     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1564
    },

    {
       45, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,

     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1571, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,

     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,

     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570
    },

    {
       45, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566,-1567, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
    -1567, 1566, 1566,-1567, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,

     1566, 1566, 1566,-1567, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566,-1567, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,

     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566
    },

    {
       45, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,

     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572,-1568, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1573, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,

     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,

     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572
    },

    {
       45, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568,-1569, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,

    -1569, 1568, 1568,-1569, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568,-1569, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568,-1569, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,

     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568

    },

    {
       45, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1575, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,

     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,

     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574
    },

    {
       45, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570,-1571, 1570, 1570,

     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
    -1571, 1570, 1570,-1571, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570,-1571, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570,-1571, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,

     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,

     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570
    },

    {
       45, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576,-1572, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1577, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,

     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,

     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576
    },

    {
       45, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,

     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572,-1573, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
    -1573, 1572, 1572,-1573, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572,-1573, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572,-1573, 1572, 1572, 1572, 1572,

     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,

     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572
    },

    {
       45, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,

     1579, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,

     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578

    },

    {
       45, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574,-1575, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
    -1575, 1574, 1574,-1575, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574,-1575, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,

     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574,-1575, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,

     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574
    },

    {
       45, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580,-1576, 1580, 1580, 1580, 1580,

     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1581, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,

     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,

     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580
    },

    {
       45, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576,-1577, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
    -1577, 1576, 1576,-1577, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,

     1576, 1576, 1576,-1577, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576,-1577, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,

     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576
    },

    {
       45, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,

     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1583, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,

     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,

     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582
    },

    {
       45, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578,-1579, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,

    -1579, 1578, 1578,-1579, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578,-1579, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578,-1579, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,

     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1578

    },

    {
       45, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584,-1580, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1585, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,

     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,

     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584
    },

    {
       45, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580,-1581, 1580, 1580,

     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
    -1581, 1580, 1580,-1581, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580,-1581, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580,-1581, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,

     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,

     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580
    },

    {
       45, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1587, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,

     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,

     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586
    },

    {
       45, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,

     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582,-1583, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
    -1583, 1582, 1582,-1583, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582,-1583, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582,-1583, 1582, 1582, 1582, 1582,

     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,

     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582
    },

    {
       45, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588,-1584, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,

     1589, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,

     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588

    },

    {
       45, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584,-1585, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
    -1585, 1584, 1584,-1585, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584,-1585, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,

     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584,-1585, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,

     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584
    },

    {
       45, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,

     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1591, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,

     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,

     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590
    },

    {
       45, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586,-1587, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
    -1587, 1586, 1586,-1587, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,

     1586, 1586, 1586,-1587, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586,-1587, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,

     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586
    },

    {
       45, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,

     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592,-1588, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1593, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,

     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,

     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592
    },

    {
       45, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588,-1589, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,

    -1589, 1588, 1588,-1589, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588,-1589, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588,-1589, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,

     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1588

    },

    {
       45, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1595, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,

     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,

     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594
    },

    {
       45, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590,-1591, 1590, 1590,

     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
    -1591, 1590, 1590,-1591, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590,-1591, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590,-1591, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,

     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,

     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1590, 1590, 1590, 1590
    },

    {
       45, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596,-1592, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1597, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,

     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,

     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596
    },

    {
       45, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,

     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592,-1593, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
    -1593, 1592, 1592,-1593, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592,-1593, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592,-1593, 1592, 1592, 1592, 1592,

     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,

     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1592, 1592
    },

    {
       45, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,

     1599, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,

     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598

    },

    {
       45, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594,-1595, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
    -1595, 1594, 1594,-1595, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594,-1595, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,

     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594,-1595, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,

     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594
    },

    {
       45, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600,-1596, 1600, 1600, 1600, 1600,

     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1601, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,

     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,

     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600
    },

    {
       45, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596,-1597, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
    -1597, 1596, 1596,-1597, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,

     1596, 1596, 1596,-1597, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596,-1597, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,

     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1596, 1596, 1596
    },

    {
       45, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,

     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1603, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,

     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,

     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602
    },

    {
       45, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598,-1599, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,

    -1599, 1598, 1598,-1599, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598,-1599, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598,-1599, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,

     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1598

    },

    {
       45, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604,-1600, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1605, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,

     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,

     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604
    },

    {
       45, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600,-1601, 1600, 1600,

     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
    -1601, 1600, 1600,-1601, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600,-1601, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600,-1601, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,

     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,

     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600
    },

    {
       45, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1607, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,

     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,

     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606
    },

    {
       45, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,

     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602,-1603, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
    -1603, 1602, 1602,-1603, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602,-1603, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602,-1603, 1602, 1602, 1602, 1602,

     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,

     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602
    },

    {
       45, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608,-1604, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,

     1609, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,

     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608

    },

    {
       45, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604,-1605, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
    -1605, 1604, 1604,-1605, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604,-1605, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,

     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604,-1605, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,

     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1604
    },

    {
       45, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,

     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1611, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,

     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,

     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610
    },

    {
       45, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606,-1607, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
    -1607, 1606, 1606,-1607, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,

     1606, 1606, 1606,-1607, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606,-1607, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,

     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606
    },

    {
       45, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,

     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612,-1608, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1613, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,

     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,

     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612
    },

    {
       45, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608,-1609, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,

    -1609, 1608, 1608,-1609, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608,-1609, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608,-1609, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,

     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1608

    },

    {
       45, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1615, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,

     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,

     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614
    },

    {
       45, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610,-1611, 1610, 1610,

     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
    -1611, 1610, 1610,-1611, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610,-1611, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610,-1611, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,

     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,

     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610
    },

    {
       45, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616,-1612, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1617, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,

     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,

     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616
    },

    {
       45, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,

     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612,-1613, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
    -1613, 1612, 1612,-1613, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612,-1613, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612,-1613, 1612, 1612, 1612, 1612,

     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,

     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612
    },

    {
       45, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,

     1619, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,

     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618

    },

    {
       45, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614,-1615, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
    -1615, 1614, 1614,-1615, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614,-1615, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,

     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614,-1615, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,

     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1614, 1614
    },

    {
       45, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620,-1616, 1620, 1620, 1620, 1620,

     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1621, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,

     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,

     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620
    },

    {
       45, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616,-1617, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
    -1617, 1616, 1616,-1617, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,

     1616, 1616, 1616,-1617, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616,-1617, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,

     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616
    },

    {
       45, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,

     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1623, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,

     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,

     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622
    },

    {
       45, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618,-1619, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,

    -1619, 1618, 1618,-1619, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618,-1619, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618,-1619, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,

     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1618, 1618, 1618, 1618

    },

    {
       45, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624,-1620, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1625, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,

     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,

     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624
    },

    {
       45, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620,-1621, 1620, 1620,

     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
    -1621, 1620, 1620,-1621, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620,-1621, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620,-1621, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,

     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,

     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620
    },

    {
       45, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1627, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,

     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,

     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626
    },

    {
       45, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,

     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622,-1623, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
    -1623, 1622, 1622,-1623, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622,-1623, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622,-1623, 1622, 1622, 1622, 1622,

     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,

     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622
    },

    {
       45, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628,-1624, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,

     1629, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,

     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628

    },

    {
       45, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624,-1625, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
    -1625, 1624, 1624,-1625, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624,-1625, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,

     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624,-1625, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,

     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1624, 1624, 1624
    },

    {
       45, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,

     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1631, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,

     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,

     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630
    },

    {
       45, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626,-1627, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
    -1627, 1626, 1626,-1627, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,

     1626, 1626, 1626,-1627, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626,-1627, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,

     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1626
    },

    {
       45, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,

     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632,-1628, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1633, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,

     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,

     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632
    },

    {
       45, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628,-1629, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,

    -1629, 1628, 1628,-1629, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628,-1629, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628,-1629, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,

     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1628

    },

    {
       45, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1635, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,

     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,

     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634
    },

    {
       45, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630,-1631, 1630, 1630,

     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
    -1631, 1630, 1630,-1631, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630,-1631, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630,-1631, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,

     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,

     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1630, 1630
    },

    {
       45, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636,-1632, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1637, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,

     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,

     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636
    },

    {
       45, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,

     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632,-1633, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
    -1633, 1632, 1632,-1633, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632,-1633, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632,-1633, 1632, 1632, 1632, 1632,

     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,

     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632
    },

    {
       45, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,

     1639, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,

     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638

    },

    {
       45, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634,-1635, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
    -1635, 1634, 1634,-1635, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634,-1635, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,

     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634,-1635, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,

     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634
    },

    {
       45, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640,-1636, 1640, 1640, 1640, 1640,

     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1641, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,

     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,

     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640
    },

    {
       45, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636,-1637, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
    -1637, 1636, 1636,-1637, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,

     1636, 1636, 1636,-1637, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636,-1637, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,

     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636
    },

    {
       45, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,

     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1643, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,

     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,

     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642
    },

    {
       45, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638,-1639, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,

    -1639, 1638, 1638,-1639, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638,-1639, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638,-1639, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,

     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1638

    },

    {
       45, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644,-1640, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1645, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,

     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,

     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644
    },

    {
       45, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640,-1641, 1640, 1640,

     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
    -1641, 1640, 1640,-1641, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640,-1641, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640,-1641, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,

     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,

     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640
    },

    {
       45, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1647, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,

     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,

     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646
    },

    {
       45, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,

     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642,-1643, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
    -1643, 1642, 1642,-1643, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642,-1643, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642,-1643, 1642, 1642, 1642, 1642,

     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,

     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642
    },

    {
       45, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648,-1644, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,

     1649, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,

     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648

    },

    {
       45, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644,-1645, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
    -1645, 1644, 1644,-1645, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644,-1645, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,

     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644,-1645, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,

     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644
    },

    {
       45, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,

     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1651, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,

     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,

     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650
    },

    {
       45, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646,-1647, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
    -1647, 1646, 1646,-1647, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,

     1646, 1646, 1646,-1647, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646,-1647, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,

     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646
    },

    {
       45, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,

     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652,-1648, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1653, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,

     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,

     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652
    },

    {
       45, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648,-1649, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,

    -1649, 1648, 1648,-1649, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648,-1649, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648,-1649, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,

     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1648

    },

    {
       45, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1655, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,

     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,

     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654
    },

    {
       45, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650,-1651, 1650, 1650,

     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
    -1651, 1650, 1650,-1651, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650,-1651, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650,-1651, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,

     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,

     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650
    },

    {
       45, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656,-1652, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1657, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,

     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,

     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656
    },

    {
       45, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,

     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652,-1653, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
    -1653, 1652, 1652,-1653, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652,-1653, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652,-1653, 1652, 1652, 1652, 1652,

     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,

     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652
    },

    {
       45, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,

     1659, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,

     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658

    },

    {
       45, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654,-1655, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
    -1655, 1654, 1654,-1655, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654,-1655, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,

     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654,-1655, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,

     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654
    },

    {
       45, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660,-1656, 1660, 1660, 1660, 1660,

     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1661, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,

     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,

     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660
    },

    {
       45, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656,-1657, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
    -1657, 1656, 1656,-1657, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,

     1656, 1656, 1656,-1657, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656,-1657, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,

     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656
    },

    {
       45, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,

     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1663, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,

     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,

     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662
    },

    {
       45, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658,-1659, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,

    -1659, 1658, 1658,-1659, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658,-1659, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658,-1659, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,

     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658

    },

    {
       45, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664,-1660, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1665, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,

     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,

     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664
    },

    {
       45, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660,-1661, 1660, 1660,

     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
    -1661, 1660, 1660,-1661, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660,-1661, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660,-1661, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,

     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,

     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1660, 1660
    },

    {
       45, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1667, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,

     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,

     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666
    },

    {
       45, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,

     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662,-1663, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
    -1663, 1662, 1662,-1663, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662,-1663, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662,-1663, 1662, 1662, 1662, 1662,

     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,

     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662
    },

    {
       45, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668,-1664, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,

     1669, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,

     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668

    },

    {
       45, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664,-1665, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
    -1665, 1664, 1664,-1665, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664,-1665, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,

     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664,-1665, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,

     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1664, 1664, 1664
    },

    {
       45, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,

     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1671, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,

     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,

     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670
    },

    {
       45, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666,-1667, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
    -1667, 1666, 1666,-1667, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,

     1666, 1666, 1666,-1667, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666,-1667, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,

     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1666
    },

    {
       45, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,

     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672,-1668, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1673, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,

     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,

     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672
    },

    {
       45, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668,-1669, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,

    -1669, 1668, 1668,-1669, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668,-1669, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668,-1669, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,

     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1668

    },

    {
       45, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1675, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,

     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,

     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674
    },

    {
       45, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670,-1671, 1670, 1670,

     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
    -1671, 1670, 1670,-1671, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670,-1671, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670,-1671, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,

     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,

     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1670, 1670
    },

    {
       45, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676,-1672, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1677, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,

     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,

     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676
    },

    {
       45, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,

     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672,-1673, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
    -1673, 1672, 1672,-1673, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672,-1673, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672,-1673, 1672, 1672, 1672, 1672,

     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,

     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672
    },

    {
       45, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,

     1679, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,

     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678

    },

    {
       45, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674,-1675, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
    -1675, 1674, 1674,-1675, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674,-1675, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,

     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674,-1675, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,

     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1674, 1674, 1674
    },

    {
       45, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680,-1676, 1680, 1680, 1680, 1680,

     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1681, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,

     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,

     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680
    },

    {
       45, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676,-1677, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
    -1677, 1676, 1676,-1677, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,

     1676, 1676, 1676,-1677, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676,-1677, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,

     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1676
    },

    {
       45, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,

     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1683, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,

     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,

     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682
    },

    {
       45, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678,-1679, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,

    -1679, 1678, 1678,-1679, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678,-1679, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678,-1679, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,

     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678

    },

    {
       45, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684,-1680, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1685, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,

     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,

     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684
    },

    {
       45, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680,-1681, 1680, 1680,

     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
    -1681, 1680, 1680,-1681, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680,-1681, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680,-1681, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,

     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,

     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1680, 1680
    },

    {
       45, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1687, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,

     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,

     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686
    },

    {
       45, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,

     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682,-1683, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
    -1683, 1682, 1682,-1683, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682,-1683, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682,-1683, 1682, 1682, 1682, 1682,

     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,

     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682
    },

    {
       45, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688,-1684, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,

     1689, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,

     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688

    },

    {
       45, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684,-1685, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
    -1685, 1684, 1684,-1685, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684,-1685, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,

     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684,-1685, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,

     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1684, 1684, 1684, 1684, 1684
    },

    {
       45, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,

     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1691, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,

     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,

     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690
    },

    {
       45, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686,-1687, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
    -1687, 1686, 1686,-1687, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,

     1686, 1686, 1686,-1687, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686,-1687, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,

     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1686
    },

    {
       45, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,

     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692,-1688, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1693, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,

     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,

     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692
    },

    {
       45, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688,-1689, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,

    -1689, 1688, 1688,-1689, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688,-1689, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688,-1689, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,

     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1688

    },

    {
       45, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1695, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,

     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,

     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694
    },

    {
       45, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690,-1691, 1690, 1690,

     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
    -1691, 1690, 1690,-1691, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690,-1691, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690,-1691, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,

     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,

     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690
    },

    {
       45, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696,-1692, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1697, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,

     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,

     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696
    },

    {
       45, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,

     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692,-1693, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
    -1693, 1692, 1692,-1693, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692,-1693, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692,-1693, 1692, 1692, 1692, 1692,

     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,

     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692
    },

    {
       45, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,

     1699, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,

     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698

    },

    {
       45, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694,-1695, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
    -1695, 1694, 1694,-1695, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694,-1695, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,

     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694,-1695, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,

     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1694, 1694
    },

    {
       45, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700,-1696, 1700, 1700, 1700, 1700,

     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1701, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,

     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,

     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700
    },

    {
       45, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696,-1697, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
    -1697, 1696, 1696,-1697, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,

     1696, 1696, 1696,-1697, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696,-1697, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,

     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1696
    },

    {
       45, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,

     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1703, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,

     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,

     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702
    },

    {
       45, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698,-1699, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,

    -1699, 1698, 1698,-1699, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698,-1699, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698,-1699, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,

     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1698

    },

    {
       45, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704,-1700, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1705, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,

     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,

     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704
    },

    {
       45, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700,-1701, 1700, 1700,

     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
    -1701, 1700, 1700,-1701, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700,-1701, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700,-1701, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,

     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,

     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1700, 1700
    },

    {
       45, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1707, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,

     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,

     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706
    },

    {
       45, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,

     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702,-1703, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
    -1703, 1702, 1702,-1703, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702,-1703, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702,-1703, 1702, 1702, 1702, 1702,

     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,

     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702
    },

    {
       45, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708,-1704, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,

     1709, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,

     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708

    },

    {
       45, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704,-1705, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
    -1705, 1704, 1704,-1705, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704,-1705, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,

     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704,-1705, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,

     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1704, 1704
    },

    {
       45, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,

     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1711, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,

     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,

     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710
    },

    {
       45, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706,-1707, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
    -1707, 1706, 1706,-1707, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,

     1706, 1706, 1706,-1707, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706,-1707, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,

     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1706
    },

    {
       45, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,

     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712,-1708, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1713, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,

     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,

     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712
    },

    {
       45, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708,-1709, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,

    -1709, 1708, 1708,-1709, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708,-1709, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708,-1709, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,

     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708

    },

    {
       45, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1715, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,

     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,

     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714
    },

    {
       45, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710,-1711, 1710, 1710,

     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
    -1711, 1710, 1710,-1711, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710,-1711, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710,-1711, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,

     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,

     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710
    },

    {
       45, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716,-1712, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1717, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,

     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,

     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716
    },

    {
       45, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,

     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712,-1713, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
    -1713, 1712, 1712,-1713, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712,-1713, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712,-1713, 1712, 1712, 1712, 1712,

     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,

     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712
    },

    {
       45, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,

     1719, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,

     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718

    },

    {
       45, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714,-1715, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
    -1715, 1714, 1714,-1715, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714,-1715, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,

     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714,-1715, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,

     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1714
    },

    {
       45, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720,-1716, 1720, 1720, 1720, 1720,

     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1721, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,

     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,

     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720
    },

    {
       45, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716,-1717, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
    -1717, 1716, 1716,-1717, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,

     1716, 1716, 1716,-1717, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716,-1717, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,

     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1716
    },

    {
       45, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,

     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1723, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,

     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,

     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722
    },

    {
       45, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718,-1719, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,

    -1719, 1718, 1718,-1719, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718,-1719, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718,-1719, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,

     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718

    },

    {
       45, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724,-1720, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1725, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,

     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,

     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724
    },

    {
       45, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720,-1721, 1720, 1720,

     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
    -1721, 1720, 1720,-1721, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720,-1721, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720,-1721, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,

     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,

     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720
    },

    {
       45, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1727, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,

     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,

     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726
    },

    {
       45, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,

     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722,-1723, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
    -1723, 1722, 1722,-1723, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722,-1723, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722,-1723, 1722, 1722, 1722, 1722,

     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,

     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1722
    },

    {
       45, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728,-1724, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,

     1729, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,

     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728

    },

    {
       45, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724,-1725, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
    -1725, 1724, 1724,-1725, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724,-1725, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,

     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724,-1725, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,

     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724
    },

    {
       45, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,

     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1731, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,

     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,

     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730
    },

    {
       45, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726,-1727, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
    -1727, 1726, 1726,-1727, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,

     1726, 1726, 1726,-1727, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726,-1727, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,

     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726
    },

    {
       45, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,

     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732,-1728, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1733, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,

     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,

     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732
    },

    {
       45, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728,-1729, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,

    -1729, 1728, 1728,-1729, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728,-1729, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728,-1729, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,

     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728

    },

    {
       45, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1735, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,

     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,

     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734
    },

    {
       45, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730,-1731, 1730, 1730,

     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
    -1731, 1730, 1730,-1731, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730,-1731, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730,-1731, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,

     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,

     1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1730, 1730, 1730, 1730, 1730, 1730
    },

    {
       45, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736,-1732, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1737, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,

     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,

     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736
    },

    {
       45, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,

     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732,-1733, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
    -1733, 1732, 1732,-1733, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732,-1733, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732,-1733, 1732, 1732, 1732, 1732,

     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,

     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1732, 1732, 1732, 1732
    },

    {
       45, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,

     1739, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,

     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738

    },

    {
       45, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734,-1735, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
    -1735, 1734, 1734,-1735, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734,-1735, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,

     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734,-1735, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,

     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734
    },

    {
       45, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740,-1736, 1740, 1740, 1740, 1740,

     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1741, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,

     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,

     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740
    },

    {
       45, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736,-1737, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
    -1737, 1736, 1736,-1737, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,

     1736, 1736, 1736,-1737, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736,-1737, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,

     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736
    },

    {
       45, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,

     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1743, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,

     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,

     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742
    },

    {
       45, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738,-1739, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,

    -1739, 1738, 1738,-1739, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738,-1739, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738,-1739, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,

     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738

    },

    {
       45, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744,-1740, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1745, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,

     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,

     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744
    },

    {
       45, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740,-1741, 1740, 1740,

     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
    -1741, 1740, 1740,-1741, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740,-1741, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740,-1741, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,

     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,

     1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1740
    },

    {
       45, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1747, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,

     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,

     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746
    },

    {
       45, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,

     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742,-1743, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
    -1743, 1742, 1742,-1743, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742,-1743, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742,-1743, 1742, 1742, 1742, 1742,

     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,

     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1742, 1742, 1742, 1742
    },

    {
       45, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748,-1744, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,

     1749, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,

     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748

    },

    {
       45, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744,-1745, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
    -1745, 1744, 1744,-1745, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744,-1745, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,

     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744,-1745, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,

     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1744, 1744
    },

    {
       45, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,

     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1751, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,

     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,

     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750
    },

    {
       45, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746,-1747, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
    -1747, 1746, 1746,-1747, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,

     1746, 1746, 1746,-1747, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746,-1747, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,

     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746
    },

    {
       45, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,

     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752,-1748, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1753, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,

     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,

     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752
    },

    {
       45, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748,-1749, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,

    -1749, 1748, 1748,-1749, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748,-1749, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748,-1749, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,

     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748

    },

    {
       45, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1755, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,

     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,

     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754
    },

    {
       45, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750,-1751, 1750, 1750,

     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
    -1751, 1750, 1750,-1751, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750,-1751, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750,-1751, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,

     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,

     1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1750, 1750, 1750, 1750
    },

    {
       45, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756,-1752, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1757, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,

     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,

     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756
    },

    {
       45, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,

     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752,-1753, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
    -1753, 1752, 1752,-1753, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752,-1753, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752,-1753, 1752, 1752, 1752, 1752,

     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,

     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1752, 1752, 1752, 1752
    },

    {
       45, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,

     1759, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,

     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758

    },

    {
       45, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754,-1755, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
    -1755, 1754, 1754,-1755, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754,-1755, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,

     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754,-1755, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,

     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1754, 1754
    },

    {
       45, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760,-1756, 1760, 1760, 1760, 1760,

     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1761, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,

     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,

     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760
    },

    {
       45, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756,-1757, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
    -1757, 1756, 1756,-1757, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,

     1756, 1756, 1756,-1757, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756,-1757, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,

     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756
    },

    {
       45, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,

     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1763, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,

     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,

     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762
    },

    {
       45, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758,-1759, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,

    -1759, 1758, 1758,-1759, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758,-1759, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758,-1759, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,

     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758,
     1758, 1758, 1758, 1758, 1758, 1758

    },

    {
       45, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764,-1760, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1765, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,

     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,

     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764
    },

    {
       45, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760,-1761, 1760, 1760,

     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
    -1761, 1760, 1760,-1761, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760,-1761, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760,-1761, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,

     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,

     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1760, 1760, 1760, 1760, 1760, 1760
    },

    {
       45, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1767, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,

     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,

     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766
    },

    {
       45, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,

     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762,-1763, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
    -1763, 1762, 1762,-1763, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762,-1763, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762,-1763, 1762, 1762, 1762, 1762,

     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,

     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1762, 1762
    },

    {
       45, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768,-1764, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,

     1769, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,

     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768

    },

    {
       45, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764,-1765, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
    -1765, 1764, 1764,-1765, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764,-1765, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,

     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764,-1765, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,

     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764
    },

    {
       45, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,

     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1771, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,

     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,

     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770
    },

    {
       45, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766,-1767, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
    -1767, 1766, 1766,-1767, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,

     1766, 1766, 1766,-1767, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766,-1767, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,

     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766
    },

    {
       45, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,

     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772,-1768, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1773, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,

     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,

     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772
    },

    {
       45, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768,-1769, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,

    -1769, 1768, 1768,-1769, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768,-1769, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768,-1769, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,

     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1768, 1768, 1768

    },

    {
       45, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1775, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,

     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,

     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774
    },

    {
       45, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770,-1771, 1770, 1770,

     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
    -1771, 1770, 1770,-1771, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770,-1771, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770,-1771, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,

     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,

     1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1770, 1770, 1770, 1770
    },

    {
       45, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776,-1772, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1777, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,

     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,

     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776
    },

    {
       45, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,

     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772,-1773, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
    -1773, 1772, 1772,-1773, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772,-1773, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772,-1773, 1772, 1772, 1772, 1772,

     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,

     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772
    },

    {
       45, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,

     1779, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,

     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778

    },

    {
       45, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774,-1775, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
    -1775, 1774, 1774,-1775, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774,-1775, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,

     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774,-1775, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,

     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1774
    },

    {
       45, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780,-1776, 1780, 1780, 1780, 1780,

     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1781, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,

     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,

     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780
    },

    {
       45, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776,-1777, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
    -1777, 1776, 1776,-1777, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,

     1776, 1776, 1776,-1777, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776,-1777, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,

     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776
    },

    {
       45, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,

     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1783, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,

     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,

     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782
    },

    {
       45, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778,-1779, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,

    -1779, 1778, 1778,-1779, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778,-1779, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778,-1779, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,

     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778

    },

    {
       45, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784,-1780, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1785, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,

     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,

     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784
    },

    {
       45, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780,-1781, 1780, 1780,

     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
    -1781, 1780, 1780,-1781, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780,-1781, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780,-1781, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,

     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,

     1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1780, 1780, 1780, 1780, 1780, 1780
    },

    {
       45, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1787, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,

     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,

     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786
    },

    {
       45, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,

     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782,-1783, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
    -1783, 1782, 1782,-1783, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782,-1783, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782,-1783, 1782, 1782, 1782, 1782,

     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,

     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782
    },

    {
       45, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788,-1784, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,

     1789, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,

     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788

    },

    {
       45, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784,-1785, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
    -1785, 1784, 1784,-1785, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784,-1785, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,

     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784,-1785, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,

     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1784, 1784
    },

    {
       45, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,

     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1791, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,

     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,

     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790
    },

    {
       45, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786,-1787, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
    -1787, 1786, 1786,-1787, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,

     1786, 1786, 1786,-1787, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786,-1787, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,

     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786
    },

    {
       45, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,

     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792,-1788, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1793, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,

     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,

     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792
    },

    {
       45, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788,-1789, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,

    -1789, 1788, 1788,-1789, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788,-1789, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788,-1789, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,

     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788

    },

    {
       45, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1795, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,

     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,

     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794
    },

    {
       45, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790,-1791, 1790, 1790,

     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
    -1791, 1790, 1790,-1791, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790,-1791, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790,-1791, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,

     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,

     1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1790, 1790, 1790
    },

    {
       45, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796,-1792, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1797, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,

     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,

     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796
    },

    {
       45, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,

     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792,-1793, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
    -1793, 1792, 1792,-1793, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792,-1793, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792,-1793, 1792, 1792, 1792, 1792,

     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,

     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792
    },

    {
       45, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,

     1799, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,

     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798

    },

    {
       45, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794,-1795, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
    -1795, 1794, 1794,-1795, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794,-1795, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,

     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794,-1795, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,

     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1794, 1794
    },

    {
       45, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800,-1796, 1800, 1800, 1800, 1800,

     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1801, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,

     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,

     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800
    },

    {
       45, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796,-1797, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
    -1797, 1796, 1796,-1797, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,

     1796, 1796, 1796,-1797, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796,-1797, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,

     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796
    },

    {
       45, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,

     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1803, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,

     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,

     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802
    },

    {
       45, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798,-1799, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,

    -1799, 1798, 1798,-1799, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798,-1799, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798,-1799, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,

     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1798, 1798, 1798, 1798

    },

    {
       45, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804,-1800, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1805, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,

     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,

     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804
    },

    {
       45, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800,-1801, 1800, 1800,

     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
    -1801, 1800, 1800,-1801, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800,-1801, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800,-1801, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,

     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,

     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800
    },

    {
       45, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1807, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,

     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,

     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806
    },

    {
       45, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,

     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802,-1803, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
    -1803, 1802, 1802,-1803, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802,-1803, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802,-1803, 1802, 1802, 1802, 1802,

     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,

     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1802, 1802, 1802, 1802
    },

    {
       45, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808,-1804, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,

     1809, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,

     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808

    },

    {
       45, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804,-1805, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
    -1805, 1804, 1804,-1805, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804,-1805, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,

     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804,-1805, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,

     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1804, 1804
    },

    {
       45, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,

     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1811, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,

     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,

     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810
    },

    {
       45, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806,-1807, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
    -1807, 1806, 1806,-1807, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,

     1806, 1806, 1806,-1807, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806,-1807, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,

     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806, 1806,
     1806, 1806, 1806, 1806, 1806, 1806
    },

    {
       45, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,

     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812,-1808, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1813, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,

     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,

     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812
    },

    {
       45, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808,-1809, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,

    -1809, 1808, 1808,-1809, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808,-1809, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808,-1809, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,

     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808,
     1808, 1808, 1808, 1808, 1808, 1808

    },

    {
       45, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1815, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,

     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,

     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814
    },

    {
       45, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810,-1811, 1810, 1810,

     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
    -1811, 1810, 1810,-1811, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810,-1811, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810,-1811, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,

     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,

     1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1810, 1810, 1810, 1810, 1810, 1810
    },

    {
       45, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816,-1812, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1817, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,

     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,

     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816
    },

    {
       45, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,

     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812,-1813, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
    -1813, 1812, 1812,-1813, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812,-1813, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812,-1813, 1812, 1812, 1812, 1812,

     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,

     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1812, 1812, 1812, 1812
    },

    {
       45, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,

     1819, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,

     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818

    },

    {
       45, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814,-1815, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
    -1815, 1814, 1814,-1815, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814,-1815, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,

     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814,-1815, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,

     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1814, 1814
    },

    {
       45, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820,-1816, 1820, 1820, 1820, 1820,

     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1821, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,

     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,

     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820
    },

    {
       45, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816,-1817, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
    -1817, 1816, 1816,-1817, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,

     1816, 1816, 1816,-1817, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816,-1817, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,

     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816
    },

    {
       45, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,

     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1823, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,

     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,

     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822
    },

    {
       45, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818,-1819, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,

    -1819, 1818, 1818,-1819, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818,-1819, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818,-1819, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,

     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818,
     1818, 1818, 1818, 1818, 1818, 1818

    },

    {
       45, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824,-1820, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1825, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,

     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,

     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824
    },

    {
       45, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820,-1821, 1820, 1820,

     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
    -1821, 1820, 1820,-1821, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820,-1821, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820,-1821, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,

     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,

     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820
    },

    {
       45, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1827, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,

     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,

     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826
    },

    {
       45, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,

     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822,-1823, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
    -1823, 1822, 1822,-1823, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822,-1823, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822,-1823, 1822, 1822, 1822, 1822,

     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,

     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1822, 1822, 1822, 1822
    },

    {
       45, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828,-1824, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,

     1829, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,

     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828

    },

    {
       45, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824,-1825, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
    -1825, 1824, 1824,-1825, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824,-1825, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,

     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824,-1825, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,

     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824, 1824,
     1824, 1824, 1824, 1824, 1824, 1824
    },

    {
       45, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,

     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1831, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,

     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,

     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830
    },

    {
       45, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826,-1827, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
    -1827, 1826, 1826,-1827, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,

     1826, 1826, 1826,-1827, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826,-1827, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,

     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826
    },

    {
       45, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,

     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832,-1828, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1833, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,

     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,

     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832
    },

    {
       45, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828,-1829, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,

    -1829, 1828, 1828,-1829, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828,-1829, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828,-1829, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,

     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828,
     1828, 1828, 1828, 1828, 1828, 1828

    },

    {
       45, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1835, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,

     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,

     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834
    },

    {
       45, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830,-1831, 1830, 1830,

     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
    -1831, 1830, 1830,-1831, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830,-1831, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830,-1831, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,

     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,

     1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1830, 1830, 1830, 1830, 1830, 1830
    },

    {
       45, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836,-1832, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1837, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,

     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,

     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836
    },

    {
       45, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,

     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832,-1833, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
    -1833, 1832, 1832,-1833, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832,-1833, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832,-1833, 1832, 1832, 1832, 1832,

     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,

     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832
    },

    {
       45, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,

     1839, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,

     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838

    },

    {
       45, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834,-1835, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
    -1835, 1834, 1834,-1835, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834,-1835, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,

     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834,-1835, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,

     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1834, 1834, 1834, 1834, 1834, 1834
    },

    {
       45, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840,-1836, 1840, 1840, 1840, 1840,

     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1841, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,

     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,

     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840
    },

    {
       45, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836,-1837, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
    -1837, 1836, 1836,-1837, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,

     1836, 1836, 1836,-1837, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836,-1837, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,

     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836,
     1836, 1836, 1836, 1836, 1836, 1836
    },

    {
       45, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,

     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1843, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,

     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,

     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842
    },

    {
       45, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838,-1839, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,

    -1839, 1838, 1838,-1839, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838,-1839, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838,-1839, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,

     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838

    },

    {
       45, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844,-1840, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1845, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,

     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,

     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844
    },

    {
       45, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840,-1841, 1840, 1840,

     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
    -1841, 1840, 1840,-1841, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840,-1841, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840,-1841, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,

     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,

     1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840, 1840, 1840
    },

    {
       45, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1847, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,

     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,

     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846
    },

    {
       45, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,

     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842,-1843, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
    -1843, 1842, 1842,-1843, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842,-1843, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842,-1843, 1842, 1842, 1842, 1842,

     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,

     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842
    },

    {
       45, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848,-1844, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,

     1849, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,

     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848

    },

    {
       45, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844,-1845, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
    -1845, 1844, 1844,-1845, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844,-1845, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,

     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844,-1845, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,

     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844, 1844,
     1844, 1844, 1844, 1844, 1844, 1844
    },

    {
       45, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,

     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1851, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,

     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,

     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850
    },

    {
       45, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846,-1847, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
    -1847, 1846, 1846,-1847, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,

     1846, 1846, 1846,-1847, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846,-1847, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,

     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
     1846, 1846, 1846, 1846, 1846, 1846
    },

    {
       45, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,

     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852,-1848, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1853, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,

     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,

     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852
    },

    {
       45, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848,-1849, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,

    -1849, 1848, 1848,-1849, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848,-1849, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848,-1849, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,

     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848, 1848, 1848, 1848, 1848, 1848

    },

    {
       45, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1855, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,

     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,

     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854
    },

    {
       45, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850,-1851, 1850, 1850,

     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
    -1851, 1850, 1850,-1851, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850,-1851, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850,-1851, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,

     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,

     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850
    },

    {
       45, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856,-1852, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1857, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,

     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,

     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856
    },

    {
       45, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,

     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852,-1853, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
    -1853, 1852, 1852,-1853, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852,-1853, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852,-1853, 1852, 1852, 1852, 1852,

     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,

     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1852, 1852
    },

    {
       45, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,

     1859, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,

     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858

    },

    {
       45, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854,-1855, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
    -1855, 1854, 1854,-1855, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854,-1855, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,

     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854,-1855, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,

     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854
    },

    {
       45, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860,-1856, 1860, 1860, 1860, 1860,

     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1861, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,

     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,

     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860
    },

    {
       45, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856,-1857, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
    -1857, 1856, 1856,-1857, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,

     1856, 1856, 1856,-1857, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856,-1857, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,

     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856, 1856,
     1856, 1856, 1856, 1856, 1856, 1856
    },

    {
       45, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,

     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1863, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,

     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,

     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862
    },

    {
       45, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858,-1859, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,

    -1859, 1858, 1858,-1859, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858,-1859, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858,-1859, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,

     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858

    },

    {
       45, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864,-1860, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1865, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,

     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,

     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864
    },

    {
       45, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860,-1861, 1860, 1860,

     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
    -1861, 1860, 1860,-1861, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860,-1861, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860,-1861, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,

     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,

     1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1860, 1860, 1860
    },

    {
       45, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1867, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,

     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,

     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866
    },

    {
       45, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,

     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862,-1863, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
    -1863, 1862, 1862,-1863, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862,-1863, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862,-1863, 1862, 1862, 1862, 1862,

     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,

     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862, 1862,
     1862, 1862, 1862, 1862, 1862, 1862
    },

    {
       45, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868,-1864, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,

     1869, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,

     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868

    },

    {
       45, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864,-1865, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
    -1865, 1864, 1864,-1865, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864,-1865, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,

     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864,-1865, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,

     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864, 1864,
     1864, 1864, 1864, 1864, 1864, 1864
    },

    {
       45, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,

     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1871, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,

     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,

     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870
    },

    {
       45, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866,-1867, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
    -1867, 1866, 1866,-1867, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,

     1866, 1866, 1866,-1867, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866,-1867, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,

     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866
    },

    {
       45, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,

     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872,-1868, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1873, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,

     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,

     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872
    },

    {
       45, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868,-1869, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,

    -1869, 1868, 1868,-1869, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868,-1869, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868,-1869, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,

     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868

    },

    {
       45, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1875, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,

     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,

     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874
    },

    {
       45, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870,-1871, 1870, 1870,

     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
    -1871, 1870, 1870,-1871, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870,-1871, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870,-1871, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,

     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,

     1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870, 1870,
     1870, 1870, 1870, 1870, 1870, 1870
    },

    {
       45, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876,-1872, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1877, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,

     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,

     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876
    },

    {
       45, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,

     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872,-1873, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
    -1873, 1872, 1872,-1873, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872,-1873, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872,-1873, 1872, 1872, 1872, 1872,

     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,

     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872, 1872,
     1872, 1872, 1872, 1872, 1872, 1872
    },

    {
       45, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,

     1879, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,

     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878

    },

    {
       45, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874,-1875, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
    -1875, 1874, 1874,-1875, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874,-1875, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,

     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874,-1875, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,

     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874, 1874,
     1874, 1874, 1874, 1874, 1874, 1874
    },

    {
       45, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880,-1876, 1880, 1880, 1880, 1880,

     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1881, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,

     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,

     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880
    },

    {
       45, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876,-1877, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
    -1877, 1876, 1876,-1877, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,

     1876, 1876, 1876,-1877, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876,-1877, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,

     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876
    },

    {
       45, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,

     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1883, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,

     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,

     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882
    },

    {
       45, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878,-1879, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,

    -1879, 1878, 1878,-1879, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878,-1879, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878,-1879, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,

     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878, 1878,
     1878, 1878, 1878, 1878, 1878, 1878

    },

    {
       45, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884,-1880, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1885, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,

     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,

     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884
    },

    {
       45, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880,-1881, 1880, 1880,

     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
    -1881, 1880, 1880,-1881, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880,-1881, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880,-1881, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,

     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,

     1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880, 1880,
     1880, 1880, 1880, 1880, 1880, 1880
    },

    {
       45, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1887, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,

     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,

     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886
    },

    {
       45, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,

     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882,-1883, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
    -1883, 1882, 1882,-1883, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882,-1883, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882,-1883, 1882, 1882, 1882, 1882,

     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,

     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882, 1882,
     1882, 1882, 1882, 1882, 1882, 1882
    },

    {
       45, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888,-1884, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,

     1889, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,

     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888

    },

    {
       45, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884,-1885, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
    -1885, 1884, 1884,-1885, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884,-1885, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,

     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884,-1885, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,

     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884, 1884,
     1884, 1884, 1884, 1884, 1884, 1884
    },

    {
       45, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,

     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1891, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,

     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,

     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890
    },

    {
       45, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886,-1887, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
    -1887, 1886, 1886,-1887, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,

     1886, 1886, 1886,-1887, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886,-1887, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,

     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886
    },

    {
       45, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,

     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892,-1888, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1893, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,

     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,

     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892
    },

    {
       45, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888,-1889, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,

    -1889, 1888, 1888,-1889, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888,-1889, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888,-1889, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,

     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888, 1888,
     1888, 1888, 1888, 1888, 1888, 1888

    },

    {
       45, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1895, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,

     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,

     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894
    },

    {
       45, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890,-1891, 1890, 1890,

     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
    -1891, 1890, 1890,-1891, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890,-1891, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890,-1891, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,

     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,

     1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890, 1890,
     1890, 1890, 1890, 1890, 1890, 1890
    },

    {
       45, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896,-1892, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1897, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,

     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,

     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896
    },

    {
       45, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,

     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892,-1893, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
    -1893, 1892, 1892,-1893, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892,-1893, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892,-1893, 1892, 1892, 1892, 1892,

     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,

     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892
    },

    {
       45, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,

     1899, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,

     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898

    },

    {
       45, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894,-1895, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
    -1895, 1894, 1894,-1895, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894,-1895, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,

     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894,-1895, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,

     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894
    },

    {
       45, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900,-1896, 1900, 1900, 1900, 1900,

     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1901, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,

     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,

     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900
    },

    {
       45, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896,-1897, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
    -1897, 1896, 1896,-1897, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,

     1896, 1896, 1896,-1897, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896,-1897, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,

     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896, 1896,
     1896, 1896, 1896, 1896, 1896, 1896
    },

    {
       45, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,

     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1903, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,

     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,

     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902
    },

    {
       45, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898,-1899, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,

    -1899, 1898, 1898,-1899, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898,-1899, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898,-1899, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,

     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898, 1898,
     1898, 1898, 1898, 1898, 1898, 1898

    },

    {
       45, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904,-1900, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1905, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,

     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,

     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904
    },

    {
       45, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900,-1901, 1900, 1900,

     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
    -1901, 1900, 1900,-1901, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900,-1901, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900,-1901, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,

     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,

     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900
    },

    {
       45, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1907, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,

     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,

     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906
    },

    {
       45, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,

     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902,-1903, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
    -1903, 1902, 1902,-1903, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902,-1903, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902,-1903, 1902, 1902, 1902, 1902,

     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,

     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902, 1902,
     1902, 1902, 1902, 1902, 1902, 1902
    },

    {
       45, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908,-1904, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,

     1909, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,

     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908

    },

    {
       45, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904,-1905, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
    -1905, 1904, 1904,-1905, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904,-1905, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,

     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904,-1905, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,

     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904, 1904,
     1904, 1904, 1904, 1904, 1904, 1904
    },

    {
       45, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,

     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1911, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,

     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,

     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910
    },

    {
       45, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906,-1907, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
    -1907, 1906, 1906,-1907, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,

     1906, 1906, 1906,-1907, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906,-1907, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,

     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906, 1906,
     1906, 1906, 1906, 1906, 1906, 1906
    },

    {
       45, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,

     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912,-1908, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1913, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,

     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,

     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912
    },

    {
       45, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908,-1909, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,

    -1909, 1908, 1908,-1909, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908,-1909, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908,-1909, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,

     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908, 1908,
     1908, 1908, 1908, 1908, 1908, 1908

    },

    {
       45, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1915, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,

     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,

     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914
    },

    {
       45, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910,-1911, 1910, 1910,

     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
    -1911, 1910, 1910,-1911, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910,-1911, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910,-1911, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,

     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,

     1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910, 1910,
     1910, 1910, 1910, 1910, 1910, 1910
    },

    {
       45, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916,-1912, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1917, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,

     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,

     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916
    },

    {
       45, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,

     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912,-1913, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
    -1913, 1912, 1912,-1913, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912,-1913, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912,-1913, 1912, 1912, 1912, 1912,

     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,

     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912, 1912,
     1912, 1912, 1912, 1912, 1912, 1912
    },

    {
       45, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,

     1919, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,

     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918

    },

    {
       45, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914,-1915, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
    -1915, 1914, 1914,-1915, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914,-1915, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,

     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914,-1915, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,

     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914
    },

    {
       45, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920,-1916, 1920, 1920, 1920, 1920,

     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1921, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,

     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,

     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920
    },

    {
       45, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916,-1917, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
    -1917, 1916, 1916,-1917, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,

     1916, 1916, 1916,-1917, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916,-1917, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,

     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916, 1916,
     1916, 1916, 1916, 1916, 1916, 1916
    },

    {
       45, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,

     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1923, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,

     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,

     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922
    },

    {
       45, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918,-1919, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,

    -1919, 1918, 1918,-1919, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918,-1919, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918,-1919, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,

     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918, 1918,
     1918, 1918, 1918, 1918, 1918, 1918

    },

    {
       45, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924,-1920, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1925, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,

     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,

     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924
    },

    {
       45, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920,-1921, 1920, 1920,

     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
    -1921, 1920, 1920,-1921, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920,-1921, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920,-1921, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,

     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,

     1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920, 1920,
     1920, 1920, 1920, 1920, 1920, 1920
    },

    {
       45, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1927, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,

     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,

     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926
    },

    {
       45, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,

     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922,-1923, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
    -1923, 1922, 1922,-1923, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922,-1923, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922,-1923, 1922, 1922, 1922, 1922,

     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,

     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922, 1922,
     1922, 1922, 1922, 1922, 1922, 1922
    },

    {
       45, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928,-1924, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,

     1929, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,

     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928

    },

    {
       45, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924,-1925, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
    -1925, 1924, 1924,-1925, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924,-1925, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,

     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924,-1925, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,

     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924, 1924,
     1924, 1924, 1924, 1924, 1924, 1924
    },

    {
       45, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,

     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1931, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,

     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,

     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930
    },

    {
       45, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926,-1927, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
    -1927, 1926, 1926,-1927, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,

     1926, 1926, 1926,-1927, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926,-1927, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,

     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926, 1926,
     1926, 1926, 1926, 1926, 1926, 1926
    },

    {
       45, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,

     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932,-1928, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1933, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,

     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,

     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932
    },

    {
       45, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928,-1929, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,

    -1929, 1928, 1928,-1929, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928,-1929, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928,-1929, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,

     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928, 1928,
     1928, 1928, 1928, 1928, 1928, 1928

    },

    {
       45, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1935, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,

     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,

     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934
    },

    {
       45, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930,-1931, 1930, 1930,

     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
    -1931, 1930, 1930,-1931, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930,-1931, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930,-1931, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,

     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,

     1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930, 1930,
     1930, 1930, 1930, 1930, 1930, 1930
    },

    {
       45, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936,-1932, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1937, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,

     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,

     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936
    },

    {
       45, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,

     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932,-1933, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
    -1933, 1932, 1932,-1933, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932,-1933, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932,-1933, 1932, 1932, 1932, 1932,

     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,

     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932, 1932,
     1932, 1932, 1932, 1932, 1932, 1932
    },

    {
       45, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,

     1939, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,

     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938

    },

    {
       45, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934,-1935, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
    -1935, 1934, 1934,-1935, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934,-1935, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,

     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934,-1935, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,

     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934, 1934,
     1934, 1934, 1934, 1934, 1934, 1934
    },

    {
       45, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940,-1936, 1940, 1940, 1940, 1940,

     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1941, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,

     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,

     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940
    },

    {
       45, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936,-1937, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
    -1937, 1936, 1936,-1937, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,

     1936, 1936, 1936,-1937, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936,-1937, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,

     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936, 1936,
     1936, 1936, 1936, 1936, 1936, 1936
    },

    {
       45, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,

     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1943, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,

     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,

     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942
    },

    {
       45, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938,-1939, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,

    -1939, 1938, 1938,-1939, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938,-1939, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938,-1939, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,

     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938, 1938,
     1938, 1938, 1938, 1938, 1938, 1938

    },

    {
       45, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944,-1940, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1945, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,

     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,

     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944
    },

    {
       45, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940,-1941, 1940, 1940,

     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
    -1941, 1940, 1940,-1941, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940,-1941, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940,-1941, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,

     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,

     1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940, 1940,
     1940, 1940, 1940, 1940, 1940, 1940
    },

    {
       45, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1947, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,

     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,

     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946
    },

    {
       45, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,

     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942,-1943, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
    -1943, 1942, 1942,-1943, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942,-1943, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942,-1943, 1942, 1942, 1942, 1942,

     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,

     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942, 1942,
     1942, 1942, 1942, 1942, 1942, 1942
    },

    {
       45, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948,-1944, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,

     1949, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,

     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948

    },

    {
       45, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944,-1945, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
    -1945, 1944, 1944,-1945, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944,-1945, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,

     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944,-1945, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,

     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944, 1944,
     1944, 1944, 1944, 1944, 1944, 1944
    },

    {
       45, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,

     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1951, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,

     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,

     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950
    },

    {
       45, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946,-1947, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
    -1947, 1946, 1946,-1947, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,

     1946, 1946, 1946,-1947, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946,-1947, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,

     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946, 1946,
     1946, 1946, 1946, 1946, 1946, 1946
    },

    {
       45, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,

     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952,-1948, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1953, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,

     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,

     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952
    },

    {
       45, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948,-1949, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,

    -1949, 1948, 1948,-1949, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948,-1949, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948,-1949, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,

     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948, 1948,
     1948, 1948, 1948, 1948, 1948, 1948

    },

    {
       45, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1955, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,

     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,

     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954
    },

    {
       45, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950,-1951, 1950, 1950,

     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
    -1951, 1950, 1950,-1951, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950,-1951, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950,-1951, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,

     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,

     1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950, 1950,
     1950, 1950, 1950, 1950, 1950, 1950
    },

    {
       45, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956,-1952, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1957, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,

     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,

     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956
    },

    {
       45, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,

     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952,-1953, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
    -1953, 1952, 1952,-1953, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952,-1953, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952,-1953, 1952, 1952, 1952, 1952,

     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,

     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952, 1952,
     1952, 1952, 1952, 1952, 1952, 1952
    },

    {
       45, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,

     1959, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,

     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958

    },

    {
       45, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954,-1955, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
    -1955, 1954, 1954,-1955, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954,-1955, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,

     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954,-1955, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,

     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954, 1954,
     1954, 1954, 1954, 1954, 1954, 1954
    },

    {
       45, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960,-1956, 1960, 1960, 1960, 1960,

     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1961, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,

     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,

     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960
    },

    {
       45, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956,-1957, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
    -1957, 1956, 1956,-1957, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,

     1956, 1956, 1956,-1957, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956,-1957, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,

     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956, 1956,
     1956, 1956, 1956, 1956, 1956, 1956
    },

    {
       45, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,

     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1963, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,

     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,

     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962
    },

    {
       45, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958,-1959, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,

    -1959, 1958, 1958,-1959, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958,-1959, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958,-1959, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,

     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958, 1958,
     1958, 1958, 1958, 1958, 1958, 1958

    },

    {
       45, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964,-1960, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1965, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,

     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,

     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964
    },

    {
       45, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960,-1961, 1960, 1960,

     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
    -1961, 1960, 1960,-1961, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960,-1961, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960,-1961, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,

     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,

     1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960, 1960,
     1960, 1960, 1960, 1960, 1960, 1960
    },

    {
       45, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1967, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,

     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,

     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966
    },

    {
       45, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,

     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962,-1963, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
    -1963, 1962, 1962,-1963, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962,-1963, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962,-1963, 1962, 1962, 1962, 1962,

     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,

     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962, 1962,
     1962, 1962, 1962, 1962, 1962, 1962
    },

    {
       45, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968,-1964, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,

     1969, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,

     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968

    },

    {
       45, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964,-1965, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
    -1965, 1964, 1964,-1965, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964,-1965, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,

     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964,-1965, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,

     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964, 1964,
     1964, 1964, 1964, 1964, 1964, 1964
    },

    {
       45, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,

     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1971, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,

     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,

     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970
    },

    {
       45, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966,-1967, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
    -1967, 1966, 1966,-1967, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,

     1966, 1966, 1966,-1967, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966,-1967, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,

     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 1966, 1966
    },

    {
       45, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,

     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972,-1968, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1973, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,

     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,

     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972
    },

    {
       45, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968,-1969, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,

    -1969, 1968, 1968,-1969, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968,-1969, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968,-1969, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,

     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968, 1968,
     1968, 1968, 1968, 1968, 1968, 1968

    },

    {
       45, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1975, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,

     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,

     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974
    },

    {
       45, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970,-1971, 1970, 1970,

     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
    -1971, 1970, 1970,-1971, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970,-1971, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970,-1971, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,

     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,

     1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970, 1970,
     1970, 1970, 1970, 1970, 1970, 1970
    },

    {
       45, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976,-1972, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1977, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,

     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,

     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976
    },

    {
       45, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,

     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972,-1973, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
    -1973, 1972, 1972,-1973, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972,-1973, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972,-1973, 1972, 1972, 1972, 1972,

     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,

     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972, 1972,
     1972, 1972, 1972, 1972, 1972, 1972
    },

    {
       45, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,

     1979, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,

     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978

    },

    {
       45, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974,-1975, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
    -1975, 1974, 1974,-1975, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974,-1975, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,

     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974,-1975, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,

     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974, 1974,
     1974, 1974, 1974, 1974, 1974, 1974
    },

    {
       45, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980,-1976, 1980, 1980, 1980, 1980,

     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1981, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,

     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,

     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980
    },

    {
       45, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976,-1977, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
    -1977, 1976, 1976,-1977, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,

     1976, 1976, 1976,-1977, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976,-1977, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,

     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976,
     1976, 1976, 1976, 1976, 1976, 1976
    },

    {
       45, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,

     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1983, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,

     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,

     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982
    },

    {
       45, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978,-1979, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,

    -1979, 1978, 1978,-1979, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978,-1979, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978,-1979, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,

     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978, 1978,
     1978, 1978, 1978, 1978, 1978, 1978

    },

    {
       45, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984,-1980, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1985, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,

     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,

     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984
    },

    {
       45, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980,-1981, 1980, 1980,

     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
    -1981, 1980, 1980,-1981, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980,-1981, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980,-1981, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,

     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,

     1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980, 1980,
     1980, 1980, 1980, 1980, 1980, 1980
    },

    {
       45, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1987, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,

     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,

     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986
    },

    {
       45, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,

     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982,-1983, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
    -1983, 1982, 1982,-1983, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982,-1983, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982,-1983, 1982, 1982, 1982, 1982,

     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,

     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982, 1982,
     1982, 1982, 1982, 1982, 1982, 1982
    },

    {
       45, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988,-1984, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,

     1989, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,

     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988

    },

    {
       45, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984,-1985, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
    -1985, 1984, 1984,-1985, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984,-1985, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,

     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984,-1985, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,

     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984, 1984,
     1984, 1984, 1984, 1984, 1984, 1984
    },

    {
       45, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,

     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1991, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,

     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,

     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990
    },

    {
       45, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986,-1987, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
    -1987, 1986, 1986,-1987, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,

     1986, 1986, 1986,-1987, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986,-1987, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,

     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1986, 1986, 1986, 1986, 1986, 1986
    },

    {
       45, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,

     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992,-1988, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1993, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,

     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,

     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992
    },

    {
       45, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988,-1989, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,

    -1989, 1988, 1988,-1989, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988,-1989, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988,-1989, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,

     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988, 1988,
     1988, 1988, 1988, 1988, 1988, 1988

    },

    {
       45, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1995, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,

     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,

     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994
    },

    {
       45, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990,-1991, 1990, 1990,

     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
    -1991, 1990, 1990,-1991, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990,-1991, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990,-1991, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,

     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,

     1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990, 1990,
     1990, 1990, 1990, 1990, 1990, 1990
    },

    {
       45, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996,-1992, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1997, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,

     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,

     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996
    },

    {
       45, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,

     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992,-1993, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
    -1993, 1992, 1992,-1993, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992,-1993, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992,-1993, 1992, 1992, 1992, 1992,

     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,

     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992,
     1992, 1992, 1992, 1992, 1992, 1992
    },

    {
       45, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,

     1999, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,

     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998

    },

    {
       45, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994,-1995, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
    -1995, 1994, 1994,-1995, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994,-1995, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,

     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994,-1995, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,

     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994, 1994,
     1994, 1994, 1994, 1994, 1994, 1994
    },

    {
       45, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000,-1996, 2000, 2000, 2000, 2000,

     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2001, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,

     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,

     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000
    },

    {
       45, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996,-1997, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
    -1997, 1996, 1996,-1997, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,

     1996, 1996, 1996,-1997, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996,-1997, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,

     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996, 1996,
     1996, 1996, 1996, 1996, 1996, 1996
    },

    {
       45, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,

     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2003, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,

     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,

     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002
    },

    {
       45, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998,-1999, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,

    -1999, 1998, 1998,-1999, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998,-1999, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998,-1999, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,

     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998, 1998,
     1998, 1998, 1998, 1998, 1998, 1998

    },

    {
       45, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004,-2000, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2005, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,

     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,

     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004
    },

    {
       45, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000,-2001, 2000, 2000,

     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
    -2001, 2000, 2000,-2001, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000,-2001, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000,-2001, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,

     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,

     2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000,
     2000, 2000, 2000, 2000, 2000, 2000
    },

    {
       45, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2007, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,

     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,

     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006
    },

    {
       45, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,

     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002,-2003, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
    -2003, 2002, 2002,-2003, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002,-2003, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002,-2003, 2002, 2002, 2002, 2002,

     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,

     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002, 2002,
     2002, 2002, 2002, 2002, 2002, 2002
    },

    {
       45, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008,-2004, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,

     2009, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,

     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008

    },

    {
       45, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004,-2005, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
    -2005, 2004, 2004,-2005, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004,-2005, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,

     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004,-2005, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,

     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004, 2004,
     2004, 2004, 2004, 2004, 2004, 2004
    },

    {
       45, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,

     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2011, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,

     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,

     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010
    },

    {
       45, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006,-2007, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
    -2007, 2006, 2006,-2007, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,

     2006, 2006, 2006,-2007, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006,-2007, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,

     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006, 2006,
     2006, 2006, 2006, 2006, 2006, 2006
    },

    {
       45, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,

     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012,-2008, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2013, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,

     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,

     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012
    },

    {
       45, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008,-2009, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,

    -2009, 2008, 2008,-2009, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008,-2009, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008,-2009, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,

     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008,
     2008, 2008, 2008, 2008, 2008, 2008

    },

    {
       45, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2015, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,

     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,

     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014
    },

    {
       45, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010,-2011, 2010, 2010,

     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
    -2011, 2010, 2010,-2011, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010,-2011, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010,-2011, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,

     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,

     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2010, 2010, 2010, 2010, 2010
    },

    {
       45, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016,-2012, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2017, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,

     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,

     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016
    },

    {
       45, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,

     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012,-2013, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
    -2013, 2012, 2012,-2013, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012,-2013, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012,-2013, 2012, 2012, 2012, 2012,

     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,

     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012, 2012,
     2012, 2012, 2012, 2012, 2012, 2012
    },

    {
       45, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,

     2019, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,

     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018

    },

    {
       45, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014,-2015, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
    -2015, 2014, 2014,-2015, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014,-2015, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,

     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014,-2015, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,

     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2014,
     2014, 2014, 2014, 2014, 2014, 2014
    },

    {
       45, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020,-2016, 2020, 2020, 2020, 2020,

     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2021, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,

     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,

     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020
    },

    {
       45, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016,-2017, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
    -2017, 2016, 2016,-2017, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,

     2016, 2016, 2016,-2017, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016,-2017, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,

     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016, 2016,
     2016, 2016, 2016, 2016, 2016, 2016
    },

    {
       45, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,

     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2023, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,

     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,

     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022
    },

    {
       45, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018,-2019, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,

    -2019, 2018, 2018,-2019, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018,-2019, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018,-2019, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,

     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018, 2018,
     2018, 2018, 2018, 2018, 2018, 2018

    },

    {
       45, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024,-2020, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2025, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,

     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,

     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024
    },

    {
       45, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020,-2021, 2020, 2020,

     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
    -2021, 2020, 2020,-2021, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020,-2021, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020,-2021, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,

     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,

     2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020, 2020,
     2020, 2020, 2020, 2020, 2020, 2020
    },

    {
       45, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2027, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,

     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,

     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026
    },

    {
       45, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,

     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022,-2023, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
    -2023, 2022, 2022,-2023, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022,-2023, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022,-2023, 2022, 2022, 2022, 2022,

     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,

     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022, 2022,
     2022, 2022, 2022, 2022, 2022, 2022
    },

    {
       45, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028,-2024, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,

     2029, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,

     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028

    },

    {
       45, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024,-2025, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
    -2025, 2024, 2024,-2025, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024,-2025, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,

     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024,-2025, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,

     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024,
     2024, 2024, 2024, 2024, 2024, 2024
    },

    {
       45, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,

     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2031, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,

     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,

     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030
    },

    {
       45, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026,-2027, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
    -2027, 2026, 2026,-2027, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,

     2026, 2026, 2026,-2027, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026,-2027, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,

     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026, 2026,
     2026, 2026, 2026, 2026, 2026, 2026
    },

    {
       45, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,

     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032,-2028, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2033, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,

     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,

     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032
    },

    {
       45, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028,-2029, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,

    -2029, 2028, 2028,-2029, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028,-2029, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028,-2029, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,

     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028, 2028,
     2028, 2028, 2028, 2028, 2028, 2028

    },

    {
       45, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2035, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,

     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,

     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034
    },

    {
       45, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030,-2031, 2030, 2030,

     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
    -2031, 2030, 2030,-2031, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030,-2031, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030,-2031, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,

     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,

     2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030, 2030,
     2030, 2030, 2030, 2030, 2030, 2030
    },

    {
       45, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036,-2032, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2037, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,

     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,

     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036
    },

    {
       45, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,

     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032,-2033, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
    -2033, 2032, 2032,-2033, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032,-2033, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032,-2033, 2032, 2032, 2032, 2032,

     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,

     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032, 2032,
     2032, 2032, 2032, 2032, 2032, 2032
    },

    {
       45, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,

     2039, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,

     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038

    },

    {
       45, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034,-2035, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
    -2035, 2034, 2034,-2035, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034,-2035, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,

     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034,-2035, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,

     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034
    },

    {
       45, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040,-2036, 2040, 2040, 2040, 2040,

     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2041, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,

     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,

     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040
    },

    {
       45, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036,-2037, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
    -2037, 2036, 2036,-2037, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,

     2036, 2036, 2036,-2037, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036,-2037, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,

     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036
    },

    {
       45, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,

     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2043, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,

     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,

     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042
    },

    {
       45, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038,-2039, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,

    -2039, 2038, 2038,-2039, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038,-2039, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038,-2039, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,

     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038, 2038,
     2038, 2038, 2038, 2038, 2038, 2038

    },

    {
       45, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044,-2040, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2045, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,

     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,

     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044
    },

    {
       45, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040,-2041, 2040, 2040,

     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
    -2041, 2040, 2040,-2041, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040,-2041, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040,-2041, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,

     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,

     2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040,
     2040, 2040, 2040, 2040, 2040, 2040
    },

    {
       45, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2047, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,

     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,

     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046
    },

    {
       45, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,

     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042,-2043, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
    -2043, 2042, 2042,-2043, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042,-2043, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042,-2043, 2042, 2042, 2042, 2042,

     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,

     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042, 2042,
     2042, 2042, 2042, 2042, 2042, 2042
    },

    {
       45, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048,-2044, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,

     2049, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,

     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048

    },

    {
       45, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044,-2045, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
    -2045, 2044, 2044,-2045, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044,-2045, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,

     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044,-2045, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,

     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2044, 2044
    },

    {
       45, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,

     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2051, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,

     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,

     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050
    },

    {
       45, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046,-2047, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
    -2047, 2046, 2046,-2047, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,

     2046, 2046, 2046,-2047, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046,-2047, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,

     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046, 2046,
     2046, 2046, 2046, 2046, 2046, 2046
    },

    {
       45, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,

     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052,-2048, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2053, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,

     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,

     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052
    },

    {
       45, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048,-2049, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,

    -2049, 2048, 2048,-2049, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048,-2049, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048,-2049, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,

     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2048

    },

    {
       45, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2055, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,

     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,

     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054
    },

    {
       45, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050,-2051, 2050, 2050,

     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
    -2051, 2050, 2050,-2051, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050,-2051, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050,-2051, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,

     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,

     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050, 2050, 2050, 2050, 2050, 2050
    },

    {
       45, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056,-2052, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2057, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,

     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,

     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056
    },

    {
       45, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,

     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052,-2053, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
    -2053, 2052, 2052,-2053, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052,-2053, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052,-2053, 2052, 2052, 2052, 2052,

     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,

     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052
    },

    {
       45, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,

     2059, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,

     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058

    },

    {
       45, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054,-2055, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
    -2055, 2054, 2054,-2055, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054,-2055, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,

     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054,-2055, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,

     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054, 2054,
     2054, 2054, 2054, 2054, 2054, 2054
    },

    {
       45, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060,-2056, 2060, 2060, 2060, 2060,

     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2061, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,

     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,

     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060
    },

    {
       45, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056,-2057, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
    -2057, 2056, 2056,-2057, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,

     2056, 2056, 2056,-2057, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056,-2057, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,

     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056
    },

    {
       45, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,

     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2063, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,

     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,

     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062
    },

    {
       45, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058,-2059, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,

    -2059, 2058, 2058,-2059, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058,-2059, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058,-2059, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,

     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058, 2058,
     2058, 2058, 2058, 2058, 2058, 2058

    },

    {
       45, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064,-2060, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2065, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,

     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,

     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064
    },

    {
       45, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060,-2061, 2060, 2060,

     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
    -2061, 2060, 2060,-2061, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060,-2061, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060,-2061, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,

     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,

     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060
    },

    {
       45, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2067, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,

     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,

     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066
    },

    {
       45, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,

     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062,-2063, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
    -2063, 2062, 2062,-2063, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062,-2063, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062,-2063, 2062, 2062, 2062, 2062,

     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,

     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     2062, 2062, 2062, 2062, 2062, 2062
    },

    {
       45, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068,-2064, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,

     2069, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,

     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068

    },

    {
       45, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064,-2065, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
    -2065, 2064, 2064,-2065, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064,-2065, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,

     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064,-2065, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,

     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064, 2064,
     2064, 2064, 2064, 2064, 2064, 2064
    },

    {
       45, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,

     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2071, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,

     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,

     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070
    },

    {
       45, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066,-2067, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
    -2067, 2066, 2066,-2067, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,

     2066, 2066, 2066,-2067, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066,-2067, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,

     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066
    },

    {
       45, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,

     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072,-2068, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2073, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,

     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,

     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072
    },

    {
       45, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068,-2069, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,

    -2069, 2068, 2068,-2069, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068,-2069, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068,-2069, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,

     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068, 2068,
     2068, 2068, 2068, 2068, 2068, 2068

    },

    {
       45, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2075, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,

     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,

     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074
    },

    {
       45, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070,-2071, 2070, 2070,

     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
    -2071, 2070, 2070,-2071, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070,-2071, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070,-2071, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,

     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,

     2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070, 2070,
     2070, 2070, 2070, 2070, 2070, 2070
    },

    {
       45, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076,-2072, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2077, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,

     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,

     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076
    },

    {
       45, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,

     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072,-2073, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
    -2073, 2072, 2072,-2073, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072,-2073, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072,-2073, 2072, 2072, 2072, 2072,

     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,

     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072,
     2072, 2072, 2072, 2072, 2072, 2072
    },

    {
       45, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,

     2079, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,

     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078

    },

    {
       45, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074,-2075, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
    -2075, 2074, 2074,-2075, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074,-2075, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,

     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074,-2075, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,

     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074, 2074,
     2074, 2074, 2074, 2074, 2074, 2074
    },

    {
       45, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080,-2076, 2080, 2080, 2080, 2080,

     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2081, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,

     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,

     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080
    },

    {
       45, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076,-2077, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
    -2077, 2076, 2076,-2077, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,

     2076, 2076, 2076,-2077, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076,-2077, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,

     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076, 2076,
     2076, 2076, 2076, 2076, 2076, 2076
    },

    {
       45, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,

     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2083, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,

     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,

     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082
    },

    {
       45, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078,-2079, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,

    -2079, 2078, 2078,-2079, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078,-2079, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078,-2079, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,

     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078, 2078,
     2078, 2078, 2078, 2078, 2078, 2078

    },

    {
       45, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084,-2080, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2085, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,

     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,

     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084
    },

    {
       45, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080,-2081, 2080, 2080,

     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
    -2081, 2080, 2080,-2081, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080,-2081, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080,-2081, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,

     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,

     2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080, 2080,
     2080, 2080, 2080, 2080, 2080, 2080
    },

    {
       45, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2087, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,

     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,

     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086
    },

    {
       45, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,

     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082,-2083, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
    -2083, 2082, 2082,-2083, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082,-2083, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082,-2083, 2082, 2082, 2082, 2082,

     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,

     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082, 2082,
     2082, 2082, 2082, 2082, 2082, 2082
    },

    {
       45, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088,-2084, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,

     2089, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,

     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088

    },

    {
       45, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084,-2085, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
    -2085, 2084, 2084,-2085, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084,-2085, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,

     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084,-2085, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,

     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084, 2084,
     2084, 2084, 2084, 2084, 2084, 2084
    },

    {
       45, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,

     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2091, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,

     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,

     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090
    },

    {
       45, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086,-2087, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
    -2087, 2086, 2086,-2087, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,

     2086, 2086, 2086,-2087, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086,-2087, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,

     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086, 2086,
     2086, 2086, 2086, 2086, 2086, 2086
    },

    {
       45, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,

     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092,-2088, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2093, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,

     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,

     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092
    },

    {
       45, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088,-2089, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,

    -2089, 2088, 2088,-2089, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088,-2089, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088,-2089, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,

     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088,
     2088, 2088, 2088, 2088, 2088, 2088

    },

    {
       45, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2095, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,

     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,

     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094
    },

    {
       45, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090,-2091, 2090, 2090,

     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
    -2091, 2090, 2090,-2091, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090,-2091, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090,-2091, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,

     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,

     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090, 2090,
     2090, 2090, 2090, 2090, 2090, 2090
    },

    {
       45, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096,-2092, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2097, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,

     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,

     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096
    },

    {
       45, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,

     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092,-2093, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
    -2093, 2092, 2092,-2093, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092,-2093, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092,-2093, 2092, 2092, 2092, 2092,

     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,

     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092, 2092,
     2092, 2092, 2092, 2092, 2092, 2092
    },

    {
       45, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,

     2099, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,

     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098

    },

    {
       45, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094,-2095, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
    -2095, 2094, 2094,-2095, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094,-2095, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,

     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094,-2095, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,

     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094, 2094,
     2094, 2094, 2094, 2094, 2094, 2094
    },

    {
       45, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100,-2096, 2100, 2100, 2100, 2100,

     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2101, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,

     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,

     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100
    },

    {
       45, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096,-2097, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
    -2097, 2096, 2096,-2097, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,

     2096, 2096, 2096,-2097, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096,-2097, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,

     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096, 2096,
     2096, 2096, 2096, 2096, 2096, 2096
    },

    {
       45, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,

     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2103, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,

     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,

     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102
    },

    {
       45, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098,-2099, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,

    -2099, 2098, 2098,-2099, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098,-2099, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098,-2099, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,

     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098, 2098

    },

    {
       45, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104,-2100, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2105, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,

     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,

     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104
    },

    {
       45, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100,-2101, 2100, 2100,

     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
    -2101, 2100, 2100,-2101, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100,-2101, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100,-2101, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,

     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,

     2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100, 2100,
     2100, 2100, 2100, 2100, 2100, 2100
    },

    {
       45, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2107, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,

     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,

     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106
    },

    {
       45, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,

     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102,-2103, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
    -2103, 2102, 2102,-2103, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102,-2103, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102,-2103, 2102, 2102, 2102, 2102,

     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,

     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102, 2102,
     2102, 2102, 2102, 2102, 2102, 2102
    },

    {
       45, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108,-2104, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,

     2109, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,

     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108

    },

    {
       45, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104,-2105, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
    -2105, 2104, 2104,-2105, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104,-2105, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,

     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104,-2105, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,

     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104,
     2104, 2104, 2104, 2104, 2104, 2104
    },

    {
       45, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,

     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2111, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,

     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,

     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110
    },

    {
       45, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106,-2107, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
    -2107, 2106, 2106,-2107, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,

     2106, 2106, 2106,-2107, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106,-2107, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,

     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106, 2106,
     2106, 2106, 2106, 2106, 2106, 2106
    },

    {
       45, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,

     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112,-2108, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2113, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,

     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,

     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112
    },

    {
       45, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108,-2109, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,

    -2109, 2108, 2108,-2109, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108,-2109, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108,-2109, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,

     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108

    },

    {
       45, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2115, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,

     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,

     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114
    },

    {
       45, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110,-2111, 2110, 2110,

     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
    -2111, 2110, 2110,-2111, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110,-2111, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110,-2111, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,

     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,

     2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110, 2110,
     2110, 2110, 2110, 2110, 2110, 2110
    },

    {
       45, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116,-2112, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2117, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,

     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,

     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116
    },

    {
       45, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,

     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112,-2113, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
    -2113, 2112, 2112,-2113, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112,-2113, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112,-2113, 2112, 2112, 2112, 2112,

     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,

     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112
    },

    {
       45, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,

     2119, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,

     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118

    },

    {
       45, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114,-2115, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
    -2115, 2114, 2114,-2115, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114,-2115, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,

     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114,-2115, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,

     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114
    },

    {
       45, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120,-2116, 2120, 2120, 2120, 2120,

     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2121, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,

     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,

     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120
    },

    {
       45, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116,-2117, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
    -2117, 2116, 2116,-2117, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,

     2116, 2116, 2116,-2117, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116,-2117, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,

     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116
    },

    {
       45, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,

     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2123, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,

     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,

     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122
    },

    {
       45, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118,-2119, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,

    -2119, 2118, 2118,-2119, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118,-2119, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118,-2119, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,

     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118, 2118,
     2118, 2118, 2118, 2118, 2118, 2118

    },

    {
       45, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124,-2120, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2125, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,

     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,

     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124
    },

    {
       45, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120,-2121, 2120, 2120,

     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
    -2121, 2120, 2120,-2121, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120,-2121, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120,-2121, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,

     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,

     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2120,
     2120, 2120, 2120, 2120, 2120, 2120
    },

    {
       45, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2127, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,

     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,

     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126
    },

    {
       45, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,

     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122,-2123, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
    -2123, 2122, 2122,-2123, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122,-2123, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122,-2123, 2122, 2122, 2122, 2122,

     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,

     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122, 2122,
     2122, 2122, 2122, 2122, 2122, 2122
    },

    {
       45, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128,-2124, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,

     2129, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,

     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128

    },

    {
       45, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124,-2125, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
    -2125, 2124, 2124,-2125, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124,-2125, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,

     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124,-2125, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,

     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124, 2124,
     2124, 2124, 2124, 2124, 2124, 2124
    },

    {
       45, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,

     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2131, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,

     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,

     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130
    },

    {
       45, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126,-2127, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
    -2127, 2126, 2126,-2127, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,

     2126, 2126, 2126,-2127, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126,-2127, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,

     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126, 2126,
     2126, 2126, 2126, 2126, 2126, 2126
    },

    {
       45, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,

     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132,-2128, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2133, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,

     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,

     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132
    },

    {
       45, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128,-2129, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,

    -2129, 2128, 2128,-2129, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128,-2129, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128,-2129, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,

     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2128, 2128, 2128, 2128, 2128

    },

    {
       45, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2135, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,

     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,

     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134
    },

    {
       45, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130,-2131, 2130, 2130,

     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
    -2131, 2130, 2130,-2131, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130,-2131, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130,-2131, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,

     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,

     2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130
    },

    {
       45, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136,-2132, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2137, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,

     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,

     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136
    },

    {
       45, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,

     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132,-2133, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
    -2133, 2132, 2132,-2133, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132,-2133, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132,-2133, 2132, 2132, 2132, 2132,

     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,

     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,
     2132, 2132, 2132, 2132, 2132, 2132
    },

    {
       45, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,

     2139, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,

     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138

    },

    {
       45, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134,-2135, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
    -2135, 2134, 2134,-2135, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134,-2135, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,

     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134,-2135, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,

     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134
    },

    {
       45, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140,-2136, 2140, 2140, 2140, 2140,

     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2141, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,

     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,

     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140
    },

    {
       45, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136,-2137, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
    -2137, 2136, 2136,-2137, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,

     2136, 2136, 2136,-2137, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136,-2137, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,

     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136, 2136,
     2136, 2136, 2136, 2136, 2136, 2136
    },

    {
       45, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,

     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2143, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,

     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,

     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142
    },

    {
       45, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138,-2139, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,

    -2139, 2138, 2138,-2139, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138,-2139, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138,-2139, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,

     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138, 2138, 2138, 2138, 2138, 2138

    },

    {
       45, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144,-2140, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2145, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,

     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,

     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144
    },

    {
       45, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140,-2141, 2140, 2140,

     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
    -2141, 2140, 2140,-2141, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140,-2141, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140,-2141, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,

     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,

     2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140, 2140,
     2140, 2140, 2140, 2140, 2140, 2140
    },

    {
       45, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2147, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,

     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,

     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146
    },

    {
       45, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,

     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142,-2143, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
    -2143, 2142, 2142,-2143, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142,-2143, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142,-2143, 2142, 2142, 2142, 2142,

     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,

     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142, 2142,
     2142, 2142, 2142, 2142, 2142, 2142
    },

    {
       45, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148,-2144, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,

     2149, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,

     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148

    },

    {
       45, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144,-2145, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
    -2145, 2144, 2144,-2145, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144,-2145, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,

     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144,-2145, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,

     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144, 2144,
     2144, 2144, 2144, 2144, 2144, 2144
    },

    {
       45, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,

     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2151, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,

     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,

     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150
    },

    {
       45, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146,-2147, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
    -2147, 2146, 2146,-2147, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,

     2146, 2146, 2146,-2147, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146,-2147, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,

     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146, 2146,
     2146, 2146, 2146, 2146, 2146, 2146
    },

    {
       45, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,

     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152,-2148, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2153, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,

     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,

     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152
    },

    {
       45, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148,-2149, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,

    -2149, 2148, 2148,-2149, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148,-2149, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148,-2149, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,

     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148, 2148,
     2148, 2148, 2148, 2148, 2148, 2148

    },

    {
       45, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2155, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,

     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,

     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154
    },

    {
       45, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150,-2151, 2150, 2150,

     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
    -2151, 2150, 2150,-2151, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150,-2151, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150,-2151, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,

     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,

     2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150, 2150,
     2150, 2150, 2150, 2150, 2150, 2150
    },

    {
       45, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156,-2152, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2157, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,

     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,

     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156
    },

    {
       45, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,

     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152,-2153, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
    -2153, 2152, 2152,-2153, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152,-2153, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152,-2153, 2152, 2152, 2152, 2152,

     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,

     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152, 2152,
     2152, 2152, 2152, 2152, 2152, 2152
    },

    {
       45, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,

     2159, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,

     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158

    },

    {
       45, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154,-2155, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
    -2155, 2154, 2154,-2155, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154,-2155, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,

     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154,-2155, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,

     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154, 2154,
     2154, 2154, 2154, 2154, 2154, 2154
    },

    {
       45, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160,-2156, 2160, 2160, 2160, 2160,

     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2161, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,

     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,

     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160
    },

    {
       45, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156,-2157, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
    -2157, 2156, 2156,-2157, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,

     2156, 2156, 2156,-2157, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156,-2157, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,

     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156, 2156,
     2156, 2156, 2156, 2156, 2156, 2156
    },

    {
       45, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,

     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2163, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,

     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,

     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162
    },

    {
       45, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158,-2159, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,

    -2159, 2158, 2158,-2159, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158,-2159, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158,-2159, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,

     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158, 2158,
     2158, 2158, 2158, 2158, 2158, 2158

    },

    {
       45, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164,-2160, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2165, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,

     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,

     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164
    },

    {
       45, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160,-2161, 2160, 2160,

     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
    -2161, 2160, 2160,-2161, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160,-2161, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160,-2161, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,

     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,

     2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160, 2160,
     2160, 2160, 2160, 2160, 2160, 2160
    },

    {
       45, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2167, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,

     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,

     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166
    },

    {
       45, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,

     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162,-2163, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
    -2163, 2162, 2162,-2163, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162,-2163, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162,-2163, 2162, 2162, 2162, 2162,

     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,

     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162
    },

    {
       45, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168,-2164, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,

     2169, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,

     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168

    },

    {
       45, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164,-2165, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
    -2165, 2164, 2164,-2165, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164,-2165, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,

     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164,-2165, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,

     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164, 2164,
     2164, 2164, 2164, 2164, 2164, 2164
    },

    {
       45, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,

     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2171, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,

     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,

     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170
    },

    {
       45, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166,-2167, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
    -2167, 2166, 2166,-2167, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,

     2166, 2166, 2166,-2167, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166,-2167, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,

     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166, 2166,
     2166, 2166, 2166, 2166, 2166, 2166
    },

    {
       45, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,

     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172,-2168, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2173, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,

     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,

     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172
    },

    {
       45, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168,-2169, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,

    -2169, 2168, 2168,-2169, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168,-2169, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168,-2169, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,

     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168,
     2168, 2168, 2168, 2168, 2168, 2168

    },

    {
       45, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2175, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,

     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,

     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174
    },

    {
       45, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170,-2171, 2170, 2170,

     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
    -2171, 2170, 2170,-2171, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170,-2171, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170,-2171, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,

     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,

     2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170, 2170,
     2170, 2170, 2170, 2170, 2170, 2170
    },

    {
       45, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176,-2172, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2177, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,

     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,

     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176
    },

    {
       45, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,

     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172,-2173, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
    -2173, 2172, 2172,-2173, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172,-2173, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172,-2173, 2172, 2172, 2172, 2172,

     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,

     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172, 2172,
     2172, 2172, 2172, 2172, 2172, 2172
    },

    {
       45, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,

     2179, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,

     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178

    },

    {
       45, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174,-2175, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
    -2175, 2174, 2174,-2175, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174,-2175, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,

     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174,-2175, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,

     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174, 2174,
     2174, 2174, 2174, 2174, 2174, 2174
    },

    {
       45, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180,-2176, 2180, 2180, 2180, 2180,

     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2181, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,

     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,

     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180
    },

    {
       45, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176,-2177, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
    -2177, 2176, 2176,-2177, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,

     2176, 2176, 2176,-2177, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176,-2177, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,

     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176, 2176,
     2176, 2176, 2176, 2176, 2176, 2176
    },

    {
       45, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,

     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2183, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,

     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,

     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182
    },

    {
       45, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178,-2179, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,

    -2179, 2178, 2178,-2179, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178,-2179, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178,-2179, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,

     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178, 2178,
     2178, 2178, 2178, 2178, 2178, 2178

    },

    {
       45, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184,-2180, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2185, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,

     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,

     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184
    },

    {
       45, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180,-2181, 2180, 2180,

     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
    -2181, 2180, 2180,-2181, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180,-2181, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180,-2181, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,

     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,

     2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180, 2180,
     2180, 2180, 2180, 2180, 2180, 2180
    },

    {
       45, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2187, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,

     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,

     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186
    },

    {
       45, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,

     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182,-2183, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
    -2183, 2182, 2182,-2183, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182,-2183, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182,-2183, 2182, 2182, 2182, 2182,

     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,

     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182, 2182,
     2182, 2182, 2182, 2182, 2182, 2182
    },

    {
       45, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188,-2184, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,

     2189, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,

     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188

    },

    {
       45, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184,-2185, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
    -2185, 2184, 2184,-2185, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184,-2185, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,

     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184,-2185, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,

     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184,
     2184, 2184, 2184, 2184, 2184, 2184
    },

    {
       45, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,

     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2191, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,

     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,

     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190
    },

    {
       45, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186,-2187, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
    -2187, 2186, 2186,-2187, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,

     2186, 2186, 2186,-2187, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186,-2187, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,

     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186, 2186,
     2186, 2186, 2186, 2186, 2186, 2186
    },

    {
       45, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,

     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192,-2188, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2193, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,

     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,

     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192
    },

    {
       45, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188,-2189, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,

    -2189, 2188, 2188,-2189, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188,-2189, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188,-2189, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,

     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188

    },

    {
       45, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2195, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,

     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,

     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194
    },

    {
       45, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190,-2191, 2190, 2190,

     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
    -2191, 2190, 2190,-2191, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190,-2191, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190,-2191, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,

     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,

     2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190, 2190,
     2190, 2190, 2190, 2190, 2190, 2190
    },

    {
       45, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196,-2192, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2197, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,

     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,

     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196
    },

    {
       45, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,

     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192,-2193, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
    -2193, 2192, 2192,-2193, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192,-2193, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192,-2193, 2192, 2192, 2192, 2192,

     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,

     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192, 2192,
     2192, 2192, 2192, 2192, 2192, 2192
    },

    {
       45, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,

     2199, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,

     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198

    },

    {
       45, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194,-2195, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
    -2195, 2194, 2194,-2195, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194,-2195, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,

     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194,-2195, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,

     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194, 2194,
     2194, 2194, 2194, 2194, 2194, 2194
    },

    {
       45, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200,-2196, 2200, 2200, 2200, 2200,

     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2201, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,

     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,

     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200
    },

    {
       45, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196,-2197, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
    -2197, 2196, 2196,-2197, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,

     2196, 2196, 2196,-2197, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196,-2197, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,

     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196, 2196,
     2196, 2196, 2196, 2196, 2196, 2196
    },

    {
       45, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,

     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2203, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,

     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,

     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202
    },

    {
       45, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198,-2199, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,

    -2199, 2198, 2198,-2199, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198,-2199, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198,-2199, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,

     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198, 2198,
     2198, 2198, 2198, 2198, 2198, 2198

    },

    {
       45, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204,-2200, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2205, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,

     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,

     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204
    },

    {
       45, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200,-2201, 2200, 2200,

     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
    -2201, 2200, 2200,-2201, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200,-2201, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200,-2201, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,

     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,

     2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200,
     2200, 2200, 2200, 2200, 2200, 2200
    },

    {
       45, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2207, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,

     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,

     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206
    },

    {
       45, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,

     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202,-2203, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
    -2203, 2202, 2202,-2203, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202,-2203, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202,-2203, 2202, 2202, 2202, 2202,

     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,

     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202, 2202,
     2202, 2202, 2202, 2202, 2202, 2202
    },

    {
       45, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208,-2204, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,

     2209, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,

     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208

    },

    {
       45, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204,-2205, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
    -2205, 2204, 2204,-2205, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204,-2205, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,

     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204,-2205, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,

     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204, 2204,
     2204, 2204, 2204, 2204, 2204, 2204
    },

    {
       45, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,

     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2211, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,

     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,

     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210
    },

    {
       45, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206,-2207, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
    -2207, 2206, 2206,-2207, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,

     2206, 2206, 2206,-2207, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206,-2207, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,

     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2206, 2206, 2206
    },

    {
       45, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,

     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212,-2208, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2213, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,

     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,

     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212
    },

    {
       45, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208,-2209, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,

    -2209, 2208, 2208,-2209, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208,-2209, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208,-2209, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,

     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208, 2208,
     2208, 2208, 2208, 2208, 2208, 2208

    },

    {
       45, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2215, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,

     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,

     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214
    },

    {
       45, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210,-2211, 2210, 2210,

     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
    -2211, 2210, 2210,-2211, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210,-2211, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210,-2211, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,

     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,

     2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210, 2210,
     2210, 2210, 2210, 2210, 2210, 2210
    },

    {
       45, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216,-2212, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2217, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,

     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,

     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216
    },

    {
       45, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,

     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212,-2213, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
    -2213, 2212, 2212,-2213, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212,-2213, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212,-2213, 2212, 2212, 2212, 2212,

     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,

     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212
    },

    {
       45, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,

     2219, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,

     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218

    },

    {
       45, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214,-2215, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
    -2215, 2214, 2214,-2215, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214,-2215, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,

     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214,-2215, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,

     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214, 2214,
     2214, 2214, 2214, 2214, 2214, 2214
    },

    {
       45, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220,-2216, 2220, 2220, 2220, 2220,

     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2221, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,

     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,

     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220
    },

    {
       45, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216,-2217, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
    -2217, 2216, 2216,-2217, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,

     2216, 2216, 2216,-2217, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216,-2217, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,

     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 2216, 2216
    },

    {
       45, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,

     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2223, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,

     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,

     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222
    },

    {
       45, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218,-2219, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,

    -2219, 2218, 2218,-2219, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218,-2219, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218,-2219, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,

     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 2218, 2218

    },

    {
       45, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224,-2220, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2225, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,

     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,

     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224
    },

    {
       45, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220,-2221, 2220, 2220,

     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
    -2221, 2220, 2220,-2221, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220,-2221, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220,-2221, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,

     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,

     2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220, 2220,
     2220, 2220, 2220, 2220, 2220, 2220
    },

    {
       45, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2227, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,

     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,

     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226
    },

    {
       45, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,

     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222,-2223, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
    -2223, 2222, 2222,-2223, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222,-2223, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222,-2223, 2222, 2222, 2222, 2222,

     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,

     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222
    },

    {
       45, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228,-2224, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,

     2229, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,

     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228

    },

    {
       45, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224,-2225, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
    -2225, 2224, 2224,-2225, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224,-2225, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,

     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224,-2225, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,

     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224, 2224,
     2224, 2224, 2224, 2224, 2224, 2224
    },

    {
       45, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,

     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2231, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,

     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,

     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230
    },

    {
       45, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226,-2227, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
    -2227, 2226, 2226,-2227, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,

     2226, 2226, 2226,-2227, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226,-2227, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,

     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226, 2226,
     2226, 2226, 2226, 2226, 2226, 2226
    },

    {
       45, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,

     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232,-2228, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2233, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,

     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,

     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232
    },

    {
       45, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228,-2229, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,

    -2229, 2228, 2228,-2229, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228,-2229, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228,-2229, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,

     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228, 2228,
     2228, 2228, 2228, 2228, 2228, 2228

    },

    {
       45, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2235, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,

     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,

     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234
    },

    {
       45, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230,-2231, 2230, 2230,

     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
    -2231, 2230, 2230,-2231, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230,-2231, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230,-2231, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,

     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,

     2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230, 2230,
     2230, 2230, 2230, 2230, 2230, 2230
    },

    {
       45, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236,-2232, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2237, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,

     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,

     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236
    },

    {
       45, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,

     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232,-2233, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
    -2233, 2232, 2232,-2233, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232,-2233, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232,-2233, 2232, 2232, 2232, 2232,

     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,

     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2232, 2232, 2232, 2232, 2232, 2232
    },

    {
       45, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,

     2239, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,

     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238

    },

    {
       45, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234,-2235, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
    -2235, 2234, 2234,-2235, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234,-2235, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,

     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234,-2235, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,

     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234
    },

    {
       45, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240,-2236, 2240, 2240, 2240, 2240,

     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2241, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,

     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,

     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240
    },

    {
       45, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236,-2237, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
    -2237, 2236, 2236,-2237, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,

     2236, 2236, 2236,-2237, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236,-2237, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,

     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236, 2236,
     2236, 2236, 2236, 2236, 2236, 2236
    },

    {
       45, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,

     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2243, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,

     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,

     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242
    },

    {
       45, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238,-2239, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,

    -2239, 2238, 2238,-2239, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238,-2239, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238,-2239, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,

     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238, 2238,
     2238, 2238, 2238, 2238, 2238, 2238

    },

    {
       45, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244,-2240, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2245, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,

     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,

     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244
    },

    {
       45, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240,-2241, 2240, 2240,

     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
    -2241, 2240, 2240,-2241, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240,-2241, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240,-2241, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,

     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,

     2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2240,
     2240, 2240, 2240, 2240, 2240, 2240
    },

    {
       45, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2247, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,

     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,

     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246
    },

    {
       45, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,

     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242,-2243, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
    -2243, 2242, 2242,-2243, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242,-2243, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242,-2243, 2242, 2242, 2242, 2242,

     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,

     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242, 2242,
     2242, 2242, 2242, 2242, 2242, 2242
    },

    {
       45, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248,-2244, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,

     2249, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,

     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248

    },

    {
       45, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244,-2245, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
    -2245, 2244, 2244,-2245, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244,-2245, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,

     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244,-2245, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,

     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244, 2244,
     2244, 2244, 2244, 2244, 2244, 2244
    },

    {
       45, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,

     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2251, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,

     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,

     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250
    },

    {
       45, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246,-2247, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
    -2247, 2246, 2246,-2247, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,

     2246, 2246, 2246,-2247, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246,-2247, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,

     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246, 2246,
     2246, 2246, 2246, 2246, 2246, 2246
    },

    {
       45, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,

     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252,-2248, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2253, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,

     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,

     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252
    },

    {
       45, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248,-2249, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,

    -2249, 2248, 2248,-2249, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248,-2249, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248,-2249, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,

     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248

    },

    {
       45, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2255, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,

     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,

     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254
    },

    {
       45, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250,-2251, 2250, 2250,

     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
    -2251, 2250, 2250,-2251, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250,-2251, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250,-2251, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,

     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,

     2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250, 2250,
     2250, 2250, 2250, 2250, 2250, 2250
    },

    {
       45, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256,-2252, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2257, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,

     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,

     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256
    },

    {
       45, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,

     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252,-2253, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
    -2253, 2252, 2252,-2253, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252,-2253, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252,-2253, 2252, 2252, 2252, 2252,

     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,

     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252, 2252,
     2252, 2252, 2252, 2252, 2252, 2252
    },

    {
       45, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,

     2259, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,

     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258

    },

    {
       45, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254,-2255, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
    -2255, 2254, 2254,-2255, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254,-2255, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,

     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254,-2255, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,

     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254, 2254,
     2254, 2254, 2254, 2254, 2254, 2254
    },

    {
       45, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260,-2256, 2260, 2260, 2260, 2260,

     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2261, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,

     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,

     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260
    },

    {
       45, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256,-2257, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
    -2257, 2256, 2256,-2257, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,

     2256, 2256, 2256,-2257, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256,-2257, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,

     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256
    },

    {
       45, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,

     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2263, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,

     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,

     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262
    },

    {
       45, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258,-2259, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,

    -2259, 2258, 2258,-2259, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258,-2259, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258,-2259, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,

     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258, 2258,
     2258, 2258, 2258, 2258, 2258, 2258

    },

    {
       45, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264,-2260, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2265, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,

     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,

     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264
    },

    {
       45, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260,-2261, 2260, 2260,

     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
    -2261, 2260, 2260,-2261, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260,-2261, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260,-2261, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,

     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,

     2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2260, 2260
    },

    {
       45, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2267, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,

     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,

     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266
    },

    {
       45, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,

     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262,-2263, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
    -2263, 2262, 2262,-2263, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262,-2263, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262,-2263, 2262, 2262, 2262, 2262,

     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,

     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262
    },

    {
       45, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268,-2264, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,

     2269, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,

     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268

    },

    {
       45, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264,-2265, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
    -2265, 2264, 2264,-2265, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264,-2265, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,

     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264,-2265, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,

     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2264, 2264, 2264, 2264
    },

    {
       45, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,

     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2271, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,

     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,

     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270
    },

    {
       45, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266,-2267, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
    -2267, 2266, 2266,-2267, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,

     2266, 2266, 2266,-2267, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266,-2267, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,

     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266,
     2266, 2266, 2266, 2266, 2266, 2266
    },

    {
       45, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,

     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272,-2268, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2273, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,

     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,

     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272
    },

    {
       45, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268,-2269, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,

    -2269, 2268, 2268,-2269, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268,-2269, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268,-2269, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,

     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268, 2268,
     2268, 2268, 2268, 2268, 2268, 2268

    },

    {
       45, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2275, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,

     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,

     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274
    },

    {
       45, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270,-2271, 2270, 2270,

     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
    -2271, 2270, 2270,-2271, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270,-2271, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270,-2271, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,

     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,

     2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270, 2270,
     2270, 2270, 2270, 2270, 2270, 2270
    },

    {
       45, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276,-2272, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2277, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,

     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,

     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276
    },

    {
       45, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,

     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272,-2273, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
    -2273, 2272, 2272,-2273, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272,-2273, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272,-2273, 2272, 2272, 2272, 2272,

     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,

     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272, 2272,
     2272, 2272, 2272, 2272, 2272, 2272
    },

    {
       45, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,

     2279, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,

     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278

    },

    {
       45, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274,-2275, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
    -2275, 2274, 2274,-2275, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274,-2275, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,

     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274,-2275, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,

     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274, 2274,
     2274, 2274, 2274, 2274, 2274, 2274
    },

    {
       45, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280,-2276, 2280, 2280, 2280, 2280,

     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2281, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,

     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,

     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280
    },

    {
       45, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276,-2277, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
    -2277, 2276, 2276,-2277, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,

     2276, 2276, 2276,-2277, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276,-2277, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,

     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2276, 2276
    },

    {
       45, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,

     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2283, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,

     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,

     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282
    },

    {
       45, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278,-2279, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,

    -2279, 2278, 2278,-2279, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278,-2279, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278,-2279, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,

     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278, 2278,
     2278, 2278, 2278, 2278, 2278, 2278

    },

    {
       45, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284,-2280, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2285, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,

     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,

     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284
    },

    {
       45, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280,-2281, 2280, 2280,

     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
    -2281, 2280, 2280,-2281, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280,-2281, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280,-2281, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,

     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,

     2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280, 2280,
     2280, 2280, 2280, 2280, 2280, 2280
    },

    {
       45, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2287, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,

     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,

     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286
    },

    {
       45, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,

     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282,-2283, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
    -2283, 2282, 2282,-2283, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282,-2283, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282,-2283, 2282, 2282, 2282, 2282,

     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,

     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2282, 2282
    },

    {
       45, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288,-2284, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,

     2289, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,

     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288

    },

    {
       45, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284,-2285, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
    -2285, 2284, 2284,-2285, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284,-2285, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,

     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284,-2285, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,

     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284, 2284,
     2284, 2284, 2284, 2284, 2284, 2284
    },

    {
       45, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,

     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2291, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,

     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,

     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290
    },

    {
       45, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286,-2287, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
    -2287, 2286, 2286,-2287, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,

     2286, 2286, 2286,-2287, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286,-2287, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,

     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286
    },

    {
       45, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,

     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292,-2288, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2293, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,

     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,

     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292
    },

    {
       45, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288,-2289, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,

    -2289, 2288, 2288,-2289, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288,-2289, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288,-2289, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,

     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288, 2288,
     2288, 2288, 2288, 2288, 2288, 2288

    },

    {
       45, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2295, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,

     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,

     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294
    },

    {
       45, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290,-2291, 2290, 2290,

     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
    -2291, 2290, 2290,-2291, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290,-2291, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290,-2291, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,

     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,

     2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2290, 2290
    },

    {
       45, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296,-2292, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2297, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,

     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,

     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296
    },

    {
       45, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,

     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292,-2293, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
    -2293, 2292, 2292,-2293, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292,-2293, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292,-2293, 2292, 2292, 2292, 2292,

     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,

     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292, 2292,
     2292, 2292, 2292, 2292, 2292, 2292
    },

    {
       45, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,

     2299, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,

     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298

    },

    {
       45, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294,-2295, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
    -2295, 2294, 2294,-2295, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294,-2295, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,

     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294,-2295, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,

     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2294, 2294
    },

    {
       45, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300,-2296, 2300, 2300, 2300, 2300,

     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2301, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,

     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,

     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300
    },

    {
       45, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296,-2297, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
    -2297, 2296, 2296,-2297, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,

     2296, 2296, 2296,-2297, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296,-2297, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,

     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296,
     2296, 2296, 2296, 2296, 2296, 2296
    },

    {
       45, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,

     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2303, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,

     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,

     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302
    },

    {
       45, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298,-2299, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,

    -2299, 2298, 2298,-2299, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298,-2299, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298,-2299, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,

     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298, 2298,
     2298, 2298, 2298, 2298, 2298, 2298

    },

    {
       45, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304,-2300, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2305, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,

     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,

     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304
    },

    {
       45, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300,-2301, 2300, 2300,

     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
    -2301, 2300, 2300,-2301, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300,-2301, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300,-2301, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,

     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,

     2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300, 2300,
     2300, 2300, 2300, 2300, 2300, 2300
    },

    {
       45, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2307, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,

     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,

     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306
    },

    {
       45, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,

     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302,-2303, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
    -2303, 2302, 2302,-2303, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302,-2303, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302,-2303, 2302, 2302, 2302, 2302,

     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,

     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 2302,
     2302, 2302, 2302, 2302, 2302, 2302
    },

    {
       45, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308,-2304, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,

     2309, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,

     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308

    },

    {
       45, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304,-2305, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
    -2305, 2304, 2304,-2305, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304,-2305, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,

     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304,-2305, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,

     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304,
     2304, 2304, 2304, 2304, 2304, 2304
    },

    {
       45, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,

     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2311, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,

     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,

     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310
    },

    {
       45, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306,-2307, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
    -2307, 2306, 2306,-2307, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,

     2306, 2306, 2306,-2307, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306,-2307, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,

     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306
    },

    {
       45, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,

     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312,-2308, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2313, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,

     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,

     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312
    },

    {
       45, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308,-2309, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,

    -2309, 2308, 2308,-2309, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308,-2309, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308,-2309, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,

     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308, 2308,
     2308, 2308, 2308, 2308, 2308, 2308

    },

    {
       45, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2315, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,

     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,

     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314
    },

    {
       45, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310,-2311, 2310, 2310,

     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
    -2311, 2310, 2310,-2311, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310,-2311, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310,-2311, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,

     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,

     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2310, 2310
    },

    {
       45, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316,-2312, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2317, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,

     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,

     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316
    },

    {
       45, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,

     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312,-2313, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
    -2313, 2312, 2312,-2313, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312,-2313, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312,-2313, 2312, 2312, 2312, 2312,

     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,

     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312, 2312,
     2312, 2312, 2312, 2312, 2312, 2312
    },

    {
       45, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,

     2319, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,

     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318

    },

    {
       45, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314,-2315, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
    -2315, 2314, 2314,-2315, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314,-2315, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,

     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314,-2315, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,

     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2314,
     2314, 2314, 2314, 2314, 2314, 2314
    },

    {
       45, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320,-2316, 2320, 2320, 2320, 2320,

     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2321, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,

     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,

     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320
    },

    {
       45, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316,-2317, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
    -2317, 2316, 2316,-2317, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,

     2316, 2316, 2316,-2317, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316,-2317, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,

     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316, 2316,
     2316, 2316, 2316, 2316, 2316, 2316
    },

    {
       45, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,

     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2323, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,

     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,

     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322
    },

    {
       45, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318,-2319, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,

    -2319, 2318, 2318,-2319, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318,-2319, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318,-2319, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,

     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318, 2318,
     2318, 2318, 2318, 2318, 2318, 2318

    },

    {
       45, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324,-2320, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2325, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,

     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,

     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324
    },

    {
       45, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320,-2321, 2320, 2320,

     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
    -2321, 2320, 2320,-2321, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320,-2321, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320,-2321, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,

     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,

     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2320, 2320, 2320, 2320, 2320, 2320
    },

    {
       45, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2327, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,

     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,

     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326
    },

    {
       45, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,

     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322,-2323, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
    -2323, 2322, 2322,-2323, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322,-2323, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322,-2323, 2322, 2322, 2322, 2322,

     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,

     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322,
     2322, 2322, 2322, 2322, 2322, 2322
    },

    {
       45, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328,-2324, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,

     2329, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,

     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328

    },

    {
       45, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324,-2325, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
    -2325, 2324, 2324,-2325, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324,-2325, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,

     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324,-2325, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,

     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324
    },

    {
       45, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,

     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2331, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,

     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,

     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330
    },

    {
       45, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326,-2327, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
    -2327, 2326, 2326,-2327, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,

     2326, 2326, 2326,-2327, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326,-2327, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,

     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326
    },

    {
       45, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,

     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332,-2328, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2333, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,

     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,

     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332
    },

    {
       45, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328,-2329, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,

    -2329, 2328, 2328,-2329, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328,-2329, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328,-2329, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,

     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328

    },

    {
       45, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2335, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,

     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,

     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334
    },

    {
       45, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330,-2331, 2330, 2330,

     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
    -2331, 2330, 2330,-2331, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330,-2331, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330,-2331, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,

     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,

     2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330, 2330,
     2330, 2330, 2330, 2330, 2330, 2330
    },

    {
       45, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336,-2332, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2337, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,

     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,

     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336
    },

    {
       45, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,

     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332,-2333, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
    -2333, 2332, 2332,-2333, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332,-2333, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332,-2333, 2332, 2332, 2332, 2332,

     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,

     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332
    },

    {
       45, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,

     2339, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,

     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338

    },

    {
       45, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334,-2335, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
    -2335, 2334, 2334,-2335, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334,-2335, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,

     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334,-2335, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,

     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2334,
     2334, 2334, 2334, 2334, 2334, 2334
    },

    {
       45, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340,-2336, 2340, 2340, 2340, 2340,

     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2341, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,

     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,

     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340
    },

    {
       45, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336,-2337, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
    -2337, 2336, 2336,-2337, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,

     2336, 2336, 2336,-2337, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336,-2337, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,

     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336, 2336,
     2336, 2336, 2336, 2336, 2336, 2336
    },

    {
       45, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,

     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2343, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,

     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,

     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342
    },

    {
       45, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338,-2339, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,

    -2339, 2338, 2338,-2339, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338,-2339, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338,-2339, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,

     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338, 2338,
     2338, 2338, 2338, 2338, 2338, 2338

    },

    {
       45, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344,-2340, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2345, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,

     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,

     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344
    },

    {
       45, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340,-2341, 2340, 2340,

     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
    -2341, 2340, 2340,-2341, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340,-2341, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340,-2341, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,

     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,

     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340
    },

    {
       45, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2347, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,

     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,

     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346
    },

    {
       45, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,

     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342,-2343, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
    -2343, 2342, 2342,-2343, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342,-2343, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342,-2343, 2342, 2342, 2342, 2342,

     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,

     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342, 2342,
     2342, 2342, 2342, 2342, 2342, 2342
    },

    {
       45, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348,-2344, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,

     2349, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,

     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348

    },

    {
       45, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344,-2345, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
    -2345, 2344, 2344,-2345, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344,-2345, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,

     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344,-2345, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,

     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344
    },

    {
       45, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,

     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2351, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,

     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,

     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350
    },

    {
       45, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346,-2347, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
    -2347, 2346, 2346,-2347, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,

     2346, 2346, 2346,-2347, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346,-2347, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,

     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346, 2346,
     2346, 2346, 2346, 2346, 2346, 2346
    },

    {
       45, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,

     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352,-2348, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2353, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,

     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,

     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352
    },

    {
       45, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348,-2349, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,

    -2349, 2348, 2348,-2349, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348,-2349, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348,-2349, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,

     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348, 2348,
     2348, 2348, 2348, 2348, 2348, 2348

    },

    {
       45, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2355, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,

     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,

     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354
    },

    {
       45, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350,-2351, 2350, 2350,

     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
    -2351, 2350, 2350,-2351, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350,-2351, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350,-2351, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,

     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,

     2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350, 2350,
     2350, 2350, 2350, 2350, 2350, 2350
    },

    {
       45, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356,-2352, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2357, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,

     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,

     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356
    },

    {
       45, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,

     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352,-2353, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
    -2353, 2352, 2352,-2353, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352,-2353, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352,-2353, 2352, 2352, 2352, 2352,

     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,

     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352
    },

    {
       45, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,

     2359, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,

     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358

    },

    {
       45, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354,-2355, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
    -2355, 2354, 2354,-2355, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354,-2355, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,

     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354,-2355, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,

     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354, 2354,
     2354, 2354, 2354, 2354, 2354, 2354
    },

    {
       45, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360,-2356, 2360, 2360, 2360, 2360,

     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2361, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,

     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,

     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360
    },

    {
       45, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356,-2357, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
    -2357, 2356, 2356,-2357, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,

     2356, 2356, 2356,-2357, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356,-2357, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,

     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356
    },

    {
       45, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,

     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2363, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,

     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,

     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362
    },

    {
       45, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358,-2359, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,

    -2359, 2358, 2358,-2359, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358,-2359, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358,-2359, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,

     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358,
     2358, 2358, 2358, 2358, 2358, 2358

    },

    {
       45, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364,-2360, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2365, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,

     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,

     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364
    },

    {
       45, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360,-2361, 2360, 2360,

     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
    -2361, 2360, 2360,-2361, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360,-2361, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360,-2361, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,

     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,

     2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360, 2360,
     2360, 2360, 2360, 2360, 2360, 2360
    },

    {
       45, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2367, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,

     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,

     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366
    },

    {
       45, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,

     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362,-2363, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
    -2363, 2362, 2362,-2363, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362,-2363, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362,-2363, 2362, 2362, 2362, 2362,

     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,

     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362, 2362,
     2362, 2362, 2362, 2362, 2362, 2362
    },

    {
       45, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368,-2364, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,

     2369, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,

     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368

    },

    {
       45, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364,-2365, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
    -2365, 2364, 2364,-2365, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364,-2365, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,

     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364,-2365, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,

     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364, 2364,
     2364, 2364, 2364, 2364, 2364, 2364
    },

    {
       45, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,

     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2371, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,

     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,

     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370
    },

    {
       45, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366,-2367, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
    -2367, 2366, 2366,-2367, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,

     2366, 2366, 2366,-2367, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366,-2367, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,

     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366, 2366,
     2366, 2366, 2366, 2366, 2366, 2366
    },

    {
       45, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,

     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372,-2368, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2373, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,

     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,

     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372
    },

    {
       45, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368,-2369, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,

    -2369, 2368, 2368,-2369, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368,-2369, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368,-2369, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,

     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368, 2368,
     2368, 2368, 2368, 2368, 2368, 2368

    },

    {
       45, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2375, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,

     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,

     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374
    },

    {
       45, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370,-2371, 2370, 2370,

     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
    -2371, 2370, 2370,-2371, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370,-2371, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370,-2371, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,

     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,

     2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370, 2370,
     2370, 2370, 2370, 2370, 2370, 2370
    },

    {
       45, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376,-2372, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2377, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,

     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,

     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376
    },

    {
       45, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,

     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372,-2373, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
    -2373, 2372, 2372,-2373, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372,-2373, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372,-2373, 2372, 2372, 2372, 2372,

     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,

     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372, 2372,
     2372, 2372, 2372, 2372, 2372, 2372
    },

    {
       45, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,

     2379, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,

     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378

    },

    {
       45, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374,-2375, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
    -2375, 2374, 2374,-2375, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374,-2375, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,

     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374,-2375, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,

     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374, 2374,
     2374, 2374, 2374, 2374, 2374, 2374
    },

    {
       45, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380,-2376, 2380, 2380, 2380, 2380,

     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2381, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,

     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,

     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380
    },

    {
       45, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376,-2377, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
    -2377, 2376, 2376,-2377, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,

     2376, 2376, 2376,-2377, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376,-2377, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,

     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376, 2376,
     2376, 2376, 2376, 2376, 2376, 2376
    },

    {
       45, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,

     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2383, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,

     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,

     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382
    },

    {
       45, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378,-2379, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,

    -2379, 2378, 2378,-2379, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378,-2379, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378,-2379, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,

     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378, 2378,
     2378, 2378, 2378, 2378, 2378, 2378

    },

    {
       45, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384,-2380, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2385, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,

     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,

     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384
    },

    {
       45, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380,-2381, 2380, 2380,

     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
    -2381, 2380, 2380,-2381, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380,-2381, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380,-2381, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,

     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,

     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380
    },

    {
       45, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2387, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,

     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,

     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386
    },

    {
       45, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,

     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382,-2383, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
    -2383, 2382, 2382,-2383, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382,-2383, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382,-2383, 2382, 2382, 2382, 2382,

     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,

     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382, 2382,
     2382, 2382, 2382, 2382, 2382, 2382
    },

    {
       45, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388,-2384, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,

     2389, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,

     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388

    },

    {
       45, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384,-2385, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
    -2385, 2384, 2384,-2385, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384,-2385, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,

     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384,-2385, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,

     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384, 2384,
     2384, 2384, 2384, 2384, 2384, 2384
    },

    {
       45, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,

     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2391, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,

     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,

     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390
    },

    {
       45, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386,-2387, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
    -2387, 2386, 2386,-2387, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,

     2386, 2386, 2386,-2387, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386,-2387, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,

     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2386,
     2386, 2386, 2386, 2386, 2386, 2386
    },

    {
       45, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,

     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392,-2388, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2393, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,

     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,

     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392
    },

    {
       45, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388,-2389, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,

    -2389, 2388, 2388,-2389, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388,-2389, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388,-2389, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,

     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388, 2388,
     2388, 2388, 2388, 2388, 2388, 2388

    },

    {
       45, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2395, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,

     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,

     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394
    },

    {
       45, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390,-2391, 2390, 2390,

     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
    -2391, 2390, 2390,-2391, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390,-2391, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390,-2391, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,

     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,

     2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390, 2390,
     2390, 2390, 2390, 2390, 2390, 2390
    },

    {
       45, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396,-2392, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2397, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,

     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,

     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396
    },

    {
       45, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,

     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392,-2393, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
    -2393, 2392, 2392,-2393, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392,-2393, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392,-2393, 2392, 2392, 2392, 2392,

     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,

     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392, 2392,
     2392, 2392, 2392, 2392, 2392, 2392
    },

    {
       45, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,

     2399, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,

     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398

    },

    {
       45, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394,-2395, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
    -2395, 2394, 2394,-2395, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394,-2395, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,

     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394,-2395, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,

     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2394, 2394, 2394, 2394, 2394
    },

    {
       45, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400,-2396, 2400, 2400, 2400, 2400,

     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2401, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,

     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,

     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400
    },

    {
       45, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396,-2397, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
    -2397, 2396, 2396,-2397, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,

     2396, 2396, 2396,-2397, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396,-2397, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,

     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2396
    },

    {
       45, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,

     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2403, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,

     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,

     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402
    },

    {
       45, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398,-2399, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,

    -2399, 2398, 2398,-2399, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398,-2399, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398,-2399, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,

     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 2398,
     2398, 2398, 2398, 2398, 2398, 2398

    },

    {
       45, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404,-2400, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2405, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,

     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,

     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404
    },

    {
       45, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400,-2401, 2400, 2400,

     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
    -2401, 2400, 2400,-2401, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400,-2401, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400,-2401, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,

     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,

     2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 2400,
     2400, 2400, 2400, 2400, 2400, 2400
    },

    {
       45, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2407, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,

     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,

     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406
    },

    {
       45, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,

     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402,-2403, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
    -2403, 2402, 2402,-2403, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402,-2403, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402,-2403, 2402, 2402, 2402, 2402,

     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,

     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402
    },

    {
       45, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408,-2404, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,

     2409, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,

     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408

    },

    {
       45, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404,-2405, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
    -2405, 2404, 2404,-2405, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404,-2405, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,

     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404,-2405, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,

     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404, 2404,
     2404, 2404, 2404, 2404, 2404, 2404
    },

    {
       45, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,

     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2411, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,

     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,

     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410
    },

    {
       45, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406,-2407, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
    -2407, 2406, 2406,-2407, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,

     2406, 2406, 2406,-2407, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406,-2407, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,

     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,
     2406, 2406, 2406, 2406, 2406, 2406
    },

    {
       45, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,

     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412,-2408, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2413, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,

     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,

     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412
    },

    {
       45, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408,-2409, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,

    -2409, 2408, 2408,-2409, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408,-2409, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408,-2409, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,

     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408

    },

    {
       45, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2415, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,

     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,

     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414
    },

    {
       45, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410,-2411, 2410, 2410,

     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
    -2411, 2410, 2410,-2411, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410,-2411, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410,-2411, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,

     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,

     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410
    },

    {
       45, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416,-2412, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2417, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,

     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,

     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416
    },

    {
       45, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,

     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412,-2413, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
    -2413, 2412, 2412,-2413, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412,-2413, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412,-2413, 2412, 2412, 2412, 2412,

     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,

     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412, 2412,
     2412, 2412, 2412, 2412, 2412, 2412
    },

    {
       45, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,

     2419, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,

     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418

    },

    {
       45, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414,-2415, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
    -2415, 2414, 2414,-2415, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414,-2415, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,

     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414,-2415, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,

     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414
    },

    {
       45, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420,-2416, 2420, 2420, 2420, 2420,

     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2421, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,

     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,

     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420
    },

    {
       45, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416,-2417, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
    -2417, 2416, 2416,-2417, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,

     2416, 2416, 2416,-2417, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416,-2417, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,

     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416
    },

    {
       45, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,

     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2423, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,

     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,

     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422
    },

    {
       45, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418,-2419, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,

    -2419, 2418, 2418,-2419, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418,-2419, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418,-2419, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,

     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418, 2418,
     2418, 2418, 2418, 2418, 2418, 2418

    },

    {
       45, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424,-2420, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2425, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,

     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,

     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424
    },

    {
       45, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420,-2421, 2420, 2420,

     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
    -2421, 2420, 2420,-2421, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420,-2421, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420,-2421, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,

     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,

     2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420, 2420,
     2420, 2420, 2420, 2420, 2420, 2420
    },

    {
       45, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2427, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,

     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,

     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426
    },

    {
       45, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,

     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422,-2423, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
    -2423, 2422, 2422,-2423, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422,-2423, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422,-2423, 2422, 2422, 2422, 2422,

     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,

     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422
    },

    {
       45, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428,-2424, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,

     2429, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,

     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428

    },

    {
       45, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424,-2425, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
    -2425, 2424, 2424,-2425, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424,-2425, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,

     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424,-2425, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,

     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424, 2424,
     2424, 2424, 2424, 2424, 2424, 2424
    },

    {
       45, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,

     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2431, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,

     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,

     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430
    },

    {
       45, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426,-2427, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
    -2427, 2426, 2426,-2427, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,

     2426, 2426, 2426,-2427, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426,-2427, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,

     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426
    },

    {
       45, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,

     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432,-2428, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2433, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,

     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,

     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432
    },

    {
       45, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428,-2429, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,

    -2429, 2428, 2428,-2429, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428,-2429, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428,-2429, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,

     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428, 2428,
     2428, 2428, 2428, 2428, 2428, 2428

    },

    {
       45, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2435, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,

     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,

     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434
    },

    {
       45, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430,-2431, 2430, 2430,

     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
    -2431, 2430, 2430,-2431, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430,-2431, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430,-2431, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,

     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,

     2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430, 2430,
     2430, 2430, 2430, 2430, 2430, 2430
    },

    {
       45, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436,-2432, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2437, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,

     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,

     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436
    },

    {
       45, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,

     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432,-2433, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
    -2433, 2432, 2432,-2433, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432,-2433, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432,-2433, 2432, 2432, 2432, 2432,

     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,

     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432, 2432,
     2432, 2432, 2432, 2432, 2432, 2432
    },

    {
       45, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,

     2439, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,

     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438

    },

    {
       45, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434,-2435, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
    -2435, 2434, 2434,-2435, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434,-2435, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,

     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434,-2435, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,

     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434
    },

    {
       45, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440,-2436, 2440, 2440, 2440, 2440,

     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2441, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,

     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,

     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440
    },

    {
       45, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436,-2437, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
    -2437, 2436, 2436,-2437, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,

     2436, 2436, 2436,-2437, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436,-2437, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,

     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436
    },

    {
       45, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,

     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2443, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,

     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,

     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442
    },

    {
       45, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438,-2439, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,

    -2439, 2438, 2438,-2439, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438,-2439, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438,-2439, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,

     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438, 2438,
     2438, 2438, 2438, 2438, 2438, 2438

    },

    {
       45, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444,-2440, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2445, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,

     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,

     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444
    },

    {
       45, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440,-2441, 2440, 2440,

     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
    -2441, 2440, 2440,-2441, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440,-2441, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440,-2441, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,

     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,

     2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440, 2440,
     2440, 2440, 2440, 2440, 2440, 2440
    },

    {
       45, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2447, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,

     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,

     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446
    },

    {
       45, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,

     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442,-2443, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
    -2443, 2442, 2442,-2443, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442,-2443, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442,-2443, 2442, 2442, 2442, 2442,

     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,

     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442, 2442,
     2442, 2442, 2442, 2442, 2442, 2442
    },

    {
       45, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448,-2444, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,

     2449, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,

     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448

    },

    {
       45, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444,-2445, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
    -2445, 2444, 2444,-2445, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444,-2445, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,

     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444,-2445, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,

     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444, 2444,
     2444, 2444, 2444, 2444, 2444, 2444
    },

    {
       45, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,

     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2451, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,

     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,

     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450
    },

    {
       45, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446,-2447, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
    -2447, 2446, 2446,-2447, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,

     2446, 2446, 2446,-2447, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446,-2447, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,

     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446, 2446,
     2446, 2446, 2446, 2446, 2446, 2446
    },

    {
       45, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,

     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452,-2448, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2453, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,

     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,

     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452
    },

    {
       45, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448,-2449, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,

    -2449, 2448, 2448,-2449, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448,-2449, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448,-2449, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,

     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448, 2448,
     2448, 2448, 2448, 2448, 2448, 2448

    },

    {
       45, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2455, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,

     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,

     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454
    },

    {
       45, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450,-2451, 2450, 2450,

     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
    -2451, 2450, 2450,-2451, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450,-2451, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450,-2451, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,

     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,

     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450
    },

    {
       45, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456,-2452, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2457, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,

     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,

     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456
    },

    {
       45, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,

     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452,-2453, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
    -2453, 2452, 2452,-2453, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452,-2453, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452,-2453, 2452, 2452, 2452, 2452,

     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,

     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452, 2452,
     2452, 2452, 2452, 2452, 2452, 2452
    },

    {
       45, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,

     2459, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,

     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458

    },

    {
       45, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454,-2455, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
    -2455, 2454, 2454,-2455, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454,-2455, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,

     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454,-2455, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,

     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454
    },

    {
       45, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460,-2456, 2460, 2460, 2460, 2460,

     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2461, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,

     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,

     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460
    },

    {
       45, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456,-2457, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
    -2457, 2456, 2456,-2457, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,

     2456, 2456, 2456,-2457, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456,-2457, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,

     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2456, 2456, 2456, 2456, 2456, 2456
    },

    {
       45, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,

     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2463, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,

     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,

     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462
    },

    {
       45, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458,-2459, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,

    -2459, 2458, 2458,-2459, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458,-2459, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458,-2459, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,

     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458, 2458,
     2458, 2458, 2458, 2458, 2458, 2458

    },

    {
       45, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464,-2460, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2465, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,

     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,

     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464
    },

    {
       45, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460,-2461, 2460, 2460,

     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
    -2461, 2460, 2460,-2461, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460,-2461, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460,-2461, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,

     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,

     2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460, 2460,
     2460, 2460, 2460, 2460, 2460, 2460
    },

    {
       45, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2467, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,

     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,

     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466
    },

    {
       45, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,

     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462,-2463, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
    -2463, 2462, 2462,-2463, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462,-2463, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462,-2463, 2462, 2462, 2462, 2462,

     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,

     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462, 2462,
     2462, 2462, 2462, 2462, 2462, 2462
    },

    {
       45, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468,-2464, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,

     2469, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,

     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468

    },

    {
       45, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464,-2465, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
    -2465, 2464, 2464,-2465, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464,-2465, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,

     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464,-2465, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,

     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464
    },

    {
       45, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,

     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2471, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,

     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,

     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470
    },

    {
       45, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466,-2467, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
    -2467, 2466, 2466,-2467, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,

     2466, 2466, 2466,-2467, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466,-2467, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,

     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466, 2466,
     2466, 2466, 2466, 2466, 2466, 2466
    },

    {
       45, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,

     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472,-2468, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2473, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,

     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,

     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472
    },

    {
       45, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468,-2469, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,

    -2469, 2468, 2468,-2469, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468,-2469, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468,-2469, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,

     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468, 2468,
     2468, 2468, 2468, 2468, 2468, 2468

    },

    {
       45, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2475, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,

     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,

     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474
    },

    {
       45, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470,-2471, 2470, 2470,

     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
    -2471, 2470, 2470,-2471, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470,-2471, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470,-2471, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,

     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,

     2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470, 2470,
     2470, 2470, 2470, 2470, 2470, 2470
    },

    {
       45, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476,-2472, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2477, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,

     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,

     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476
    },

    {
       45, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,

     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472,-2473, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
    -2473, 2472, 2472,-2473, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472,-2473, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472,-2473, 2472, 2472, 2472, 2472,

     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,

     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472
    },

    {
       45, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,

     2479, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,

     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478

    },

    {
       45, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474,-2475, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
    -2475, 2474, 2474,-2475, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474,-2475, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,

     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474,-2475, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,

     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474
    },

    {
       45, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480,-2476, 2480, 2480, 2480, 2480,

     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2481, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,

     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,

     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480
    },

    {
       45, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476,-2477, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
    -2477, 2476, 2476,-2477, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,

     2476, 2476, 2476,-2477, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476,-2477, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,

     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476, 2476,
     2476, 2476, 2476, 2476, 2476, 2476
    },

    {
       45, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,

     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2483, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,

     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,

     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482
    },

    {
       45, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478,-2479, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,

    -2479, 2478, 2478,-2479, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478,-2479, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478,-2479, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,

     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478, 2478,
     2478, 2478, 2478, 2478, 2478, 2478

    },

    {
       45,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,

    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,

    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,-2480,
    -2480,-2480,-2480,-2480,-2480,-2480
    },

    {
       45, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480,-2481, 2480, 2480,

     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
    -2481, 2480, 2480,-2481, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480,-2481, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480,-2481, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,

     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,

     2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480, 2480,
     2480, 2480, 2480, 2480, 2480, 2480
    },

    {
       45,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,

    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,

    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,-2482,
    -2482,-2482,-2482,-2482,-2482,-2482
    },

    {
       45, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,

     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482,-2483, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
    -2483, 2482, 2482,-2483, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482,-2483, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482,-2483, 2482, 2482, 2482, 2482,

     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,

     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482, 2482,
     2482, 2482, 2482, 2482, 2482, 2482
    },

    } ;

static yy_state_type yy_get_previous_state (yyscan_t yyscanner );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  ,yyscan_t yyscanner);
static int yy_get_next_buffer (yyscan_t yyscanner );
static void yy_fatal_error (yyconst char msg[] ,yyscan_t yyscanner );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	yyg->yytext_ptr = yy_bp; \
	yyg->yytext_ptr -= yyg->yy_more_len; \
	yyleng = (size_t) (yy_cp - yyg->yytext_ptr); \
	yyg->yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yyg->yy_c_buf_p = yy_cp;

#define YY_NUM_RULES 209
#define YY_END_OF_BUFFER 210
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_accept[2484] =
    {   0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  210,  147,  208,  147,  148,  148,
      208,  160,  126,  180,  161,  126,  126,  126,  179,  126,
      126,  126,  126,  126,  126,  126,  133,  133,  126,  121,
      126,  126,  126,  159,  159,  159,  159,  159,  159,  159,
      159,  159,  159,  159,  159,  159,  159,  159,  159,  159,
      159,  159,  159,  159,   52,  126,  159,  182,  127,  126,

      130,  202,  206,  208,  208,  208,  204,  208,  208,  207,
      208,  199,  199,  199,  200,   50,   49,   50,   48,  132,
      131,  117,  158,  157,  157,  135,  135,  156,  123,  168,
      171,  171,  163,  163,  163,  162,  162,  162,  189,  160,
      189,  161,  189,  189,  133,  133,  184,  187,  183,  186,
      190,  195,  197,  196,  192,  198,  193,  172,  174,  147,
        0,    0,  146,  147,  151,  149,  147,  148,    0,  148,
      148,  160,   90,    0,  178,    0,    0,    0,  153,   98,
      177,  125,  105,  101,  179,  179,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,   95,   85,   93,

       86,   94,   46,    0,  137,   97,  167,  161,   96,  137,
      133,    0,    0,   51,  124,    0,  109,   91,   90,  120,
       89,   82,   92,  119,    0,  175,  159,  159,  159,  159,
       25,  159,  159,  180,  179,    0,  159,  159,  159,  159,
      159,  159,  159,   17,  159,  159,  159,  159,  159,  159,
      159,  159,  159,  159,  159,   11,  159,  159,  159,  159,
      159,  159,  106,  159,  159,  159,  159,  159,  159,  159,
      159,  159,  159,  159,  159,  159,  159,  159,  159,  103,
      159,  102,  104,    0,  202,    0,    0,    0,  202,  203,
      203,  153,    0,  128,  201,  203,  204,    0,    0,    0,

      204,  205,    0,  205,  205,  200,   49,   47,   48,  131,
      136,    0,  135,    0,  168,  170,  169,  163,  163,  164,
      165,    0,  185,  188,    0,  183,    0,  196,  192,    0,
      194,  172,    0,  147,    0,  150,    0,    0,    0,  148,
        0,   88,    0,    0,  153,  177,  177,    0,  125,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,  118,
        0,  137,    0,  137,  134,    0,  124,    0,    0,   99,
       87,  100,  116,  175,  175,  159,  107,  159,  159,  159,
      159,    0,  159,  159,  159,  159,  159,  159,  159,  159,
      159,    2,  159,  159,  159,  159,  159,  159,  159,  159,

      159,   18,  159,  159,  159,  159,  159,  159,  159,  159,
      159,  159,   53,  159,  159,  159,  159,  159,  159,  159,
      159,  159,  159,    7,  159,  159,  159,   69,   55,  159,
      108,  159,  159,  159,  159,  159,  159,  159,  159,  159,
      129,  203,    0,  153,  155,  203,  205,  205,  136,    0,
        0,    0,    0,    0,  122,  183,  196,    0,  173,  147,
        0,    0,    0,    0,  148,    0,  125,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,  166,  124,    0,
        0,    0,    0,    0,  159,  159,  159,  159,  159,  159,
       28,  159,  159,  159,  159,  159,  159,  159,  159,  159,

       33,   14,  159,  159,  159,  159,  159,  159,   45,   63,
        1,  159,  159,  159,  159,  159,   32,  159,  159,  159,
      159,  159,   83,  159,  159,  159,  159,  159,  159,  159,
      159,  159,  159,  159,  159,  159,  159,  111,  159,  159,
      159,  159,  159,  159,  159,  159,  159,  159,  159,  159,
      159,    0,    0,  122,    0,    0,    0,    0,  183,  196,
      191,  147,    0,  152,  152,    0,    0,  148,    0,  125,
        0,    0,    0,    0,    0,    0,   56,    0,    0,    0,
        0,    0,  124,    0,    0,    0,  181,  181,    0,  159,
       84,  159,  159,  113,   30,    8,  159,  159,   35,   54,

        4,  159,  159,  159,  159,   72,  159,  159,   13,  159,
      159,  159,   77,  159,  159,  159,  159,  159,  159,  159,
      159,   71,  159,  159,   34,  159,  159,  159,  159,  159,
      110,  159,  159,   10,   37,  159,   81,   15,    6,  159,
      159,  159,  159,  159,  159,  159,  159,  159,  159,  154,
        0,    0,    0,    0,  147,    0,  149,  149,    0,  148,
        0,    0,    0,    0,   61,    0,    0,    0,    0,    0,
        0,   57,    0,    0,    0,    0,    0,    0,  159,    0,
        0,    0,  159,  159,  159,  159,  159,  159,   12,  159,
       19,  159,  159,  159,  159,  159,  159,   70,  159,  159,

      159,  159,  159,  159,  159,  159,  159,   80,  159,    5,
       75,   26,    0,    0,  115,    0,  159,  159,  159,  159,
      159,  159,  159,  159,  159,  159,  147,    0,    0,  148,
        0,    0,   59,    0,    0,    0,    0,    0,    0,    0,
       62,    0,  159,  114,    0,    0,    0,  159,  159,  159,
      159,   22,   29,  159,  159,  159,  159,   39,    9,   20,
      159,  159,   64,  159,  159,  159,  159,  112,   78,  159,
       66,    0,    0,    0,  159,  159,  144,  159,  159,  159,
      159,  159,  159,  159,  147,    0,    0,  148,    0,    0,
       58,    0,    0,    0,   60,    0,   76,    0,    0,    0,

      159,   42,   43,   31,  159,  159,  159,   16,    3,  159,
      159,  159,  159,  159,  159,  159,   44,  159,    0,    0,
        0,  159,  159,  143,  159,  159,  142,  159,  159,  159,
      147,    0,    0,  148,    0,    0,  176,   41,  159,  159,
       27,  159,  159,  159,   38,   36,   68,   79,  159,  138,
      159,  159,  159,  159,  159,  139,  147,    0,    0,  148,
        0,  176,  176,   23,   21,   40,  159,   24,  159,  159,
      159,  159,  141,  159,  147,    0,    0,  148,    0,  159,
      159,  159,  159,  159,  159,  147,    0,    0,  148,    0,
       65,   67,  159,  140,  159,  159,  147,    0,    0,  148,

        0,  159,  159,  145,  147,    0,    0,  148,    0,  159,
      159,  147,    0,    0,  148,    0,  159,   73,  147,    0,
        0,  148,    0,  159,  147,    0,    0,    0,  148,    0,
      159,  147,    0,    0,    0,    0,    0,  148,    0,  159,
      147,    0,    0,    0,    0,  148,    0,  159,  147,    0,
        0,    0,    0,  148,    0,  159,  147,    0,    0,    0,
        0,  148,    0,  159,  147,    0,  148,    0,  159,  147,
        0,  148,    0,  159,  147,    0,  148,    0,   74,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,

        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,

        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,

        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,

        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,

        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,

        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,

        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,

        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,

        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,

        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,

        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,

        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,

        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,

        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,

        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0,  147,    0,  148,    0,  147,    0,  148,
        0,  147,    0,  148,    0,  147,    0,  148,    0,  147,
        0,  148,    0
    } ;

static yyconst yy_state_type yy_NUL_trans[2484] =
    {   0,
       46,   46,   49,   49,   51,   51,   49,   49,  102,  102,
      107,  107,  112,  112,  112,  112,   51,   51,  116,  116,
      120,  120,   51,   51,   51,   51,   51,   51,  130,  130,
      130,  130,  133,  133,  139,  139,   51,   51,   51,   51,
      155,  155,  158,  158,    0,  160,  162,  164,  168,  170,
        0,    0,    0,  174,    0,    0,    0,    0,  185,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,  285,    0,  289,  285,  285,  297,  301,  297,    0,
      297,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,  315,
        0,    0,  318,    0,    0,    0,    0,    0,    0,    0,
      322,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  329,    0,    0,  332,    0,  334,
      160,  162,    0,  160,    0,    0,    0,  340,  168,  168,
        0,    0,    0,  174,    0,  343,  174,  174,    0,    0,
        0,    0,    0,    0,  185,    0,  185,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,  174,  185,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  285,  289,  285,  285,  285,    0,
      289,    0,  289,    0,    0,  285,  297,  301,  297,  297,

      297,  301,  301,    0,  297,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  315,    0,    0,  318,    0,    0,
        0,  322,    0,    0,    0,    0,    0,    0,  329,    0,
        0,  332,    0,  460,  334,    0,    0,    0,    0,  465,
      340,    0,  174,  343,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,  289,    0,    0,    0,  285,  301,  297,    0,    0,
      555,    0,    0,    0,    0,    0,    0,    0,    0,  562,
      460,    0,    0,    0,  568,  465,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  555,    0,    0,  653,    0,    0,
        0,  655,  562,    0,    0,    0,    0,  660,  568,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,  653,  653,  727,  655,    0,    0,    0,  730,
      660,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      745,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,  772,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,  785,  727,    0,  788,
      730,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  745,    0,  799,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,  772,    0,  820,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  831,  785,    0,  834,  788,    0,
        0,    0,    0,    0,    0,    0,    0,    0,  799,  799,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,  820,
      820,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      857,  831,    0,  860,  834,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,  875,  857,    0,  878,
      860,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  886,  875,    0,  889,  878,    0,
        0,    0,    0,    0,    0,  897,  886,    0,  900,  889,
        0,    0,    0,    0,    0,    0,  905,  897,    0,  908,

      900,    0,    0,    0,  912,  905,    0,  915,  908,    0,
        0,  919,  912,    0,  922,  915,    0,    0,  925,  919,
        0,  929,  922,    0,  932,  925,    0,    0,  938,  929,
        0,  941,  932,    0,    0,    0,    0,  946,  938,    0,
      949,  941,    0,    0,    0,  954,  946,    0,  957,  949,
        0,    0,    0,  962,  954,    0,  965,  957,    0,    0,
        0,  967,  962,    0,  970,  965,  972,  967,    0,  975,
      970,  977,  972,    0,  980,  975,  982,  977,    0,  984,
      980,  986,  982,  988,  984,  990,  986,  992,  988,  994,
      990,  996,  992,  998,  994, 1000,  996, 1002,  998, 1004,

     1000, 1006, 1002, 1008, 1004, 1010, 1006, 1012, 1008, 1014,
     1010, 1016, 1012, 1018, 1014, 1020, 1016, 1022, 1018, 1024,
     1020, 1026, 1022, 1028, 1024, 1030, 1026, 1032, 1028, 1034,
     1030, 1036, 1032, 1038, 1034, 1040, 1036, 1042, 1038, 1044,
     1040, 1046, 1042, 1048, 1044, 1050, 1046, 1052, 1048, 1054,
     1050, 1056, 1052, 1058, 1054, 1060, 1056, 1062, 1058, 1064,
     1060, 1066, 1062, 1068, 1064, 1070, 1066, 1072, 1068, 1074,
     1070, 1076, 1072, 1078, 1074, 1080, 1076, 1082, 1078, 1084,
     1080, 1086, 1082, 1088, 1084, 1090, 1086, 1092, 1088, 1094,
     1090, 1096, 1092, 1098, 1094, 1100, 1096, 1102, 1098, 1104,

     1100, 1106, 1102, 1108, 1104, 1110, 1106, 1112, 1108, 1114,
     1110, 1116, 1112, 1118, 1114, 1120, 1116, 1122, 1118, 1124,
     1120, 1126, 1122, 1128, 1124, 1130, 1126, 1132, 1128, 1134,
     1130, 1136, 1132, 1138, 1134, 1140, 1136, 1142, 1138, 1144,
     1140, 1146, 1142, 1148, 1144, 1150, 1146, 1152, 1148, 1154,
     1150, 1156, 1152, 1158, 1154, 1160, 1156, 1162, 1158, 1164,
     1160, 1166, 1162, 1168, 1164, 1170, 1166, 1172, 1168, 1174,
     1170, 1176, 1172, 1178, 1174, 1180, 1176, 1182, 1178, 1184,
     1180, 1186, 1182, 1188, 1184, 1190, 1186, 1192, 1188, 1194,
     1190, 1196, 1192, 1198, 1194, 1200, 1196, 1202, 1198, 1204,

     1200, 1206, 1202, 1208, 1204, 1210, 1206, 1212, 1208, 1214,
     1210, 1216, 1212, 1218, 1214, 1220, 1216, 1222, 1218, 1224,
     1220, 1226, 1222, 1228, 1224, 1230, 1226, 1232, 1228, 1234,
     1230, 1236, 1232, 1238, 1234, 1240, 1236, 1242, 1238, 1244,
     1240, 1246, 1242, 1248, 1244, 1250, 1246, 1252, 1248, 1254,
     1250, 1256, 1252, 1258, 1254, 1260, 1256, 1262, 1258, 1264,
     1260, 1266, 1262, 1268, 1264, 1270, 1266, 1272, 1268, 1274,
     1270, 1276, 1272, 1278, 1274, 1280, 1276, 1282, 1278, 1284,
     1280, 1286, 1282, 1288, 1284, 1290, 1286, 1292, 1288, 1294,
     1290, 1296, 1292, 1298, 1294, 1300, 1296, 1302, 1298, 1304,

     1300, 1306, 1302, 1308, 1304, 1310, 1306, 1312, 1308, 1314,
     1310, 1316, 1312, 1318, 1314, 1320, 1316, 1322, 1318, 1324,
     1320, 1326, 1322, 1328, 1324, 1330, 1326, 1332, 1328, 1334,
     1330, 1336, 1332, 1338, 1334, 1340, 1336, 1342, 1338, 1344,
     1340, 1346, 1342, 1348, 1344, 1350, 1346, 1352, 1348, 1354,
     1350, 1356, 1352, 1358, 1354, 1360, 1356, 1362, 1358, 1364,
     1360, 1366, 1362, 1368, 1364, 1370, 1366, 1372, 1368, 1374,
     1370, 1376, 1372, 1378, 1374, 1380, 1376, 1382, 1378, 1384,
     1380, 1386, 1382, 1388, 1384, 1390, 1386, 1392, 1388, 1394,
     1390, 1396, 1392, 1398, 1394, 1400, 1396, 1402, 1398, 1404,

     1400, 1406, 1402, 1408, 1404, 1410, 1406, 1412, 1408, 1414,
     1410, 1416, 1412, 1418, 1414, 1420, 1416, 1422, 1418, 1424,
     1420, 1426, 1422, 1428, 1424, 1430, 1426, 1432, 1428, 1434,
     1430, 1436, 1432, 1438, 1434, 1440, 1436, 1442, 1438, 1444,
     1440, 1446, 1442, 1448, 1444, 1450, 1446, 1452, 1448, 1454,
     1450, 1456, 1452, 1458, 1454, 1460, 1456, 1462, 1458, 1464,
     1460, 1466, 1462, 1468, 1464, 1470, 1466, 1472, 1468, 1474,
     1470, 1476, 1472, 1478, 1474, 1480, 1476, 1482, 1478, 1484,
     1480, 1486, 1482, 1488, 1484, 1490, 1486, 1492, 1488, 1494,
     1490, 1496, 1492, 1498, 1494, 1500, 1496, 1502, 1498, 1504,

     1500, 1506, 1502, 1508, 1504, 1510, 1506, 1512, 1508, 1514,
     1510, 1516, 1512, 1518, 1514, 1520, 1516, 1522, 1518, 1524,
     1520, 1526, 1522, 1528, 1524, 1530, 1526, 1532, 1528, 1534,
     1530, 1536, 1532, 1538, 1534, 1540, 1536, 1542, 1538, 1544,
     1540, 1546, 1542, 1548, 1544, 1550, 1546, 1552, 1548, 1554,
     1550, 1556, 1552, 1558, 1554, 1560, 1556, 1562, 1558, 1564,
     1560, 1566, 1562, 1568, 1564, 1570, 1566, 1572, 1568, 1574,
     1570, 1576, 1572, 1578, 1574, 1580, 1576, 1582, 1578, 1584,
     1580, 1586, 1582, 1588, 1584, 1590, 1586, 1592, 1588, 1594,
     1590, 1596, 1592, 1598, 1594, 1600, 1596, 1602, 1598, 1604,

     1600, 1606, 1602, 1608, 1604, 1610, 1606, 1612, 1608, 1614,
     1610, 1616, 1612, 1618, 1614, 1620, 1616, 1622, 1618, 1624,
     1620, 1626, 1622, 1628, 1624, 1630, 1626, 1632, 1628, 1634,
     1630, 1636, 1632, 1638, 1634, 1640, 1636, 1642, 1638, 1644,
     1640, 1646, 1642, 1648, 1644, 1650, 1646, 1652, 1648, 1654,
     1650, 1656, 1652, 1658, 1654, 1660, 1656, 1662, 1658, 1664,
     1660, 1666, 1662, 1668, 1664, 1670, 1666, 1672, 1668, 1674,
     1670, 1676, 1672, 1678, 1674, 1680, 1676, 1682, 1678, 1684,
     1680, 1686, 1682, 1688, 1684, 1690, 1686, 1692, 1688, 1694,
     1690, 1696, 1692, 1698, 1694, 1700, 1696, 1702, 1698, 1704,

     1700, 1706, 1702, 1708, 1704, 1710, 1706, 1712, 1708, 1714,
     1710, 1716, 1712, 1718, 1714, 1720, 1716, 1722, 1718, 1724,
     1720, 1726, 1722, 1728, 1724, 1730, 1726, 1732, 1728, 1734,
     1730, 1736, 1732, 1738, 1734, 1740, 1736, 1742, 1738, 1744,
     1740, 1746, 1742, 1748, 1744, 1750, 1746, 1752, 1748, 1754,
     1750, 1756, 1752, 1758, 1754, 1760, 1756, 1762, 1758, 1764,
     1760, 1766, 1762, 1768, 1764, 1770, 1766, 1772, 1768, 1774,
     1770, 1776, 1772, 1778, 1774, 1780, 1776, 1782, 1778, 1784,
     1780, 1786, 1782, 1788, 1784, 1790, 1786, 1792, 1788, 1794,
     1790, 1796, 1792, 1798, 1794, 1800, 1796, 1802, 1798, 1804,

     1800, 1806, 1802, 1808, 1804, 1810, 1806, 1812, 1808, 1814,
     1810, 1816, 1812, 1818, 1814, 1820, 1816, 1822, 1818, 1824,
     1820, 1826, 1822, 1828, 1824, 1830, 1826, 1832, 1828, 1834,
     1830, 1836, 1832, 1838, 1834, 1840, 1836, 1842, 1838, 1844,
     1840, 1846, 1842, 1848, 1844, 1850, 1846, 1852, 1848, 1854,
     1850, 1856, 1852, 1858, 1854, 1860, 1856, 1862, 1858, 1864,
     1860, 1866, 1862, 1868, 1864, 1870, 1866, 1872, 1868, 1874,
     1870, 1876, 1872, 1878, 1874, 1880, 1876, 1882, 1878, 1884,
     1880, 1886, 1882, 1888, 1884, 1890, 1886, 1892, 1888, 1894,
     1890, 1896, 1892, 1898, 1894, 1900, 1896, 1902, 1898, 1904,

     1900, 1906, 1902, 1908, 1904, 1910, 1906, 1912, 1908, 1914,
     1910, 1916, 1912, 1918, 1914, 1920, 1916, 1922, 1918, 1924,
     1920, 1926, 1922, 1928, 1924, 1930, 1926, 1932, 1928, 1934,
     1930, 1936, 1932, 1938, 1934, 1940, 1936, 1942, 1938, 1944,
     1940, 1946, 1942, 1948, 1944, 1950, 1946, 1952, 1948, 1954,
     1950, 1956, 1952, 1958, 1954, 1960, 1956, 1962, 1958, 1964,
     1960, 1966, 1962, 1968, 1964, 1970, 1966, 1972, 1968, 1974,
     1970, 1976, 1972, 1978, 1974, 1980, 1976, 1982, 1978, 1984,
     1980, 1986, 1982, 1988, 1984, 1990, 1986, 1992, 1988, 1994,
     1990, 1996, 1992, 1998, 1994, 2000, 1996, 2002, 1998, 2004,

     2000, 2006, 2002, 2008, 2004, 2010, 2006, 2012, 2008, 2014,
     2010, 2016, 2012, 2018, 2014, 2020, 2016, 2022, 2018, 2024,
     2020, 2026, 2022, 2028, 2024, 2030, 2026, 2032, 2028, 2034,
     2030, 2036, 2032, 2038, 2034, 2040, 2036, 2042, 2038, 2044,
     2040, 2046, 2042, 2048, 2044, 2050, 2046, 2052, 2048, 2054,
     2050, 2056, 2052, 2058, 2054, 2060, 2056, 2062, 2058, 2064,
     2060, 2066, 2062, 2068, 2064, 2070, 2066, 2072, 2068, 2074,
     2070, 2076, 2072, 2078, 2074, 2080, 2076, 2082, 2078, 2084,
     2080, 2086, 2082, 2088, 2084, 2090, 2086, 2092, 2088, 2094,
     2090, 2096, 2092, 2098, 2094, 2100, 2096, 2102, 2098, 2104,

     2100, 2106, 2102, 2108, 2104, 2110, 2106, 2112, 2108, 2114,
     2110, 2116, 2112, 2118, 2114, 2120, 2116, 2122, 2118, 2124,
     2120, 2126, 2122, 2128, 2124, 2130, 2126, 2132, 2128, 2134,
     2130, 2136, 2132, 2138, 2134, 2140, 2136, 2142, 2138, 2144,
     2140, 2146, 2142, 2148, 2144, 2150, 2146, 2152, 2148, 2154,
     2150, 2156, 2152, 2158, 2154, 2160, 2156, 2162, 2158, 2164,
     2160, 2166, 2162, 2168, 2164, 2170, 2166, 2172, 2168, 2174,
     2170, 2176, 2172, 2178, 2174, 2180, 2176, 2182, 2178, 2184,
     2180, 2186, 2182, 2188, 2184, 2190, 2186, 2192, 2188, 2194,
     2190, 2196, 2192, 2198, 2194, 2200, 2196, 2202, 2198, 2204,

     2200, 2206, 2202, 2208, 2204, 2210, 2206, 2212, 2208, 2214,
     2210, 2216, 2212, 2218, 2214, 2220, 2216, 2222, 2218, 2224,
     2220, 2226, 2222, 2228, 2224, 2230, 2226, 2232, 2228, 2234,
     2230, 2236, 2232, 2238, 2234, 2240, 2236, 2242, 2238, 2244,
     2240, 2246, 2242, 2248, 2244, 2250, 2246, 2252, 2248, 2254,
     2250, 2256, 2252, 2258, 2254, 2260, 2256, 2262, 2258, 2264,
     2260, 2266, 2262, 2268, 2264, 2270, 2266, 2272, 2268, 2274,
     2270, 2276, 2272, 2278, 2274, 2280, 2276, 2282, 2278, 2284,
     2280, 2286, 2282, 2288, 2284, 2290, 2286, 2292, 2288, 2294,
     2290, 2296, 2292, 2298, 2294, 2300, 2296, 2302, 2298, 2304,

     2300, 2306, 2302, 2308, 2304, 2310, 2306, 2312, 2308, 2314,
     2310, 2316, 2312, 2318, 2314, 2320, 2316, 2322, 2318, 2324,
     2320, 2326, 2322, 2328, 2324, 2330, 2326, 2332, 2328, 2334,
     2330, 2336, 2332, 2338, 2334, 2340, 2336, 2342, 2338, 2344,
     2340, 2346, 2342, 2348, 2344, 2350, 2346, 2352, 2348, 2354,
     2350, 2356, 2352, 2358, 2354, 2360, 2356, 2362, 2358, 2364,
     2360, 2366, 2362, 2368, 2364, 2370, 2366, 2372, 2368, 2374,
     2370, 2376, 2372, 2378, 2374, 2380, 2376, 2382, 2378, 2384,
     2380, 2386, 2382, 2388, 2384, 2390, 2386, 2392, 2388, 2394,
     2390, 2396, 2392, 2398, 2394, 2400, 2396, 2402, 2398, 2404,

     2400, 2406, 2402, 2408, 2404, 2410, 2406, 2412, 2408, 2414,
     2410, 2416, 2412, 2418, 2414, 2420, 2416, 2422, 2418, 2424,
     2420, 2426, 2422, 2428, 2424, 2430, 2426, 2432, 2428, 2434,
     2430, 2436, 2432, 2438, 2434, 2440, 2436, 2442, 2438, 2444,
     2440, 2446, 2442, 2448, 2444, 2450, 2446, 2452, 2448, 2454,
     2450, 2456, 2452, 2458, 2454, 2460, 2456, 2462, 2458, 2464,
     2460, 2466, 2462, 2468, 2464, 2470, 2466, 2472, 2468, 2474,
     2470, 2476, 2472, 2478, 2474, 2480, 2476, 2482, 2478,    0,
     2480,    0, 2482
    } ;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() (yyg->yy_more_flag = 1)
#define YY_MORE_ADJ yyg->yy_more_len
#define YY_RESTORE_YY_MORE_OFFSET
#line 1 "hphp.ll"
#line 2 "hphp.ll"
#include "hphp/parser/scanner.h"

// macros for flex
#define YYSTYPE HPHP::ScannerToken
#define YYLTYPE HPHP::Location
#define YY_EXTRA_TYPE HPHP::Scanner*
#define _scanner yyextra
#define YY_INPUT(buf,result,max) _scanner->read(buf,result,max)
#define YY_FATAL_ERROR(msg) \
  do { \
    struct yyguts_t *yyg = (struct yyguts_t *)yyscanner; \
    _scanner->error(msg); \
  } while (0) \

#undef YY_READ_BUF_SIZE
#undef YY_BUF_SIZE
#define YY_READ_BUF_SIZE 1024*128 /* for reading from input */
#define YY_BUF_SIZE 1024*64 /* for pattern matching */

#define DECLARE_YYCURSOR \
  char *&cursor = yyg->yy_c_buf_p; *cursor = yyg->yy_hold_char;
#define DECLARE_YYLIMIT \
  char *limit = YY_CURRENT_BUFFER->yy_ch_buf + yyg->yy_n_chars;
#define YYCURSOR  cursor
#define YYLIMIT   limit
#define RESET_YYCURSOR yyg->yy_hold_char = *YYCURSOR; *YYCURSOR = '\0';

// macros for rules
#define RETTOKEN(t) do {_scanner->setToken(yytext, yyleng, t); return t;} \
  while (0)
#define RETSTEP(t)  do {_scanner->stepPos(yytext, yyleng, t); return t;} \
  while (0)
#define SETTOKEN(t) _scanner->setToken(yytext, yyleng, t)
#define STEPPOS(t)  _scanner->stepPos(yytext, yyleng, t)

#define XHP_ONLY_KEYWORD(tok) do {                           \
  RETTOKEN(_scanner->isXHPSyntaxEnabled() ? (tok) : T_STRING); \
} while (0)

#define HH_ONLY_KEYWORD(tok) do {                               \
  RETTOKEN(_scanner->isHHSyntaxEnabled() ? (tok) : T_STRING); \
} while (0)

#define IS_LABEL_START(c) \
  (((c) >= 'a' && (c) <= 'z') || ((c) >= 'A' && (c) <= 'Z') || \
   (c) == '_' || (c) >= 0x7F)

/**
 * "Next token" types tell us how to treat a token based on the previous
 * token for the purpose of recognizing XHP tags, XHP class names, XHP
 * category names, and type lists.
 *   XhpTag:
 *     '<' will be treated as the start of an XHP tag
 *   XhpTagMaybe:
 *     '<' will be treated as possibly being the start of an XHP tag;
 *     we will scan ahead looking at subsequent characters to figure
 *     out if '<' is definitely the start of an XHP tag
 *   XhpClassName:
 *     ':' will be treated as the start of an XHP class name
 *   XhpCategoryName:
 *     '%' will be treated as the start of an XHP category name
 *   TypeListMaybe:
 *     '<' should be recognized as possibly being the start of a type list;
 *     this will be resolved by inspecting subsequent tokens
 */
namespace NextTokenType {
  static const int Normal = 0x1;
  static const int XhpTag = 0x2;
  static const int XhpTagMaybe = 0x4;
  static const int XhpClassName = 0x8;
  static const int XhpCategoryName = 0x10;
  static const int TypeListMaybe = 0x20;
}

static int getNextTokenType(int t) {
  switch (t) {
    case '=': case '.': case '+': case '-': case '*': case '/': case '%':
    case '!': case '~': case '&': case '^': case '<': case '>': case '?':
    case ':': case '[': case '{': case ';': case '@': case -1:
    case T_LOGICAL_OR:
    case T_LOGICAL_XOR:
    case T_LOGICAL_AND:
    case T_SL:
    case T_SR:
    case T_BOOLEAN_OR:
    case T_BOOLEAN_AND:
    case T_IS_EQUAL:
    case T_IS_NOT_EQUAL:
    case T_IS_IDENTICAL:
    case T_IS_NOT_IDENTICAL:
    case T_IS_SMALLER_OR_EQUAL:
    case T_IS_GREATER_OR_EQUAL:
    case T_PLUS_EQUAL:
    case T_MINUS_EQUAL:
    case T_MUL_EQUAL:
    case T_DIV_EQUAL:
    case T_CONCAT_EQUAL:
    case T_MOD_EQUAL:
    case T_AND_EQUAL:
    case T_OR_EQUAL:
    case T_XOR_EQUAL:
    case T_SL_EQUAL:
    case T_SR_EQUAL:
    case T_ECHO:
    case T_PRINT:
    case T_CLONE:
    case T_EXIT:
    case T_RETURN:
    case T_YIELD:
    case T_AWAIT:
    case T_NEW:
    case T_INSTANCEOF:
    case T_DOUBLE_ARROW:
    case T_NS_SEPARATOR:
    case T_INLINE_HTML:
    case T_INT_CAST:
    case T_DOUBLE_CAST:
    case T_STRING_CAST:
    case T_ARRAY_CAST:
    case T_OBJECT_CAST:
    case T_BOOL_CAST:
    case T_UNSET_CAST:
    case T_UNRESOLVED_LT:
    case T_AS:
      return NextTokenType::XhpTag |
             NextTokenType::XhpClassName;
    case ',': case '(': case '|':
      return NextTokenType::XhpTag |
             NextTokenType::XhpClassName |
             NextTokenType::XhpCategoryName;
    case '}':
      return NextTokenType::XhpTagMaybe |
             NextTokenType::XhpClassName;
    case T_INC:
    case T_DEC:
      return NextTokenType::XhpTagMaybe;
    case T_EXTENDS:
    case T_CLASS:
    case T_PRIVATE:
    case T_PROTECTED:
    case T_PUBLIC:
    case T_STATIC:
      return NextTokenType::XhpClassName;
    case T_STRING:
    case T_XHP_CHILDREN:
    case T_XHP_REQUIRED:
    case T_XHP_ENUM:
    case T_ARRAY:
      return NextTokenType::TypeListMaybe;
    case T_XHP_ATTRIBUTE:
      return NextTokenType::XhpClassName |
             NextTokenType::TypeListMaybe;
    case T_XHP_CATEGORY:
      return NextTokenType::XhpCategoryName |
             NextTokenType::TypeListMaybe;
    default:
      return NextTokenType::Normal;
  }
}






















/*
 * LITERAL_DOLLAR matches unescaped $ that aren't followed by a label character
 * or a { and therefore will be taken literally. The case of literal $ before
 * a variable or "${" is handled in a rule for each string type
 */
/*
 * CHARS matches everything up to a variable or "{$"
 * {'s are matched as long as they aren't followed by a $
 * The case of { before "{$" is handled in a rule for each string type
 *
 * For heredocs, matching continues across/after newlines if/when it's known
 * that the next line doesn't contain a possible ending label
 */
#line 79623 "lex.yy.cpp"

#define INITIAL 0
#define ST_IN_HTML 1
#define ST_IN_SCRIPTING 2
#define ST_AFTER_HASHBANG 3
#define ST_DOUBLE_QUOTES 4
#define ST_BACKQUOTE 5
#define ST_HEREDOC 6
#define ST_NOWDOC 7
#define ST_END_HEREDOC 8
#define ST_LOOKING_FOR_PROPERTY 9
#define ST_LOOKING_FOR_VARNAME 10
#define ST_LOOKING_FOR_COLON 11
#define ST_VAR_OFFSET 12
#define ST_LT_CHECK 13
#define ST_COMMENT 14
#define ST_DOC_COMMENT 15
#define ST_ONE_LINE_COMMENT 16
#define ST_XHP_IN_TAG 17
#define ST_XHP_END_SINGLETON_TAG 18
#define ST_XHP_END_CLOSE_TAG 19
#define ST_XHP_CHILD 20
#define ST_XHP_COMMENT 21

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

/* Holds the entire state of the reentrant scanner. */
struct yyguts_t
    {

    /* User-defined. Not touched by flex. */
    YY_EXTRA_TYPE yyextra_r;

    /* The rest are the same as the globals declared in the non-reentrant scanner. */
    FILE *yyin_r, *yyout_r;
    size_t yy_buffer_stack_top; /**< index of top of stack. */
    size_t yy_buffer_stack_max; /**< capacity of stack. */
    YY_BUFFER_STATE * yy_buffer_stack; /**< Stack as an array. */
    char yy_hold_char;
    int yy_n_chars;
    int yyleng_r;
    char *yy_c_buf_p;
    int yy_init;
    int yy_start;
    int yy_did_buffer_switch_on_eof;
    int yy_start_stack_ptr;
    int yy_start_stack_depth;
    int *yy_start_stack;
    yy_state_type yy_last_accepting_state;
    char* yy_last_accepting_cpos;

    int yylineno_r;
    int yy_flex_debug_r;

    char *yytext_r;
    int yy_more_flag;
    int yy_more_len;

    YYSTYPE * yylval_r;

    YYLTYPE * yylloc_r;

    }; /* end struct yyguts_t */

static int yy_init_globals (yyscan_t yyscanner );

    /* This must go here because YYSTYPE and YYLTYPE are included
     * from bison output in section 1.*/
    #    define yylval yyg->yylval_r
    
    #    define yylloc yyg->yylloc_r
    
int hphplex_init (yyscan_t* scanner);

int hphplex_init_extra (YY_EXTRA_TYPE user_defined,yyscan_t* scanner);

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int hphplex_destroy (yyscan_t yyscanner );

int hphpget_debug (yyscan_t yyscanner );

void hphpset_debug (int debug_flag ,yyscan_t yyscanner );

YY_EXTRA_TYPE hphpget_extra (yyscan_t yyscanner );

void hphpset_extra (YY_EXTRA_TYPE user_defined ,yyscan_t yyscanner );

FILE *hphpget_in (yyscan_t yyscanner );

void hphpset_in  (FILE * in_str ,yyscan_t yyscanner );

FILE *hphpget_out (yyscan_t yyscanner );

void hphpset_out  (FILE * out_str ,yyscan_t yyscanner );

int hphpget_leng (yyscan_t yyscanner );

char *hphpget_text (yyscan_t yyscanner );

int hphpget_lineno (yyscan_t yyscanner );

void hphpset_lineno (int line_number ,yyscan_t yyscanner );

YYSTYPE * hphpget_lval (yyscan_t yyscanner );

void hphpset_lval (YYSTYPE * yylval_param ,yyscan_t yyscanner );

       YYLTYPE *hphpget_lloc (yyscan_t yyscanner );
    
        void hphpset_lloc (YYLTYPE * yylloc_param ,yyscan_t yyscanner );
    
/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int hphpwrap (yyscan_t yyscanner );
#else
extern int hphpwrap (yyscan_t yyscanner );
#endif
#endif

    static void yyunput (int c,char *buf_ptr  ,yyscan_t yyscanner);
    
#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int ,yyscan_t yyscanner);
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * ,yyscan_t yyscanner);
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (yyscan_t yyscanner );
#else
static int input (yyscan_t yyscanner );
#endif

#endif

    static void yy_push_state (int new_state ,yyscan_t yyscanner);
    
    static void yy_pop_state (yyscan_t yyscanner );
    
    static int yy_top_state (yyscan_t yyscanner );
    
/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	errno=0; \
	while ( (result = read( fileno(yyin), (char *) buf, max_size )) < 0 ) \
	{ \
		if( errno != EINTR) \
		{ \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
			break; \
		} \
		errno=0; \
		clearerr(yyin); \
	}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg , yyscanner)
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int hphplex \
               (YYSTYPE * yylval_param,YYLTYPE * yylloc_param ,yyscan_t yyscanner);

#define YY_DECL int hphplex \
               (YYSTYPE * yylval_param, YYLTYPE * yylloc_param , yyscan_t yyscanner)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

#line 222 "hphp.ll"


#line 79883 "lex.yy.cpp"

    yylval = yylval_param;

    yylloc = yylloc_param;

	if ( !yyg->yy_init )
		{
		yyg->yy_init = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! yyg->yy_start )
			yyg->yy_start = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			hphpensure_buffer_stack (yyscanner);
			YY_CURRENT_BUFFER_LVALUE =
				hphp_create_buffer(yyin,YY_BUF_SIZE ,yyscanner);
		}

		hphp_load_buffer_state(yyscanner );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yyg->yy_more_len = 0;
		if ( yyg->yy_more_flag )
			{
			yyg->yy_more_len = yyg->yy_c_buf_p - yyg->yytext_ptr;
			yyg->yy_more_flag = 0;
			}
		yy_cp = yyg->yy_c_buf_p;

		/* Support of yytext. */
		*yy_cp = yyg->yy_hold_char;

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = yyg->yy_start;
yy_match:
		while ( (yy_current_state = yy_nxt[yy_current_state][ YY_SC_TO_UI(*yy_cp) ]) > 0 )
			{
			if ( yy_accept[yy_current_state] )
				{
				yyg->yy_last_accepting_state = yy_current_state;
				yyg->yy_last_accepting_cpos = yy_cp;
				}

			++yy_cp;
			}

		yy_current_state = -yy_current_state;

yy_find_action:
		yy_act = yy_accept[yy_current_state];

		YY_DO_BEFORE_ACTION;

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = yyg->yy_hold_char;
			yy_cp = yyg->yy_last_accepting_cpos + 1;
			yy_current_state = yyg->yy_last_accepting_state;
			goto yy_find_action;

case 1:
YY_RULE_SETUP
#line 224 "hphp.ll"
{ RETTOKEN(T_EXIT);}
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 225 "hphp.ll"
{ RETTOKEN(T_EXIT);}
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 226 "hphp.ll"
{ RETTOKEN(T_FUNCTION);}
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 227 "hphp.ll"
{ RETTOKEN(T_CONST);}
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 228 "hphp.ll"
{ RETTOKEN(T_RETURN); }
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 229 "hphp.ll"
{ RETTOKEN(T_YIELD);}
	YY_BREAK
case 7:
YY_RULE_SETUP
#line 230 "hphp.ll"
{ RETTOKEN(T_TRY);}
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 231 "hphp.ll"
{ RETTOKEN(T_CATCH);}
	YY_BREAK
case 9:
YY_RULE_SETUP
#line 232 "hphp.ll"
{ RETTOKEN(T_FINALLY);}
	YY_BREAK
case 10:
YY_RULE_SETUP
#line 233 "hphp.ll"
{ RETTOKEN(T_THROW);}
	YY_BREAK
case 11:
YY_RULE_SETUP
#line 234 "hphp.ll"
{ RETTOKEN(T_IF);}
	YY_BREAK
case 12:
YY_RULE_SETUP
#line 235 "hphp.ll"
{ RETTOKEN(T_ELSEIF);}
	YY_BREAK
case 13:
YY_RULE_SETUP
#line 236 "hphp.ll"
{ RETTOKEN(T_ENDIF);}
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 237 "hphp.ll"
{ RETTOKEN(T_ELSE);}
	YY_BREAK
case 15:
YY_RULE_SETUP
#line 238 "hphp.ll"
{ RETTOKEN(T_WHILE);}
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 239 "hphp.ll"
{ RETTOKEN(T_ENDWHILE);}
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 240 "hphp.ll"
{ RETTOKEN(T_DO);}
	YY_BREAK
case 18:
YY_RULE_SETUP
#line 241 "hphp.ll"
{ RETTOKEN(T_FOR);}
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 242 "hphp.ll"
{ RETTOKEN(T_ENDFOR);}
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 243 "hphp.ll"
{ RETTOKEN(T_FOREACH);}
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 244 "hphp.ll"
{ RETTOKEN(T_ENDFOREACH);}
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 245 "hphp.ll"
{ RETTOKEN(T_DECLARE);}
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 246 "hphp.ll"
{ RETTOKEN(T_ENDDECLARE);}
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 247 "hphp.ll"
{ RETTOKEN(T_INSTANCEOF);}
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 248 "hphp.ll"
{ RETTOKEN(T_AS);}
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 249 "hphp.ll"
{ RETTOKEN(T_SWITCH);}
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 250 "hphp.ll"
{ RETTOKEN(T_ENDSWITCH);}
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 251 "hphp.ll"
{ RETTOKEN(T_CASE);}
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 252 "hphp.ll"
{ RETTOKEN(T_DEFAULT);}
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 253 "hphp.ll"
{ RETTOKEN(T_BREAK);}
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 254 "hphp.ll"
{ RETTOKEN(T_CONTINUE);}
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 255 "hphp.ll"
{ RETTOKEN(T_GOTO);}
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 256 "hphp.ll"
{ RETTOKEN(T_ECHO);}
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 257 "hphp.ll"
{ RETTOKEN(T_PRINT);}
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 258 "hphp.ll"
{ RETTOKEN(T_CLASS);}
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 259 "hphp.ll"
{ RETTOKEN(T_INTERFACE);}
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 260 "hphp.ll"
{ RETTOKEN(T_TRAIT);}
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 261 "hphp.ll"
{ RETTOKEN(T_INSTEADOF);}
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 262 "hphp.ll"
{ RETTOKEN(T_EXTENDS);}
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 263 "hphp.ll"
{ RETTOKEN(T_IMPLEMENTS);}
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 264 "hphp.ll"
{ XHP_ONLY_KEYWORD(T_XHP_ATTRIBUTE); }
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 265 "hphp.ll"
{ XHP_ONLY_KEYWORD(T_XHP_CATEGORY); }
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 266 "hphp.ll"
{ XHP_ONLY_KEYWORD(T_XHP_CHILDREN); }
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 267 "hphp.ll"
{ XHP_ONLY_KEYWORD(T_XHP_REQUIRED); }
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 268 "hphp.ll"
{ XHP_ONLY_KEYWORD(T_XHP_ENUM); }
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 270 "hphp.ll"
{
        STEPPOS(T_OBJECT_OPERATOR);
        yy_push_state(ST_LOOKING_FOR_PROPERTY, yyscanner);
        return T_OBJECT_OPERATOR;
}
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 276 "hphp.ll"
{
        RETSTEP(T_OBJECT_OPERATOR);
}
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 280 "hphp.ll"
{
        SETTOKEN(T_STRING);
        yy_pop_state(yyscanner);
        return T_STRING;
}
	YY_BREAK
case 49:
/* rule 49 can match eol */
YY_RULE_SETUP
#line 286 "hphp.ll"
{
        RETSTEP(T_WHITESPACE);
}
	YY_BREAK
case 50:
/* rule 50 can match eol */
YY_RULE_SETUP
#line 290 "hphp.ll"
{
        yyless(0);
        yy_pop_state(yyscanner);
}
	YY_BREAK
case 51:
YY_RULE_SETUP
#line 295 "hphp.ll"
{ RETSTEP(T_DOUBLE_COLON);}
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 296 "hphp.ll"
{ RETTOKEN(T_NS_SEPARATOR);}
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 297 "hphp.ll"
{ RETTOKEN(T_NEW);}
	YY_BREAK
case 54:
YY_RULE_SETUP
#line 298 "hphp.ll"
{ RETTOKEN(T_CLONE);}
	YY_BREAK
case 55:
YY_RULE_SETUP
#line 299 "hphp.ll"
{ RETTOKEN(T_VAR);}
	YY_BREAK
case 56:
YY_RULE_SETUP
#line 301 "hphp.ll"
{
  if (_scanner->lastToken() != T_FUNCTION || !_scanner->isHHSyntaxEnabled()) {
    RETSTEP(T_INT_CAST);
  }
  yyless(1);
  RETSTEP('(');
}
	YY_BREAK
case 57:
YY_RULE_SETUP
#line 309 "hphp.ll"
{
  if (_scanner->lastToken() != T_FUNCTION || !_scanner->isHHSyntaxEnabled()) {
    RETSTEP(T_DOUBLE_CAST);
  }
  yyless(1);
  RETSTEP('(');
}
	YY_BREAK
case 58:
YY_RULE_SETUP
#line 317 "hphp.ll"
{
  if (_scanner->lastToken() != T_FUNCTION || !_scanner->isHHSyntaxEnabled()) {
    RETSTEP(T_STRING_CAST);
  }
  yyless(1);
  RETSTEP('(');
}
	YY_BREAK
case 59:
YY_RULE_SETUP
#line 325 "hphp.ll"
{
  if (_scanner->lastToken() != T_FUNCTION || !_scanner->isHHSyntaxEnabled()) {
    RETSTEP(T_ARRAY_CAST);
  }
  yyless(1);
  RETSTEP('(');
}
	YY_BREAK
case 60:
YY_RULE_SETUP
#line 333 "hphp.ll"
{
  if (_scanner->lastToken() != T_FUNCTION || !_scanner->isHHSyntaxEnabled()) {
    RETSTEP(T_OBJECT_CAST);
  }
  yyless(1);
  RETSTEP('(');
}
	YY_BREAK
case 61:
YY_RULE_SETUP
#line 341 "hphp.ll"
{
  if (_scanner->lastToken() != T_FUNCTION || !_scanner->isHHSyntaxEnabled()) {
    RETSTEP(T_BOOL_CAST);
  }
  yyless(1);
  RETSTEP('(');
}
	YY_BREAK
case 62:
YY_RULE_SETUP
#line 349 "hphp.ll"
{
  if (_scanner->lastToken() != T_FUNCTION || !_scanner->isHHSyntaxEnabled()) {
    RETSTEP(T_UNSET_CAST);
  }
  yyless(1);
  RETSTEP('(');
}
	YY_BREAK
case 63:
YY_RULE_SETUP
#line 357 "hphp.ll"
{ RETTOKEN(T_EVAL);}
	YY_BREAK
case 64:
YY_RULE_SETUP
#line 358 "hphp.ll"
{ RETTOKEN(T_INCLUDE);}
	YY_BREAK
case 65:
YY_RULE_SETUP
#line 359 "hphp.ll"
{ RETTOKEN(T_INCLUDE_ONCE);}
	YY_BREAK
case 66:
YY_RULE_SETUP
#line 360 "hphp.ll"
{ RETTOKEN(T_REQUIRE);}
	YY_BREAK
case 67:
YY_RULE_SETUP
#line 361 "hphp.ll"
{ RETTOKEN(T_REQUIRE_ONCE);}
	YY_BREAK
case 68:
YY_RULE_SETUP
#line 362 "hphp.ll"
{ RETTOKEN(T_NAMESPACE);}
	YY_BREAK
case 69:
YY_RULE_SETUP
#line 363 "hphp.ll"
{ RETTOKEN(T_USE);}
	YY_BREAK
case 70:
YY_RULE_SETUP
#line 364 "hphp.ll"
{ RETTOKEN(T_GLOBAL);}
	YY_BREAK
case 71:
YY_RULE_SETUP
#line 365 "hphp.ll"
{ RETTOKEN(T_ISSET);}
	YY_BREAK
case 72:
YY_RULE_SETUP
#line 366 "hphp.ll"
{ RETTOKEN(T_EMPTY);}
	YY_BREAK
case 73:
YY_RULE_SETUP
#line 367 "hphp.ll"
{ RETTOKEN(T_HALT_COMPILER);}
	YY_BREAK
case 74:
YY_RULE_SETUP
#line 368 "hphp.ll"
{ RETTOKEN(T_COMPILER_HALT_OFFSET);}
	YY_BREAK
case 75:
YY_RULE_SETUP
#line 369 "hphp.ll"
{ RETTOKEN(T_STATIC);}
	YY_BREAK
case 76:
YY_RULE_SETUP
#line 370 "hphp.ll"
{ RETTOKEN(T_ABSTRACT);}
	YY_BREAK
case 77:
YY_RULE_SETUP
#line 371 "hphp.ll"
{ RETTOKEN(T_FINAL);}
	YY_BREAK
case 78:
YY_RULE_SETUP
#line 372 "hphp.ll"
{ RETTOKEN(T_PRIVATE);}
	YY_BREAK
case 79:
YY_RULE_SETUP
#line 373 "hphp.ll"
{ RETTOKEN(T_PROTECTED);}
	YY_BREAK
case 80:
YY_RULE_SETUP
#line 374 "hphp.ll"
{ RETTOKEN(T_PUBLIC);}
	YY_BREAK
case 81:
YY_RULE_SETUP
#line 375 "hphp.ll"
{ RETTOKEN(T_UNSET);}
	YY_BREAK
case 82:
YY_RULE_SETUP
#line 376 "hphp.ll"
{ RETSTEP(T_DOUBLE_ARROW);}
	YY_BREAK
case 83:
YY_RULE_SETUP
#line 377 "hphp.ll"
{ RETTOKEN(T_LIST);}
	YY_BREAK
case 84:
YY_RULE_SETUP
#line 378 "hphp.ll"
{ RETTOKEN(T_ARRAY);}
	YY_BREAK
case 85:
YY_RULE_SETUP
#line 379 "hphp.ll"
{ RETSTEP(T_INC);}
	YY_BREAK
case 86:
YY_RULE_SETUP
#line 380 "hphp.ll"
{ RETSTEP(T_DEC);}
	YY_BREAK
case 87:
YY_RULE_SETUP
#line 381 "hphp.ll"
{ RETSTEP(T_IS_IDENTICAL);}
	YY_BREAK
case 88:
YY_RULE_SETUP
#line 382 "hphp.ll"
{ RETSTEP(T_IS_NOT_IDENTICAL);}
	YY_BREAK
case 89:
YY_RULE_SETUP
#line 383 "hphp.ll"
{ RETSTEP(T_IS_EQUAL);}
	YY_BREAK
case 90:
YY_RULE_SETUP
#line 384 "hphp.ll"
{ RETSTEP(T_IS_NOT_EQUAL);}
	YY_BREAK
case 91:
YY_RULE_SETUP
#line 385 "hphp.ll"
{ RETSTEP(T_IS_SMALLER_OR_EQUAL);}
	YY_BREAK
case 92:
YY_RULE_SETUP
#line 386 "hphp.ll"
{ RETSTEP(T_IS_GREATER_OR_EQUAL);}
	YY_BREAK
case 93:
YY_RULE_SETUP
#line 387 "hphp.ll"
{ RETSTEP(T_PLUS_EQUAL);}
	YY_BREAK
case 94:
YY_RULE_SETUP
#line 388 "hphp.ll"
{ RETSTEP(T_MINUS_EQUAL);}
	YY_BREAK
case 95:
YY_RULE_SETUP
#line 389 "hphp.ll"
{ RETSTEP(T_MUL_EQUAL);}
	YY_BREAK
case 96:
YY_RULE_SETUP
#line 390 "hphp.ll"
{ RETSTEP(T_DIV_EQUAL);}
	YY_BREAK
case 97:
YY_RULE_SETUP
#line 391 "hphp.ll"
{ RETSTEP(T_CONCAT_EQUAL);}
	YY_BREAK
case 98:
YY_RULE_SETUP
#line 392 "hphp.ll"
{ RETSTEP(T_MOD_EQUAL);}
	YY_BREAK
case 99:
YY_RULE_SETUP
#line 393 "hphp.ll"
{ RETSTEP(T_SL_EQUAL);}
	YY_BREAK
case 100:
YY_RULE_SETUP
#line 394 "hphp.ll"
{ RETSTEP(T_SR_EQUAL);}
	YY_BREAK
case 101:
YY_RULE_SETUP
#line 395 "hphp.ll"
{ RETSTEP(T_AND_EQUAL);}
	YY_BREAK
case 102:
YY_RULE_SETUP
#line 396 "hphp.ll"
{ RETSTEP(T_OR_EQUAL);}
	YY_BREAK
case 103:
YY_RULE_SETUP
#line 397 "hphp.ll"
{ RETSTEP(T_XOR_EQUAL);}
	YY_BREAK
case 104:
YY_RULE_SETUP
#line 398 "hphp.ll"
{ RETSTEP(T_BOOLEAN_OR);}
	YY_BREAK
case 105:
YY_RULE_SETUP
#line 399 "hphp.ll"
{ RETSTEP(T_BOOLEAN_AND);}
	YY_BREAK
case 106:
YY_RULE_SETUP
#line 400 "hphp.ll"
{ RETTOKEN(T_LOGICAL_OR);}
	YY_BREAK
case 107:
YY_RULE_SETUP
#line 401 "hphp.ll"
{ RETTOKEN(T_LOGICAL_AND);}
	YY_BREAK
case 108:
YY_RULE_SETUP
#line 402 "hphp.ll"
{ RETTOKEN(T_LOGICAL_XOR);}
	YY_BREAK
case 109:
YY_RULE_SETUP
#line 403 "hphp.ll"
{ RETSTEP(T_SL);}
	YY_BREAK
case 110:
YY_RULE_SETUP
#line 405 "hphp.ll"
{ HH_ONLY_KEYWORD(T_SHAPE); }
	YY_BREAK
case 111:
YY_RULE_SETUP
#line 406 "hphp.ll"
{ HH_ONLY_KEYWORD(T_UNRESOLVED_TYPE); }
	YY_BREAK
case 112:
YY_RULE_SETUP
#line 407 "hphp.ll"
{ HH_ONLY_KEYWORD(T_UNRESOLVED_NEWTYPE); }
	YY_BREAK
case 113:
YY_RULE_SETUP
#line 408 "hphp.ll"
{ HH_ONLY_KEYWORD(T_AWAIT);}
	YY_BREAK
case 114:
/* rule 114 can match eol */
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 5;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 409 "hphp.ll"
{
  HH_ONLY_KEYWORD(T_ASYNC);
}
	YY_BREAK
case 115:
/* rule 115 can match eol */
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 5;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 413 "hphp.ll"
{
  HH_ONLY_KEYWORD(T_TUPLE);
}
	YY_BREAK
case 116:
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 417 "hphp.ll"
{
  int ntt = getNextTokenType(_scanner->lastToken());
  if (!_scanner->isXHPSyntaxEnabled() ||
      ((ntt & NextTokenType::XhpClassName) && _scanner->lastToken() != '}')) {
    RETSTEP('?');
  }
  /* If XHP is enabled and "?:" occurs in a place where an XHP class name is
     not expected or it occurs after "}", drop into the ST_LOOKING_FOR_COLON
     state to avoid potentially treating ":" as the beginning of an XHP class
     name */
  BEGIN(ST_LOOKING_FOR_COLON);
  RETSTEP('?');
}
	YY_BREAK
case 117:
YY_RULE_SETUP
#line 431 "hphp.ll"
{
  BEGIN(ST_IN_SCRIPTING);
  RETSTEP(':');
}
	YY_BREAK
case 118:
YY_RULE_SETUP
#line 436 "hphp.ll"
{
  if (!_scanner->isHHSyntaxEnabled()) {
    yyless(1);
    RETSTEP('.');
  }
  RETTOKEN(T_VARARG);
}
	YY_BREAK
case 119:
YY_RULE_SETUP
#line 444 "hphp.ll"
{
  if (_scanner->getLookaheadLtDepth() < 2) {
    RETSTEP(T_SR);
  }
  yyless(1);
  RETSTEP('>');
}
	YY_BREAK
case 120:
YY_RULE_SETUP
#line 452 "hphp.ll"
{
  if (!_scanner->isXHPSyntaxEnabled()) {
    assert(!_scanner->isHHSyntaxEnabled());
    yyless(1);
    RETSTEP('<');
  }
  int ntt = getNextTokenType(_scanner->lastToken());
  if (ntt & NextTokenType::XhpTag) {
    yyless(1);
    STEPPOS(T_XHP_TAG_LT);
    yy_push_state(ST_XHP_IN_TAG, yyscanner);
    return T_XHP_TAG_LT;
  }
  if (ntt & NextTokenType::XhpTagMaybe) {
    // Shift to state state ST_LT_CHECK to do a more extensive check to
    // determine if this is the beginning of an XHP tag.
    yyless(0);
    BEGIN(ST_LT_CHECK);
    break;
  }
  yyless(1);
  if (_scanner->isHHSyntaxEnabled() && (ntt & NextTokenType::TypeListMaybe)) {
    // Return T_UNRESOLVED_LT; the scanner will inspect subseqent tokens
    // to resolve this.
    RETSTEP(T_UNRESOLVED_LT);
  }
  RETSTEP('<');
}
	YY_BREAK
case 121:
YY_RULE_SETUP
#line 481 "hphp.ll"
{
  if (_scanner->isHHSyntaxEnabled()) {
    int ntt = getNextTokenType(_scanner->lastToken());
    if (ntt & NextTokenType::TypeListMaybe) {
      // Return T_UNRESOLVED_LT; the scanner will inspect subseqent tokens
      // to resolve this.
      RETSTEP(T_UNRESOLVED_LT);
    }
  }
  RETSTEP('<');
}
	YY_BREAK
case 122:
/* rule 122 can match eol */
YY_RULE_SETUP
#line 493 "hphp.ll"
{
  BEGIN(ST_IN_SCRIPTING);
  yyless(1);
  STEPPOS(T_XHP_TAG_LT);
  yy_push_state(ST_XHP_IN_TAG, yyscanner);
  return T_XHP_TAG_LT;
}
	YY_BREAK
case 123:
YY_RULE_SETUP
#line 501 "hphp.ll"
{
  BEGIN(ST_IN_SCRIPTING);
  RETSTEP('<');
}
	YY_BREAK
case 124:
YY_RULE_SETUP
#line 506 "hphp.ll"
{
  if (_scanner->isXHPSyntaxEnabled()) {
    int ntt = getNextTokenType(_scanner->lastToken());
    if (ntt & NextTokenType::XhpClassName) {
      yytext++; yyleng--; // skipping the first colon
      RETTOKEN(T_XHP_LABEL);
    }
  }
  yyless(1);
  RETSTEP(':');
}
	YY_BREAK
case 125:
YY_RULE_SETUP
#line 518 "hphp.ll"
{
  if (_scanner->isXHPSyntaxEnabled()) {
    int ntt = getNextTokenType(_scanner->lastToken());
    if (ntt & NextTokenType::XhpCategoryName) {
      yytext++; yyleng--; // skipping "%"
      RETTOKEN(T_XHP_CATEGORY_LABEL);
    }
  }
  yyless(1);
  RETSTEP('%');
}
	YY_BREAK
case 126:
YY_RULE_SETUP
#line 530 "hphp.ll"
{RETSTEP(yytext[0]);}
	YY_BREAK
case 127:
YY_RULE_SETUP
#line 532 "hphp.ll"
{
        STEPPOS('{');
        yy_push_state(ST_IN_SCRIPTING, yyscanner);
        return '{';
}
	YY_BREAK
case 128:
YY_RULE_SETUP
#line 538 "hphp.ll"
{
        STEPPOS(T_DOLLAR_OPEN_CURLY_BRACES);
        yy_push_state(ST_LOOKING_FOR_VARNAME, yyscanner);
        return T_DOLLAR_OPEN_CURLY_BRACES;
}
	YY_BREAK
case 129:
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 544 "hphp.ll"
{
        STEPPOS('}');
        // We need to be robust against a '}' in PHP code with
        // no corresponding '{'
        struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
        if (yyg->yy_start_stack_ptr) {
          yy_pop_state(yyscanner);
          if (YY_START == ST_IN_SCRIPTING) {
            /* If XHP is enabled and "}:" occurs (and "}" does not cause us
               to transition to some state other than ST_IN_SCRIPTING), drop
               into the ST_LOOKING_FOR_COLON state to avoid potentially
               treating ":" as the beginning of an XHP class name */
            BEGIN(ST_LOOKING_FOR_COLON);
          }
        }
        return '}';
}
	YY_BREAK
case 130:
YY_RULE_SETUP
#line 562 "hphp.ll"
{
        STEPPOS('}');
        // We need to be robust against a '}' in PHP code with
        // no corresponding '{'
        struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
        if (yyg->yy_start_stack_ptr) yy_pop_state(yyscanner);
        return '}';
}
	YY_BREAK
case 131:
YY_RULE_SETUP
#line 571 "hphp.ll"
{
        SETTOKEN(T_STRING_VARNAME);
        // Change state to IN_SCRIPTING; current state will be popped
        // when we encounter '}'
        BEGIN(ST_IN_SCRIPTING);
        return T_STRING_VARNAME;
}
	YY_BREAK
case 132:
/* rule 132 can match eol */
YY_RULE_SETUP
#line 579 "hphp.ll"
{
        yyless(0);
        // Change state to IN_SCRIPTING; current state will be popped
        // when we encounter '}'
        BEGIN(ST_IN_SCRIPTING);
}
	YY_BREAK
case 133:
YY_RULE_SETUP
#line 586 "hphp.ll"
{
        errno = 0;
        long ret = strtoll(yytext, NULL, 0);
        if (errno == ERANGE || ret < 0) {
                _scanner->error("Dec number is too big: %s", yytext);
                if (_scanner->isHHFile()) {
                        RETTOKEN(T_HH_ERROR);
                }
        }
        RETTOKEN(T_LNUMBER);
}
	YY_BREAK
case 134:
YY_RULE_SETUP
#line 598 "hphp.ll"
{
        errno = 0;
        long ret = strtoull(yytext, NULL, 16);
        if (errno == ERANGE || ret < 0) {
                _scanner->error("Hex number is too big: %s", yytext);
                if (_scanner->isHHFile()) {
                        RETTOKEN(T_HH_ERROR);
                }
        }
        RETTOKEN(T_LNUMBER);
}
	YY_BREAK
case 135:
YY_RULE_SETUP
#line 610 "hphp.ll"
{ /* Offset could be treated as a long */
        errno = 0;
        long ret = strtoll(yytext, NULL, 0);
        if (ret == LLONG_MAX && errno == ERANGE) {
                _scanner->error("Offset number is too big: %s", yytext);
                if (_scanner->isHHFile()) {
                        RETTOKEN(T_HH_ERROR);
                }
        }
        RETTOKEN(T_NUM_STRING);
}
	YY_BREAK
case 136:
YY_RULE_SETUP
#line 622 "hphp.ll"
{ /* Offset must be treated as a string */
        RETTOKEN(T_NUM_STRING);
}
	YY_BREAK
case 137:
YY_RULE_SETUP
#line 626 "hphp.ll"
{
        RETTOKEN(T_DNUMBER);
}
	YY_BREAK
case 138:
YY_RULE_SETUP
#line 630 "hphp.ll"
{ RETTOKEN(T_CLASS_C); }
	YY_BREAK
case 139:
YY_RULE_SETUP
#line 631 "hphp.ll"
{ RETTOKEN(T_TRAIT_C); }
	YY_BREAK
case 140:
YY_RULE_SETUP
#line 632 "hphp.ll"
{ RETTOKEN(T_FUNC_C); }
	YY_BREAK
case 141:
YY_RULE_SETUP
#line 633 "hphp.ll"
{ RETTOKEN(T_METHOD_C);}
	YY_BREAK
case 142:
YY_RULE_SETUP
#line 634 "hphp.ll"
{ RETTOKEN(T_LINE); }
	YY_BREAK
case 143:
YY_RULE_SETUP
#line 635 "hphp.ll"
{ RETTOKEN(T_FILE); }
	YY_BREAK
case 144:
YY_RULE_SETUP
#line 636 "hphp.ll"
{ RETTOKEN(T_DIR); }
	YY_BREAK
case 145:
YY_RULE_SETUP
#line 637 "hphp.ll"
{ RETTOKEN(T_NS_C); }
	YY_BREAK
case 146:
/* rule 146 can match eol */
YY_RULE_SETUP
#line 639 "hphp.ll"
{
        _scanner->setHashBang(yytext, yyleng, T_INLINE_HTML);
        BEGIN(ST_IN_SCRIPTING);
        yy_push_state(ST_AFTER_HASHBANG, yyscanner);
        return T_INLINE_HTML;
}
	YY_BREAK
case 147:
/* rule 147 can match eol */
YY_RULE_SETUP
#line 646 "hphp.ll"
{
        SETTOKEN(T_INLINE_HTML);
        BEGIN(ST_IN_SCRIPTING);
        yy_push_state(ST_IN_HTML, yyscanner);
        return T_INLINE_HTML;
}
	YY_BREAK
case 148:
/* rule 148 can match eol */
YY_RULE_SETUP
#line 653 "hphp.ll"
{
        SETTOKEN(T_INLINE_HTML);
        BEGIN(ST_IN_HTML);
        return T_INLINE_HTML;
}
	YY_BREAK
case 149:
/* rule 149 can match eol */
YY_RULE_SETUP
#line 659 "hphp.ll"
{
        if (_scanner->shortTags() || yyleng > 2) {
          SETTOKEN(T_OPEN_TAG);
          if (YY_START == INITIAL) {
            BEGIN(ST_IN_SCRIPTING);
          } else {
            yy_pop_state(yyscanner);
          }
          return T_OPEN_TAG;
        } else {
          SETTOKEN(T_INLINE_HTML);
          if (YY_START == INITIAL) {
            BEGIN(ST_IN_SCRIPTING);
            yy_push_state(ST_IN_HTML, yyscanner);
          } else if (YY_START == ST_AFTER_HASHBANG) {
            BEGIN(ST_IN_HTML);
          }
          return T_INLINE_HTML;
        }
}
	YY_BREAK
case 150:
YY_RULE_SETUP
#line 680 "hphp.ll"
{
        if ((yytext[1]=='%' && _scanner->aspTags()) ||
            (yytext[1]=='?' && _scanner->shortTags())) {
          if (YY_START == INITIAL) {
            BEGIN(ST_IN_SCRIPTING);
          } else {
            yy_pop_state(yyscanner);
          }
          RETTOKEN(T_ECHO); //return T_OPEN_TAG_WITH_ECHO;
        } else {
          if (YY_START == INITIAL) {
            BEGIN(ST_IN_SCRIPTING);
            yy_push_state(ST_IN_HTML, yyscanner);
          } else if (YY_START == ST_AFTER_HASHBANG) {
            BEGIN(ST_IN_HTML);
          }
          RETTOKEN(T_INLINE_HTML);
        }
}
	YY_BREAK
case 151:
YY_RULE_SETUP
#line 700 "hphp.ll"
{
        if (_scanner->aspTags()) {
          if (YY_START == INITIAL) {
            BEGIN(ST_IN_SCRIPTING);
          } else {
            yy_pop_state(yyscanner);
          }
          RETTOKEN(T_OPEN_TAG);
        } else {
          if (YY_START == INITIAL) {
            BEGIN(ST_IN_SCRIPTING);
            yy_push_state(ST_IN_HTML, yyscanner);
          } else if (YY_START == ST_AFTER_HASHBANG) {
            BEGIN(ST_IN_HTML);
          }
          RETTOKEN(T_INLINE_HTML);
        }
}
	YY_BREAK
case 152:
/* rule 152 can match eol */
YY_RULE_SETUP
#line 719 "hphp.ll"
{
        if (YY_START == INITIAL) {
          BEGIN(ST_IN_SCRIPTING);
        } else if (YY_START == ST_AFTER_HASHBANG) {
          yy_pop_state(yyscanner);
        } else {
          _scanner->error("HH mode: content before <?hh");
          return T_HH_ERROR;
        }
        STEPPOS(T_OPEN_TAG);
        _scanner->setHHFile();
        return T_OPEN_TAG;
}
	YY_BREAK
case 153:
YY_RULE_SETUP
#line 733 "hphp.ll"
{
        _scanner->setToken(yytext, yyleng, yytext+1, yyleng-1, T_VARIABLE);
        return T_VARIABLE;
}
	YY_BREAK
case 154:
YY_RULE_SETUP
#line 738 "hphp.ll"
{
        yyless(yyleng - 3);
        yy_push_state(ST_LOOKING_FOR_PROPERTY, yyscanner);
        _scanner->setToken(yytext, yyleng, yytext+1, yyleng-1, T_VARIABLE);
        return T_VARIABLE;
}
	YY_BREAK
case 155:
YY_RULE_SETUP
#line 745 "hphp.ll"
{
        yyless(yyleng - 1);
        yy_push_state(ST_VAR_OFFSET, yyscanner);
        _scanner->setToken(yytext, yyleng, yytext+1, yyleng-1, T_VARIABLE);
        return T_VARIABLE;
}
	YY_BREAK
case 156:
YY_RULE_SETUP
#line 752 "hphp.ll"
{
        yy_pop_state(yyscanner);
        return ']';
}
	YY_BREAK
case 157:
YY_RULE_SETUP
#line 757 "hphp.ll"
{
        /* Only '[' can be valid, but returning other tokens will allow
           a more explicit parse error */
        return yytext[0];
}
	YY_BREAK
case 158:
/* rule 158 can match eol */
YY_RULE_SETUP
#line 763 "hphp.ll"
{
        /* Invalid rule to return a more explicit parse error with proper
           line number */
        yyless(0);
        yy_pop_state(yyscanner);
        RETSTEP(T_ENCAPSED_AND_WHITESPACE);
}
	YY_BREAK
case 159:
YY_RULE_SETUP
#line 771 "hphp.ll"
{
        RETTOKEN(T_STRING);
}
	YY_BREAK
case 160:
/* rule 160 can match eol */
YY_RULE_SETUP
#line 775 "hphp.ll"
{
        RETSTEP(T_WHITESPACE);
}
	YY_BREAK
case 161:
YY_RULE_SETUP
#line 779 "hphp.ll"
{
        yy_push_state(ST_ONE_LINE_COMMENT, yyscanner);
        yymore();
}
	YY_BREAK
case 162:
YY_RULE_SETUP
#line 784 "hphp.ll"
{
        yymore();
}
	YY_BREAK
case 163:
/* rule 163 can match eol */
YY_RULE_SETUP
#line 788 "hphp.ll"
{
        switch (yytext[yyleng-1]) {
        case '?':
        case '%':
        case '>':
                yyless(yyleng-1);
                yymore();
                break;
        default:
                STEPPOS(T_COMMENT);
                yy_pop_state(yyscanner);
                return T_COMMENT;
        }
}
	YY_BREAK
case 164:
/* rule 164 can match eol */
YY_RULE_SETUP
#line 803 "hphp.ll"
{
        STEPPOS(T_COMMENT);
        yy_pop_state(yyscanner);
        return T_COMMENT;
}
	YY_BREAK
case 165:
YY_RULE_SETUP
#line 809 "hphp.ll"
{
        if (_scanner->isHHFile()) {
          _scanner->error("HH mode: ?> not allowed");
          return T_HH_ERROR;
        }
        if (_scanner->aspTags() || yytext[yyleng-2] != '%') {
          _scanner->setToken(yytext, yyleng-2, yytext, yyleng-2, T_COMMENT);
                yyless(yyleng-2);
                yy_pop_state(yyscanner);
                return T_COMMENT;
        } else {
                yymore();
        }
}
	YY_BREAK
case 166:
/* rule 166 can match eol */
YY_RULE_SETUP
#line 824 "hphp.ll"
{
        yy_push_state(ST_DOC_COMMENT, yyscanner);
        yymore();
}
	YY_BREAK
case 167:
YY_RULE_SETUP
#line 829 "hphp.ll"
{
        yy_push_state(ST_COMMENT, yyscanner);
        yymore();
}
	YY_BREAK
case 168:
/* rule 168 can match eol */
YY_RULE_SETUP
#line 834 "hphp.ll"
{
        yymore();
}
	YY_BREAK
case 169:
YY_RULE_SETUP
#line 838 "hphp.ll"
{
        SETTOKEN(T_DOC_COMMENT);
        yy_pop_state(yyscanner);
        return T_DOC_COMMENT;
}
	YY_BREAK
case 170:
YY_RULE_SETUP
#line 844 "hphp.ll"
{
        STEPPOS(T_COMMENT);
        yy_pop_state(yyscanner);
        return T_COMMENT;
}
	YY_BREAK
case 171:
YY_RULE_SETUP
#line 850 "hphp.ll"
{
        yymore();
}
	YY_BREAK
case 172:
/* rule 172 can match eol */
YY_RULE_SETUP
#line 854 "hphp.ll"
{
        yymore();
}
	YY_BREAK
case 173:
YY_RULE_SETUP
#line 858 "hphp.ll"
{
        STEPPOS(T_COMMENT);
        yy_pop_state(yyscanner);
        return T_COMMENT;
}
	YY_BREAK
case 174:
YY_RULE_SETUP
#line 864 "hphp.ll"
{
        yymore();
}
	YY_BREAK
case 175:
/* rule 175 can match eol */
YY_RULE_SETUP
#line 868 "hphp.ll"
{
        if (_scanner->isHHFile()) {
          _scanner->error("HH mode: ?> not allowed");
          return T_HH_ERROR;
        }
        yy_push_state(ST_IN_HTML, yyscanner);
        if (_scanner->full()) {
          RETSTEP(T_CLOSE_TAG);
        } else {
          RETSTEP(';');
        }
}
	YY_BREAK
case 176:
/* rule 176 can match eol */
YY_RULE_SETUP
#line 881 "hphp.ll"
{
        yy_push_state(ST_IN_HTML, yyscanner);
        if (_scanner->full()) {
          RETSTEP(T_CLOSE_TAG);
        } else {
          RETSTEP(';');
        }
}
	YY_BREAK
case 177:
/* rule 177 can match eol */
YY_RULE_SETUP
#line 890 "hphp.ll"
{
        if (_scanner->aspTags()) {
                yy_push_state(ST_IN_HTML, yyscanner);
                if (_scanner->full()) {
                  RETSTEP(T_CLOSE_TAG);
                } else {
                  RETSTEP(';');
                }
        } else {
                yyless(1);
                _scanner->setToken(yytext, 1, yytext, 1);
                RETSTEP(yytext[0]);
        }
}
	YY_BREAK
case 178:
/* rule 178 can match eol */
YY_RULE_SETUP
#line 905 "hphp.ll"
{
        int bprefix = (yytext[0] != '"') ? 1 : 0;
        std::string strval =
          _scanner->escape(yytext + bprefix + 1,
                           yyleng - bprefix - 2, '"');
        _scanner->setToken(yytext, yyleng, strval.c_str(), strval.length());
        return T_CONSTANT_ENCAPSED_STRING;
}
	YY_BREAK
case 179:
/* rule 179 can match eol */
YY_RULE_SETUP
#line 914 "hphp.ll"
{
        int bprefix = (yytext[0] != '\'') ? 1 : 0;
        int closed = (yytext[yyleng - 1] == '\'');
        std::string strval =
          _scanner->escape(yytext + bprefix + 1,
                           yyleng - bprefix - 2, '\'');
        _scanner->setToken(yytext, yyleng, strval.c_str(), strval.length());
        return closed ? T_CONSTANT_ENCAPSED_STRING : T_ENCAPSED_AND_WHITESPACE;
}
	YY_BREAK
case 180:
YY_RULE_SETUP
#line 924 "hphp.ll"
{
        int bprefix = (yytext[0] != '"') ? 1 : 0;
        _scanner->setToken(yytext, yyleng, yytext + bprefix, yyleng - bprefix);
        BEGIN(ST_DOUBLE_QUOTES);
        return '\"';
}
	YY_BREAK
case 181:
/* rule 181 can match eol */
YY_RULE_SETUP
#line 931 "hphp.ll"
{
        int bprefix = (yytext[0] != '<') ? 1 : 0;
        int label_len = yyleng-bprefix-3-1-(yytext[yyleng-2]=='\r'?1:0);
        char *s = yytext+bprefix+3;
        while ((*s == ' ') || (*s == '\t')) {
                s++;
                label_len--;
        }
        if (*s == '\'') {
                s++;
                label_len -= 2;
                BEGIN(ST_NOWDOC);
        } else {
                if (*s == '"') {
                       s++;
                       label_len -= 2;
                }
                BEGIN(ST_HEREDOC);
        }
        _scanner->setHeredocLabel(s, label_len);
        _scanner->setToken(yytext, yyleng, s, label_len);
        return T_START_HEREDOC;
}
	YY_BREAK
case 182:
YY_RULE_SETUP
#line 955 "hphp.ll"
{
        STEPPOS('`');
        BEGIN(ST_BACKQUOTE);
        return '`';
}
	YY_BREAK
case 183:
YY_RULE_SETUP
#line 961 "hphp.ll"
{
        RETTOKEN(T_XHP_LABEL);
}
	YY_BREAK
case 184:
YY_RULE_SETUP
#line 965 "hphp.ll"
{
  RETSTEP(yytext[0]);
}
	YY_BREAK
case 185:
/* rule 185 can match eol */
YY_RULE_SETUP
#line 969 "hphp.ll"
{
  _scanner->setToken(yytext, yyleng, yytext+1, yyleng-2);
  return T_XHP_TEXT;
}
	YY_BREAK
case 186:
YY_RULE_SETUP
#line 974 "hphp.ll"
{
  STEPPOS('{');
  yy_push_state(ST_IN_SCRIPTING, yyscanner);
  return '{';
}
	YY_BREAK
case 187:
YY_RULE_SETUP
#line 980 "hphp.ll"
{
  STEPPOS(T_XHP_TAG_GT);
  BEGIN(ST_XHP_CHILD);
  return T_XHP_TAG_GT;
}
	YY_BREAK
case 188:
YY_RULE_SETUP
#line 986 "hphp.ll"
{
  BEGIN(ST_XHP_END_SINGLETON_TAG);
  yyless(1);
  return '/';
}
	YY_BREAK
case 189:
/* rule 189 can match eol */
YY_RULE_SETUP
#line 992 "hphp.ll"
{
  // This rule ensures we get a reasonable syntax error message
  // when unexpected characters occur inside XHP tags
  STEPPOS(yytext[0]);
  _scanner->error("Unexpected character in input: '%c' (ASCII=%d)",
                  yytext[0], yytext[0]);
  return yytext[0];
}
	YY_BREAK
case 190:
YY_RULE_SETUP
#line 1001 "hphp.ll"
{
  STEPPOS(T_XHP_TAG_GT);
  yy_pop_state(yyscanner);
  return T_XHP_TAG_GT;
}
	YY_BREAK
case 191:
YY_RULE_SETUP
#line 1007 "hphp.ll"
{
  yy_push_state(ST_XHP_COMMENT, yyscanner);
  yymore();
}
	YY_BREAK
case 192:
/* rule 192 can match eol */
YY_RULE_SETUP
#line 1012 "hphp.ll"
{
  RETTOKEN(T_XHP_TEXT);
}
	YY_BREAK
case 193:
YY_RULE_SETUP
#line 1016 "hphp.ll"
{
  STEPPOS('{');
  yy_push_state(ST_IN_SCRIPTING, yyscanner);
  return '{';
}
	YY_BREAK
case 194:
YY_RULE_SETUP
#line 1022 "hphp.ll"
{
  BEGIN(ST_XHP_END_CLOSE_TAG);
  yyless(1);
  RETSTEP(T_XHP_TAG_LT);
}
	YY_BREAK
case 195:
YY_RULE_SETUP
#line 1028 "hphp.ll"
{
  RETSTEP('/');
}
	YY_BREAK
case 196:
YY_RULE_SETUP
#line 1032 "hphp.ll"
{
  RETTOKEN(T_XHP_LABEL);
}
	YY_BREAK
case 197:
YY_RULE_SETUP
#line 1036 "hphp.ll"
{
  STEPPOS(T_XHP_TAG_GT);
  yy_pop_state(yyscanner);
  return T_XHP_TAG_GT;
}
	YY_BREAK
case 198:
YY_RULE_SETUP
#line 1042 "hphp.ll"
{
  STEPPOS(T_XHP_TAG_LT);
  yy_push_state(ST_XHP_IN_TAG, yyscanner);
  return T_XHP_TAG_LT;
}
	YY_BREAK
case 199:
/* rule 199 can match eol */
YY_RULE_SETUP
#line 1048 "hphp.ll"
{
  int refillResult = EOB_ACT_CONTINUE_SCAN;
  std::vector<std::string> docPieces;
  size_t totalDocSize = 0;
  std::string entireDoc;
  int docLabelLen = _scanner->getHeredocLabelLen();
  bool isHeredoc = (YYSTATE == ST_HEREDOC);
  DECLARE_YYCURSOR;
  DECLARE_YYLIMIT;

  YYCURSOR--;

  // The rules that lead to this state all consume an end-of-line.
  bool lookingForEndLabel = true;

  while (refillResult == EOB_ACT_CONTINUE_SCAN) {
    while (YYCURSOR < YYLIMIT) {
      switch (*YYCURSOR++) {
        case '\r':
          lookingForEndLabel = true;
          continue;
        case '\n':
          lookingForEndLabel = true;
          continue;
        case '$':
          lookingForEndLabel = false;
          if (isHeredoc) {
            if (YYCURSOR == YYLIMIT) {
              --YYCURSOR;
              goto doc_scan_get_more_buffer;
            }
            if (IS_LABEL_START(*YYCURSOR) || *YYCURSOR == '{') {
              --YYCURSOR;
              goto doc_scan_done;
            }
          }
          continue;
        case '{':
          lookingForEndLabel = false;
          if (isHeredoc) {
            if (YYCURSOR == YYLIMIT) {
              --YYCURSOR;
              goto doc_scan_get_more_buffer;
            }
            if (*YYCURSOR == '$') {
              --YYCURSOR;
              goto doc_scan_done;
            }
          }
          continue;
        case '\\':
          lookingForEndLabel = false;
          if (isHeredoc) {
            if (YYCURSOR == YYLIMIT) {
              --YYCURSOR;
              goto doc_scan_get_more_buffer;
            }
            if (*YYCURSOR != '\n' && *YYCURSOR != '\r') {
              YYCURSOR++;
            }
          }
          continue;
        default:
          if (lookingForEndLabel) {
            lookingForEndLabel = false;

            // Check for ending label on this line.
            if (!IS_LABEL_START(YYCURSOR[-1])) continue;

            // Adjust cursor to the start of the potential label.
            // If a label is recgonized, we want the cursor pointing at it.
            --YYCURSOR;

            if ((docLabelLen + 2) > (YYLIMIT - YYCURSOR)) {
              lookingForEndLabel = true;
              goto doc_scan_get_more_buffer;
            }

            if (!memcmp(YYCURSOR, _scanner->getHeredocLabel(), docLabelLen)) {
              const char *end = YYCURSOR + docLabelLen;
              if (*end == ';') {
                end++;
              }
              if (*end == '\n' || *end == '\r') {
                BEGIN(ST_END_HEREDOC);
                goto doc_scan_done;
              }
            }
            ++YYCURSOR; // No label found, consume this character.
          }
          continue;
      }
    }

doc_scan_get_more_buffer:
    // We ran off the end of the buffer, but no end label has been found.
    // Save off the string we have so far, re-fill the buffer, and repeat.
    yyleng = YYCURSOR - yytext;
    docPieces.emplace_back(yytext, yyleng);
    if (totalDocSize >= entireDoc.max_size() - yyleng) {
      _scanner->error("%sdoc too large", isHeredoc ? "Here" : "Now");
      return 0;
    }
    totalDocSize += yyleng;

    // yy_get_next_buffer() needs the text pointing at the data we want to keep
    // in the buffer, and the cursor pointing off the end. It will move what's
    // at yytext (if anything) to the beginning of the buffer and fill the rest
    // with new data.
    yytext = yytext + yyleng;
    yyleng = 0;
    YYCURSOR = YYLIMIT + 1;
    refillResult = yy_get_next_buffer(yyscanner);

    // Point to the beginning of the (possibly new) buffer.
    YYCURSOR = yyg->yy_c_buf_p = yytext;
    YYLIMIT = YY_CURRENT_BUFFER->yy_ch_buf + yyg->yy_n_chars;
  }

  _scanner->error("Unterminated %sdoc at end of file",
                  isHeredoc ? "here" : "now");
  return 0;

doc_scan_done:
  yyleng = YYCURSOR - yytext;
  totalDocSize += yyleng;
  RESET_YYCURSOR;

  if (totalDocSize > 0) {
    entireDoc.reserve(totalDocSize);

    for (const auto& piece: docPieces) {
      entireDoc.append(piece);
    }

    if (yyleng > 0) {
      entireDoc.append(yytext, yyleng);
    }

    // Newline before label will be subtracted from returned text, but
    // raw text will include it, for zend_highlight/strip, tokenizer, etc.
    int newline = 0;
    bool endLabelFound = (YYSTATE == ST_END_HEREDOC);
    if (endLabelFound && (entireDoc.length() > 0)) {
      auto it = entireDoc.end();
      if (*--it == '\n') {
        ++newline;
        if ((entireDoc.length() > 1) && (*--it == '\r')) {
          ++newline;
        }
      }
    }

    if (isHeredoc) {
      std::string escapedDoc = _scanner->escape(entireDoc.c_str(),
                                                entireDoc.length() - newline,
                                                0);
      _scanner->setToken(entireDoc.c_str(), entireDoc.length(),
                         escapedDoc.c_str(), escapedDoc.length());
    } else {
      _scanner->setToken(entireDoc.c_str(), entireDoc.length(),
                         entireDoc.c_str(), entireDoc.length() - newline);
    }
    return T_ENCAPSED_AND_WHITESPACE;
  } else {
    // No data before the label means we just go right to ST_END_HEREDOC
    // without forming a new token.
  }
}
	YY_BREAK
case 200:
YY_RULE_SETUP
#line 1218 "hphp.ll"
{
        BEGIN(ST_IN_SCRIPTING);
        RETSTEP(T_END_HEREDOC);
}
	YY_BREAK
case 201:
YY_RULE_SETUP
#line 1223 "hphp.ll"
{
        _scanner->setToken(yytext, 1, yytext, 1);
        yy_push_state(ST_IN_SCRIPTING, yyscanner);
        yyless(1);
        return T_CURLY_OPEN;
}
	YY_BREAK
case 202:
/* rule 202 can match eol */
YY_RULE_SETUP
#line 1230 "hphp.ll"
{
        std::string strval = _scanner->escape(yytext, yyleng, '"');
        _scanner->setToken(yytext, yyleng, strval.c_str(), strval.length());
        return T_ENCAPSED_AND_WHITESPACE;
}
	YY_BREAK
case 203:
/* rule 203 can match eol */
YY_RULE_SETUP
#line 1236 "hphp.ll"
{
        yyless(yyleng - 1);
        std::string strval = _scanner->escape(yytext, yyleng, '"');
        _scanner->setToken(yytext, yyleng, strval.c_str(), strval.length());
        return T_ENCAPSED_AND_WHITESPACE;
}
	YY_BREAK
case 204:
/* rule 204 can match eol */
YY_RULE_SETUP
#line 1243 "hphp.ll"
{
        std::string strval = _scanner->escape(yytext, yyleng, '`');
        _scanner->setToken(yytext, yyleng, strval.c_str(), strval.length());
        return T_ENCAPSED_AND_WHITESPACE;
}
	YY_BREAK
case 205:
/* rule 205 can match eol */
YY_RULE_SETUP
#line 1249 "hphp.ll"
{
        yyless(yyleng - 1);
        std::string strval = _scanner->escape(yytext, yyleng, '`');
        _scanner->setToken(yytext, yyleng, strval.c_str(), strval.length());
        return T_ENCAPSED_AND_WHITESPACE;
}
	YY_BREAK
case 206:
YY_RULE_SETUP
#line 1256 "hphp.ll"
{
        BEGIN(ST_IN_SCRIPTING);
        return '"';
}
	YY_BREAK
case 207:
YY_RULE_SETUP
#line 1261 "hphp.ll"
{
        BEGIN(ST_IN_SCRIPTING);
        return '`';
}
	YY_BREAK
case YY_STATE_EOF(ST_COMMENT):
case YY_STATE_EOF(ST_DOC_COMMENT):
#line 1266 "hphp.ll"
{
        _scanner->error("Unterminated comment at end of file");
        return 0;
}
	YY_BREAK
case 208:
/* rule 208 can match eol */
YY_RULE_SETUP
#line 1271 "hphp.ll"
{
        _scanner->error("Unexpected character in input: '%c' (ASCII=%d)",
                        yytext[0], yytext[0]);
}
	YY_BREAK
case 209:
YY_RULE_SETUP
#line 1276 "hphp.ll"
ECHO;
	YY_BREAK
#line 81798 "lex.yy.cpp"
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(ST_IN_HTML):
case YY_STATE_EOF(ST_IN_SCRIPTING):
case YY_STATE_EOF(ST_AFTER_HASHBANG):
case YY_STATE_EOF(ST_DOUBLE_QUOTES):
case YY_STATE_EOF(ST_BACKQUOTE):
case YY_STATE_EOF(ST_HEREDOC):
case YY_STATE_EOF(ST_NOWDOC):
case YY_STATE_EOF(ST_END_HEREDOC):
case YY_STATE_EOF(ST_LOOKING_FOR_PROPERTY):
case YY_STATE_EOF(ST_LOOKING_FOR_VARNAME):
case YY_STATE_EOF(ST_LOOKING_FOR_COLON):
case YY_STATE_EOF(ST_VAR_OFFSET):
case YY_STATE_EOF(ST_LT_CHECK):
case YY_STATE_EOF(ST_ONE_LINE_COMMENT):
case YY_STATE_EOF(ST_XHP_IN_TAG):
case YY_STATE_EOF(ST_XHP_END_SINGLETON_TAG):
case YY_STATE_EOF(ST_XHP_END_CLOSE_TAG):
case YY_STATE_EOF(ST_XHP_CHILD):
case YY_STATE_EOF(ST_XHP_COMMENT):
	yyterminate();

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - yyg->yytext_ptr) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = yyg->yy_hold_char;
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * hphplex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			yyg->yy_n_chars = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( yyg->yy_c_buf_p <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			yyg->yy_c_buf_p = yyg->yytext_ptr + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state( yyscanner );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state , yyscanner);

			yy_bp = yyg->yytext_ptr + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++yyg->yy_c_buf_p;
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = yyg->yy_c_buf_p;
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer( yyscanner ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				yyg->yy_did_buffer_switch_on_eof = 0;

				if ( hphpwrap(yyscanner ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					yyg->yy_c_buf_p = yyg->yytext_ptr + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! yyg->yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				yyg->yy_c_buf_p =
					yyg->yytext_ptr + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state( yyscanner );

				yy_cp = yyg->yy_c_buf_p;
				yy_bp = yyg->yytext_ptr + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				yyg->yy_c_buf_p =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars];

				yy_current_state = yy_get_previous_state( yyscanner );

				yy_cp = yyg->yy_c_buf_p;
				yy_bp = yyg->yytext_ptr + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of hphplex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	register char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	register char *source = yyg->yytext_ptr;
	register int number_to_move, i;
	int ret_val;

	if ( yyg->yy_c_buf_p > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( yyg->yy_c_buf_p - yyg->yytext_ptr - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) (yyg->yy_c_buf_p - yyg->yytext_ptr) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER;

			int yy_c_buf_p_offset =
				(int) (yyg->yy_c_buf_p - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					hphprealloc((void *) b->yy_ch_buf,b->yy_buf_size + 2 ,yyscanner );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			yyg->yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			yyg->yy_n_chars, (size_t) num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars;
		}

	if ( yyg->yy_n_chars == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			hphprestart(yyin  ,yyscanner);
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((yy_size_t) (yyg->yy_n_chars + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		yy_size_t new_size = yyg->yy_n_chars + number_to_move + (yyg->yy_n_chars >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) hphprealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size ,yyscanner );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	yyg->yy_n_chars += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

	yyg->yytext_ptr = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (yyscan_t yyscanner)
{
	register yy_state_type yy_current_state;
	register char *yy_cp;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	yy_current_state = yyg->yy_start;

	for ( yy_cp = yyg->yytext_ptr + YY_MORE_ADJ; yy_cp < yyg->yy_c_buf_p; ++yy_cp )
		{
		if ( *yy_cp )
			{
			yy_current_state = yy_nxt[yy_current_state][YY_SC_TO_UI(*yy_cp)];
			}
		else
			yy_current_state = yy_NUL_trans[yy_current_state];
		if ( yy_accept[yy_current_state] )
			{
			yyg->yy_last_accepting_state = yy_current_state;
			yyg->yy_last_accepting_cpos = yy_cp;
			}
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state , yyscan_t yyscanner)
{
	register int yy_is_jam;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner; /* This var may be unused depending upon options. */
	register char *yy_cp = yyg->yy_c_buf_p;

	yy_current_state = yy_NUL_trans[yy_current_state];
	yy_is_jam = (yy_current_state == 0);

	if ( ! yy_is_jam )
		{
		if ( yy_accept[yy_current_state] )
			{
			yyg->yy_last_accepting_state = yy_current_state;
			yyg->yy_last_accepting_cpos = yy_cp;
			}
		}

	return yy_is_jam ? 0 : yy_current_state;
}

    static void yyunput (int c, register char * yy_bp , yyscan_t yyscanner)
{
	register char *yy_cp;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

    yy_cp = yyg->yy_c_buf_p;

	/* undo effects of setting up yytext */
	*yy_cp = yyg->yy_hold_char;

	if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = yyg->yy_n_chars + 2;
		register char *dest = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[
					YY_CURRENT_BUFFER_LVALUE->yy_buf_size + 2];
		register char *source =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move];

		while ( source > YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars =
			yyg->yy_n_chars = YY_CURRENT_BUFFER_LVALUE->yy_buf_size;

		if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;

	yyg->yytext_ptr = yy_bp;
	yyg->yy_hold_char = *yy_cp;
	yyg->yy_c_buf_p = yy_cp;
}

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (yyscan_t yyscanner)
#else
    static int input  (yyscan_t yyscanner)
#endif

{
	int c;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	*yyg->yy_c_buf_p = yyg->yy_hold_char;

	if ( *yyg->yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( yyg->yy_c_buf_p < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars] )
			/* This was really a NUL. */
			*yyg->yy_c_buf_p = '\0';

		else
			{ /* need more input */
			int offset = yyg->yy_c_buf_p - yyg->yytext_ptr;
			++yyg->yy_c_buf_p;

			switch ( yy_get_next_buffer( yyscanner ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					hphprestart(yyin ,yyscanner);

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( hphpwrap(yyscanner ) )
						return EOF;

					if ( ! yyg->yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput(yyscanner);
#else
					return input(yyscanner);
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					yyg->yy_c_buf_p = yyg->yytext_ptr + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) yyg->yy_c_buf_p;	/* cast for 8-bit char's */
	*yyg->yy_c_buf_p = '\0';	/* preserve yytext */
	yyg->yy_hold_char = *++yyg->yy_c_buf_p;

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * @param yyscanner The scanner object.
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void hphprestart  (FILE * input_file , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	if ( ! YY_CURRENT_BUFFER ){
        hphpensure_buffer_stack (yyscanner);
		YY_CURRENT_BUFFER_LVALUE =
            hphp_create_buffer(yyin,YY_BUF_SIZE ,yyscanner);
	}

	hphp_init_buffer(YY_CURRENT_BUFFER,input_file ,yyscanner);
	hphp_load_buffer_state(yyscanner );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * @param yyscanner The scanner object.
 */
    void hphp_switch_to_buffer  (YY_BUFFER_STATE  new_buffer , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	/* TODO. We should be able to replace this entire function body
	 * with
	 *		hphppop_buffer_state();
	 *		hphppush_buffer_state(new_buffer);
     */
	hphpensure_buffer_stack (yyscanner);
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*yyg->yy_c_buf_p = yyg->yy_hold_char;
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = yyg->yy_c_buf_p;
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars;
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	hphp_load_buffer_state(yyscanner );

	/* We don't actually know whether we did this switch during
	 * EOF (hphpwrap()) processing, but the only time this flag
	 * is looked at is after hphpwrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	yyg->yy_did_buffer_switch_on_eof = 1;
}

static void hphp_load_buffer_state  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	yyg->yy_n_chars = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	yyg->yytext_ptr = yyg->yy_c_buf_p = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	yyg->yy_hold_char = *yyg->yy_c_buf_p;
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * @param yyscanner The scanner object.
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE hphp_create_buffer  (FILE * file, int  size , yyscan_t yyscanner)
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) hphpalloc(sizeof( struct yy_buffer_state ) ,yyscanner );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in hphp_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) hphpalloc(b->yy_buf_size + 2 ,yyscanner );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in hphp_create_buffer()" );

	b->yy_is_our_buffer = 1;

	hphp_init_buffer(b,file ,yyscanner);

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with hphp_create_buffer()
 * @param yyscanner The scanner object.
 */
    void hphp_delete_buffer (YY_BUFFER_STATE  b , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		hphpfree((void *) b->yy_ch_buf ,yyscanner );

	hphpfree((void *) b ,yyscanner );
}

#ifndef __cplusplus
extern int isatty (int );
#endif /* __cplusplus */
    
/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a hphprestart() or at EOF.
 */
    static void hphp_init_buffer  (YY_BUFFER_STATE  b, FILE * file , yyscan_t yyscanner)

{
	int oerrno = errno;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	hphp_flush_buffer(b ,yyscanner);

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then hphp_init_buffer was _probably_
     * called from hphprestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * @param yyscanner The scanner object.
 */
    void hphp_flush_buffer (YY_BUFFER_STATE  b , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		hphp_load_buffer_state(yyscanner );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  @param yyscanner The scanner object.
 */
void hphppush_buffer_state (YY_BUFFER_STATE new_buffer , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	if (new_buffer == NULL)
		return;

	hphpensure_buffer_stack(yyscanner);

	/* This block is copied from hphp_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*yyg->yy_c_buf_p = yyg->yy_hold_char;
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = yyg->yy_c_buf_p;
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars;
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		yyg->yy_buffer_stack_top++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from hphp_switch_to_buffer. */
	hphp_load_buffer_state(yyscanner );
	yyg->yy_did_buffer_switch_on_eof = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  @param yyscanner The scanner object.
 */
void hphppop_buffer_state (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	if (!YY_CURRENT_BUFFER)
		return;

	hphp_delete_buffer(YY_CURRENT_BUFFER ,yyscanner);
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if (yyg->yy_buffer_stack_top > 0)
		--yyg->yy_buffer_stack_top;

	if (YY_CURRENT_BUFFER) {
		hphp_load_buffer_state(yyscanner );
		yyg->yy_did_buffer_switch_on_eof = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void hphpensure_buffer_stack (yyscan_t yyscanner)
{
	int num_to_alloc;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	if (!yyg->yy_buffer_stack) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		yyg->yy_buffer_stack = (struct yy_buffer_state**)hphpalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								, yyscanner);
		if ( ! yyg->yy_buffer_stack )
			YY_FATAL_ERROR( "out of dynamic memory in hphpensure_buffer_stack()" );
								  
		memset(yyg->yy_buffer_stack, 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		yyg->yy_buffer_stack_max = num_to_alloc;
		yyg->yy_buffer_stack_top = 0;
		return;
	}

	if (yyg->yy_buffer_stack_top >= (yyg->yy_buffer_stack_max) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = yyg->yy_buffer_stack_max + grow_size;
		yyg->yy_buffer_stack = (struct yy_buffer_state**)hphprealloc
								(yyg->yy_buffer_stack,
								num_to_alloc * sizeof(struct yy_buffer_state*)
								, yyscanner);
		if ( ! yyg->yy_buffer_stack )
			YY_FATAL_ERROR( "out of dynamic memory in hphpensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset(yyg->yy_buffer_stack + yyg->yy_buffer_stack_max, 0, grow_size * sizeof(struct yy_buffer_state*));
		yyg->yy_buffer_stack_max = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * @param yyscanner The scanner object.
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE hphp_scan_buffer  (char * base, yy_size_t  size , yyscan_t yyscanner)
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) hphpalloc(sizeof( struct yy_buffer_state ) ,yyscanner );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in hphp_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	hphp_switch_to_buffer(b ,yyscanner );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to hphplex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * @param yyscanner The scanner object.
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       hphp_scan_bytes() instead.
 */
YY_BUFFER_STATE hphp_scan_string (yyconst char * yystr , yyscan_t yyscanner)
{
    
	return hphp_scan_bytes(yystr,strlen(yystr) ,yyscanner);
}

/** Setup the input buffer state to scan the given bytes. The next call to hphplex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * @param yyscanner The scanner object.
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE hphp_scan_bytes  (yyconst char * yybytes, int  _yybytes_len , yyscan_t yyscanner)
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _yybytes_len + 2;
	buf = (char *) hphpalloc(n ,yyscanner );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in hphp_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = hphp_scan_buffer(buf,n ,yyscanner);
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in hphp_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

    static void yy_push_state (int  new_state , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	if ( yyg->yy_start_stack_ptr >= yyg->yy_start_stack_depth )
		{
		yy_size_t new_size;

		yyg->yy_start_stack_depth += YY_START_STACK_INCR;
		new_size = yyg->yy_start_stack_depth * sizeof( int );

		if ( ! yyg->yy_start_stack )
			yyg->yy_start_stack = (int *) hphpalloc(new_size ,yyscanner );

		else
			yyg->yy_start_stack = (int *) hphprealloc((void *) yyg->yy_start_stack,new_size ,yyscanner );

		if ( ! yyg->yy_start_stack )
			YY_FATAL_ERROR( "out of memory expanding start-condition stack" );
		}

	yyg->yy_start_stack[yyg->yy_start_stack_ptr++] = YY_START;

	BEGIN(new_state);
}

    static void yy_pop_state  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	if ( --yyg->yy_start_stack_ptr < 0 )
		YY_FATAL_ERROR( "start-condition stack underflow" );

	BEGIN(yyg->yy_start_stack[yyg->yy_start_stack_ptr]);
}

    static int yy_top_state  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	return yyg->yy_start_stack[yyg->yy_start_stack_ptr - 1];
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yy_fatal_error (yyconst char* msg , yyscan_t yyscanner)
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = yyg->yy_hold_char; \
		yyg->yy_c_buf_p = yytext + yyless_macro_arg; \
		yyg->yy_hold_char = *yyg->yy_c_buf_p; \
		*yyg->yy_c_buf_p = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the user-defined data for this scanner.
 * @param yyscanner The scanner object.
 */
YY_EXTRA_TYPE hphpget_extra  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yyextra;
}

/** Get the current line number.
 * @param yyscanner The scanner object.
 */
int hphpget_lineno  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    
        if (! YY_CURRENT_BUFFER)
            return 0;
    
    return yylineno;
}

/** Get the current column number.
 * @param yyscanner The scanner object.
 */
int hphpget_column  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    
        if (! YY_CURRENT_BUFFER)
            return 0;
    
    return yycolumn;
}

/** Get the input stream.
 * @param yyscanner The scanner object.
 */
FILE *hphpget_in  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yyin;
}

/** Get the output stream.
 * @param yyscanner The scanner object.
 */
FILE *hphpget_out  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yyout;
}

/** Get the length of the current token.
 * @param yyscanner The scanner object.
 */
int hphpget_leng  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yyleng;
}

/** Get the current token.
 * @param yyscanner The scanner object.
 */

char *hphpget_text  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yytext;
}

/** Set the user-defined data. This data is never touched by the scanner.
 * @param user_defined The data to be associated with this scanner.
 * @param yyscanner The scanner object.
 */
void hphpset_extra (YY_EXTRA_TYPE  user_defined , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    yyextra = user_defined ;
}

/** Set the current line number.
 * @param line_number
 * @param yyscanner The scanner object.
 */
void hphpset_lineno (int  line_number , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

        /* lineno is only valid if an input buffer exists. */
        if (! YY_CURRENT_BUFFER )
           yy_fatal_error( "hphpset_lineno called with no buffer" , yyscanner); 
    
    yylineno = line_number;
}

/** Set the current column.
 * @param line_number
 * @param yyscanner The scanner object.
 */
void hphpset_column (int  column_no , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

        /* column is only valid if an input buffer exists. */
        if (! YY_CURRENT_BUFFER )
           yy_fatal_error( "hphpset_column called with no buffer" , yyscanner); 
    
    yycolumn = column_no;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param in_str A readable stream.
 * @param yyscanner The scanner object.
 * @see hphp_switch_to_buffer
 */
void hphpset_in (FILE *  in_str , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    yyin = in_str ;
}

void hphpset_out (FILE *  out_str , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    yyout = out_str ;
}

int hphpget_debug  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yy_flex_debug;
}

void hphpset_debug (int  bdebug , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    yy_flex_debug = bdebug ;
}

/* Accessor methods for yylval and yylloc */

YYSTYPE * hphpget_lval  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yylval;
}

void hphpset_lval (YYSTYPE *  yylval_param , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    yylval = yylval_param;
}

YYLTYPE *hphpget_lloc  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yylloc;
}
    
void hphpset_lloc (YYLTYPE *  yylloc_param , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    yylloc = yylloc_param;
}
    
/* User-visible API */

/* hphplex_init is special because it creates the scanner itself, so it is
 * the ONLY reentrant function that doesn't take the scanner as the last argument.
 * That's why we explicitly handle the declaration, instead of using our macros.
 */

int hphplex_init(yyscan_t* ptr_yy_globals)

{
    if (ptr_yy_globals == NULL){
        errno = EINVAL;
        return 1;
    }

    *ptr_yy_globals = (yyscan_t) hphpalloc ( sizeof( struct yyguts_t ), NULL );

    if (*ptr_yy_globals == NULL){
        errno = ENOMEM;
        return 1;
    }

    /* By setting to 0xAA, we expose bugs in yy_init_globals. Leave at 0x00 for releases. */
    memset(*ptr_yy_globals,0x00,sizeof(struct yyguts_t));

    return yy_init_globals ( *ptr_yy_globals );
}

/* hphplex_init_extra has the same functionality as hphplex_init, but follows the
 * convention of taking the scanner as the last argument. Note however, that
 * this is a *pointer* to a scanner, as it will be allocated by this call (and
 * is the reason, too, why this function also must handle its own declaration).
 * The user defined value in the first argument will be available to hphpalloc in
 * the yyextra field.
 */

int hphplex_init_extra(YY_EXTRA_TYPE yy_user_defined,yyscan_t* ptr_yy_globals )

{
    struct yyguts_t dummy_yyguts;

    hphpset_extra (yy_user_defined, &dummy_yyguts);

    if (ptr_yy_globals == NULL){
        errno = EINVAL;
        return 1;
    }
	
    *ptr_yy_globals = (yyscan_t) hphpalloc ( sizeof( struct yyguts_t ), &dummy_yyguts );
	
    if (*ptr_yy_globals == NULL){
        errno = ENOMEM;
        return 1;
    }
    
    /* By setting to 0xAA, we expose bugs in
    yy_init_globals. Leave at 0x00 for releases. */
    memset(*ptr_yy_globals,0x00,sizeof(struct yyguts_t));
    
    hphpset_extra (yy_user_defined, *ptr_yy_globals);
    
    return yy_init_globals ( *ptr_yy_globals );
}

static int yy_init_globals (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from hphplex_destroy(), so don't allocate here.
     */

    yyg->yy_buffer_stack = 0;
    yyg->yy_buffer_stack_top = 0;
    yyg->yy_buffer_stack_max = 0;
    yyg->yy_c_buf_p = (char *) 0;
    yyg->yy_init = 0;
    yyg->yy_start = 0;

    yyg->yy_start_stack_ptr = 0;
    yyg->yy_start_stack_depth = 0;
    yyg->yy_start_stack =  NULL;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = (FILE *) 0;
    yyout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * hphplex_init()
     */
    return 0;
}

/* hphplex_destroy is for both reentrant and non-reentrant scanners. */
int hphplex_destroy  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		hphp_delete_buffer(YY_CURRENT_BUFFER ,yyscanner );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		hphppop_buffer_state(yyscanner);
	}

	/* Destroy the stack itself. */
	hphpfree(yyg->yy_buffer_stack ,yyscanner);
	yyg->yy_buffer_stack = NULL;

    /* Destroy the start condition stack. */
        hphpfree(yyg->yy_start_stack ,yyscanner );
        yyg->yy_start_stack = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * hphplex() is called, initialization will occur. */
    yy_init_globals( yyscanner);

    /* Destroy the main struct (reentrant only). */
    hphpfree ( yyscanner , yyscanner );
    yyscanner = NULL;
    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n , yyscan_t yyscanner)
{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s , yyscan_t yyscanner)
{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *hphpalloc (yy_size_t  size , yyscan_t yyscanner)
{
	return (void *) malloc( size );
}

void *hphprealloc  (void * ptr, yy_size_t  size , yyscan_t yyscanner)
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void hphpfree (void * ptr , yyscan_t yyscanner)
{
	free( (char *) ptr );	/* see hphprealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 1276 "hphp.ll"



namespace HPHP {
  void Scanner::init() {
    hphplex_init_extra(this,&m_yyscanner);
    struct yyguts_t *yyg = (struct yyguts_t *)m_yyscanner;
    BEGIN(INITIAL);
  }

  int Scanner::scan() {
    return hphplex(m_token,m_loc,m_yyscanner);
  }

  void Scanner::reset() {
    void *yyscanner = (void *)m_yyscanner;
    struct yyguts_t *yyg = (struct yyguts_t *)m_yyscanner;
    YY_FLUSH_BUFFER;
    hphplex_destroy(m_yyscanner);
  }

  static void suppress_unused_errors() {
    yyunput(0,0,0);
    yy_top_state(0);
    suppress_unused_errors();
  }
}

extern "C" {
  int hphpwrap(yyscan_t yyscanner) {
    return 1;
  }
}

